// DO NOT EDIT.  Make changes to POAType.java instead.
package com.verifiedpoa.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _POAType extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "POAType";

  // Attribute Keys
  public static final ERXKey<String> STATE_NAME = new ERXKey<String>("stateName", Type.Attribute);
  public static final ERXKey<String> TYPE_NAME = new ERXKey<String>("typeName", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String STATE_NAME_KEY = STATE_NAME.key();
  public static final String TYPE_NAME_KEY = TYPE_NAME.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_POAType.class);

  public POAType localInstanceIn(EOEditingContext editingContext) {
    POAType localInstance = (POAType)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String stateName() {
    return (String) storedValueForKey(_POAType.STATE_NAME_KEY);
  }

  public void setStateName(String value) {
    log.debug( "updating stateName from {} to {}", stateName(), value);
    takeStoredValueForKey(value, _POAType.STATE_NAME_KEY);
  }

  public String typeName() {
    return (String) storedValueForKey(_POAType.TYPE_NAME_KEY);
  }

  public void setTypeName(String value) {
    log.debug( "updating typeName from {} to {}", typeName(), value);
    takeStoredValueForKey(value, _POAType.TYPE_NAME_KEY);
  }


  public static POAType createPOAType(EOEditingContext editingContext, String stateName
, String typeName
) {
    POAType eo = (POAType) EOUtilities.createAndInsertInstance(editingContext, _POAType.ENTITY_NAME);
    eo.setStateName(stateName);
    eo.setTypeName(typeName);
    return eo;
  }

  public static ERXFetchSpecification<POAType> fetchSpec() {
    return new ERXFetchSpecification<POAType>(_POAType.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<POAType> fetchAllPOATypes(EOEditingContext editingContext) {
    return _POAType.fetchAllPOATypes(editingContext, null);
  }

  public static NSArray<POAType> fetchAllPOATypes(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _POAType.fetchPOATypes(editingContext, null, sortOrderings);
  }

  public static NSArray<POAType> fetchPOATypes(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<POAType> fetchSpec = new ERXFetchSpecification<POAType>(_POAType.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<POAType> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static POAType fetchPOAType(EOEditingContext editingContext, String keyName, Object value) {
    return _POAType.fetchPOAType(editingContext, ERXQ.equals(keyName, value));
  }

  public static POAType fetchPOAType(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<POAType> eoObjects = _POAType.fetchPOATypes(editingContext, qualifier, null);
    POAType eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one POAType that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static POAType fetchRequiredPOAType(EOEditingContext editingContext, String keyName, Object value) {
    return _POAType.fetchRequiredPOAType(editingContext, ERXQ.equals(keyName, value));
  }

  public static POAType fetchRequiredPOAType(EOEditingContext editingContext, EOQualifier qualifier) {
    POAType eoObject = _POAType.fetchPOAType(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no POAType that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static POAType localInstanceIn(EOEditingContext editingContext, POAType eo) {
    POAType localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
