package org.opencalaccess.asias.eo;

import org.opencalaccess.U;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.foundation.NSArray;

import er.extensions.eof.ERXKey;
import er.extensions.eof.ERXKey.Type;

public class ASIASIncident extends _ASIASIncident {

	private static final long serialVersionUID = -6427318920047314707L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(ASIASIncident.class);

	public static final ERXKey<String> INCIDENT_DATE_TIME = new ERXKey<String>("dateTime", Type.Attribute);
	public static final ERXKey<String> ENTRY_DATE_TIME = new ERXKey<String>("entryDateTime", Type.Attribute);

	public String dateTime() {
		NSArray<String> parts = NSArray.componentsSeparatedByString(this.incidentDate(), "-");
		StringBuilder str = new StringBuilder();
		str.append("20");
		str.append(parts.get(2));
		str.append("-");
		str.append(U.shortMonthToNum.get(parts.get(1)));
		str.append("-");
		str.append(parts.get(0));
		str.append(" ");
		str.append(this.incidentTime());
		return str.toString();
	}

	public String entryDateTime() {
		NSArray<String> parts = NSArray.componentsSeparatedByString(this.entryDate(), "-");
		StringBuilder str = new StringBuilder();
		str.append("20");
		str.append(parts.get(2));
		str.append("-");
		str.append(U.shortMonthToNum.get(parts.get(1)));
		str.append("-");
		str.append(parts.get(0));
		return str.toString();
	}

	public String severity() {
		return this.damage().substring(0, 1);
	}
}
