// DO NOT EDIT.  Make changes to ASIASDayReport.java instead.
package org.opencalaccess.asias.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ASIASDayReport extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "ASIASDayReport";

  // Attribute Keys
  public static final ERXKey<String> DATE_STR = new ERXKey<String>("dateStr", Type.Attribute);
  public static final ERXKey<Integer> PAGE_SIZE = new ERXKey<Integer>("pageSize", Type.Attribute);
  public static final ERXKey<String> SOURCE_URL = new ERXKey<String>("sourceUrl", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.asias.eo.ASIASIncident> INCIDENTS = new ERXKey<org.opencalaccess.asias.eo.ASIASIncident>("incidents", Type.ToManyRelationship);

  // Attributes
  public static final String DATE_STR_KEY = DATE_STR.key();
  public static final String PAGE_SIZE_KEY = PAGE_SIZE.key();
  public static final String SOURCE_URL_KEY = SOURCE_URL.key();

  // Relationships
  public static final String INCIDENTS_KEY = INCIDENTS.key();

  private static final Logger log = LoggerFactory.getLogger(_ASIASDayReport.class);

  public ASIASDayReport localInstanceIn(EOEditingContext editingContext) {
    ASIASDayReport localInstance = (ASIASDayReport)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String dateStr() {
    return (String) storedValueForKey(_ASIASDayReport.DATE_STR_KEY);
  }

  public void setDateStr(String value) {
    log.debug( "updating dateStr from {} to {}", dateStr(), value);
    takeStoredValueForKey(value, _ASIASDayReport.DATE_STR_KEY);
  }

  public Integer pageSize() {
    return (Integer) storedValueForKey(_ASIASDayReport.PAGE_SIZE_KEY);
  }

  public void setPageSize(Integer value) {
    log.debug( "updating pageSize from {} to {}", pageSize(), value);
    takeStoredValueForKey(value, _ASIASDayReport.PAGE_SIZE_KEY);
  }

  public String sourceUrl() {
    return (String) storedValueForKey(_ASIASDayReport.SOURCE_URL_KEY);
  }

  public void setSourceUrl(String value) {
    log.debug( "updating sourceUrl from {} to {}", sourceUrl(), value);
    takeStoredValueForKey(value, _ASIASDayReport.SOURCE_URL_KEY);
  }

  public NSArray<org.opencalaccess.asias.eo.ASIASIncident> incidents() {
    return (NSArray<org.opencalaccess.asias.eo.ASIASIncident>)storedValueForKey(_ASIASDayReport.INCIDENTS_KEY);
  }

  public NSArray<org.opencalaccess.asias.eo.ASIASIncident> incidents(EOQualifier qualifier) {
    return incidents(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.asias.eo.ASIASIncident> incidents(EOQualifier qualifier, boolean fetch) {
    return incidents(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.asias.eo.ASIASIncident> incidents(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.asias.eo.ASIASIncident> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.asias.eo.ASIASIncident.REPORT_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.asias.eo.ASIASIncident.fetchASIASIncidents(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = incidents();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.asias.eo.ASIASIncident>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.asias.eo.ASIASIncident>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToIncidents(org.opencalaccess.asias.eo.ASIASIncident object) {
    includeObjectIntoPropertyWithKey(object, _ASIASDayReport.INCIDENTS_KEY);
  }

  public void removeFromIncidents(org.opencalaccess.asias.eo.ASIASIncident object) {
    excludeObjectFromPropertyWithKey(object, _ASIASDayReport.INCIDENTS_KEY);
  }

  public void addToIncidentsRelationship(org.opencalaccess.asias.eo.ASIASIncident object) {
    log.debug("adding {} to incidents relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToIncidents(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ASIASDayReport.INCIDENTS_KEY);
    }
  }

  public void removeFromIncidentsRelationship(org.opencalaccess.asias.eo.ASIASIncident object) {
    log.debug("removing {} from incidents relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromIncidents(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ASIASDayReport.INCIDENTS_KEY);
    }
  }

  public org.opencalaccess.asias.eo.ASIASIncident createIncidentsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.asias.eo.ASIASIncident.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ASIASDayReport.INCIDENTS_KEY);
    return (org.opencalaccess.asias.eo.ASIASIncident) eo;
  }

  public void deleteIncidentsRelationship(org.opencalaccess.asias.eo.ASIASIncident object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ASIASDayReport.INCIDENTS_KEY);
  }

  public void deleteAllIncidentsRelationships() {
    Enumeration<org.opencalaccess.asias.eo.ASIASIncident> objects = incidents().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteIncidentsRelationship(objects.nextElement());
    }
  }


  public static ASIASDayReport createASIASDayReport(EOEditingContext editingContext, Integer pageSize
, String sourceUrl
) {
    ASIASDayReport eo = (ASIASDayReport) EOUtilities.createAndInsertInstance(editingContext, _ASIASDayReport.ENTITY_NAME);
    eo.setPageSize(pageSize);
    eo.setSourceUrl(sourceUrl);
    return eo;
  }

  public static ERXFetchSpecification<ASIASDayReport> fetchSpec() {
    return new ERXFetchSpecification<ASIASDayReport>(_ASIASDayReport.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ASIASDayReport> fetchAllASIASDayReports(EOEditingContext editingContext) {
    return _ASIASDayReport.fetchAllASIASDayReports(editingContext, null);
  }

  public static NSArray<ASIASDayReport> fetchAllASIASDayReports(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ASIASDayReport.fetchASIASDayReports(editingContext, null, sortOrderings);
  }

  public static NSArray<ASIASDayReport> fetchASIASDayReports(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ASIASDayReport> fetchSpec = new ERXFetchSpecification<ASIASDayReport>(_ASIASDayReport.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ASIASDayReport> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ASIASDayReport fetchASIASDayReport(EOEditingContext editingContext, String keyName, Object value) {
    return _ASIASDayReport.fetchASIASDayReport(editingContext, ERXQ.equals(keyName, value));
  }

  public static ASIASDayReport fetchASIASDayReport(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ASIASDayReport> eoObjects = _ASIASDayReport.fetchASIASDayReports(editingContext, qualifier, null);
    ASIASDayReport eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one ASIASDayReport that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ASIASDayReport fetchRequiredASIASDayReport(EOEditingContext editingContext, String keyName, Object value) {
    return _ASIASDayReport.fetchRequiredASIASDayReport(editingContext, ERXQ.equals(keyName, value));
  }

  public static ASIASDayReport fetchRequiredASIASDayReport(EOEditingContext editingContext, EOQualifier qualifier) {
    ASIASDayReport eoObject = _ASIASDayReport.fetchASIASDayReport(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no ASIASDayReport that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ASIASDayReport localInstanceIn(EOEditingContext editingContext, ASIASDayReport eo) {
    ASIASDayReport localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
