// DO NOT EDIT.  Make changes to ASIASIncident.java instead.
package org.opencalaccess.asias.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ASIASIncident extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "ASIASIncident";

  // Attribute Keys
  public static final ERXKey<String> ACTIVITY = new ERXKey<String>("activity", Type.Attribute);
  public static final ERXKey<String> AIRCRAFT_MAKE = new ERXKey<String>("aircraftMake", Type.Attribute);
  public static final ERXKey<String> AIRCRAFT_MISSING = new ERXKey<String>("aircraftMissing", Type.Attribute);
  public static final ERXKey<String> AIRCRAFT_MODEL = new ERXKey<String>("aircraftModel", Type.Attribute);
  public static final ERXKey<String> AIRCRAFT_OPERATOR = new ERXKey<String>("aircraftOperator", Type.Attribute);
  public static final ERXKey<Integer> CABIN_CREW_FATAL = new ERXKey<Integer>("cabinCrewFatal", Type.Attribute);
  public static final ERXKey<Integer> CABIN_CREW_MINOR = new ERXKey<Integer>("cabinCrewMinor", Type.Attribute);
  public static final ERXKey<Integer> CABIN_CREW_NONE = new ERXKey<Integer>("cabinCrewNone", Type.Attribute);
  public static final ERXKey<Integer> CABIN_CREW_SERIOUS = new ERXKey<Integer>("cabinCrewSerious", Type.Attribute);
  public static final ERXKey<Integer> CABIN_CREW_UNK = new ERXKey<Integer>("cabinCrewUnk", Type.Attribute);
  public static final ERXKey<String> CITY = new ERXKey<String>("city", Type.Attribute);
  public static final ERXKey<String> COUNTRY = new ERXKey<String>("country", Type.Attribute);
  public static final ERXKey<String> DAMAGE = new ERXKey<String>("damage", Type.Attribute);
  public static final ERXKey<String> DESCRIPTION = new ERXKey<String>("description", Type.Attribute);
  public static final ERXKey<String> ENTRY_DATE = new ERXKey<String>("entryDate", Type.Attribute);
  public static final ERXKey<String> EVENT_TYPE = new ERXKey<String>("eventType", Type.Attribute);
  public static final ERXKey<String> FAA_FSDO = new ERXKey<String>("faaFsdo", Type.Attribute);
  public static final ERXKey<Integer> FLIGHT_CREW_FATAL = new ERXKey<Integer>("flightCrewFatal", Type.Attribute);
  public static final ERXKey<Integer> FLIGHT_CREW_MINOR = new ERXKey<Integer>("flightCrewMinor", Type.Attribute);
  public static final ERXKey<Integer> FLIGHT_CREW_NONE = new ERXKey<Integer>("flightCrewNone", Type.Attribute);
  public static final ERXKey<Integer> FLIGHT_CREW_SERIOUS = new ERXKey<Integer>("flightCrewSerious", Type.Attribute);
  public static final ERXKey<Integer> FLIGHT_CREW_UNK = new ERXKey<Integer>("flightCrewUnk", Type.Attribute);
  public static final ERXKey<String> FLIGHT_NUMBER = new ERXKey<String>("flightNumber", Type.Attribute);
  public static final ERXKey<String> FLIGHT_PHASE = new ERXKey<String>("flightPhase", Type.Attribute);
  public static final ERXKey<Integer> GROUND_FATAL = new ERXKey<Integer>("groundFatal", Type.Attribute);
  public static final ERXKey<Integer> GROUND_MINOR = new ERXKey<Integer>("groundMinor", Type.Attribute);
  public static final ERXKey<Integer> GROUND_NONE = new ERXKey<Integer>("groundNone", Type.Attribute);
  public static final ERXKey<Integer> GROUND_SERIOUS = new ERXKey<Integer>("groundSerious", Type.Attribute);
  public static final ERXKey<Integer> GROUND_UNK = new ERXKey<Integer>("groundUnk", Type.Attribute);
  public static final ERXKey<String> HIGHEST_INJURY = new ERXKey<String>("highestInjury", Type.Attribute);
  public static final ERXKey<String> INCIDENT_DATE = new ERXKey<String>("incidentDate", Type.Attribute);
  public static final ERXKey<String> INCIDENT_TIME = new ERXKey<String>("incidentTime", Type.Attribute);
  public static final ERXKey<String> OPERATION = new ERXKey<String>("operation", Type.Attribute);
  public static final ERXKey<Integer> PAX_FATAL = new ERXKey<Integer>("paxFatal", Type.Attribute);
  public static final ERXKey<Integer> PAX_MINOR = new ERXKey<Integer>("paxMinor", Type.Attribute);
  public static final ERXKey<Integer> PAX_NONE = new ERXKey<Integer>("paxNone", Type.Attribute);
  public static final ERXKey<Integer> PAX_SERIOUS = new ERXKey<Integer>("paxSerious", Type.Attribute);
  public static final ERXKey<Integer> PAX_UNK = new ERXKey<Integer>("paxUnk", Type.Attribute);
  public static final ERXKey<String> REGISTRATION = new ERXKey<String>("registration", Type.Attribute);
  public static final ERXKey<String> STATE = new ERXKey<String>("state", Type.Attribute);
  public static final ERXKey<Integer> TOTAL_FATAL = new ERXKey<Integer>("totalFatal", Type.Attribute);
  public static final ERXKey<String> UPDATED = new ERXKey<String>("updated", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.asias.eo.ASIASDayReport> REPORT = new ERXKey<org.opencalaccess.asias.eo.ASIASDayReport>("report", Type.ToOneRelationship);

  // Attributes
  public static final String ACTIVITY_KEY = ACTIVITY.key();
  public static final String AIRCRAFT_MAKE_KEY = AIRCRAFT_MAKE.key();
  public static final String AIRCRAFT_MISSING_KEY = AIRCRAFT_MISSING.key();
  public static final String AIRCRAFT_MODEL_KEY = AIRCRAFT_MODEL.key();
  public static final String AIRCRAFT_OPERATOR_KEY = AIRCRAFT_OPERATOR.key();
  public static final String CABIN_CREW_FATAL_KEY = CABIN_CREW_FATAL.key();
  public static final String CABIN_CREW_MINOR_KEY = CABIN_CREW_MINOR.key();
  public static final String CABIN_CREW_NONE_KEY = CABIN_CREW_NONE.key();
  public static final String CABIN_CREW_SERIOUS_KEY = CABIN_CREW_SERIOUS.key();
  public static final String CABIN_CREW_UNK_KEY = CABIN_CREW_UNK.key();
  public static final String CITY_KEY = CITY.key();
  public static final String COUNTRY_KEY = COUNTRY.key();
  public static final String DAMAGE_KEY = DAMAGE.key();
  public static final String DESCRIPTION_KEY = DESCRIPTION.key();
  public static final String ENTRY_DATE_KEY = ENTRY_DATE.key();
  public static final String EVENT_TYPE_KEY = EVENT_TYPE.key();
  public static final String FAA_FSDO_KEY = FAA_FSDO.key();
  public static final String FLIGHT_CREW_FATAL_KEY = FLIGHT_CREW_FATAL.key();
  public static final String FLIGHT_CREW_MINOR_KEY = FLIGHT_CREW_MINOR.key();
  public static final String FLIGHT_CREW_NONE_KEY = FLIGHT_CREW_NONE.key();
  public static final String FLIGHT_CREW_SERIOUS_KEY = FLIGHT_CREW_SERIOUS.key();
  public static final String FLIGHT_CREW_UNK_KEY = FLIGHT_CREW_UNK.key();
  public static final String FLIGHT_NUMBER_KEY = FLIGHT_NUMBER.key();
  public static final String FLIGHT_PHASE_KEY = FLIGHT_PHASE.key();
  public static final String GROUND_FATAL_KEY = GROUND_FATAL.key();
  public static final String GROUND_MINOR_KEY = GROUND_MINOR.key();
  public static final String GROUND_NONE_KEY = GROUND_NONE.key();
  public static final String GROUND_SERIOUS_KEY = GROUND_SERIOUS.key();
  public static final String GROUND_UNK_KEY = GROUND_UNK.key();
  public static final String HIGHEST_INJURY_KEY = HIGHEST_INJURY.key();
  public static final String INCIDENT_DATE_KEY = INCIDENT_DATE.key();
  public static final String INCIDENT_TIME_KEY = INCIDENT_TIME.key();
  public static final String OPERATION_KEY = OPERATION.key();
  public static final String PAX_FATAL_KEY = PAX_FATAL.key();
  public static final String PAX_MINOR_KEY = PAX_MINOR.key();
  public static final String PAX_NONE_KEY = PAX_NONE.key();
  public static final String PAX_SERIOUS_KEY = PAX_SERIOUS.key();
  public static final String PAX_UNK_KEY = PAX_UNK.key();
  public static final String REGISTRATION_KEY = REGISTRATION.key();
  public static final String STATE_KEY = STATE.key();
  public static final String TOTAL_FATAL_KEY = TOTAL_FATAL.key();
  public static final String UPDATED_KEY = UPDATED.key();

  // Relationships
  public static final String REPORT_KEY = REPORT.key();

  private static final Logger log = LoggerFactory.getLogger(_ASIASIncident.class);

  public ASIASIncident localInstanceIn(EOEditingContext editingContext) {
    ASIASIncident localInstance = (ASIASIncident)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activity() {
    return (String) storedValueForKey(_ASIASIncident.ACTIVITY_KEY);
  }

  public void setActivity(String value) {
    log.debug( "updating activity from {} to {}", activity(), value);
    takeStoredValueForKey(value, _ASIASIncident.ACTIVITY_KEY);
  }

  public String aircraftMake() {
    return (String) storedValueForKey(_ASIASIncident.AIRCRAFT_MAKE_KEY);
  }

  public void setAircraftMake(String value) {
    log.debug( "updating aircraftMake from {} to {}", aircraftMake(), value);
    takeStoredValueForKey(value, _ASIASIncident.AIRCRAFT_MAKE_KEY);
  }

  public String aircraftMissing() {
    return (String) storedValueForKey(_ASIASIncident.AIRCRAFT_MISSING_KEY);
  }

  public void setAircraftMissing(String value) {
    log.debug( "updating aircraftMissing from {} to {}", aircraftMissing(), value);
    takeStoredValueForKey(value, _ASIASIncident.AIRCRAFT_MISSING_KEY);
  }

  public String aircraftModel() {
    return (String) storedValueForKey(_ASIASIncident.AIRCRAFT_MODEL_KEY);
  }

  public void setAircraftModel(String value) {
    log.debug( "updating aircraftModel from {} to {}", aircraftModel(), value);
    takeStoredValueForKey(value, _ASIASIncident.AIRCRAFT_MODEL_KEY);
  }

  public String aircraftOperator() {
    return (String) storedValueForKey(_ASIASIncident.AIRCRAFT_OPERATOR_KEY);
  }

  public void setAircraftOperator(String value) {
    log.debug( "updating aircraftOperator from {} to {}", aircraftOperator(), value);
    takeStoredValueForKey(value, _ASIASIncident.AIRCRAFT_OPERATOR_KEY);
  }

  public Integer cabinCrewFatal() {
    return (Integer) storedValueForKey(_ASIASIncident.CABIN_CREW_FATAL_KEY);
  }

  public void setCabinCrewFatal(Integer value) {
    log.debug( "updating cabinCrewFatal from {} to {}", cabinCrewFatal(), value);
    takeStoredValueForKey(value, _ASIASIncident.CABIN_CREW_FATAL_KEY);
  }

  public Integer cabinCrewMinor() {
    return (Integer) storedValueForKey(_ASIASIncident.CABIN_CREW_MINOR_KEY);
  }

  public void setCabinCrewMinor(Integer value) {
    log.debug( "updating cabinCrewMinor from {} to {}", cabinCrewMinor(), value);
    takeStoredValueForKey(value, _ASIASIncident.CABIN_CREW_MINOR_KEY);
  }

  public Integer cabinCrewNone() {
    return (Integer) storedValueForKey(_ASIASIncident.CABIN_CREW_NONE_KEY);
  }

  public void setCabinCrewNone(Integer value) {
    log.debug( "updating cabinCrewNone from {} to {}", cabinCrewNone(), value);
    takeStoredValueForKey(value, _ASIASIncident.CABIN_CREW_NONE_KEY);
  }

  public Integer cabinCrewSerious() {
    return (Integer) storedValueForKey(_ASIASIncident.CABIN_CREW_SERIOUS_KEY);
  }

  public void setCabinCrewSerious(Integer value) {
    log.debug( "updating cabinCrewSerious from {} to {}", cabinCrewSerious(), value);
    takeStoredValueForKey(value, _ASIASIncident.CABIN_CREW_SERIOUS_KEY);
  }

  public Integer cabinCrewUnk() {
    return (Integer) storedValueForKey(_ASIASIncident.CABIN_CREW_UNK_KEY);
  }

  public void setCabinCrewUnk(Integer value) {
    log.debug( "updating cabinCrewUnk from {} to {}", cabinCrewUnk(), value);
    takeStoredValueForKey(value, _ASIASIncident.CABIN_CREW_UNK_KEY);
  }

  public String city() {
    return (String) storedValueForKey(_ASIASIncident.CITY_KEY);
  }

  public void setCity(String value) {
    log.debug( "updating city from {} to {}", city(), value);
    takeStoredValueForKey(value, _ASIASIncident.CITY_KEY);
  }

  public String country() {
    return (String) storedValueForKey(_ASIASIncident.COUNTRY_KEY);
  }

  public void setCountry(String value) {
    log.debug( "updating country from {} to {}", country(), value);
    takeStoredValueForKey(value, _ASIASIncident.COUNTRY_KEY);
  }

  public String damage() {
    return (String) storedValueForKey(_ASIASIncident.DAMAGE_KEY);
  }

  public void setDamage(String value) {
    log.debug( "updating damage from {} to {}", damage(), value);
    takeStoredValueForKey(value, _ASIASIncident.DAMAGE_KEY);
  }

  public String description() {
    return (String) storedValueForKey(_ASIASIncident.DESCRIPTION_KEY);
  }

  public void setDescription(String value) {
    log.debug( "updating description from {} to {}", description(), value);
    takeStoredValueForKey(value, _ASIASIncident.DESCRIPTION_KEY);
  }

  public String entryDate() {
    return (String) storedValueForKey(_ASIASIncident.ENTRY_DATE_KEY);
  }

  public void setEntryDate(String value) {
    log.debug( "updating entryDate from {} to {}", entryDate(), value);
    takeStoredValueForKey(value, _ASIASIncident.ENTRY_DATE_KEY);
  }

  public String eventType() {
    return (String) storedValueForKey(_ASIASIncident.EVENT_TYPE_KEY);
  }

  public void setEventType(String value) {
    log.debug( "updating eventType from {} to {}", eventType(), value);
    takeStoredValueForKey(value, _ASIASIncident.EVENT_TYPE_KEY);
  }

  public String faaFsdo() {
    return (String) storedValueForKey(_ASIASIncident.FAA_FSDO_KEY);
  }

  public void setFaaFsdo(String value) {
    log.debug( "updating faaFsdo from {} to {}", faaFsdo(), value);
    takeStoredValueForKey(value, _ASIASIncident.FAA_FSDO_KEY);
  }

  public Integer flightCrewFatal() {
    return (Integer) storedValueForKey(_ASIASIncident.FLIGHT_CREW_FATAL_KEY);
  }

  public void setFlightCrewFatal(Integer value) {
    log.debug( "updating flightCrewFatal from {} to {}", flightCrewFatal(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_CREW_FATAL_KEY);
  }

  public Integer flightCrewMinor() {
    return (Integer) storedValueForKey(_ASIASIncident.FLIGHT_CREW_MINOR_KEY);
  }

  public void setFlightCrewMinor(Integer value) {
    log.debug( "updating flightCrewMinor from {} to {}", flightCrewMinor(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_CREW_MINOR_KEY);
  }

  public Integer flightCrewNone() {
    return (Integer) storedValueForKey(_ASIASIncident.FLIGHT_CREW_NONE_KEY);
  }

  public void setFlightCrewNone(Integer value) {
    log.debug( "updating flightCrewNone from {} to {}", flightCrewNone(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_CREW_NONE_KEY);
  }

  public Integer flightCrewSerious() {
    return (Integer) storedValueForKey(_ASIASIncident.FLIGHT_CREW_SERIOUS_KEY);
  }

  public void setFlightCrewSerious(Integer value) {
    log.debug( "updating flightCrewSerious from {} to {}", flightCrewSerious(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_CREW_SERIOUS_KEY);
  }

  public Integer flightCrewUnk() {
    return (Integer) storedValueForKey(_ASIASIncident.FLIGHT_CREW_UNK_KEY);
  }

  public void setFlightCrewUnk(Integer value) {
    log.debug( "updating flightCrewUnk from {} to {}", flightCrewUnk(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_CREW_UNK_KEY);
  }

  public String flightNumber() {
    return (String) storedValueForKey(_ASIASIncident.FLIGHT_NUMBER_KEY);
  }

  public void setFlightNumber(String value) {
    log.debug( "updating flightNumber from {} to {}", flightNumber(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_NUMBER_KEY);
  }

  public String flightPhase() {
    return (String) storedValueForKey(_ASIASIncident.FLIGHT_PHASE_KEY);
  }

  public void setFlightPhase(String value) {
    log.debug( "updating flightPhase from {} to {}", flightPhase(), value);
    takeStoredValueForKey(value, _ASIASIncident.FLIGHT_PHASE_KEY);
  }

  public Integer groundFatal() {
    return (Integer) storedValueForKey(_ASIASIncident.GROUND_FATAL_KEY);
  }

  public void setGroundFatal(Integer value) {
    log.debug( "updating groundFatal from {} to {}", groundFatal(), value);
    takeStoredValueForKey(value, _ASIASIncident.GROUND_FATAL_KEY);
  }

  public Integer groundMinor() {
    return (Integer) storedValueForKey(_ASIASIncident.GROUND_MINOR_KEY);
  }

  public void setGroundMinor(Integer value) {
    log.debug( "updating groundMinor from {} to {}", groundMinor(), value);
    takeStoredValueForKey(value, _ASIASIncident.GROUND_MINOR_KEY);
  }

  public Integer groundNone() {
    return (Integer) storedValueForKey(_ASIASIncident.GROUND_NONE_KEY);
  }

  public void setGroundNone(Integer value) {
    log.debug( "updating groundNone from {} to {}", groundNone(), value);
    takeStoredValueForKey(value, _ASIASIncident.GROUND_NONE_KEY);
  }

  public Integer groundSerious() {
    return (Integer) storedValueForKey(_ASIASIncident.GROUND_SERIOUS_KEY);
  }

  public void setGroundSerious(Integer value) {
    log.debug( "updating groundSerious from {} to {}", groundSerious(), value);
    takeStoredValueForKey(value, _ASIASIncident.GROUND_SERIOUS_KEY);
  }

  public Integer groundUnk() {
    return (Integer) storedValueForKey(_ASIASIncident.GROUND_UNK_KEY);
  }

  public void setGroundUnk(Integer value) {
    log.debug( "updating groundUnk from {} to {}", groundUnk(), value);
    takeStoredValueForKey(value, _ASIASIncident.GROUND_UNK_KEY);
  }

  public String highestInjury() {
    return (String) storedValueForKey(_ASIASIncident.HIGHEST_INJURY_KEY);
  }

  public void setHighestInjury(String value) {
    log.debug( "updating highestInjury from {} to {}", highestInjury(), value);
    takeStoredValueForKey(value, _ASIASIncident.HIGHEST_INJURY_KEY);
  }

  public String incidentDate() {
    return (String) storedValueForKey(_ASIASIncident.INCIDENT_DATE_KEY);
  }

  public void setIncidentDate(String value) {
    log.debug( "updating incidentDate from {} to {}", incidentDate(), value);
    takeStoredValueForKey(value, _ASIASIncident.INCIDENT_DATE_KEY);
  }

  public String incidentTime() {
    return (String) storedValueForKey(_ASIASIncident.INCIDENT_TIME_KEY);
  }

  public void setIncidentTime(String value) {
    log.debug( "updating incidentTime from {} to {}", incidentTime(), value);
    takeStoredValueForKey(value, _ASIASIncident.INCIDENT_TIME_KEY);
  }

  public String operation() {
    return (String) storedValueForKey(_ASIASIncident.OPERATION_KEY);
  }

  public void setOperation(String value) {
    log.debug( "updating operation from {} to {}", operation(), value);
    takeStoredValueForKey(value, _ASIASIncident.OPERATION_KEY);
  }

  public Integer paxFatal() {
    return (Integer) storedValueForKey(_ASIASIncident.PAX_FATAL_KEY);
  }

  public void setPaxFatal(Integer value) {
    log.debug( "updating paxFatal from {} to {}", paxFatal(), value);
    takeStoredValueForKey(value, _ASIASIncident.PAX_FATAL_KEY);
  }

  public Integer paxMinor() {
    return (Integer) storedValueForKey(_ASIASIncident.PAX_MINOR_KEY);
  }

  public void setPaxMinor(Integer value) {
    log.debug( "updating paxMinor from {} to {}", paxMinor(), value);
    takeStoredValueForKey(value, _ASIASIncident.PAX_MINOR_KEY);
  }

  public Integer paxNone() {
    return (Integer) storedValueForKey(_ASIASIncident.PAX_NONE_KEY);
  }

  public void setPaxNone(Integer value) {
    log.debug( "updating paxNone from {} to {}", paxNone(), value);
    takeStoredValueForKey(value, _ASIASIncident.PAX_NONE_KEY);
  }

  public Integer paxSerious() {
    return (Integer) storedValueForKey(_ASIASIncident.PAX_SERIOUS_KEY);
  }

  public void setPaxSerious(Integer value) {
    log.debug( "updating paxSerious from {} to {}", paxSerious(), value);
    takeStoredValueForKey(value, _ASIASIncident.PAX_SERIOUS_KEY);
  }

  public Integer paxUnk() {
    return (Integer) storedValueForKey(_ASIASIncident.PAX_UNK_KEY);
  }

  public void setPaxUnk(Integer value) {
    log.debug( "updating paxUnk from {} to {}", paxUnk(), value);
    takeStoredValueForKey(value, _ASIASIncident.PAX_UNK_KEY);
  }

  public String registration() {
    return (String) storedValueForKey(_ASIASIncident.REGISTRATION_KEY);
  }

  public void setRegistration(String value) {
    log.debug( "updating registration from {} to {}", registration(), value);
    takeStoredValueForKey(value, _ASIASIncident.REGISTRATION_KEY);
  }

  public String state() {
    return (String) storedValueForKey(_ASIASIncident.STATE_KEY);
  }

  public void setState(String value) {
    log.debug( "updating state from {} to {}", state(), value);
    takeStoredValueForKey(value, _ASIASIncident.STATE_KEY);
  }

  public Integer totalFatal() {
    return (Integer) storedValueForKey(_ASIASIncident.TOTAL_FATAL_KEY);
  }

  public void setTotalFatal(Integer value) {
    log.debug( "updating totalFatal from {} to {}", totalFatal(), value);
    takeStoredValueForKey(value, _ASIASIncident.TOTAL_FATAL_KEY);
  }

  public String updated() {
    return (String) storedValueForKey(_ASIASIncident.UPDATED_KEY);
  }

  public void setUpdated(String value) {
    log.debug( "updating updated from {} to {}", updated(), value);
    takeStoredValueForKey(value, _ASIASIncident.UPDATED_KEY);
  }

  public org.opencalaccess.asias.eo.ASIASDayReport report() {
    return (org.opencalaccess.asias.eo.ASIASDayReport)storedValueForKey(_ASIASIncident.REPORT_KEY);
  }

  public void setReport(org.opencalaccess.asias.eo.ASIASDayReport value) {
    takeStoredValueForKey(value, _ASIASIncident.REPORT_KEY);
  }

  public void setReportRelationship(org.opencalaccess.asias.eo.ASIASDayReport value) {
    log.debug("updating report from {} to {}", report(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setReport(value);
    }
    else if (value == null) {
      org.opencalaccess.asias.eo.ASIASDayReport oldValue = report();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _ASIASIncident.REPORT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _ASIASIncident.REPORT_KEY);
    }
  }


  public static ASIASIncident createASIASIncident(EOEditingContext editingContext, String activity
, String aircraftMake
, String aircraftMissing
, String aircraftModel
, String aircraftOperator
, Integer cabinCrewFatal
, Integer cabinCrewMinor
, Integer cabinCrewNone
, Integer cabinCrewSerious
, Integer cabinCrewUnk
, String city
, String country
, String damage
, String description
, String entryDate
, String eventType
, String faaFsdo
, Integer flightCrewFatal
, Integer flightCrewMinor
, Integer flightCrewNone
, Integer flightCrewSerious
, Integer flightCrewUnk
, String flightNumber
, String flightPhase
, Integer groundFatal
, Integer groundMinor
, Integer groundNone
, Integer groundSerious
, Integer groundUnk
, String highestInjury
, String incidentDate
, String incidentTime
, String operation
, Integer paxFatal
, Integer paxMinor
, Integer paxNone
, Integer paxSerious
, Integer paxUnk
, String registration
, String state
, Integer totalFatal
, String updated
, org.opencalaccess.asias.eo.ASIASDayReport report) {
    ASIASIncident eo = (ASIASIncident) EOUtilities.createAndInsertInstance(editingContext, _ASIASIncident.ENTITY_NAME);
    eo.setActivity(activity);
    eo.setAircraftMake(aircraftMake);
    eo.setAircraftMissing(aircraftMissing);
    eo.setAircraftModel(aircraftModel);
    eo.setAircraftOperator(aircraftOperator);
    eo.setCabinCrewFatal(cabinCrewFatal);
    eo.setCabinCrewMinor(cabinCrewMinor);
    eo.setCabinCrewNone(cabinCrewNone);
    eo.setCabinCrewSerious(cabinCrewSerious);
    eo.setCabinCrewUnk(cabinCrewUnk);
    eo.setCity(city);
    eo.setCountry(country);
    eo.setDamage(damage);
    eo.setDescription(description);
    eo.setEntryDate(entryDate);
    eo.setEventType(eventType);
    eo.setFaaFsdo(faaFsdo);
    eo.setFlightCrewFatal(flightCrewFatal);
    eo.setFlightCrewMinor(flightCrewMinor);
    eo.setFlightCrewNone(flightCrewNone);
    eo.setFlightCrewSerious(flightCrewSerious);
    eo.setFlightCrewUnk(flightCrewUnk);
    eo.setFlightNumber(flightNumber);
    eo.setFlightPhase(flightPhase);
    eo.setGroundFatal(groundFatal);
    eo.setGroundMinor(groundMinor);
    eo.setGroundNone(groundNone);
    eo.setGroundSerious(groundSerious);
    eo.setGroundUnk(groundUnk);
    eo.setHighestInjury(highestInjury);
    eo.setIncidentDate(incidentDate);
    eo.setIncidentTime(incidentTime);
    eo.setOperation(operation);
    eo.setPaxFatal(paxFatal);
    eo.setPaxMinor(paxMinor);
    eo.setPaxNone(paxNone);
    eo.setPaxSerious(paxSerious);
    eo.setPaxUnk(paxUnk);
    eo.setRegistration(registration);
    eo.setState(state);
    eo.setTotalFatal(totalFatal);
    eo.setUpdated(updated);
    eo.setReportRelationship(report);
    return eo;
  }

  public static ERXFetchSpecification<ASIASIncident> fetchSpec() {
    return new ERXFetchSpecification<ASIASIncident>(_ASIASIncident.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ASIASIncident> fetchAllASIASIncidents(EOEditingContext editingContext) {
    return _ASIASIncident.fetchAllASIASIncidents(editingContext, null);
  }

  public static NSArray<ASIASIncident> fetchAllASIASIncidents(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ASIASIncident.fetchASIASIncidents(editingContext, null, sortOrderings);
  }

  public static NSArray<ASIASIncident> fetchASIASIncidents(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ASIASIncident> fetchSpec = new ERXFetchSpecification<ASIASIncident>(_ASIASIncident.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ASIASIncident> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ASIASIncident fetchASIASIncident(EOEditingContext editingContext, String keyName, Object value) {
    return _ASIASIncident.fetchASIASIncident(editingContext, ERXQ.equals(keyName, value));
  }

  public static ASIASIncident fetchASIASIncident(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ASIASIncident> eoObjects = _ASIASIncident.fetchASIASIncidents(editingContext, qualifier, null);
    ASIASIncident eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one ASIASIncident that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ASIASIncident fetchRequiredASIASIncident(EOEditingContext editingContext, String keyName, Object value) {
    return _ASIASIncident.fetchRequiredASIASIncident(editingContext, ERXQ.equals(keyName, value));
  }

  public static ASIASIncident fetchRequiredASIASIncident(EOEditingContext editingContext, EOQualifier qualifier) {
    ASIASIncident eoObject = _ASIASIncident.fetchASIASIncident(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no ASIASIncident that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ASIASIncident localInstanceIn(EOEditingContext editingContext, ASIASIncident eo) {
    ASIASIncident localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
