// DO NOT EDIT.  Make changes to OsmRelationCheck.java instead.
package org.opencalaccess.boundaries.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _OsmRelationCheck extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "OsmRelationCheck";

  // Attribute Keys
  public static final ERXKey<Long> CHECKED_TIME = new ERXKey<Long>("checkedTime", Type.Attribute);
  public static final ERXKey<Integer> CHECK_RESULT = new ERXKey<Integer>("checkResult", Type.Attribute);
  public static final ERXKey<String> MESSAGE = new ERXKey<String>("message", Type.Attribute);
  public static final ERXKey<String> OSM_UPDATE_DATE = new ERXKey<String>("osmUpdateDate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.boundaries.eo.OsmRelation> RELATION = new ERXKey<org.opencalaccess.boundaries.eo.OsmRelation>("relation", Type.ToOneRelationship);

  // Attributes
  public static final String CHECKED_TIME_KEY = CHECKED_TIME.key();
  public static final String CHECK_RESULT_KEY = CHECK_RESULT.key();
  public static final String MESSAGE_KEY = MESSAGE.key();
  public static final String OSM_UPDATE_DATE_KEY = OSM_UPDATE_DATE.key();

  // Relationships
  public static final String RELATION_KEY = RELATION.key();

  private static final Logger log = LoggerFactory.getLogger(_OsmRelationCheck.class);

  public OsmRelationCheck localInstanceIn(EOEditingContext editingContext) {
    OsmRelationCheck localInstance = (OsmRelationCheck)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long checkedTime() {
    return (Long) storedValueForKey(_OsmRelationCheck.CHECKED_TIME_KEY);
  }

  public void setCheckedTime(Long value) {
    log.debug( "updating checkedTime from {} to {}", checkedTime(), value);
    takeStoredValueForKey(value, _OsmRelationCheck.CHECKED_TIME_KEY);
  }

  public Integer checkResult() {
    return (Integer) storedValueForKey(_OsmRelationCheck.CHECK_RESULT_KEY);
  }

  public void setCheckResult(Integer value) {
    log.debug( "updating checkResult from {} to {}", checkResult(), value);
    takeStoredValueForKey(value, _OsmRelationCheck.CHECK_RESULT_KEY);
  }

  public String message() {
    return (String) storedValueForKey(_OsmRelationCheck.MESSAGE_KEY);
  }

  public void setMessage(String value) {
    log.debug( "updating message from {} to {}", message(), value);
    takeStoredValueForKey(value, _OsmRelationCheck.MESSAGE_KEY);
  }

  public String osmUpdateDate() {
    return (String) storedValueForKey(_OsmRelationCheck.OSM_UPDATE_DATE_KEY);
  }

  public void setOsmUpdateDate(String value) {
    log.debug( "updating osmUpdateDate from {} to {}", osmUpdateDate(), value);
    takeStoredValueForKey(value, _OsmRelationCheck.OSM_UPDATE_DATE_KEY);
  }

  public org.opencalaccess.boundaries.eo.OsmRelation relation() {
    return (org.opencalaccess.boundaries.eo.OsmRelation)storedValueForKey(_OsmRelationCheck.RELATION_KEY);
  }

  public void setRelation(org.opencalaccess.boundaries.eo.OsmRelation value) {
    takeStoredValueForKey(value, _OsmRelationCheck.RELATION_KEY);
  }

  public void setRelationRelationship(org.opencalaccess.boundaries.eo.OsmRelation value) {
    log.debug("updating relation from {} to {}", relation(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setRelation(value);
    }
    else if (value == null) {
      org.opencalaccess.boundaries.eo.OsmRelation oldValue = relation();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _OsmRelationCheck.RELATION_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _OsmRelationCheck.RELATION_KEY);
    }
  }


  public static OsmRelationCheck createOsmRelationCheck(EOEditingContext editingContext, Integer checkResult
, org.opencalaccess.boundaries.eo.OsmRelation relation) {
    OsmRelationCheck eo = (OsmRelationCheck) EOUtilities.createAndInsertInstance(editingContext, _OsmRelationCheck.ENTITY_NAME);
    eo.setCheckResult(checkResult);
    eo.setRelationRelationship(relation);
    return eo;
  }

  public static ERXFetchSpecification<OsmRelationCheck> fetchSpec() {
    return new ERXFetchSpecification<OsmRelationCheck>(_OsmRelationCheck.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<OsmRelationCheck> fetchAllOsmRelationChecks(EOEditingContext editingContext) {
    return _OsmRelationCheck.fetchAllOsmRelationChecks(editingContext, null);
  }

  public static NSArray<OsmRelationCheck> fetchAllOsmRelationChecks(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _OsmRelationCheck.fetchOsmRelationChecks(editingContext, null, sortOrderings);
  }

  public static NSArray<OsmRelationCheck> fetchOsmRelationChecks(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<OsmRelationCheck> fetchSpec = new ERXFetchSpecification<OsmRelationCheck>(_OsmRelationCheck.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<OsmRelationCheck> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static OsmRelationCheck fetchOsmRelationCheck(EOEditingContext editingContext, String keyName, Object value) {
    return _OsmRelationCheck.fetchOsmRelationCheck(editingContext, ERXQ.equals(keyName, value));
  }

  public static OsmRelationCheck fetchOsmRelationCheck(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<OsmRelationCheck> eoObjects = _OsmRelationCheck.fetchOsmRelationChecks(editingContext, qualifier, null);
    OsmRelationCheck eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one OsmRelationCheck that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OsmRelationCheck fetchRequiredOsmRelationCheck(EOEditingContext editingContext, String keyName, Object value) {
    return _OsmRelationCheck.fetchRequiredOsmRelationCheck(editingContext, ERXQ.equals(keyName, value));
  }

  public static OsmRelationCheck fetchRequiredOsmRelationCheck(EOEditingContext editingContext, EOQualifier qualifier) {
    OsmRelationCheck eoObject = _OsmRelationCheck.fetchOsmRelationCheck(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no OsmRelationCheck that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OsmRelationCheck localInstanceIn(EOEditingContext editingContext, OsmRelationCheck eo) {
    OsmRelationCheck localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
