package org.opencalaccess.cafppc.eo;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.net.URL;

import org.opencalaccess.U;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.foundation.NSArray;

import er.extensions.foundation.ERXValueUtilities;

public class FppcWarning extends _FppcWarning {

	private static final long serialVersionUID = 2780873450850580218L;

	private static final String tmpFile = "/tmp/xxx.pdf";

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(FppcWarning.class);

	public FppcWarningText latestText() {
		for (FppcWarningText text : this.texts()) {
			if (ERXValueUtilities.isNull(text.updated())) {
				return text;
			}
		}
		return null;
	}

	public void addText() {

//		PDDocument document = null;

		File inFile = null;

		StringBuffer str = new StringBuffer();

		try {

			BufferedInputStream in = null;
			FileOutputStream fout = null;
			try {
				in = new BufferedInputStream(new URL(this.fppcUrl()).openStream());
				fout = new FileOutputStream(tmpFile);

				final byte data[] = new byte[1024];
				int count;
				while ((count = in.read(data, 0, 1024)) != -1) {
					fout.write(data, 0, count);
					/*
					 * byte next[] = Arrays.copyOf(data, count); idx++; bytes.put(idx, next);
					 */
				}
			} catch (java.io.IOException ioe) {

			} finally {
				try {
					if (in != null) {
						in.close();
					}
					if (fout != null) {
						fout.close();
					}
				} catch (java.io.IOException ioe) {
					System.err.println("What the heck?");
				}
			}

			inFile = new File(tmpFile);
			System.out.println("Tmp file length: " + inFile.length());

//			try {
//				document = PDDocument.load(inFile);
//				System.out.println("document: " + document);
//
//				int pages = document.getNumberOfPages();
//				System.out.println("pages: " + pages);
//
//				for (int pageNum = 0; pageNum < pages; pageNum++) {
//
//					Rectangle rect = new Rectangle(10, 10, 600, 750);
//
//					PDPage page = document.getPage(pageNum);
//
//					PDFTextStripperByArea stripper = new PDFTextStripperByArea();
//					stripper.setSortByPosition(true);
//					stripper.addRegion("class1", rect);
//					stripper.extractRegions(page);
//
//					str.append(stripper.getTextForRegion("class1"));
//					str.append("\n");
//				}
//			} catch (java.io.IOException ioe) {
//				System.err.println("What the heck?");
//			}
//
		} finally {
 
		}

		@SuppressWarnings("unused")
		FppcWarningText text = FppcWarningText.createFppcWarningText(this.editingContext(), System.currentTimeMillis(),
				str.toString(), this);

		//this.addObjectToPropertyWithKey(text, FppcWarning.TEXTS_KEY);

		//this.fix();
	}

	public void fix() {

		FppcWarningText text = this.latestText();

		NSArray<String> lines = NSArray.componentsSeparatedByString(text.warningText(), "\n");

		// Find LetterDate in text of letter.
		//
		for (String line : lines) {

			line = line.trim();

			line = line.replaceAll("\\,", " ");
			line = line.replaceAll("\\.", " ");
			line = line.replaceAll("  ", " ");

			NSArray<String> dateStrParts = NSArray.componentsSeparatedByString(line, " ");

			if (dateStrParts.size() == 3) {

				String month = dateStrParts.get(0);

				if (month.length() < 3) {
					return;
				}

				month = month.substring(0, 1).toUpperCase() + month.substring(1).toLowerCase();

				boolean ok = U.longMonthToNum.containsKey(month);

				String day = null;
				String year = null;
				if (ok) {
					try {
						int d = Integer.valueOf(dateStrParts.get(1));
						day = (d < 10) ? "0" + d : "" + d;
						year = dateStrParts.get(2);
					} catch (NumberFormatException e) {
					}
				}

				if (ok && day != null && year != null) {
					String letterDate = year + "-" + U.longMonthToNum.get(month) + "-" + day;
					if (letterDate.length() != 10) {
						System.out.println("What? letterDate = \"" + letterDate + "\"");
					} else {
						text.warning().setLetterDate(letterDate);
						break;
					}
				}
			}
		}

		// Find LetterDate in text of letter.
		//
		if (text.title() == null) {
			for (int idx = 0; idx < lines.size(); idx++) {

				String line = lines.get(idx);

				if (line.startsWith("Dear") && line.endsWith(":")) {
					int jdx = idx - 1;
					while (lines.get(jdx).equals("")) {
						jdx--;
					}

					text.setTitle(lines.get(jdx));
				}
			}
		}
	}
}
