package org.opencalaccess.cafppc.eo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSRange;

public class FppcWarningText extends _FppcWarningText {

	private static final long serialVersionUID = 8120337237746089626L;

	private static final String CR = new String(new char[] { (char)13 });

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(FppcWarningText.class);

	public void fixTitle() {

		int dateFoundAt = -1;
		int dearFoundAt = -1;

		NSArray<String> lines = NSArray.componentsSeparatedByString(this.warningText(), "\n");

		for (int idx = 0; idx < lines.size(); idx++) {

			String line = lines.get(idx);

			if (line.startsWith("Dear") && dearFoundAt < 0) { dearFoundAt = idx; }
			if (line.startsWith("January") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("February") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("March") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("April") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("May") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("June") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("July") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("August") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("September") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("October") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("November") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
			if (line.startsWith("December") && dateFoundAt < 0) { dateFoundAt = idx + 1; }
		}

		if (dearFoundAt < 0) {
			this.setTitle("INVALID");
		} else {

			if (dateFoundAt < 0 || dateFoundAt > dearFoundAt) {
				dateFoundAt = 0;
			}

			NSArray<String> sublines = lines.subarrayWithRange(new NSRange(dateFoundAt, dearFoundAt - dateFoundAt));

			String title = sublines.componentsJoinedByString(". ");

			this.setTitle(title);

			String caseNum = new String(title);

			if (caseNum.indexOf("FPPC No.") > 0) {
				caseNum = caseNum.substring(caseNum.indexOf("FPPC No.") + "FPPC No.".length());
			} else {
				if (caseNum.indexOf("FPPC Case No.") > 0) {
					caseNum = caseNum.substring(caseNum.indexOf("FPPC Case No.") + "FPPC Case No.".length());
				} else {
					if (caseNum.indexOf("Case No.") > 0) {
						caseNum = caseNum.substring(caseNum.indexOf("Case No.") + "Case No.".length());
					}
				}
			}

			caseNum = caseNum.trim();
			caseNum = caseNum.substring(0, caseNum.indexOf(" "));
			caseNum = caseNum.replaceAll(",", "");
			caseNum = caseNum.replaceAll(";", "");
			caseNum = caseNum.replaceAll(":", "");

			System.err.println("case number = \"" + caseNum + "\"");

			FppcCase fppcCase = FppcCase.fetchFppcCase(this.editingContext(), FppcCase.NAME_KEY, caseNum);

			if (fppcCase == null) {
				fppcCase = FppcCase.createFppcCase(this.editingContext(), caseNum);
			}

			this.warning().setFppcCase(fppcCase);
		}
	}

	
	public String titleMarkup() {
		NSArray<String> parts = NSArray.componentsSeparatedByString(this.title(), CR);
		StringBuilder str = new StringBuilder();
		for (String part : parts) {
			str.append(part);
			str.append("<br/>");
		}
		return str.toString();
	}
}
