// DO NOT EDIT.  Make changes to FppcCase.java instead.
package org.opencalaccess.cafppc.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _FppcCase extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "FppcCase";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cafppc.eo.FppcWarning> WARNINGS = new ERXKey<org.opencalaccess.cafppc.eo.FppcWarning>("warnings", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String WARNINGS_KEY = WARNINGS.key();

  private static final Logger log = LoggerFactory.getLogger(_FppcCase.class);

  public FppcCase localInstanceIn(EOEditingContext editingContext) {
    FppcCase localInstance = (FppcCase)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_FppcCase.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _FppcCase.NAME_KEY);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarning> warnings() {
    return (NSArray<org.opencalaccess.cafppc.eo.FppcWarning>)storedValueForKey(_FppcCase.WARNINGS_KEY);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarning> warnings(EOQualifier qualifier) {
    return warnings(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarning> warnings(EOQualifier qualifier, boolean fetch) {
    return warnings(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarning> warnings(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cafppc.eo.FppcWarning> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cafppc.eo.FppcWarning.FPPC_CASE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cafppc.eo.FppcWarning.fetchFppcWarnings(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = warnings();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cafppc.eo.FppcWarning>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cafppc.eo.FppcWarning>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToWarnings(org.opencalaccess.cafppc.eo.FppcWarning object) {
    includeObjectIntoPropertyWithKey(object, _FppcCase.WARNINGS_KEY);
  }

  public void removeFromWarnings(org.opencalaccess.cafppc.eo.FppcWarning object) {
    excludeObjectFromPropertyWithKey(object, _FppcCase.WARNINGS_KEY);
  }

  public void addToWarningsRelationship(org.opencalaccess.cafppc.eo.FppcWarning object) {
    log.debug("adding {} to warnings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToWarnings(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _FppcCase.WARNINGS_KEY);
    }
  }

  public void removeFromWarningsRelationship(org.opencalaccess.cafppc.eo.FppcWarning object) {
    log.debug("removing {} from warnings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromWarnings(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _FppcCase.WARNINGS_KEY);
    }
  }

  public org.opencalaccess.cafppc.eo.FppcWarning createWarningsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cafppc.eo.FppcWarning.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _FppcCase.WARNINGS_KEY);
    return (org.opencalaccess.cafppc.eo.FppcWarning) eo;
  }

  public void deleteWarningsRelationship(org.opencalaccess.cafppc.eo.FppcWarning object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _FppcCase.WARNINGS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllWarningsRelationships() {
    Enumeration<org.opencalaccess.cafppc.eo.FppcWarning> objects = warnings().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteWarningsRelationship(objects.nextElement());
    }
  }


  public static FppcCase createFppcCase(EOEditingContext editingContext, String name
) {
    FppcCase eo = (FppcCase) EOUtilities.createAndInsertInstance(editingContext, _FppcCase.ENTITY_NAME);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<FppcCase> fetchSpec() {
    return new ERXFetchSpecification<FppcCase>(_FppcCase.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<FppcCase> fetchAllFppcCases(EOEditingContext editingContext) {
    return _FppcCase.fetchAllFppcCases(editingContext, null);
  }

  public static NSArray<FppcCase> fetchAllFppcCases(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _FppcCase.fetchFppcCases(editingContext, null, sortOrderings);
  }

  public static NSArray<FppcCase> fetchFppcCases(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<FppcCase> fetchSpec = new ERXFetchSpecification<FppcCase>(_FppcCase.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<FppcCase> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static FppcCase fetchFppcCase(EOEditingContext editingContext, String keyName, Object value) {
    return _FppcCase.fetchFppcCase(editingContext, ERXQ.equals(keyName, value));
  }

  public static FppcCase fetchFppcCase(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<FppcCase> eoObjects = _FppcCase.fetchFppcCases(editingContext, qualifier, null);
    FppcCase eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one FppcCase that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static FppcCase fetchRequiredFppcCase(EOEditingContext editingContext, String keyName, Object value) {
    return _FppcCase.fetchRequiredFppcCase(editingContext, ERXQ.equals(keyName, value));
  }

  public static FppcCase fetchRequiredFppcCase(EOEditingContext editingContext, EOQualifier qualifier) {
    FppcCase eoObject = _FppcCase.fetchFppcCase(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no FppcCase that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static FppcCase localInstanceIn(EOEditingContext editingContext, FppcCase eo) {
    FppcCase localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
