// DO NOT EDIT.  Make changes to FppcWarning.java instead.
package org.opencalaccess.cafppc.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _FppcWarning extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "FppcWarning";

  // Attribute Keys
  public static final ERXKey<String> FPPC_URL = new ERXKey<String>("fppcUrl", Type.Attribute);
  public static final ERXKey<String> LETTER_DATE = new ERXKey<String>("letterDate", Type.Attribute);
  public static final ERXKey<Integer> PAGE_NUM = new ERXKey<Integer>("pageNum", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cafppc.eo.FppcCase> FPPC_CASE = new ERXKey<org.opencalaccess.cafppc.eo.FppcCase>("fppcCase", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.cafppc.eo.FppcWarningText> TEXTS = new ERXKey<org.opencalaccess.cafppc.eo.FppcWarningText>("texts", Type.ToManyRelationship);

  // Attributes
  public static final String FPPC_URL_KEY = FPPC_URL.key();
  public static final String LETTER_DATE_KEY = LETTER_DATE.key();
  public static final String PAGE_NUM_KEY = PAGE_NUM.key();

  // Relationships
  public static final String FPPC_CASE_KEY = FPPC_CASE.key();
  public static final String TEXTS_KEY = TEXTS.key();

  private static final Logger log = LoggerFactory.getLogger(_FppcWarning.class);

  public FppcWarning localInstanceIn(EOEditingContext editingContext) {
    FppcWarning localInstance = (FppcWarning)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String fppcUrl() {
    return (String) storedValueForKey(_FppcWarning.FPPC_URL_KEY);
  }

  public void setFppcUrl(String value) {
    log.debug( "updating fppcUrl from {} to {}", fppcUrl(), value);
    takeStoredValueForKey(value, _FppcWarning.FPPC_URL_KEY);
  }

  public String letterDate() {
    return (String) storedValueForKey(_FppcWarning.LETTER_DATE_KEY);
  }

  public void setLetterDate(String value) {
    log.debug( "updating letterDate from {} to {}", letterDate(), value);
    takeStoredValueForKey(value, _FppcWarning.LETTER_DATE_KEY);
  }

  public Integer pageNum() {
    return (Integer) storedValueForKey(_FppcWarning.PAGE_NUM_KEY);
  }

  public void setPageNum(Integer value) {
    log.debug( "updating pageNum from {} to {}", pageNum(), value);
    takeStoredValueForKey(value, _FppcWarning.PAGE_NUM_KEY);
  }

  public org.opencalaccess.cafppc.eo.FppcCase fppcCase() {
    return (org.opencalaccess.cafppc.eo.FppcCase)storedValueForKey(_FppcWarning.FPPC_CASE_KEY);
  }

  public void setFppcCase(org.opencalaccess.cafppc.eo.FppcCase value) {
    takeStoredValueForKey(value, _FppcWarning.FPPC_CASE_KEY);
  }

  public void setFppcCaseRelationship(org.opencalaccess.cafppc.eo.FppcCase value) {
    log.debug("updating fppcCase from {} to {}", fppcCase(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setFppcCase(value);
    }
    else if (value == null) {
      org.opencalaccess.cafppc.eo.FppcCase oldValue = fppcCase();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _FppcWarning.FPPC_CASE_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _FppcWarning.FPPC_CASE_KEY);
    }
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarningText> texts() {
    return (NSArray<org.opencalaccess.cafppc.eo.FppcWarningText>)storedValueForKey(_FppcWarning.TEXTS_KEY);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarningText> texts(EOQualifier qualifier) {
    return texts(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarningText> texts(EOQualifier qualifier, boolean fetch) {
    return texts(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cafppc.eo.FppcWarningText> texts(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cafppc.eo.FppcWarningText> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cafppc.eo.FppcWarningText.WARNING_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cafppc.eo.FppcWarningText.fetchFppcWarningTexts(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = texts();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cafppc.eo.FppcWarningText>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cafppc.eo.FppcWarningText>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToTexts(org.opencalaccess.cafppc.eo.FppcWarningText object) {
    includeObjectIntoPropertyWithKey(object, _FppcWarning.TEXTS_KEY);
  }

  public void removeFromTexts(org.opencalaccess.cafppc.eo.FppcWarningText object) {
    excludeObjectFromPropertyWithKey(object, _FppcWarning.TEXTS_KEY);
  }

  public void addToTextsRelationship(org.opencalaccess.cafppc.eo.FppcWarningText object) {
    log.debug("adding {} to texts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToTexts(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _FppcWarning.TEXTS_KEY);
    }
  }

  public void removeFromTextsRelationship(org.opencalaccess.cafppc.eo.FppcWarningText object) {
    log.debug("removing {} from texts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromTexts(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _FppcWarning.TEXTS_KEY);
    }
  }

  public org.opencalaccess.cafppc.eo.FppcWarningText createTextsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cafppc.eo.FppcWarningText.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _FppcWarning.TEXTS_KEY);
    return (org.opencalaccess.cafppc.eo.FppcWarningText) eo;
  }

  public void deleteTextsRelationship(org.opencalaccess.cafppc.eo.FppcWarningText object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _FppcWarning.TEXTS_KEY);
  }

  public void deleteAllTextsRelationships() {
    Enumeration<org.opencalaccess.cafppc.eo.FppcWarningText> objects = texts().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteTextsRelationship(objects.nextElement());
    }
  }


  public static FppcWarning createFppcWarning(EOEditingContext editingContext, String fppcUrl
) {
    FppcWarning eo = (FppcWarning) EOUtilities.createAndInsertInstance(editingContext, _FppcWarning.ENTITY_NAME);
    eo.setFppcUrl(fppcUrl);
    return eo;
  }

  public static ERXFetchSpecification<FppcWarning> fetchSpec() {
    return new ERXFetchSpecification<FppcWarning>(_FppcWarning.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<FppcWarning> fetchAllFppcWarnings(EOEditingContext editingContext) {
    return _FppcWarning.fetchAllFppcWarnings(editingContext, null);
  }

  public static NSArray<FppcWarning> fetchAllFppcWarnings(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _FppcWarning.fetchFppcWarnings(editingContext, null, sortOrderings);
  }

  public static NSArray<FppcWarning> fetchFppcWarnings(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<FppcWarning> fetchSpec = new ERXFetchSpecification<FppcWarning>(_FppcWarning.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<FppcWarning> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static FppcWarning fetchFppcWarning(EOEditingContext editingContext, String keyName, Object value) {
    return _FppcWarning.fetchFppcWarning(editingContext, ERXQ.equals(keyName, value));
  }

  public static FppcWarning fetchFppcWarning(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<FppcWarning> eoObjects = _FppcWarning.fetchFppcWarnings(editingContext, qualifier, null);
    FppcWarning eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one FppcWarning that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static FppcWarning fetchRequiredFppcWarning(EOEditingContext editingContext, String keyName, Object value) {
    return _FppcWarning.fetchRequiredFppcWarning(editingContext, ERXQ.equals(keyName, value));
  }

  public static FppcWarning fetchRequiredFppcWarning(EOEditingContext editingContext, EOQualifier qualifier) {
    FppcWarning eoObject = _FppcWarning.fetchFppcWarning(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no FppcWarning that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static FppcWarning localInstanceIn(EOEditingContext editingContext, FppcWarning eo) {
    FppcWarning localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
