// DO NOT EDIT.  Make changes to Named.java instead.
package org.opencalaccess.calaccess.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Named extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Named";

  // Attribute Keys
  public static final ERXKey<String> NAME_TYPE = new ERXKey<String>("nameType", Type.Attribute);
  public static final ERXKey<String> NAMF = new ERXKey<String>("namf", Type.Attribute);
  public static final ERXKey<String> NAML = new ERXKey<String>("naml", Type.Attribute);
  public static final ERXKey<String> NAMS = new ERXKey<String>("nams", Type.Attribute);
  public static final ERXKey<String> NAMT = new ERXKey<String>("namt", Type.Attribute);
  public static final ERXKey<String> TABLE_NAME = new ERXKey<String>("tableName", Type.Attribute);
  public static final ERXKey<Integer> TABLE_PK = new ERXKey<Integer>("tablePk", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.calaccess.eo.NamedUniq> UNIQ = new ERXKey<org.opencalaccess.calaccess.eo.NamedUniq>("uniq", Type.ToOneRelationship);

  // Attributes
  public static final String NAME_TYPE_KEY = NAME_TYPE.key();
  public static final String NAMF_KEY = NAMF.key();
  public static final String NAML_KEY = NAML.key();
  public static final String NAMS_KEY = NAMS.key();
  public static final String NAMT_KEY = NAMT.key();
  public static final String TABLE_NAME_KEY = TABLE_NAME.key();
  public static final String TABLE_PK_KEY = TABLE_PK.key();

  // Relationships
  public static final String UNIQ_KEY = UNIQ.key();

  private static final Logger log = LoggerFactory.getLogger(_Named.class);

  public Named localInstanceIn(EOEditingContext editingContext) {
    Named localInstance = (Named)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String nameType() {
    return (String) storedValueForKey(_Named.NAME_TYPE_KEY);
  }

  public void setNameType(String value) {
    log.debug( "updating nameType from {} to {}", nameType(), value);
    takeStoredValueForKey(value, _Named.NAME_TYPE_KEY);
  }

  public String namf() {
    return (String) storedValueForKey(_Named.NAMF_KEY);
  }

  public void setNamf(String value) {
    log.debug( "updating namf from {} to {}", namf(), value);
    takeStoredValueForKey(value, _Named.NAMF_KEY);
  }

  public String naml() {
    return (String) storedValueForKey(_Named.NAML_KEY);
  }

  public void setNaml(String value) {
    log.debug( "updating naml from {} to {}", naml(), value);
    takeStoredValueForKey(value, _Named.NAML_KEY);
  }

  public String nams() {
    return (String) storedValueForKey(_Named.NAMS_KEY);
  }

  public void setNams(String value) {
    log.debug( "updating nams from {} to {}", nams(), value);
    takeStoredValueForKey(value, _Named.NAMS_KEY);
  }

  public String namt() {
    return (String) storedValueForKey(_Named.NAMT_KEY);
  }

  public void setNamt(String value) {
    log.debug( "updating namt from {} to {}", namt(), value);
    takeStoredValueForKey(value, _Named.NAMT_KEY);
  }

  public String tableName() {
    return (String) storedValueForKey(_Named.TABLE_NAME_KEY);
  }

  public void setTableName(String value) {
    log.debug( "updating tableName from {} to {}", tableName(), value);
    takeStoredValueForKey(value, _Named.TABLE_NAME_KEY);
  }

  public Integer tablePk() {
    return (Integer) storedValueForKey(_Named.TABLE_PK_KEY);
  }

  public void setTablePk(Integer value) {
    log.debug( "updating tablePk from {} to {}", tablePk(), value);
    takeStoredValueForKey(value, _Named.TABLE_PK_KEY);
  }

  public org.opencalaccess.calaccess.eo.NamedUniq uniq() {
    return (org.opencalaccess.calaccess.eo.NamedUniq)storedValueForKey(_Named.UNIQ_KEY);
  }

  public void setUniq(org.opencalaccess.calaccess.eo.NamedUniq value) {
    takeStoredValueForKey(value, _Named.UNIQ_KEY);
  }

  public void setUniqRelationship(org.opencalaccess.calaccess.eo.NamedUniq value) {
    log.debug("updating uniq from {} to {}", uniq(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUniq(value);
    }
    else if (value == null) {
      org.opencalaccess.calaccess.eo.NamedUniq oldValue = uniq();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Named.UNIQ_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Named.UNIQ_KEY);
    }
  }


  public static Named createNamed(EOEditingContext editingContext, String nameType
, String namf
, String naml
, String nams
, String namt
, String tableName
, Integer tablePk
, org.opencalaccess.calaccess.eo.NamedUniq uniq) {
    Named eo = (Named) EOUtilities.createAndInsertInstance(editingContext, _Named.ENTITY_NAME);
    eo.setNameType(nameType);
    eo.setNamf(namf);
    eo.setNaml(naml);
    eo.setNams(nams);
    eo.setNamt(namt);
    eo.setTableName(tableName);
    eo.setTablePk(tablePk);
    eo.setUniqRelationship(uniq);
    return eo;
  }

  public static ERXFetchSpecification<Named> fetchSpec() {
    return new ERXFetchSpecification<Named>(_Named.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Named> fetchAllNameds(EOEditingContext editingContext) {
    return _Named.fetchAllNameds(editingContext, null);
  }

  public static NSArray<Named> fetchAllNameds(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Named.fetchNameds(editingContext, null, sortOrderings);
  }

  public static NSArray<Named> fetchNameds(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Named> fetchSpec = new ERXFetchSpecification<Named>(_Named.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Named> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Named fetchNamed(EOEditingContext editingContext, String keyName, Object value) {
    return _Named.fetchNamed(editingContext, ERXQ.equals(keyName, value));
  }

  public static Named fetchNamed(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Named> eoObjects = _Named.fetchNameds(editingContext, qualifier, null);
    Named eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Named that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Named fetchRequiredNamed(EOEditingContext editingContext, String keyName, Object value) {
    return _Named.fetchRequiredNamed(editingContext, ERXQ.equals(keyName, value));
  }

  public static Named fetchRequiredNamed(EOEditingContext editingContext, EOQualifier qualifier) {
    Named eoObject = _Named.fetchNamed(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Named that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Named localInstanceIn(EOEditingContext editingContext, Named eo) {
    Named localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
