// DO NOT EDIT.  Make changes to Problem.java instead.
package org.opencalaccess.calaccess.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Problem extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CalProblem";

  // Attribute Keys
  public static final ERXKey<String> DATABASE_NAME = new ERXKey<String>("databaseName", Type.Attribute);
  public static final ERXKey<Integer> PROBLEM_QUERY_PK = new ERXKey<Integer>("problemQueryPk", Type.Attribute);
  public static final ERXKey<Long> PROBLEMS_NUM = new ERXKey<Long>("problemsNum", Type.Attribute);
  public static final ERXKey<NSTimestamp> WHEN_CHECKED = new ERXKey<NSTimestamp>("whenChecked", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.calaccess.eo.ProblemQuery> PROBLEM_QUERY = new ERXKey<org.opencalaccess.calaccess.eo.ProblemQuery>("problemQuery", Type.ToOneRelationship);

  // Attributes
  public static final String DATABASE_NAME_KEY = DATABASE_NAME.key();
  public static final String PROBLEM_QUERY_PK_KEY = PROBLEM_QUERY_PK.key();
  public static final String PROBLEMS_NUM_KEY = PROBLEMS_NUM.key();
  public static final String WHEN_CHECKED_KEY = WHEN_CHECKED.key();

  // Relationships
  public static final String PROBLEM_QUERY_KEY = PROBLEM_QUERY.key();

  private static final Logger log = LoggerFactory.getLogger(_Problem.class);

  public Problem localInstanceIn(EOEditingContext editingContext) {
    Problem localInstance = (Problem)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String databaseName() {
    return (String) storedValueForKey(_Problem.DATABASE_NAME_KEY);
  }

  public void setDatabaseName(String value) {
    log.debug( "updating databaseName from {} to {}", databaseName(), value);
    takeStoredValueForKey(value, _Problem.DATABASE_NAME_KEY);
  }

  public Integer problemQueryPk() {
    return (Integer) storedValueForKey(_Problem.PROBLEM_QUERY_PK_KEY);
  }

  public void setProblemQueryPk(Integer value) {
    log.debug( "updating problemQueryPk from {} to {}", problemQueryPk(), value);
    takeStoredValueForKey(value, _Problem.PROBLEM_QUERY_PK_KEY);
  }

  public Long problemsNum() {
    return (Long) storedValueForKey(_Problem.PROBLEMS_NUM_KEY);
  }

  public void setProblemsNum(Long value) {
    log.debug( "updating problemsNum from {} to {}", problemsNum(), value);
    takeStoredValueForKey(value, _Problem.PROBLEMS_NUM_KEY);
  }

  public NSTimestamp whenChecked() {
    return (NSTimestamp) storedValueForKey(_Problem.WHEN_CHECKED_KEY);
  }

  public void setWhenChecked(NSTimestamp value) {
    log.debug( "updating whenChecked from {} to {}", whenChecked(), value);
    takeStoredValueForKey(value, _Problem.WHEN_CHECKED_KEY);
  }

  public org.opencalaccess.calaccess.eo.ProblemQuery problemQuery() {
    return (org.opencalaccess.calaccess.eo.ProblemQuery)storedValueForKey(_Problem.PROBLEM_QUERY_KEY);
  }

  public void setProblemQuery(org.opencalaccess.calaccess.eo.ProblemQuery value) {
    takeStoredValueForKey(value, _Problem.PROBLEM_QUERY_KEY);
  }

  public void setProblemQueryRelationship(org.opencalaccess.calaccess.eo.ProblemQuery value) {
    log.debug("updating problemQuery from {} to {}", problemQuery(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setProblemQuery(value);
    }
    else if (value == null) {
      org.opencalaccess.calaccess.eo.ProblemQuery oldValue = problemQuery();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Problem.PROBLEM_QUERY_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Problem.PROBLEM_QUERY_KEY);
    }
  }


  public static Problem createCalProblem(EOEditingContext editingContext, String databaseName
, Integer problemQueryPk
, org.opencalaccess.calaccess.eo.ProblemQuery problemQuery) {
    Problem eo = (Problem) EOUtilities.createAndInsertInstance(editingContext, _Problem.ENTITY_NAME);
    eo.setDatabaseName(databaseName);
    eo.setProblemQueryPk(problemQueryPk);
    eo.setProblemQueryRelationship(problemQuery);
    return eo;
  }

  public static ERXFetchSpecification<Problem> fetchSpec() {
    return new ERXFetchSpecification<Problem>(_Problem.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Problem> fetchAllCalProblems(EOEditingContext editingContext) {
    return _Problem.fetchAllCalProblems(editingContext, null);
  }

  public static NSArray<Problem> fetchAllCalProblems(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Problem.fetchCalProblems(editingContext, null, sortOrderings);
  }

  public static NSArray<Problem> fetchCalProblems(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Problem> fetchSpec = new ERXFetchSpecification<Problem>(_Problem.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Problem> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Problem fetchCalProblem(EOEditingContext editingContext, String keyName, Object value) {
    return _Problem.fetchCalProblem(editingContext, ERXQ.equals(keyName, value));
  }

  public static Problem fetchCalProblem(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Problem> eoObjects = _Problem.fetchCalProblems(editingContext, qualifier, null);
    Problem eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CalProblem that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Problem fetchRequiredCalProblem(EOEditingContext editingContext, String keyName, Object value) {
    return _Problem.fetchRequiredCalProblem(editingContext, ERXQ.equals(keyName, value));
  }

  public static Problem fetchRequiredCalProblem(EOEditingContext editingContext, EOQualifier qualifier) {
    Problem eoObject = _Problem.fetchCalProblem(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CalProblem that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Problem localInstanceIn(EOEditingContext editingContext, Problem eo) {
    Problem localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
