// DO NOT EDIT.  Make changes to ProblemQuery.java instead.
package org.opencalaccess.calaccess.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ProblemQuery extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CalProblemQuery";

  // Attribute Keys
  public static final ERXKey<String> COLUMN_NAMES = new ERXKey<String>("columnNames", Type.Attribute);
  public static final ERXKey<String> PROBLEM_QUERY = new ERXKey<String>("problemQuery", Type.Attribute);
  public static final ERXKey<String> TABLE_NAME = new ERXKey<String>("tableName", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.calaccess.eo.Problem> PROBLEMS = new ERXKey<org.opencalaccess.calaccess.eo.Problem>("problems", Type.ToManyRelationship);

  // Attributes
  public static final String COLUMN_NAMES_KEY = COLUMN_NAMES.key();
  public static final String PROBLEM_QUERY_KEY = PROBLEM_QUERY.key();
  public static final String TABLE_NAME_KEY = TABLE_NAME.key();

  // Relationships
  public static final String PROBLEMS_KEY = PROBLEMS.key();

  private static final Logger log = LoggerFactory.getLogger(_ProblemQuery.class);

  public ProblemQuery localInstanceIn(EOEditingContext editingContext) {
    ProblemQuery localInstance = (ProblemQuery)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String columnNames() {
    return (String) storedValueForKey(_ProblemQuery.COLUMN_NAMES_KEY);
  }

  public void setColumnNames(String value) {
    log.debug( "updating columnNames from {} to {}", columnNames(), value);
    takeStoredValueForKey(value, _ProblemQuery.COLUMN_NAMES_KEY);
  }

  public String problemQuery() {
    return (String) storedValueForKey(_ProblemQuery.PROBLEM_QUERY_KEY);
  }

  public void setProblemQuery(String value) {
    log.debug( "updating problemQuery from {} to {}", problemQuery(), value);
    takeStoredValueForKey(value, _ProblemQuery.PROBLEM_QUERY_KEY);
  }

  public String tableName() {
    return (String) storedValueForKey(_ProblemQuery.TABLE_NAME_KEY);
  }

  public void setTableName(String value) {
    log.debug( "updating tableName from {} to {}", tableName(), value);
    takeStoredValueForKey(value, _ProblemQuery.TABLE_NAME_KEY);
  }

  public NSArray<org.opencalaccess.calaccess.eo.Problem> problems() {
    return (NSArray<org.opencalaccess.calaccess.eo.Problem>)storedValueForKey(_ProblemQuery.PROBLEMS_KEY);
  }

  public NSArray<org.opencalaccess.calaccess.eo.Problem> problems(EOQualifier qualifier) {
    return problems(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.calaccess.eo.Problem> problems(EOQualifier qualifier, boolean fetch) {
    return problems(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.calaccess.eo.Problem> problems(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.calaccess.eo.Problem> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.calaccess.eo.Problem.PROBLEM_QUERY_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.calaccess.eo.Problem.fetchCalProblems(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = problems();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.calaccess.eo.Problem>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.calaccess.eo.Problem>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToProblems(org.opencalaccess.calaccess.eo.Problem object) {
    includeObjectIntoPropertyWithKey(object, _ProblemQuery.PROBLEMS_KEY);
  }

  public void removeFromProblems(org.opencalaccess.calaccess.eo.Problem object) {
    excludeObjectFromPropertyWithKey(object, _ProblemQuery.PROBLEMS_KEY);
  }

  public void addToProblemsRelationship(org.opencalaccess.calaccess.eo.Problem object) {
    log.debug("adding {} to problems relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToProblems(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ProblemQuery.PROBLEMS_KEY);
    }
  }

  public void removeFromProblemsRelationship(org.opencalaccess.calaccess.eo.Problem object) {
    log.debug("removing {} from problems relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromProblems(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ProblemQuery.PROBLEMS_KEY);
    }
  }

  public org.opencalaccess.calaccess.eo.Problem createProblemsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.calaccess.eo.Problem.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ProblemQuery.PROBLEMS_KEY);
    return (org.opencalaccess.calaccess.eo.Problem) eo;
  }

  public void deleteProblemsRelationship(org.opencalaccess.calaccess.eo.Problem object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ProblemQuery.PROBLEMS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllProblemsRelationships() {
    Enumeration<org.opencalaccess.calaccess.eo.Problem> objects = problems().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteProblemsRelationship(objects.nextElement());
    }
  }


  public static ProblemQuery createCalProblemQuery(EOEditingContext editingContext, String columnNames
, String problemQuery
, String tableName
) {
    ProblemQuery eo = (ProblemQuery) EOUtilities.createAndInsertInstance(editingContext, _ProblemQuery.ENTITY_NAME);
    eo.setColumnNames(columnNames);
    eo.setProblemQuery(problemQuery);
    eo.setTableName(tableName);
    return eo;
  }

  public static ERXFetchSpecification<ProblemQuery> fetchSpec() {
    return new ERXFetchSpecification<ProblemQuery>(_ProblemQuery.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ProblemQuery> fetchAllCalProblemQueries(EOEditingContext editingContext) {
    return _ProblemQuery.fetchAllCalProblemQueries(editingContext, null);
  }

  public static NSArray<ProblemQuery> fetchAllCalProblemQueries(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ProblemQuery.fetchCalProblemQueries(editingContext, null, sortOrderings);
  }

  public static NSArray<ProblemQuery> fetchCalProblemQueries(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ProblemQuery> fetchSpec = new ERXFetchSpecification<ProblemQuery>(_ProblemQuery.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ProblemQuery> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ProblemQuery fetchCalProblemQuery(EOEditingContext editingContext, String keyName, Object value) {
    return _ProblemQuery.fetchCalProblemQuery(editingContext, ERXQ.equals(keyName, value));
  }

  public static ProblemQuery fetchCalProblemQuery(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ProblemQuery> eoObjects = _ProblemQuery.fetchCalProblemQueries(editingContext, qualifier, null);
    ProblemQuery eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CalProblemQuery that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ProblemQuery fetchRequiredCalProblemQuery(EOEditingContext editingContext, String keyName, Object value) {
    return _ProblemQuery.fetchRequiredCalProblemQuery(editingContext, ERXQ.equals(keyName, value));
  }

  public static ProblemQuery fetchRequiredCalProblemQuery(EOEditingContext editingContext, EOQualifier qualifier) {
    ProblemQuery eoObject = _ProblemQuery.fetchCalProblemQuery(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CalProblemQuery that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ProblemQuery localInstanceIn(EOEditingContext editingContext, ProblemQuery eo) {
    ProblemQuery localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
