// DO NOT EDIT.  Make changes to TextMemo.java instead.
package org.opencalaccess.calaccess.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _TextMemo extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "TextMemo";

  // Attribute Keys
  public static final ERXKey<Integer> AMEND_ID = new ERXKey<Integer>("amendId", Type.Attribute);
  public static final ERXKey<Long> FILING_ID = new ERXKey<Long>("filingId", Type.Attribute);
  public static final ERXKey<String> FORM_TYPE = new ERXKey<String>("formType", Type.Attribute);
  public static final ERXKey<Long> LINE_ITEM = new ERXKey<Long>("lineItem", Type.Attribute);
  public static final ERXKey<String> REC_TYPE = new ERXKey<String>("recType", Type.Attribute);
  public static final ERXKey<String> REF_NO = new ERXKey<String>("refNo", Type.Attribute);
  public static final ERXKey<String> TEXT4000 = new ERXKey<String>("text4000", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String AMEND_ID_KEY = AMEND_ID.key();
  public static final String FILING_ID_KEY = FILING_ID.key();
  public static final String FORM_TYPE_KEY = FORM_TYPE.key();
  public static final String LINE_ITEM_KEY = LINE_ITEM.key();
  public static final String REC_TYPE_KEY = REC_TYPE.key();
  public static final String REF_NO_KEY = REF_NO.key();
  public static final String TEXT4000_KEY = TEXT4000.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_TextMemo.class);

  public TextMemo localInstanceIn(EOEditingContext editingContext) {
    TextMemo localInstance = (TextMemo)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Integer amendId() {
    return (Integer) storedValueForKey(_TextMemo.AMEND_ID_KEY);
  }

  public void setAmendId(Integer value) {
    log.debug( "updating amendId from {} to {}", amendId(), value);
    takeStoredValueForKey(value, _TextMemo.AMEND_ID_KEY);
  }

  public Long filingId() {
    return (Long) storedValueForKey(_TextMemo.FILING_ID_KEY);
  }

  public void setFilingId(Long value) {
    log.debug( "updating filingId from {} to {}", filingId(), value);
    takeStoredValueForKey(value, _TextMemo.FILING_ID_KEY);
  }

  public String formType() {
    return (String) storedValueForKey(_TextMemo.FORM_TYPE_KEY);
  }

  public void setFormType(String value) {
    log.debug( "updating formType from {} to {}", formType(), value);
    takeStoredValueForKey(value, _TextMemo.FORM_TYPE_KEY);
  }

  public Long lineItem() {
    return (Long) storedValueForKey(_TextMemo.LINE_ITEM_KEY);
  }

  public void setLineItem(Long value) {
    log.debug( "updating lineItem from {} to {}", lineItem(), value);
    takeStoredValueForKey(value, _TextMemo.LINE_ITEM_KEY);
  }

  public String recType() {
    return (String) storedValueForKey(_TextMemo.REC_TYPE_KEY);
  }

  public void setRecType(String value) {
    log.debug( "updating recType from {} to {}", recType(), value);
    takeStoredValueForKey(value, _TextMemo.REC_TYPE_KEY);
  }

  public String refNo() {
    return (String) storedValueForKey(_TextMemo.REF_NO_KEY);
  }

  public void setRefNo(String value) {
    log.debug( "updating refNo from {} to {}", refNo(), value);
    takeStoredValueForKey(value, _TextMemo.REF_NO_KEY);
  }

  public String text4000() {
    return (String) storedValueForKey(_TextMemo.TEXT4000_KEY);
  }

  public void setText4000(String value) {
    log.debug( "updating text4000 from {} to {}", text4000(), value);
    takeStoredValueForKey(value, _TextMemo.TEXT4000_KEY);
  }


  public static TextMemo createTextMemo(EOEditingContext editingContext, Integer amendId
, String formType
, String recType
, String refNo
, String text4000
) {
    TextMemo eo = (TextMemo) EOUtilities.createAndInsertInstance(editingContext, _TextMemo.ENTITY_NAME);
    eo.setAmendId(amendId);
    eo.setFormType(formType);
    eo.setRecType(recType);
    eo.setRefNo(refNo);
    eo.setText4000(text4000);
    return eo;
  }

  public static ERXFetchSpecification<TextMemo> fetchSpec() {
    return new ERXFetchSpecification<TextMemo>(_TextMemo.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<TextMemo> fetchAllTextMemos(EOEditingContext editingContext) {
    return _TextMemo.fetchAllTextMemos(editingContext, null);
  }

  public static NSArray<TextMemo> fetchAllTextMemos(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _TextMemo.fetchTextMemos(editingContext, null, sortOrderings);
  }

  public static NSArray<TextMemo> fetchTextMemos(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<TextMemo> fetchSpec = new ERXFetchSpecification<TextMemo>(_TextMemo.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<TextMemo> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static TextMemo fetchTextMemo(EOEditingContext editingContext, String keyName, Object value) {
    return _TextMemo.fetchTextMemo(editingContext, ERXQ.equals(keyName, value));
  }

  public static TextMemo fetchTextMemo(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<TextMemo> eoObjects = _TextMemo.fetchTextMemos(editingContext, qualifier, null);
    TextMemo eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one TextMemo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static TextMemo fetchRequiredTextMemo(EOEditingContext editingContext, String keyName, Object value) {
    return _TextMemo.fetchRequiredTextMemo(editingContext, ERXQ.equals(keyName, value));
  }

  public static TextMemo fetchRequiredTextMemo(EOEditingContext editingContext, EOQualifier qualifier) {
    TextMemo eoObject = _TextMemo.fetchTextMemo(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no TextMemo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static TextMemo localInstanceIn(EOEditingContext editingContext, TextMemo eo) {
    TextMemo localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
