package org.opencalaccess.cards.eo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.foundation.NSArray;

public class CardEntry extends _CardEntry {

	private static final long serialVersionUID = 414122736792334069L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(CardEntry.class);

	private static final NSArray<String> needsEsc = new NSArray<>(new String[] { "ru-RU" });

	public String word() {
		if (needsEsc.contains(super.language())) {
			String next = super.word();
			if (next == null) {
				return next;
			}
			StringBuilder str = new StringBuilder();
			for (int idx = 0; idx < next.length(); idx++) {
				str.append("&#x");
				str.append(Integer.toHexString(next.codePointAt(idx)));
				str.append(";");
			}
			return str.toString();
		} else {
			return super.word();
		}
	}
}
