package org.opencalaccess.cards.eo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;

import er.extensions.eof.ERXQ;
import er.extensions.foundation.ERXArrayUtilities;

public class CardUser extends _CardUser {

	private static final long serialVersionUID = 7760777705740790606L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(CardUser.class);

	public CardUserProfile currentProfile() {
		NSArray<CardUserProfile> found = ERXArrayUtilities.filteredArrayWithQualifierEvaluation(
				this.profiles(),
				ERXQ.isNull(CardUserProfile.DELETED_KEY));
		return (found.size() > 0) ? found.get(0) : null;
	}

	public static CardUser currentUser(EOEditingContext ec, String email) {
		return CardUser.fetchRequiredCardUser(ec, CardUser.EMAIL_KEY, email);
	}
}
