// DO NOT EDIT.  Make changes to Card.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Card extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Card";

  // Attribute Keys
  public static final ERXKey<Long> CREATED_DATE = new ERXKey<Long>("createdDate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.Card> CARD_SETS = new ERXKey<org.opencalaccess.cards.eo.Card>("cardSets", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardUser> CREATOR = new ERXKey<org.opencalaccess.cards.eo.CardUser>("creator", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardEntry> ENTRIES = new ERXKey<org.opencalaccess.cards.eo.CardEntry>("entries", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardTest> TESTS = new ERXKey<org.opencalaccess.cards.eo.CardTest>("tests", Type.ToManyRelationship);

  // Attributes
  public static final String CREATED_DATE_KEY = CREATED_DATE.key();

  // Relationships
  public static final String CARD_SETS_KEY = CARD_SETS.key();
  public static final String CREATOR_KEY = CREATOR.key();
  public static final String ENTRIES_KEY = ENTRIES.key();
  public static final String TESTS_KEY = TESTS.key();

  private static final Logger log = LoggerFactory.getLogger(_Card.class);

  public Card localInstanceIn(EOEditingContext editingContext) {
    Card localInstance = (Card)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long createdDate() {
    return (Long) storedValueForKey(_Card.CREATED_DATE_KEY);
  }

  public void setCreatedDate(Long value) {
    log.debug( "updating createdDate from {} to {}", createdDate(), value);
    takeStoredValueForKey(value, _Card.CREATED_DATE_KEY);
  }

  public org.opencalaccess.cards.eo.CardUser creator() {
    return (org.opencalaccess.cards.eo.CardUser)storedValueForKey(_Card.CREATOR_KEY);
  }

  public void setCreator(org.opencalaccess.cards.eo.CardUser value) {
    takeStoredValueForKey(value, _Card.CREATOR_KEY);
  }

  public void setCreatorRelationship(org.opencalaccess.cards.eo.CardUser value) {
    log.debug("updating creator from {} to {}", creator(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCreator(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.CardUser oldValue = creator();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Card.CREATOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Card.CREATOR_KEY);
    }
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cardSets() {
    return (NSArray<org.opencalaccess.cards.eo.Card>)storedValueForKey(_Card.CARD_SETS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cardSets(EOQualifier qualifier) {
    return cardSets(qualifier, null);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cardSets(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.cards.eo.Card> results;
      results = cardSets();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToCardSets(org.opencalaccess.cards.eo.Card object) {
    includeObjectIntoPropertyWithKey(object, _Card.CARD_SETS_KEY);
  }

  public void removeFromCardSets(org.opencalaccess.cards.eo.Card object) {
    excludeObjectFromPropertyWithKey(object, _Card.CARD_SETS_KEY);
  }

  public void addToCardSetsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("adding {} to cardSets relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCardSets(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Card.CARD_SETS_KEY);
    }
  }

  public void removeFromCardSetsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("removing {} from cardSets relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCardSets(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.CARD_SETS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.Card createCardSetsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.Card.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Card.CARD_SETS_KEY);
    return (org.opencalaccess.cards.eo.Card) eo;
  }

  public void deleteCardSetsRelationship(org.opencalaccess.cards.eo.Card object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.CARD_SETS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCardSetsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.Card> objects = cardSets().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCardSetsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.cards.eo.CardEntry> entries() {
    return (NSArray<org.opencalaccess.cards.eo.CardEntry>)storedValueForKey(_Card.ENTRIES_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardEntry> entries(EOQualifier qualifier) {
    return entries(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardEntry> entries(EOQualifier qualifier, boolean fetch) {
    return entries(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardEntry> entries(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardEntry> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardEntry.CARD_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardEntry.fetchCardEntries(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = entries();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardEntry>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardEntry>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToEntries(org.opencalaccess.cards.eo.CardEntry object) {
    includeObjectIntoPropertyWithKey(object, _Card.ENTRIES_KEY);
  }

  public void removeFromEntries(org.opencalaccess.cards.eo.CardEntry object) {
    excludeObjectFromPropertyWithKey(object, _Card.ENTRIES_KEY);
  }

  public void addToEntriesRelationship(org.opencalaccess.cards.eo.CardEntry object) {
    log.debug("adding {} to entries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToEntries(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Card.ENTRIES_KEY);
    }
  }

  public void removeFromEntriesRelationship(org.opencalaccess.cards.eo.CardEntry object) {
    log.debug("removing {} from entries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromEntries(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.ENTRIES_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardEntry createEntriesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardEntry.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Card.ENTRIES_KEY);
    return (org.opencalaccess.cards.eo.CardEntry) eo;
  }

  public void deleteEntriesRelationship(org.opencalaccess.cards.eo.CardEntry object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.ENTRIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllEntriesRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardEntry> objects = entries().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteEntriesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests() {
    return (NSArray<org.opencalaccess.cards.eo.CardTest>)storedValueForKey(_Card.TESTS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier) {
    return tests(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, boolean fetch) {
    return tests(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardTest> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardTest.CARD_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardTest.fetchCardTests(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = tests();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToTests(org.opencalaccess.cards.eo.CardTest object) {
    includeObjectIntoPropertyWithKey(object, _Card.TESTS_KEY);
  }

  public void removeFromTests(org.opencalaccess.cards.eo.CardTest object) {
    excludeObjectFromPropertyWithKey(object, _Card.TESTS_KEY);
  }

  public void addToTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("adding {} to tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToTests(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Card.TESTS_KEY);
    }
  }

  public void removeFromTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("removing {} from tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromTests(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.TESTS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardTest createTestsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardTest.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Card.TESTS_KEY);
    return (org.opencalaccess.cards.eo.CardTest) eo;
  }

  public void deleteTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Card.TESTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllTestsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardTest> objects = tests().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteTestsRelationship(objects.nextElement());
    }
  }


  public static Card createCard(EOEditingContext editingContext, Long createdDate
, org.opencalaccess.cards.eo.CardUser creator) {
    Card eo = (Card) EOUtilities.createAndInsertInstance(editingContext, _Card.ENTITY_NAME);
    eo.setCreatedDate(createdDate);
    eo.setCreatorRelationship(creator);
    return eo;
  }

  public static ERXFetchSpecification<Card> fetchSpec() {
    return new ERXFetchSpecification<Card>(_Card.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Card> fetchAllCards(EOEditingContext editingContext) {
    return _Card.fetchAllCards(editingContext, null);
  }

  public static NSArray<Card> fetchAllCards(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Card.fetchCards(editingContext, null, sortOrderings);
  }

  public static NSArray<Card> fetchCards(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Card> fetchSpec = new ERXFetchSpecification<Card>(_Card.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Card> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Card fetchCard(EOEditingContext editingContext, String keyName, Object value) {
    return _Card.fetchCard(editingContext, ERXQ.equals(keyName, value));
  }

  public static Card fetchCard(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Card> eoObjects = _Card.fetchCards(editingContext, qualifier, null);
    Card eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Card that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Card fetchRequiredCard(EOEditingContext editingContext, String keyName, Object value) {
    return _Card.fetchRequiredCard(editingContext, ERXQ.equals(keyName, value));
  }

  public static Card fetchRequiredCard(EOEditingContext editingContext, EOQualifier qualifier) {
    Card eoObject = _Card.fetchCard(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Card that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Card localInstanceIn(EOEditingContext editingContext, Card eo) {
    Card localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
