// DO NOT EDIT.  Make changes to CardEntry.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardEntry extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardEntry";

  // Attribute Keys
  public static final ERXKey<String> LANGUAGE = new ERXKey<String>("language", Type.Attribute);
  public static final ERXKey<String> WORD = new ERXKey<String>("word", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.Card> CARD = new ERXKey<org.opencalaccess.cards.eo.Card>("card", Type.ToOneRelationship);

  // Attributes
  public static final String LANGUAGE_KEY = LANGUAGE.key();
  public static final String WORD_KEY = WORD.key();

  // Relationships
  public static final String CARD_KEY = CARD.key();

  private static final Logger log = LoggerFactory.getLogger(_CardEntry.class);

  public CardEntry localInstanceIn(EOEditingContext editingContext) {
    CardEntry localInstance = (CardEntry)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String language() {
    return (String) storedValueForKey(_CardEntry.LANGUAGE_KEY);
  }

  public void setLanguage(String value) {
    log.debug( "updating language from {} to {}", language(), value);
    takeStoredValueForKey(value, _CardEntry.LANGUAGE_KEY);
  }

  public String word() {
    return (String) storedValueForKey(_CardEntry.WORD_KEY);
  }

  public void setWord(String value) {
    log.debug( "updating word from {} to {}", word(), value);
    takeStoredValueForKey(value, _CardEntry.WORD_KEY);
  }

  public org.opencalaccess.cards.eo.Card card() {
    return (org.opencalaccess.cards.eo.Card)storedValueForKey(_CardEntry.CARD_KEY);
  }

  public void setCard(org.opencalaccess.cards.eo.Card value) {
    takeStoredValueForKey(value, _CardEntry.CARD_KEY);
  }

  public void setCardRelationship(org.opencalaccess.cards.eo.Card value) {
    log.debug("updating card from {} to {}", card(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCard(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.Card oldValue = card();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardEntry.CARD_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardEntry.CARD_KEY);
    }
  }


  public static CardEntry createCardEntry(EOEditingContext editingContext, String language
, String word
, org.opencalaccess.cards.eo.Card card) {
    CardEntry eo = (CardEntry) EOUtilities.createAndInsertInstance(editingContext, _CardEntry.ENTITY_NAME);
    eo.setLanguage(language);
    eo.setWord(word);
    eo.setCardRelationship(card);
    return eo;
  }

  public static ERXFetchSpecification<CardEntry> fetchSpec() {
    return new ERXFetchSpecification<CardEntry>(_CardEntry.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardEntry> fetchAllCardEntries(EOEditingContext editingContext) {
    return _CardEntry.fetchAllCardEntries(editingContext, null);
  }

  public static NSArray<CardEntry> fetchAllCardEntries(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardEntry.fetchCardEntries(editingContext, null, sortOrderings);
  }

  public static NSArray<CardEntry> fetchCardEntries(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardEntry> fetchSpec = new ERXFetchSpecification<CardEntry>(_CardEntry.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardEntry> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardEntry fetchCardEntry(EOEditingContext editingContext, String keyName, Object value) {
    return _CardEntry.fetchCardEntry(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardEntry fetchCardEntry(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardEntry> eoObjects = _CardEntry.fetchCardEntries(editingContext, qualifier, null);
    CardEntry eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardEntry that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardEntry fetchRequiredCardEntry(EOEditingContext editingContext, String keyName, Object value) {
    return _CardEntry.fetchRequiredCardEntry(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardEntry fetchRequiredCardEntry(EOEditingContext editingContext, EOQualifier qualifier) {
    CardEntry eoObject = _CardEntry.fetchCardEntry(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardEntry that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardEntry localInstanceIn(EOEditingContext editingContext, CardEntry eo) {
    CardEntry localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
