// DO NOT EDIT.  Make changes to CardSet.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardSet extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardSet";

  // Attribute Keys
  public static final ERXKey<Long> CREATED_DATE = new ERXKey<Long>("createdDate", Type.Attribute);
  public static final ERXKey<String> DESCRIPTION = new ERXKey<String>("description", Type.Attribute);
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.Card> CARDS = new ERXKey<org.opencalaccess.cards.eo.Card>("cards", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardUser> CREATOR = new ERXKey<org.opencalaccess.cards.eo.CardUser>("creator", Type.ToOneRelationship);

  // Attributes
  public static final String CREATED_DATE_KEY = CREATED_DATE.key();
  public static final String DESCRIPTION_KEY = DESCRIPTION.key();
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String CARDS_KEY = CARDS.key();
  public static final String CREATOR_KEY = CREATOR.key();

  private static final Logger log = LoggerFactory.getLogger(_CardSet.class);

  public CardSet localInstanceIn(EOEditingContext editingContext) {
    CardSet localInstance = (CardSet)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long createdDate() {
    return (Long) storedValueForKey(_CardSet.CREATED_DATE_KEY);
  }

  public void setCreatedDate(Long value) {
    log.debug( "updating createdDate from {} to {}", createdDate(), value);
    takeStoredValueForKey(value, _CardSet.CREATED_DATE_KEY);
  }

  public String description() {
    return (String) storedValueForKey(_CardSet.DESCRIPTION_KEY);
  }

  public void setDescription(String value) {
    log.debug( "updating description from {} to {}", description(), value);
    takeStoredValueForKey(value, _CardSet.DESCRIPTION_KEY);
  }

  public String name() {
    return (String) storedValueForKey(_CardSet.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _CardSet.NAME_KEY);
  }

  public org.opencalaccess.cards.eo.CardUser creator() {
    return (org.opencalaccess.cards.eo.CardUser)storedValueForKey(_CardSet.CREATOR_KEY);
  }

  public void setCreator(org.opencalaccess.cards.eo.CardUser value) {
    takeStoredValueForKey(value, _CardSet.CREATOR_KEY);
  }

  public void setCreatorRelationship(org.opencalaccess.cards.eo.CardUser value) {
    log.debug("updating creator from {} to {}", creator(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCreator(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.CardUser oldValue = creator();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardSet.CREATOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardSet.CREATOR_KEY);
    }
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards() {
    return (NSArray<org.opencalaccess.cards.eo.Card>)storedValueForKey(_CardSet.CARDS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards(EOQualifier qualifier) {
    return cards(qualifier, null);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.cards.eo.Card> results;
      results = cards();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToCards(org.opencalaccess.cards.eo.Card object) {
    includeObjectIntoPropertyWithKey(object, _CardSet.CARDS_KEY);
  }

  public void removeFromCards(org.opencalaccess.cards.eo.Card object) {
    excludeObjectFromPropertyWithKey(object, _CardSet.CARDS_KEY);
  }

  public void addToCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("adding {} to cards relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCards(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardSet.CARDS_KEY);
    }
  }

  public void removeFromCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("removing {} from cards relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCards(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardSet.CARDS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.Card createCardsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.Card.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardSet.CARDS_KEY);
    return (org.opencalaccess.cards.eo.Card) eo;
  }

  public void deleteCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardSet.CARDS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCardsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.Card> objects = cards().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCardsRelationship(objects.nextElement());
    }
  }


  public static CardSet createCardSet(EOEditingContext editingContext, Long createdDate
, String name
, org.opencalaccess.cards.eo.CardUser creator) {
    CardSet eo = (CardSet) EOUtilities.createAndInsertInstance(editingContext, _CardSet.ENTITY_NAME);
    eo.setCreatedDate(createdDate);
    eo.setName(name);
    eo.setCreatorRelationship(creator);
    return eo;
  }

  public static ERXFetchSpecification<CardSet> fetchSpec() {
    return new ERXFetchSpecification<CardSet>(_CardSet.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardSet> fetchAllCardSets(EOEditingContext editingContext) {
    return _CardSet.fetchAllCardSets(editingContext, null);
  }

  public static NSArray<CardSet> fetchAllCardSets(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardSet.fetchCardSets(editingContext, null, sortOrderings);
  }

  public static NSArray<CardSet> fetchCardSets(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardSet> fetchSpec = new ERXFetchSpecification<CardSet>(_CardSet.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardSet> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardSet fetchCardSet(EOEditingContext editingContext, String keyName, Object value) {
    return _CardSet.fetchCardSet(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardSet fetchCardSet(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardSet> eoObjects = _CardSet.fetchCardSets(editingContext, qualifier, null);
    CardSet eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardSet that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardSet fetchRequiredCardSet(EOEditingContext editingContext, String keyName, Object value) {
    return _CardSet.fetchRequiredCardSet(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardSet fetchRequiredCardSet(EOEditingContext editingContext, EOQualifier qualifier) {
    CardSet eoObject = _CardSet.fetchCardSet(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardSet that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardSet localInstanceIn(EOEditingContext editingContext, CardSet eo) {
    CardSet localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
