// DO NOT EDIT.  Make changes to CardTest.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardTest extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardTest";

  // Attribute Keys
  public static final ERXKey<Short> IS_CORRECT = new ERXKey<Short>("isCorrect", Type.Attribute);
  public static final ERXKey<String> RESPONSE = new ERXKey<String>("response", Type.Attribute);
  public static final ERXKey<Long> TEST_TAKEN = new ERXKey<Long>("testTaken", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.Card> CARD = new ERXKey<org.opencalaccess.cards.eo.Card>("card", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardTestType> TEST_TYPE = new ERXKey<org.opencalaccess.cards.eo.CardTestType>("testType", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardUser> USER = new ERXKey<org.opencalaccess.cards.eo.CardUser>("user", Type.ToOneRelationship);

  // Attributes
  public static final String IS_CORRECT_KEY = IS_CORRECT.key();
  public static final String RESPONSE_KEY = RESPONSE.key();
  public static final String TEST_TAKEN_KEY = TEST_TAKEN.key();

  // Relationships
  public static final String CARD_KEY = CARD.key();
  public static final String TEST_TYPE_KEY = TEST_TYPE.key();
  public static final String USER_KEY = USER.key();

  private static final Logger log = LoggerFactory.getLogger(_CardTest.class);

  public CardTest localInstanceIn(EOEditingContext editingContext) {
    CardTest localInstance = (CardTest)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Short isCorrect() {
    return (Short) storedValueForKey(_CardTest.IS_CORRECT_KEY);
  }

  public void setIsCorrect(Short value) {
    log.debug( "updating isCorrect from {} to {}", isCorrect(), value);
    takeStoredValueForKey(value, _CardTest.IS_CORRECT_KEY);
  }

  public String response() {
    return (String) storedValueForKey(_CardTest.RESPONSE_KEY);
  }

  public void setResponse(String value) {
    log.debug( "updating response from {} to {}", response(), value);
    takeStoredValueForKey(value, _CardTest.RESPONSE_KEY);
  }

  public Long testTaken() {
    return (Long) storedValueForKey(_CardTest.TEST_TAKEN_KEY);
  }

  public void setTestTaken(Long value) {
    log.debug( "updating testTaken from {} to {}", testTaken(), value);
    takeStoredValueForKey(value, _CardTest.TEST_TAKEN_KEY);
  }

  public org.opencalaccess.cards.eo.Card card() {
    return (org.opencalaccess.cards.eo.Card)storedValueForKey(_CardTest.CARD_KEY);
  }

  public void setCard(org.opencalaccess.cards.eo.Card value) {
    takeStoredValueForKey(value, _CardTest.CARD_KEY);
  }

  public void setCardRelationship(org.opencalaccess.cards.eo.Card value) {
    log.debug("updating card from {} to {}", card(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCard(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.Card oldValue = card();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardTest.CARD_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardTest.CARD_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardTestType testType() {
    return (org.opencalaccess.cards.eo.CardTestType)storedValueForKey(_CardTest.TEST_TYPE_KEY);
  }

  public void setTestType(org.opencalaccess.cards.eo.CardTestType value) {
    takeStoredValueForKey(value, _CardTest.TEST_TYPE_KEY);
  }

  public void setTestTypeRelationship(org.opencalaccess.cards.eo.CardTestType value) {
    log.debug("updating testType from {} to {}", testType(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setTestType(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.CardTestType oldValue = testType();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardTest.TEST_TYPE_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardTest.TEST_TYPE_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardUser user() {
    return (org.opencalaccess.cards.eo.CardUser)storedValueForKey(_CardTest.USER_KEY);
  }

  public void setUser(org.opencalaccess.cards.eo.CardUser value) {
    takeStoredValueForKey(value, _CardTest.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.cards.eo.CardUser value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.CardUser oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardTest.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardTest.USER_KEY);
    }
  }


  public static CardTest createCardTest(EOEditingContext editingContext, org.opencalaccess.cards.eo.Card card, org.opencalaccess.cards.eo.CardTestType testType, org.opencalaccess.cards.eo.CardUser user) {
    CardTest eo = (CardTest) EOUtilities.createAndInsertInstance(editingContext, _CardTest.ENTITY_NAME);
    eo.setCardRelationship(card);
    eo.setTestTypeRelationship(testType);
    eo.setUserRelationship(user);
    return eo;
  }

  public static ERXFetchSpecification<CardTest> fetchSpec() {
    return new ERXFetchSpecification<CardTest>(_CardTest.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardTest> fetchAllCardTests(EOEditingContext editingContext) {
    return _CardTest.fetchAllCardTests(editingContext, null);
  }

  public static NSArray<CardTest> fetchAllCardTests(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardTest.fetchCardTests(editingContext, null, sortOrderings);
  }

  public static NSArray<CardTest> fetchCardTests(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardTest> fetchSpec = new ERXFetchSpecification<CardTest>(_CardTest.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardTest> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardTest fetchCardTest(EOEditingContext editingContext, String keyName, Object value) {
    return _CardTest.fetchCardTest(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardTest fetchCardTest(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardTest> eoObjects = _CardTest.fetchCardTests(editingContext, qualifier, null);
    CardTest eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardTest that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardTest fetchRequiredCardTest(EOEditingContext editingContext, String keyName, Object value) {
    return _CardTest.fetchRequiredCardTest(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardTest fetchRequiredCardTest(EOEditingContext editingContext, EOQualifier qualifier) {
    CardTest eoObject = _CardTest.fetchCardTest(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardTest that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardTest localInstanceIn(EOEditingContext editingContext, CardTest eo) {
    CardTest localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
