// DO NOT EDIT.  Make changes to CardTestType.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardTestType extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardTestType";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.CardTest> TESTS = new ERXKey<org.opencalaccess.cards.eo.CardTest>("tests", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String TESTS_KEY = TESTS.key();

  private static final Logger log = LoggerFactory.getLogger(_CardTestType.class);

  public CardTestType localInstanceIn(EOEditingContext editingContext) {
    CardTestType localInstance = (CardTestType)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_CardTestType.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _CardTestType.NAME_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests() {
    return (NSArray<org.opencalaccess.cards.eo.CardTest>)storedValueForKey(_CardTestType.TESTS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier) {
    return tests(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, boolean fetch) {
    return tests(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardTest> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardTest.TEST_TYPE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardTest.fetchCardTests(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = tests();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToTests(org.opencalaccess.cards.eo.CardTest object) {
    includeObjectIntoPropertyWithKey(object, _CardTestType.TESTS_KEY);
  }

  public void removeFromTests(org.opencalaccess.cards.eo.CardTest object) {
    excludeObjectFromPropertyWithKey(object, _CardTestType.TESTS_KEY);
  }

  public void addToTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("adding {} to tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToTests(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardTestType.TESTS_KEY);
    }
  }

  public void removeFromTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("removing {} from tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromTests(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardTestType.TESTS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardTest createTestsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardTest.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardTestType.TESTS_KEY);
    return (org.opencalaccess.cards.eo.CardTest) eo;
  }

  public void deleteTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardTestType.TESTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllTestsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardTest> objects = tests().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteTestsRelationship(objects.nextElement());
    }
  }


  public static CardTestType createCardTestType(EOEditingContext editingContext, String name
) {
    CardTestType eo = (CardTestType) EOUtilities.createAndInsertInstance(editingContext, _CardTestType.ENTITY_NAME);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<CardTestType> fetchSpec() {
    return new ERXFetchSpecification<CardTestType>(_CardTestType.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardTestType> fetchAllCardTestTypes(EOEditingContext editingContext) {
    return _CardTestType.fetchAllCardTestTypes(editingContext, null);
  }

  public static NSArray<CardTestType> fetchAllCardTestTypes(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardTestType.fetchCardTestTypes(editingContext, null, sortOrderings);
  }

  public static NSArray<CardTestType> fetchCardTestTypes(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardTestType> fetchSpec = new ERXFetchSpecification<CardTestType>(_CardTestType.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardTestType> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardTestType fetchCardTestType(EOEditingContext editingContext, String keyName, Object value) {
    return _CardTestType.fetchCardTestType(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardTestType fetchCardTestType(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardTestType> eoObjects = _CardTestType.fetchCardTestTypes(editingContext, qualifier, null);
    CardTestType eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardTestType that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardTestType fetchRequiredCardTestType(EOEditingContext editingContext, String keyName, Object value) {
    return _CardTestType.fetchRequiredCardTestType(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardTestType fetchRequiredCardTestType(EOEditingContext editingContext, EOQualifier qualifier) {
    CardTestType eoObject = _CardTestType.fetchCardTestType(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardTestType that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardTestType localInstanceIn(EOEditingContext editingContext, CardTestType eo) {
    CardTestType localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
