// DO NOT EDIT.  Make changes to CardUser.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardUser extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardUser";

  // Attribute Keys
  public static final ERXKey<String> EMAIL = new ERXKey<String>("email", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.Card> CARDS = new ERXKey<org.opencalaccess.cards.eo.Card>("cards", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardSet> CARD_SETS = new ERXKey<org.opencalaccess.cards.eo.CardSet>("cardSets", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardUserProfile> PROFILES = new ERXKey<org.opencalaccess.cards.eo.CardUserProfile>("profiles", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.cards.eo.CardTest> TESTS = new ERXKey<org.opencalaccess.cards.eo.CardTest>("tests", Type.ToManyRelationship);

  // Attributes
  public static final String EMAIL_KEY = EMAIL.key();

  // Relationships
  public static final String CARDS_KEY = CARDS.key();
  public static final String CARD_SETS_KEY = CARD_SETS.key();
  public static final String PROFILES_KEY = PROFILES.key();
  public static final String TESTS_KEY = TESTS.key();

  private static final Logger log = LoggerFactory.getLogger(_CardUser.class);

  public CardUser localInstanceIn(EOEditingContext editingContext) {
    CardUser localInstance = (CardUser)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String email() {
    return (String) storedValueForKey(_CardUser.EMAIL_KEY);
  }

  public void setEmail(String value) {
    log.debug( "updating email from {} to {}", email(), value);
    takeStoredValueForKey(value, _CardUser.EMAIL_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards() {
    return (NSArray<org.opencalaccess.cards.eo.Card>)storedValueForKey(_CardUser.CARDS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards(EOQualifier qualifier) {
    return cards(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards(EOQualifier qualifier, boolean fetch) {
    return cards(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.Card> cards(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.Card> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.Card.CREATOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.Card.fetchCards(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = cards();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.Card>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCards(org.opencalaccess.cards.eo.Card object) {
    includeObjectIntoPropertyWithKey(object, _CardUser.CARDS_KEY);
  }

  public void removeFromCards(org.opencalaccess.cards.eo.Card object) {
    excludeObjectFromPropertyWithKey(object, _CardUser.CARDS_KEY);
  }

  public void addToCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("adding {} to cards relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCards(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardUser.CARDS_KEY);
    }
  }

  public void removeFromCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    log.debug("removing {} from cards relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCards(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.CARDS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.Card createCardsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.Card.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardUser.CARDS_KEY);
    return (org.opencalaccess.cards.eo.Card) eo;
  }

  public void deleteCardsRelationship(org.opencalaccess.cards.eo.Card object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.CARDS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCardsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.Card> objects = cards().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCardsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.cards.eo.CardSet> cardSets() {
    return (NSArray<org.opencalaccess.cards.eo.CardSet>)storedValueForKey(_CardUser.CARD_SETS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardSet> cardSets(EOQualifier qualifier) {
    return cardSets(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardSet> cardSets(EOQualifier qualifier, boolean fetch) {
    return cardSets(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardSet> cardSets(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardSet> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardSet.CREATOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardSet.fetchCardSets(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = cardSets();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardSet>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardSet>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCardSets(org.opencalaccess.cards.eo.CardSet object) {
    includeObjectIntoPropertyWithKey(object, _CardUser.CARD_SETS_KEY);
  }

  public void removeFromCardSets(org.opencalaccess.cards.eo.CardSet object) {
    excludeObjectFromPropertyWithKey(object, _CardUser.CARD_SETS_KEY);
  }

  public void addToCardSetsRelationship(org.opencalaccess.cards.eo.CardSet object) {
    log.debug("adding {} to cardSets relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCardSets(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardUser.CARD_SETS_KEY);
    }
  }

  public void removeFromCardSetsRelationship(org.opencalaccess.cards.eo.CardSet object) {
    log.debug("removing {} from cardSets relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCardSets(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.CARD_SETS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardSet createCardSetsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardSet.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardUser.CARD_SETS_KEY);
    return (org.opencalaccess.cards.eo.CardSet) eo;
  }

  public void deleteCardSetsRelationship(org.opencalaccess.cards.eo.CardSet object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.CARD_SETS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCardSetsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardSet> objects = cardSets().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCardSetsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.cards.eo.CardUserProfile> profiles() {
    return (NSArray<org.opencalaccess.cards.eo.CardUserProfile>)storedValueForKey(_CardUser.PROFILES_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardUserProfile> profiles(EOQualifier qualifier) {
    return profiles(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardUserProfile> profiles(EOQualifier qualifier, boolean fetch) {
    return profiles(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardUserProfile> profiles(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardUserProfile> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardUserProfile.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardUserProfile.fetchCardUserProfiles(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = profiles();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardUserProfile>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardUserProfile>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToProfiles(org.opencalaccess.cards.eo.CardUserProfile object) {
    includeObjectIntoPropertyWithKey(object, _CardUser.PROFILES_KEY);
  }

  public void removeFromProfiles(org.opencalaccess.cards.eo.CardUserProfile object) {
    excludeObjectFromPropertyWithKey(object, _CardUser.PROFILES_KEY);
  }

  public void addToProfilesRelationship(org.opencalaccess.cards.eo.CardUserProfile object) {
    log.debug("adding {} to profiles relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToProfiles(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardUser.PROFILES_KEY);
    }
  }

  public void removeFromProfilesRelationship(org.opencalaccess.cards.eo.CardUserProfile object) {
    log.debug("removing {} from profiles relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromProfiles(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.PROFILES_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardUserProfile createProfilesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardUserProfile.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardUser.PROFILES_KEY);
    return (org.opencalaccess.cards.eo.CardUserProfile) eo;
  }

  public void deleteProfilesRelationship(org.opencalaccess.cards.eo.CardUserProfile object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.PROFILES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllProfilesRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardUserProfile> objects = profiles().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteProfilesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests() {
    return (NSArray<org.opencalaccess.cards.eo.CardTest>)storedValueForKey(_CardUser.TESTS_KEY);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier) {
    return tests(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, boolean fetch) {
    return tests(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.cards.eo.CardTest> tests(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.cards.eo.CardTest> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.cards.eo.CardTest.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.cards.eo.CardTest.fetchCardTests(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = tests();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.cards.eo.CardTest>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToTests(org.opencalaccess.cards.eo.CardTest object) {
    includeObjectIntoPropertyWithKey(object, _CardUser.TESTS_KEY);
  }

  public void removeFromTests(org.opencalaccess.cards.eo.CardTest object) {
    excludeObjectFromPropertyWithKey(object, _CardUser.TESTS_KEY);
  }

  public void addToTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("adding {} to tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToTests(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CardUser.TESTS_KEY);
    }
  }

  public void removeFromTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    log.debug("removing {} from tests relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromTests(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.TESTS_KEY);
    }
  }

  public org.opencalaccess.cards.eo.CardTest createTestsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.cards.eo.CardTest.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CardUser.TESTS_KEY);
    return (org.opencalaccess.cards.eo.CardTest) eo;
  }

  public void deleteTestsRelationship(org.opencalaccess.cards.eo.CardTest object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CardUser.TESTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllTestsRelationships() {
    Enumeration<org.opencalaccess.cards.eo.CardTest> objects = tests().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteTestsRelationship(objects.nextElement());
    }
  }


  public static CardUser createCardUser(EOEditingContext editingContext, String email
) {
    CardUser eo = (CardUser) EOUtilities.createAndInsertInstance(editingContext, _CardUser.ENTITY_NAME);
    eo.setEmail(email);
    return eo;
  }

  public static ERXFetchSpecification<CardUser> fetchSpec() {
    return new ERXFetchSpecification<CardUser>(_CardUser.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardUser> fetchAllCardUsers(EOEditingContext editingContext) {
    return _CardUser.fetchAllCardUsers(editingContext, null);
  }

  public static NSArray<CardUser> fetchAllCardUsers(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardUser.fetchCardUsers(editingContext, null, sortOrderings);
  }

  public static NSArray<CardUser> fetchCardUsers(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardUser> fetchSpec = new ERXFetchSpecification<CardUser>(_CardUser.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardUser> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardUser fetchCardUser(EOEditingContext editingContext, String keyName, Object value) {
    return _CardUser.fetchCardUser(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardUser fetchCardUser(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardUser> eoObjects = _CardUser.fetchCardUsers(editingContext, qualifier, null);
    CardUser eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardUser that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardUser fetchRequiredCardUser(EOEditingContext editingContext, String keyName, Object value) {
    return _CardUser.fetchRequiredCardUser(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardUser fetchRequiredCardUser(EOEditingContext editingContext, EOQualifier qualifier) {
    CardUser eoObject = _CardUser.fetchCardUser(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardUser that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardUser localInstanceIn(EOEditingContext editingContext, CardUser eo) {
    CardUser localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
