// DO NOT EDIT.  Make changes to CardUserProfile.java instead.
package org.opencalaccess.cards.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CardUserProfile extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CardUserProfile";

  // Attribute Keys
  public static final ERXKey<Long> DELETED = new ERXKey<Long>("deleted", Type.Attribute);
  public static final ERXKey<String> FIRST_LOCALE = new ERXKey<String>("firstLocale", Type.Attribute);
  public static final ERXKey<String> SECOND_LOCALE = new ERXKey<String>("secondLocale", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.cards.eo.CardUser> USER = new ERXKey<org.opencalaccess.cards.eo.CardUser>("user", Type.ToOneRelationship);

  // Attributes
  public static final String DELETED_KEY = DELETED.key();
  public static final String FIRST_LOCALE_KEY = FIRST_LOCALE.key();
  public static final String SECOND_LOCALE_KEY = SECOND_LOCALE.key();

  // Relationships
  public static final String USER_KEY = USER.key();

  private static final Logger log = LoggerFactory.getLogger(_CardUserProfile.class);

  public CardUserProfile localInstanceIn(EOEditingContext editingContext) {
    CardUserProfile localInstance = (CardUserProfile)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long deleted() {
    return (Long) storedValueForKey(_CardUserProfile.DELETED_KEY);
  }

  public void setDeleted(Long value) {
    log.debug( "updating deleted from {} to {}", deleted(), value);
    takeStoredValueForKey(value, _CardUserProfile.DELETED_KEY);
  }

  public String firstLocale() {
    return (String) storedValueForKey(_CardUserProfile.FIRST_LOCALE_KEY);
  }

  public void setFirstLocale(String value) {
    log.debug( "updating firstLocale from {} to {}", firstLocale(), value);
    takeStoredValueForKey(value, _CardUserProfile.FIRST_LOCALE_KEY);
  }

  public String secondLocale() {
    return (String) storedValueForKey(_CardUserProfile.SECOND_LOCALE_KEY);
  }

  public void setSecondLocale(String value) {
    log.debug( "updating secondLocale from {} to {}", secondLocale(), value);
    takeStoredValueForKey(value, _CardUserProfile.SECOND_LOCALE_KEY);
  }

  public org.opencalaccess.cards.eo.CardUser user() {
    return (org.opencalaccess.cards.eo.CardUser)storedValueForKey(_CardUserProfile.USER_KEY);
  }

  public void setUser(org.opencalaccess.cards.eo.CardUser value) {
    takeStoredValueForKey(value, _CardUserProfile.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.cards.eo.CardUser value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.cards.eo.CardUser oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CardUserProfile.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CardUserProfile.USER_KEY);
    }
  }


  public static CardUserProfile createCardUserProfile(EOEditingContext editingContext, org.opencalaccess.cards.eo.CardUser user) {
    CardUserProfile eo = (CardUserProfile) EOUtilities.createAndInsertInstance(editingContext, _CardUserProfile.ENTITY_NAME);
    eo.setUserRelationship(user);
    return eo;
  }

  public static ERXFetchSpecification<CardUserProfile> fetchSpec() {
    return new ERXFetchSpecification<CardUserProfile>(_CardUserProfile.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CardUserProfile> fetchAllCardUserProfiles(EOEditingContext editingContext) {
    return _CardUserProfile.fetchAllCardUserProfiles(editingContext, null);
  }

  public static NSArray<CardUserProfile> fetchAllCardUserProfiles(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CardUserProfile.fetchCardUserProfiles(editingContext, null, sortOrderings);
  }

  public static NSArray<CardUserProfile> fetchCardUserProfiles(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CardUserProfile> fetchSpec = new ERXFetchSpecification<CardUserProfile>(_CardUserProfile.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CardUserProfile> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CardUserProfile fetchCardUserProfile(EOEditingContext editingContext, String keyName, Object value) {
    return _CardUserProfile.fetchCardUserProfile(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardUserProfile fetchCardUserProfile(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CardUserProfile> eoObjects = _CardUserProfile.fetchCardUserProfiles(editingContext, qualifier, null);
    CardUserProfile eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CardUserProfile that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardUserProfile fetchRequiredCardUserProfile(EOEditingContext editingContext, String keyName, Object value) {
    return _CardUserProfile.fetchRequiredCardUserProfile(editingContext, ERXQ.equals(keyName, value));
  }

  public static CardUserProfile fetchRequiredCardUserProfile(EOEditingContext editingContext, EOQualifier qualifier) {
    CardUserProfile eoObject = _CardUserProfile.fetchCardUserProfile(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CardUserProfile that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CardUserProfile localInstanceIn(EOEditingContext editingContext, CardUserProfile eo) {
    CardUserProfile localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
