// DO NOT EDIT.  Make changes to CountyUrl.java instead.
package org.opencalaccess.countyurls.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CountyUrl extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CountyUrl";

  // Attribute Keys
  public static final ERXKey<String> URL = new ERXKey<String>("url", Type.Attribute);
  public static final ERXKey<String> URL_TYPE = new ERXKey<String>("urlType", Type.Attribute);
  public static final ERXKey<String> WRITER = new ERXKey<String>("writer", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.countyurls.eo.UsCounty> COUNTY = new ERXKey<org.opencalaccess.countyurls.eo.UsCounty>("county", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.countyurls.eo.CountyUrlInfo> INFOS = new ERXKey<org.opencalaccess.countyurls.eo.CountyUrlInfo>("infos", Type.ToManyRelationship);

  // Attributes
  public static final String URL_KEY = URL.key();
  public static final String URL_TYPE_KEY = URL_TYPE.key();
  public static final String WRITER_KEY = WRITER.key();

  // Relationships
  public static final String COUNTY_KEY = COUNTY.key();
  public static final String INFOS_KEY = INFOS.key();

  private static final Logger log = LoggerFactory.getLogger(_CountyUrl.class);

  public CountyUrl localInstanceIn(EOEditingContext editingContext) {
    CountyUrl localInstance = (CountyUrl)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String url() {
    return (String) storedValueForKey(_CountyUrl.URL_KEY);
  }

  public void setUrl(String value) {
    log.debug( "updating url from {} to {}", url(), value);
    takeStoredValueForKey(value, _CountyUrl.URL_KEY);
  }

  public String urlType() {
    return (String) storedValueForKey(_CountyUrl.URL_TYPE_KEY);
  }

  public void setUrlType(String value) {
    log.debug( "updating urlType from {} to {}", urlType(), value);
    takeStoredValueForKey(value, _CountyUrl.URL_TYPE_KEY);
  }

  public String writer() {
    return (String) storedValueForKey(_CountyUrl.WRITER_KEY);
  }

  public void setWriter(String value) {
    log.debug( "updating writer from {} to {}", writer(), value);
    takeStoredValueForKey(value, _CountyUrl.WRITER_KEY);
  }

  public org.opencalaccess.countyurls.eo.UsCounty county() {
    return (org.opencalaccess.countyurls.eo.UsCounty)storedValueForKey(_CountyUrl.COUNTY_KEY);
  }

  public void setCounty(org.opencalaccess.countyurls.eo.UsCounty value) {
    takeStoredValueForKey(value, _CountyUrl.COUNTY_KEY);
  }

  public void setCountyRelationship(org.opencalaccess.countyurls.eo.UsCounty value) {
    log.debug("updating county from {} to {}", county(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCounty(value);
    }
    else if (value == null) {
      org.opencalaccess.countyurls.eo.UsCounty oldValue = county();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CountyUrl.COUNTY_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CountyUrl.COUNTY_KEY);
    }
  }

  public NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo> infos() {
    return (NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo>)storedValueForKey(_CountyUrl.INFOS_KEY);
  }

  public NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo> infos(EOQualifier qualifier) {
    return infos(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo> infos(EOQualifier qualifier, boolean fetch) {
    return infos(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo> infos(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.countyurls.eo.CountyUrlInfo.URL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.countyurls.eo.CountyUrlInfo.fetchCountyUrlInfos(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = infos();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.countyurls.eo.CountyUrlInfo>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToInfos(org.opencalaccess.countyurls.eo.CountyUrlInfo object) {
    includeObjectIntoPropertyWithKey(object, _CountyUrl.INFOS_KEY);
  }

  public void removeFromInfos(org.opencalaccess.countyurls.eo.CountyUrlInfo object) {
    excludeObjectFromPropertyWithKey(object, _CountyUrl.INFOS_KEY);
  }

  public void addToInfosRelationship(org.opencalaccess.countyurls.eo.CountyUrlInfo object) {
    log.debug("adding {} to infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToInfos(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CountyUrl.INFOS_KEY);
    }
  }

  public void removeFromInfosRelationship(org.opencalaccess.countyurls.eo.CountyUrlInfo object) {
    log.debug("removing {} from infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromInfos(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CountyUrl.INFOS_KEY);
    }
  }

  public org.opencalaccess.countyurls.eo.CountyUrlInfo createInfosRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.countyurls.eo.CountyUrlInfo.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CountyUrl.INFOS_KEY);
    return (org.opencalaccess.countyurls.eo.CountyUrlInfo) eo;
  }

  public void deleteInfosRelationship(org.opencalaccess.countyurls.eo.CountyUrlInfo object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CountyUrl.INFOS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllInfosRelationships() {
    Enumeration<org.opencalaccess.countyurls.eo.CountyUrlInfo> objects = infos().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteInfosRelationship(objects.nextElement());
    }
  }


  public static CountyUrl createCountyUrl(EOEditingContext editingContext, String url
, String urlType
, String writer
, org.opencalaccess.countyurls.eo.UsCounty county) {
    CountyUrl eo = (CountyUrl) EOUtilities.createAndInsertInstance(editingContext, _CountyUrl.ENTITY_NAME);
    eo.setUrl(url);
    eo.setUrlType(urlType);
    eo.setWriter(writer);
    eo.setCountyRelationship(county);
    return eo;
  }

  public static ERXFetchSpecification<CountyUrl> fetchSpec() {
    return new ERXFetchSpecification<CountyUrl>(_CountyUrl.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CountyUrl> fetchAllCountyUrls(EOEditingContext editingContext) {
    return _CountyUrl.fetchAllCountyUrls(editingContext, null);
  }

  public static NSArray<CountyUrl> fetchAllCountyUrls(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CountyUrl.fetchCountyUrls(editingContext, null, sortOrderings);
  }

  public static NSArray<CountyUrl> fetchCountyUrls(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CountyUrl> fetchSpec = new ERXFetchSpecification<CountyUrl>(_CountyUrl.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CountyUrl> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CountyUrl fetchCountyUrl(EOEditingContext editingContext, String keyName, Object value) {
    return _CountyUrl.fetchCountyUrl(editingContext, ERXQ.equals(keyName, value));
  }

  public static CountyUrl fetchCountyUrl(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CountyUrl> eoObjects = _CountyUrl.fetchCountyUrls(editingContext, qualifier, null);
    CountyUrl eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CountyUrl that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CountyUrl fetchRequiredCountyUrl(EOEditingContext editingContext, String keyName, Object value) {
    return _CountyUrl.fetchRequiredCountyUrl(editingContext, ERXQ.equals(keyName, value));
  }

  public static CountyUrl fetchRequiredCountyUrl(EOEditingContext editingContext, EOQualifier qualifier) {
    CountyUrl eoObject = _CountyUrl.fetchCountyUrl(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CountyUrl that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CountyUrl localInstanceIn(EOEditingContext editingContext, CountyUrl eo) {
    CountyUrl localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
