// DO NOT EDIT.  Make changes to CountyUrlInfo.java instead.
package org.opencalaccess.countyurls.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CountyUrlInfo extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CountyUrlInfo";

  // Attribute Keys
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> INFO = new ERXKey<String>("info", Type.Attribute);
  public static final ERXKey<String> WRITER = new ERXKey<String>("writer", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.countyurls.eo.CountyUrl> URL = new ERXKey<org.opencalaccess.countyurls.eo.CountyUrl>("url", Type.ToOneRelationship);

  // Attributes
  public static final String CREATED_KEY = CREATED.key();
  public static final String INFO_KEY = INFO.key();
  public static final String WRITER_KEY = WRITER.key();

  // Relationships
  public static final String URL_KEY = URL.key();

  private static final Logger log = LoggerFactory.getLogger(_CountyUrlInfo.class);

  public CountyUrlInfo localInstanceIn(EOEditingContext editingContext) {
    CountyUrlInfo localInstance = (CountyUrlInfo)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long created() {
    return (Long) storedValueForKey(_CountyUrlInfo.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _CountyUrlInfo.CREATED_KEY);
  }

  public String info() {
    return (String) storedValueForKey(_CountyUrlInfo.INFO_KEY);
  }

  public void setInfo(String value) {
    log.debug( "updating info from {} to {}", info(), value);
    takeStoredValueForKey(value, _CountyUrlInfo.INFO_KEY);
  }

  public String writer() {
    return (String) storedValueForKey(_CountyUrlInfo.WRITER_KEY);
  }

  public void setWriter(String value) {
    log.debug( "updating writer from {} to {}", writer(), value);
    takeStoredValueForKey(value, _CountyUrlInfo.WRITER_KEY);
  }

  public org.opencalaccess.countyurls.eo.CountyUrl url() {
    return (org.opencalaccess.countyurls.eo.CountyUrl)storedValueForKey(_CountyUrlInfo.URL_KEY);
  }

  public void setUrl(org.opencalaccess.countyurls.eo.CountyUrl value) {
    takeStoredValueForKey(value, _CountyUrlInfo.URL_KEY);
  }

  public void setUrlRelationship(org.opencalaccess.countyurls.eo.CountyUrl value) {
    log.debug("updating url from {} to {}", url(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUrl(value);
    }
    else if (value == null) {
      org.opencalaccess.countyurls.eo.CountyUrl oldValue = url();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CountyUrlInfo.URL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CountyUrlInfo.URL_KEY);
    }
  }


  public static CountyUrlInfo createCountyUrlInfo(EOEditingContext editingContext, Long created
, String info
, String writer
, org.opencalaccess.countyurls.eo.CountyUrl url) {
    CountyUrlInfo eo = (CountyUrlInfo) EOUtilities.createAndInsertInstance(editingContext, _CountyUrlInfo.ENTITY_NAME);
    eo.setCreated(created);
    eo.setInfo(info);
    eo.setWriter(writer);
    eo.setUrlRelationship(url);
    return eo;
  }

  public static ERXFetchSpecification<CountyUrlInfo> fetchSpec() {
    return new ERXFetchSpecification<CountyUrlInfo>(_CountyUrlInfo.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CountyUrlInfo> fetchAllCountyUrlInfos(EOEditingContext editingContext) {
    return _CountyUrlInfo.fetchAllCountyUrlInfos(editingContext, null);
  }

  public static NSArray<CountyUrlInfo> fetchAllCountyUrlInfos(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CountyUrlInfo.fetchCountyUrlInfos(editingContext, null, sortOrderings);
  }

  public static NSArray<CountyUrlInfo> fetchCountyUrlInfos(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CountyUrlInfo> fetchSpec = new ERXFetchSpecification<CountyUrlInfo>(_CountyUrlInfo.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CountyUrlInfo> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CountyUrlInfo fetchCountyUrlInfo(EOEditingContext editingContext, String keyName, Object value) {
    return _CountyUrlInfo.fetchCountyUrlInfo(editingContext, ERXQ.equals(keyName, value));
  }

  public static CountyUrlInfo fetchCountyUrlInfo(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CountyUrlInfo> eoObjects = _CountyUrlInfo.fetchCountyUrlInfos(editingContext, qualifier, null);
    CountyUrlInfo eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CountyUrlInfo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CountyUrlInfo fetchRequiredCountyUrlInfo(EOEditingContext editingContext, String keyName, Object value) {
    return _CountyUrlInfo.fetchRequiredCountyUrlInfo(editingContext, ERXQ.equals(keyName, value));
  }

  public static CountyUrlInfo fetchRequiredCountyUrlInfo(EOEditingContext editingContext, EOQualifier qualifier) {
    CountyUrlInfo eoObject = _CountyUrlInfo.fetchCountyUrlInfo(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CountyUrlInfo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CountyUrlInfo localInstanceIn(EOEditingContext editingContext, CountyUrlInfo eo) {
    CountyUrlInfo localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
