// DO NOT EDIT.  Make changes to UsState.java instead.
package org.opencalaccess.countyurls.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _UsState extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "UsState";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.countyurls.eo.UsCounty> COUNTIES = new ERXKey<org.opencalaccess.countyurls.eo.UsCounty>("counties", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String COUNTIES_KEY = COUNTIES.key();

  private static final Logger log = LoggerFactory.getLogger(_UsState.class);

  public UsState localInstanceIn(EOEditingContext editingContext) {
    UsState localInstance = (UsState)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_UsState.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _UsState.NAME_KEY);
  }

  public NSArray<org.opencalaccess.countyurls.eo.UsCounty> counties() {
    return (NSArray<org.opencalaccess.countyurls.eo.UsCounty>)storedValueForKey(_UsState.COUNTIES_KEY);
  }

  public NSArray<org.opencalaccess.countyurls.eo.UsCounty> counties(EOQualifier qualifier) {
    return counties(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.countyurls.eo.UsCounty> counties(EOQualifier qualifier, boolean fetch) {
    return counties(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.countyurls.eo.UsCounty> counties(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.countyurls.eo.UsCounty> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.countyurls.eo.UsCounty.STATE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.countyurls.eo.UsCounty.fetchUsCounties(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = counties();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.countyurls.eo.UsCounty>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.countyurls.eo.UsCounty>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCounties(org.opencalaccess.countyurls.eo.UsCounty object) {
    includeObjectIntoPropertyWithKey(object, _UsState.COUNTIES_KEY);
  }

  public void removeFromCounties(org.opencalaccess.countyurls.eo.UsCounty object) {
    excludeObjectFromPropertyWithKey(object, _UsState.COUNTIES_KEY);
  }

  public void addToCountiesRelationship(org.opencalaccess.countyurls.eo.UsCounty object) {
    log.debug("adding {} to counties relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCounties(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _UsState.COUNTIES_KEY);
    }
  }

  public void removeFromCountiesRelationship(org.opencalaccess.countyurls.eo.UsCounty object) {
    log.debug("removing {} from counties relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCounties(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _UsState.COUNTIES_KEY);
    }
  }

  public org.opencalaccess.countyurls.eo.UsCounty createCountiesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.countyurls.eo.UsCounty.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _UsState.COUNTIES_KEY);
    return (org.opencalaccess.countyurls.eo.UsCounty) eo;
  }

  public void deleteCountiesRelationship(org.opencalaccess.countyurls.eo.UsCounty object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _UsState.COUNTIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCountiesRelationships() {
    Enumeration<org.opencalaccess.countyurls.eo.UsCounty> objects = counties().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCountiesRelationship(objects.nextElement());
    }
  }


  public static UsState createUsState(EOEditingContext editingContext, String name
) {
    UsState eo = (UsState) EOUtilities.createAndInsertInstance(editingContext, _UsState.ENTITY_NAME);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<UsState> fetchSpec() {
    return new ERXFetchSpecification<UsState>(_UsState.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<UsState> fetchAllUsStates(EOEditingContext editingContext) {
    return _UsState.fetchAllUsStates(editingContext, null);
  }

  public static NSArray<UsState> fetchAllUsStates(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _UsState.fetchUsStates(editingContext, null, sortOrderings);
  }

  public static NSArray<UsState> fetchUsStates(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<UsState> fetchSpec = new ERXFetchSpecification<UsState>(_UsState.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<UsState> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static UsState fetchUsState(EOEditingContext editingContext, String keyName, Object value) {
    return _UsState.fetchUsState(editingContext, ERXQ.equals(keyName, value));
  }

  public static UsState fetchUsState(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<UsState> eoObjects = _UsState.fetchUsStates(editingContext, qualifier, null);
    UsState eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one UsState that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UsState fetchRequiredUsState(EOEditingContext editingContext, String keyName, Object value) {
    return _UsState.fetchRequiredUsState(editingContext, ERXQ.equals(keyName, value));
  }

  public static UsState fetchRequiredUsState(EOEditingContext editingContext, EOQualifier qualifier) {
    UsState eoObject = _UsState.fetchUsState(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no UsState that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UsState localInstanceIn(EOEditingContext editingContext, UsState eo) {
    UsState localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
