package org.opencalaccess.courtcases.eo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.foundation.NSArray;

public class CourtPage extends _CourtPage {

	private static final long serialVersionUID = 6784901397608739190L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(CourtPage.class);

	public void setPageText(String value) {

		boolean inCaseList = false;
		int numberInPage = 0;

		for (String line : NSArray.componentsSeparatedByString(value, "\r\n")) {

			if (line.startsWith("Showing ")) {
				inCaseList = false;
			}

			if (inCaseList) {

				numberInPage++;

				NSArray<String> parts = NSArray.componentsSeparatedByString(line, "\t");

				String hour = parts.get(2).substring(0,2);
				String min = parts.get(2).substring(3,5);
				String pm = parts.get(2).substring(6);

				if (pm.equals("pm")) {
					Integer hourInt = Integer.valueOf(hour) + 12;
					hour = hourInt.toString();
					if (hour.length() == 1) { hour = "0" + hour; }
				}

				String caseDate = this.calendarDateDept().calendarDate().displayDate() + " " + hour + min;

				CourtCase.createCourtCase(
						this.editingContext(),
						parts.get(0),
						numberInPage,
						parts.get(1),
						caseDate,
						this);
			}

			if (line.startsWith("View\tCase Number")) {
				inCaseList = true;
			}
		}
		super.setPageText(value);
	}
}
