package org.opencalaccess.courtcases.eo;

import org.opencalaccess.U;
import org.opencalaccess.invites.eo.User;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.eocontrol.EOEditingContext;

public class CourtPayment extends _CourtPayment {

	private static final long serialVersionUID = 3549859293578918629L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(CourtPayment.class);

	public static CourtPayment createCourtPayment(
			EOEditingContext editingContext,
			String userAddress) {

		User user = User.userForEmail(editingContext, userAddress);

		CourtPayment nextPayment = _CourtPayment.createCourtPayment(editingContext, U.now(), U.nextUUID(), user);

		long pages = 0;
		for (CourtWorkloadEntry entry : CourtWorkloadEntry.fetchAllCourtWorkloadEntries(editingContext)) {
			if (entry.user().emailAddress().equals(userAddress) &&
					entry.completed() != null &&
					(entry.payment() == null || entry.payment().paid() == null)) {
				entry.setPayment(nextPayment);
				pages++;
			}
		}
		nextPayment.setAmount(pages * Integer.valueOf(System.getProperty("CourtWorkloadEntryPaymentCents")));

		return nextPayment;
	}

	public String amountStr() {

		Long amount = amount();

		if (amount == null) { return "0.00"; }

		StringBuilder str = new StringBuilder();
		str.append(amount / 100);
		str.append(".");
		str.append(amount % 100);
		return str.toString();
	}
}
