// DO NOT EDIT.  Make changes to CourtCalendar.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtCalendar extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtCalendar";

  // Attribute Keys
  public static final ERXKey<String> ABBREVIATION = new ERXKey<String>("abbreviation", Type.Attribute);
  public static final ERXKey<String> CAL_SPEAK = new ERXKey<String>("calSpeak", Type.Attribute);
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDate> CALENDAR_DATES = new ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDate>("calendarDates", Type.ToManyRelationship);

  // Attributes
  public static final String ABBREVIATION_KEY = ABBREVIATION.key();
  public static final String CAL_SPEAK_KEY = CAL_SPEAK.key();
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String CALENDAR_DATES_KEY = CALENDAR_DATES.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtCalendar.class);

  public CourtCalendar localInstanceIn(EOEditingContext editingContext) {
    CourtCalendar localInstance = (CourtCalendar)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String abbreviation() {
    return (String) storedValueForKey(_CourtCalendar.ABBREVIATION_KEY);
  }

  public void setAbbreviation(String value) {
    log.debug( "updating abbreviation from {} to {}", abbreviation(), value);
    takeStoredValueForKey(value, _CourtCalendar.ABBREVIATION_KEY);
  }

  public String calSpeak() {
    return (String) storedValueForKey(_CourtCalendar.CAL_SPEAK_KEY);
  }

  public void setCalSpeak(String value) {
    log.debug( "updating calSpeak from {} to {}", calSpeak(), value);
    takeStoredValueForKey(value, _CourtCalendar.CAL_SPEAK_KEY);
  }

  public String name() {
    return (String) storedValueForKey(_CourtCalendar.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _CourtCalendar.NAME_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate> calendarDates() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate>)storedValueForKey(_CourtCalendar.CALENDAR_DATES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate> calendarDates(EOQualifier qualifier) {
    return calendarDates(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate> calendarDates(EOQualifier qualifier, boolean fetch) {
    return calendarDates(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate> calendarDates(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtCalendarDate.CALENDAR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtCalendarDate.fetchCourtCalendarDates(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = calendarDates();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDate>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCalendarDates(org.opencalaccess.courtcases.eo.CourtCalendarDate object) {
    includeObjectIntoPropertyWithKey(object, _CourtCalendar.CALENDAR_DATES_KEY);
  }

  public void removeFromCalendarDates(org.opencalaccess.courtcases.eo.CourtCalendarDate object) {
    excludeObjectFromPropertyWithKey(object, _CourtCalendar.CALENDAR_DATES_KEY);
  }

  public void addToCalendarDatesRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDate object) {
    log.debug("adding {} to calendarDates relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCalendarDates(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CourtCalendar.CALENDAR_DATES_KEY);
    }
  }

  public void removeFromCalendarDatesRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDate object) {
    log.debug("removing {} from calendarDates relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCalendarDates(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendar.CALENDAR_DATES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtCalendarDate createCalendarDatesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtCalendarDate.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CourtCalendar.CALENDAR_DATES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtCalendarDate) eo;
  }

  public void deleteCalendarDatesRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDate object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendar.CALENDAR_DATES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCalendarDatesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtCalendarDate> objects = calendarDates().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCalendarDatesRelationship(objects.nextElement());
    }
  }


  public static CourtCalendar createCourtCalendar(EOEditingContext editingContext, String abbreviation
, String calSpeak
, String name
) {
    CourtCalendar eo = (CourtCalendar) EOUtilities.createAndInsertInstance(editingContext, _CourtCalendar.ENTITY_NAME);
    eo.setAbbreviation(abbreviation);
    eo.setCalSpeak(calSpeak);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<CourtCalendar> fetchSpec() {
    return new ERXFetchSpecification<CourtCalendar>(_CourtCalendar.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtCalendar> fetchAllCourtCalendars(EOEditingContext editingContext) {
    return _CourtCalendar.fetchAllCourtCalendars(editingContext, null);
  }

  public static NSArray<CourtCalendar> fetchAllCourtCalendars(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtCalendar.fetchCourtCalendars(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtCalendar> fetchCourtCalendars(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtCalendar> fetchSpec = new ERXFetchSpecification<CourtCalendar>(_CourtCalendar.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtCalendar> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtCalendar fetchCourtCalendar(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendar.fetchCourtCalendar(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendar fetchCourtCalendar(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtCalendar> eoObjects = _CourtCalendar.fetchCourtCalendars(editingContext, qualifier, null);
    CourtCalendar eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtCalendar that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendar fetchRequiredCourtCalendar(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendar.fetchRequiredCourtCalendar(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendar fetchRequiredCourtCalendar(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtCalendar eoObject = _CourtCalendar.fetchCourtCalendar(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtCalendar that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendar localInstanceIn(EOEditingContext editingContext, CourtCalendar eo) {
    CourtCalendar localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
