// DO NOT EDIT.  Make changes to CourtCalendarDate.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtCalendarDate extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtCalendarDate";

  // Attribute Keys
  public static final ERXKey<String> DISPLAY_DATE = new ERXKey<String>("displayDate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCalendar> CALENDAR = new ERXKey<org.opencalaccess.courtcases.eo.CourtCalendar>("calendar", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> CALENDAR_DATE_DEPTS = new ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDateDept>("calendarDateDepts", Type.ToManyRelationship);

  // Attributes
  public static final String DISPLAY_DATE_KEY = DISPLAY_DATE.key();

  // Relationships
  public static final String CALENDAR_KEY = CALENDAR.key();
  public static final String CALENDAR_DATE_DEPTS_KEY = CALENDAR_DATE_DEPTS.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtCalendarDate.class);

  public CourtCalendarDate localInstanceIn(EOEditingContext editingContext) {
    CourtCalendarDate localInstance = (CourtCalendarDate)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String displayDate() {
    return (String) storedValueForKey(_CourtCalendarDate.DISPLAY_DATE_KEY);
  }

  public void setDisplayDate(String value) {
    log.debug( "updating displayDate from {} to {}", displayDate(), value);
    takeStoredValueForKey(value, _CourtCalendarDate.DISPLAY_DATE_KEY);
  }

  public org.opencalaccess.courtcases.eo.CourtCalendar calendar() {
    return (org.opencalaccess.courtcases.eo.CourtCalendar)storedValueForKey(_CourtCalendarDate.CALENDAR_KEY);
  }

  public void setCalendar(org.opencalaccess.courtcases.eo.CourtCalendar value) {
    takeStoredValueForKey(value, _CourtCalendarDate.CALENDAR_KEY);
  }

  public void setCalendarRelationship(org.opencalaccess.courtcases.eo.CourtCalendar value) {
    log.debug("updating calendar from {} to {}", calendar(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCalendar(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtCalendar oldValue = calendar();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtCalendarDate.CALENDAR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtCalendarDate.CALENDAR_KEY);
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> calendarDateDepts() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept>)storedValueForKey(_CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> calendarDateDepts(EOQualifier qualifier) {
    return calendarDateDepts(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> calendarDateDepts(EOQualifier qualifier, boolean fetch) {
    return calendarDateDepts(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> calendarDateDepts(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtCalendarDateDept.CALENDAR_DATE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtCalendarDateDept.fetchCourtCalendarDateDepts(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = calendarDateDepts();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCalendarDateDept>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCalendarDateDepts(org.opencalaccess.courtcases.eo.CourtCalendarDateDept object) {
    includeObjectIntoPropertyWithKey(object, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
  }

  public void removeFromCalendarDateDepts(org.opencalaccess.courtcases.eo.CourtCalendarDateDept object) {
    excludeObjectFromPropertyWithKey(object, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
  }

  public void addToCalendarDateDeptsRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDateDept object) {
    log.debug("adding {} to calendarDateDepts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCalendarDateDepts(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
    }
  }

  public void removeFromCalendarDateDeptsRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDateDept object) {
    log.debug("removing {} from calendarDateDepts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCalendarDateDepts(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtCalendarDateDept createCalendarDateDeptsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtCalendarDateDept.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
    return (org.opencalaccess.courtcases.eo.CourtCalendarDateDept) eo;
  }

  public void deleteCalendarDateDeptsRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDateDept object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendarDate.CALENDAR_DATE_DEPTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCalendarDateDeptsRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> objects = calendarDateDepts().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCalendarDateDeptsRelationship(objects.nextElement());
    }
  }


  public static CourtCalendarDate createCourtCalendarDate(EOEditingContext editingContext, String displayDate
, org.opencalaccess.courtcases.eo.CourtCalendar calendar) {
    CourtCalendarDate eo = (CourtCalendarDate) EOUtilities.createAndInsertInstance(editingContext, _CourtCalendarDate.ENTITY_NAME);
    eo.setDisplayDate(displayDate);
    eo.setCalendarRelationship(calendar);
    return eo;
  }

  public static ERXFetchSpecification<CourtCalendarDate> fetchSpec() {
    return new ERXFetchSpecification<CourtCalendarDate>(_CourtCalendarDate.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtCalendarDate> fetchAllCourtCalendarDates(EOEditingContext editingContext) {
    return _CourtCalendarDate.fetchAllCourtCalendarDates(editingContext, null);
  }

  public static NSArray<CourtCalendarDate> fetchAllCourtCalendarDates(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtCalendarDate.fetchCourtCalendarDates(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtCalendarDate> fetchCourtCalendarDates(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtCalendarDate> fetchSpec = new ERXFetchSpecification<CourtCalendarDate>(_CourtCalendarDate.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtCalendarDate> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtCalendarDate fetchCourtCalendarDate(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendarDate.fetchCourtCalendarDate(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendarDate fetchCourtCalendarDate(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtCalendarDate> eoObjects = _CourtCalendarDate.fetchCourtCalendarDates(editingContext, qualifier, null);
    CourtCalendarDate eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtCalendarDate that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendarDate fetchRequiredCourtCalendarDate(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendarDate.fetchRequiredCourtCalendarDate(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendarDate fetchRequiredCourtCalendarDate(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtCalendarDate eoObject = _CourtCalendarDate.fetchCourtCalendarDate(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtCalendarDate that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendarDate localInstanceIn(EOEditingContext editingContext, CourtCalendarDate eo) {
    CourtCalendarDate localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
