// DO NOT EDIT.  Make changes to CourtCalendarDateDept.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtCalendarDateDept extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtCalendarDateDept";

  // Attribute Keys
  public static final ERXKey<String> DEPARTMENT = new ERXKey<String>("department", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDate> CALENDAR_DATE = new ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDate>("calendarDate", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtPage> COURT_PAGES = new ERXKey<org.opencalaccess.courtcases.eo.CourtPage>("courtPages", Type.ToManyRelationship);

  // Attributes
  public static final String DEPARTMENT_KEY = DEPARTMENT.key();

  // Relationships
  public static final String CALENDAR_DATE_KEY = CALENDAR_DATE.key();
  public static final String COURT_PAGES_KEY = COURT_PAGES.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtCalendarDateDept.class);

  public CourtCalendarDateDept localInstanceIn(EOEditingContext editingContext) {
    CourtCalendarDateDept localInstance = (CourtCalendarDateDept)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String department() {
    return (String) storedValueForKey(_CourtCalendarDateDept.DEPARTMENT_KEY);
  }

  public void setDepartment(String value) {
    log.debug( "updating department from {} to {}", department(), value);
    takeStoredValueForKey(value, _CourtCalendarDateDept.DEPARTMENT_KEY);
  }

  public org.opencalaccess.courtcases.eo.CourtCalendarDate calendarDate() {
    return (org.opencalaccess.courtcases.eo.CourtCalendarDate)storedValueForKey(_CourtCalendarDateDept.CALENDAR_DATE_KEY);
  }

  public void setCalendarDate(org.opencalaccess.courtcases.eo.CourtCalendarDate value) {
    takeStoredValueForKey(value, _CourtCalendarDateDept.CALENDAR_DATE_KEY);
  }

  public void setCalendarDateRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDate value) {
    log.debug("updating calendarDate from {} to {}", calendarDate(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCalendarDate(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtCalendarDate oldValue = calendarDate();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtCalendarDateDept.CALENDAR_DATE_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtCalendarDateDept.CALENDAR_DATE_KEY);
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPage> courtPages() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtPage>)storedValueForKey(_CourtCalendarDateDept.COURT_PAGES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPage> courtPages(EOQualifier qualifier) {
    return courtPages(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPage> courtPages(EOQualifier qualifier, boolean fetch) {
    return courtPages(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPage> courtPages(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtPage> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtPage.CALENDAR_DATE_DEPT_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtPage.fetchCourtPages(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = courtPages();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtPage>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtPage>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCourtPages(org.opencalaccess.courtcases.eo.CourtPage object) {
    includeObjectIntoPropertyWithKey(object, _CourtCalendarDateDept.COURT_PAGES_KEY);
  }

  public void removeFromCourtPages(org.opencalaccess.courtcases.eo.CourtPage object) {
    excludeObjectFromPropertyWithKey(object, _CourtCalendarDateDept.COURT_PAGES_KEY);
  }

  public void addToCourtPagesRelationship(org.opencalaccess.courtcases.eo.CourtPage object) {
    log.debug("adding {} to courtPages relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCourtPages(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CourtCalendarDateDept.COURT_PAGES_KEY);
    }
  }

  public void removeFromCourtPagesRelationship(org.opencalaccess.courtcases.eo.CourtPage object) {
    log.debug("removing {} from courtPages relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCourtPages(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendarDateDept.COURT_PAGES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtPage createCourtPagesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtPage.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CourtCalendarDateDept.COURT_PAGES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtPage) eo;
  }

  public void deleteCourtPagesRelationship(org.opencalaccess.courtcases.eo.CourtPage object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtCalendarDateDept.COURT_PAGES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCourtPagesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtPage> objects = courtPages().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCourtPagesRelationship(objects.nextElement());
    }
  }


  public static CourtCalendarDateDept createCourtCalendarDateDept(EOEditingContext editingContext, String department
, org.opencalaccess.courtcases.eo.CourtCalendarDate calendarDate) {
    CourtCalendarDateDept eo = (CourtCalendarDateDept) EOUtilities.createAndInsertInstance(editingContext, _CourtCalendarDateDept.ENTITY_NAME);
    eo.setDepartment(department);
    eo.setCalendarDateRelationship(calendarDate);
    return eo;
  }

  public static ERXFetchSpecification<CourtCalendarDateDept> fetchSpec() {
    return new ERXFetchSpecification<CourtCalendarDateDept>(_CourtCalendarDateDept.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtCalendarDateDept> fetchAllCourtCalendarDateDepts(EOEditingContext editingContext) {
    return _CourtCalendarDateDept.fetchAllCourtCalendarDateDepts(editingContext, null);
  }

  public static NSArray<CourtCalendarDateDept> fetchAllCourtCalendarDateDepts(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtCalendarDateDept.fetchCourtCalendarDateDepts(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtCalendarDateDept> fetchCourtCalendarDateDepts(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtCalendarDateDept> fetchSpec = new ERXFetchSpecification<CourtCalendarDateDept>(_CourtCalendarDateDept.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtCalendarDateDept> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtCalendarDateDept fetchCourtCalendarDateDept(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendarDateDept.fetchCourtCalendarDateDept(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendarDateDept fetchCourtCalendarDateDept(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtCalendarDateDept> eoObjects = _CourtCalendarDateDept.fetchCourtCalendarDateDepts(editingContext, qualifier, null);
    CourtCalendarDateDept eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtCalendarDateDept that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendarDateDept fetchRequiredCourtCalendarDateDept(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCalendarDateDept.fetchRequiredCourtCalendarDateDept(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCalendarDateDept fetchRequiredCourtCalendarDateDept(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtCalendarDateDept eoObject = _CourtCalendarDateDept.fetchCourtCalendarDateDept(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtCalendarDateDept that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCalendarDateDept localInstanceIn(EOEditingContext editingContext, CourtCalendarDateDept eo) {
    CourtCalendarDateDept localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
