// DO NOT EDIT.  Make changes to CourtCase.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtCase extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtCase";

  // Attribute Keys
  public static final ERXKey<String> CASE_NUMBER = new ERXKey<String>("caseNumber", Type.Attribute);
  public static final ERXKey<Integer> PAGE_POSITION = new ERXKey<Integer>("pagePosition", Type.Attribute);
  public static final ERXKey<String> PARTIES_LIST = new ERXKey<String>("partiesList", Type.Attribute);
  public static final ERXKey<String> SCHEDULED_TIME = new ERXKey<String>("scheduledTime", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtPage> COURT_PAGE = new ERXKey<org.opencalaccess.courtcases.eo.CourtPage>("courtPage", Type.ToOneRelationship);

  // Attributes
  public static final String CASE_NUMBER_KEY = CASE_NUMBER.key();
  public static final String PAGE_POSITION_KEY = PAGE_POSITION.key();
  public static final String PARTIES_LIST_KEY = PARTIES_LIST.key();
  public static final String SCHEDULED_TIME_KEY = SCHEDULED_TIME.key();

  // Relationships
  public static final String COURT_PAGE_KEY = COURT_PAGE.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtCase.class);

  public CourtCase localInstanceIn(EOEditingContext editingContext) {
    CourtCase localInstance = (CourtCase)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String caseNumber() {
    return (String) storedValueForKey(_CourtCase.CASE_NUMBER_KEY);
  }

  public void setCaseNumber(String value) {
    log.debug( "updating caseNumber from {} to {}", caseNumber(), value);
    takeStoredValueForKey(value, _CourtCase.CASE_NUMBER_KEY);
  }

  public Integer pagePosition() {
    return (Integer) storedValueForKey(_CourtCase.PAGE_POSITION_KEY);
  }

  public void setPagePosition(Integer value) {
    log.debug( "updating pagePosition from {} to {}", pagePosition(), value);
    takeStoredValueForKey(value, _CourtCase.PAGE_POSITION_KEY);
  }

  public String partiesList() {
    return (String) storedValueForKey(_CourtCase.PARTIES_LIST_KEY);
  }

  public void setPartiesList(String value) {
    log.debug( "updating partiesList from {} to {}", partiesList(), value);
    takeStoredValueForKey(value, _CourtCase.PARTIES_LIST_KEY);
  }

  public String scheduledTime() {
    return (String) storedValueForKey(_CourtCase.SCHEDULED_TIME_KEY);
  }

  public void setScheduledTime(String value) {
    log.debug( "updating scheduledTime from {} to {}", scheduledTime(), value);
    takeStoredValueForKey(value, _CourtCase.SCHEDULED_TIME_KEY);
  }

  public org.opencalaccess.courtcases.eo.CourtPage courtPage() {
    return (org.opencalaccess.courtcases.eo.CourtPage)storedValueForKey(_CourtCase.COURT_PAGE_KEY);
  }

  public void setCourtPage(org.opencalaccess.courtcases.eo.CourtPage value) {
    takeStoredValueForKey(value, _CourtCase.COURT_PAGE_KEY);
  }

  public void setCourtPageRelationship(org.opencalaccess.courtcases.eo.CourtPage value) {
    log.debug("updating courtPage from {} to {}", courtPage(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCourtPage(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtPage oldValue = courtPage();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtCase.COURT_PAGE_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtCase.COURT_PAGE_KEY);
    }
  }


  public static CourtCase createCourtCase(EOEditingContext editingContext, String caseNumber
, Integer pagePosition
, String partiesList
, String scheduledTime
, org.opencalaccess.courtcases.eo.CourtPage courtPage) {
    CourtCase eo = (CourtCase) EOUtilities.createAndInsertInstance(editingContext, _CourtCase.ENTITY_NAME);
    eo.setCaseNumber(caseNumber);
    eo.setPagePosition(pagePosition);
    eo.setPartiesList(partiesList);
    eo.setScheduledTime(scheduledTime);
    eo.setCourtPageRelationship(courtPage);
    return eo;
  }

  public static ERXFetchSpecification<CourtCase> fetchSpec() {
    return new ERXFetchSpecification<CourtCase>(_CourtCase.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtCase> fetchAllCourtCases(EOEditingContext editingContext) {
    return _CourtCase.fetchAllCourtCases(editingContext, null);
  }

  public static NSArray<CourtCase> fetchAllCourtCases(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtCase.fetchCourtCases(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtCase> fetchCourtCases(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtCase> fetchSpec = new ERXFetchSpecification<CourtCase>(_CourtCase.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtCase> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtCase fetchCourtCase(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCase.fetchCourtCase(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCase fetchCourtCase(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtCase> eoObjects = _CourtCase.fetchCourtCases(editingContext, qualifier, null);
    CourtCase eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtCase that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCase fetchRequiredCourtCase(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtCase.fetchRequiredCourtCase(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtCase fetchRequiredCourtCase(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtCase eoObject = _CourtCase.fetchCourtCase(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtCase that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtCase localInstanceIn(EOEditingContext editingContext, CourtCase eo) {
    CourtCase localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
