// DO NOT EDIT.  Make changes to CourtPage.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtPage extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtPage";

  // Attribute Keys
  public static final ERXKey<Integer> IS_VALID = new ERXKey<Integer>("isValid", Type.Attribute);
  public static final ERXKey<String> PAGE_TEXT = new ERXKey<String>("pageText", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDateDept> CALENDAR_DATE_DEPT = new ERXKey<org.opencalaccess.courtcases.eo.CourtCalendarDateDept>("calendarDateDept", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtCase> CASES = new ERXKey<org.opencalaccess.courtcases.eo.CourtCase>("cases", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> WORKLOAD_ENTRY = new ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>("workloadEntry", Type.ToOneRelationship);

  // Attributes
  public static final String IS_VALID_KEY = IS_VALID.key();
  public static final String PAGE_TEXT_KEY = PAGE_TEXT.key();

  // Relationships
  public static final String CALENDAR_DATE_DEPT_KEY = CALENDAR_DATE_DEPT.key();
  public static final String CASES_KEY = CASES.key();
  public static final String WORKLOAD_ENTRY_KEY = WORKLOAD_ENTRY.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtPage.class);

  public CourtPage localInstanceIn(EOEditingContext editingContext) {
    CourtPage localInstance = (CourtPage)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Integer isValid() {
    return (Integer) storedValueForKey(_CourtPage.IS_VALID_KEY);
  }

  public void setIsValid(Integer value) {
    log.debug( "updating isValid from {} to {}", isValid(), value);
    takeStoredValueForKey(value, _CourtPage.IS_VALID_KEY);
  }

  public String pageText() {
    return (String) storedValueForKey(_CourtPage.PAGE_TEXT_KEY);
  }

  public void setPageText(String value) {
    log.debug( "updating pageText from {} to {}", pageText(), value);
    takeStoredValueForKey(value, _CourtPage.PAGE_TEXT_KEY);
  }

  public org.opencalaccess.courtcases.eo.CourtCalendarDateDept calendarDateDept() {
    return (org.opencalaccess.courtcases.eo.CourtCalendarDateDept)storedValueForKey(_CourtPage.CALENDAR_DATE_DEPT_KEY);
  }

  public void setCalendarDateDept(org.opencalaccess.courtcases.eo.CourtCalendarDateDept value) {
    takeStoredValueForKey(value, _CourtPage.CALENDAR_DATE_DEPT_KEY);
  }

  public void setCalendarDateDeptRelationship(org.opencalaccess.courtcases.eo.CourtCalendarDateDept value) {
    log.debug("updating calendarDateDept from {} to {}", calendarDateDept(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCalendarDateDept(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtCalendarDateDept oldValue = calendarDateDept();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtPage.CALENDAR_DATE_DEPT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtPage.CALENDAR_DATE_DEPT_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtWorkloadEntry workloadEntry() {
    return (org.opencalaccess.courtcases.eo.CourtWorkloadEntry)storedValueForKey(_CourtPage.WORKLOAD_ENTRY_KEY);
  }

  public void setWorkloadEntry(org.opencalaccess.courtcases.eo.CourtWorkloadEntry value) {
    takeStoredValueForKey(value, _CourtPage.WORKLOAD_ENTRY_KEY);
  }

  public void setWorkloadEntryRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry value) {
    log.debug("updating workloadEntry from {} to {}", workloadEntry(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setWorkloadEntry(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtWorkloadEntry oldValue = workloadEntry();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtPage.WORKLOAD_ENTRY_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtPage.WORKLOAD_ENTRY_KEY);
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCase> cases() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtCase>)storedValueForKey(_CourtPage.CASES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCase> cases(EOQualifier qualifier) {
    return cases(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCase> cases(EOQualifier qualifier, boolean fetch) {
    return cases(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtCase> cases(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtCase> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtCase.COURT_PAGE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtCase.fetchCourtCases(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = cases();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCase>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtCase>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCases(org.opencalaccess.courtcases.eo.CourtCase object) {
    includeObjectIntoPropertyWithKey(object, _CourtPage.CASES_KEY);
  }

  public void removeFromCases(org.opencalaccess.courtcases.eo.CourtCase object) {
    excludeObjectFromPropertyWithKey(object, _CourtPage.CASES_KEY);
  }

  public void addToCasesRelationship(org.opencalaccess.courtcases.eo.CourtCase object) {
    log.debug("adding {} to cases relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCases(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CourtPage.CASES_KEY);
    }
  }

  public void removeFromCasesRelationship(org.opencalaccess.courtcases.eo.CourtCase object) {
    log.debug("removing {} from cases relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCases(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtPage.CASES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtCase createCasesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtCase.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CourtPage.CASES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtCase) eo;
  }

  public void deleteCasesRelationship(org.opencalaccess.courtcases.eo.CourtCase object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtPage.CASES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCasesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtCase> objects = cases().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCasesRelationship(objects.nextElement());
    }
  }


  public static CourtPage createCourtPage(EOEditingContext editingContext, org.opencalaccess.courtcases.eo.CourtCalendarDateDept calendarDateDept, org.opencalaccess.courtcases.eo.CourtWorkloadEntry workloadEntry) {
    CourtPage eo = (CourtPage) EOUtilities.createAndInsertInstance(editingContext, _CourtPage.ENTITY_NAME);
    eo.setCalendarDateDeptRelationship(calendarDateDept);
    eo.setWorkloadEntryRelationship(workloadEntry);
    return eo;
  }

  public static ERXFetchSpecification<CourtPage> fetchSpec() {
    return new ERXFetchSpecification<CourtPage>(_CourtPage.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtPage> fetchAllCourtPages(EOEditingContext editingContext) {
    return _CourtPage.fetchAllCourtPages(editingContext, null);
  }

  public static NSArray<CourtPage> fetchAllCourtPages(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtPage.fetchCourtPages(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtPage> fetchCourtPages(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtPage> fetchSpec = new ERXFetchSpecification<CourtPage>(_CourtPage.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtPage> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtPage fetchCourtPage(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtPage.fetchCourtPage(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtPage fetchCourtPage(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtPage> eoObjects = _CourtPage.fetchCourtPages(editingContext, qualifier, null);
    CourtPage eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtPage that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtPage fetchRequiredCourtPage(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtPage.fetchRequiredCourtPage(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtPage fetchRequiredCourtPage(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtPage eoObject = _CourtPage.fetchCourtPage(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtPage that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtPage localInstanceIn(EOEditingContext editingContext, CourtPage eo) {
    CourtPage localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
