// DO NOT EDIT.  Make changes to CourtPayment.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtPayment extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtPayment";

  // Attribute Keys
  public static final ERXKey<Long> AMOUNT = new ERXKey<Long>("amount", Type.Attribute);
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> DIGEST = new ERXKey<String>("digest", Type.Attribute);
  public static final ERXKey<Long> PAID = new ERXKey<Long>("paid", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.invites.eo.User> USER = new ERXKey<org.opencalaccess.invites.eo.User>("user", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> WORKLOAD_ENTRIES = new ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>("workloadEntries", Type.ToManyRelationship);

  // Attributes
  public static final String AMOUNT_KEY = AMOUNT.key();
  public static final String CREATED_KEY = CREATED.key();
  public static final String DIGEST_KEY = DIGEST.key();
  public static final String PAID_KEY = PAID.key();

  // Relationships
  public static final String USER_KEY = USER.key();
  public static final String WORKLOAD_ENTRIES_KEY = WORKLOAD_ENTRIES.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtPayment.class);

  public CourtPayment localInstanceIn(EOEditingContext editingContext) {
    CourtPayment localInstance = (CourtPayment)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long amount() {
    return (Long) storedValueForKey(_CourtPayment.AMOUNT_KEY);
  }

  public void setAmount(Long value) {
    log.debug( "updating amount from {} to {}", amount(), value);
    takeStoredValueForKey(value, _CourtPayment.AMOUNT_KEY);
  }

  public Long created() {
    return (Long) storedValueForKey(_CourtPayment.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _CourtPayment.CREATED_KEY);
  }

  public String digest() {
    return (String) storedValueForKey(_CourtPayment.DIGEST_KEY);
  }

  public void setDigest(String value) {
    log.debug( "updating digest from {} to {}", digest(), value);
    takeStoredValueForKey(value, _CourtPayment.DIGEST_KEY);
  }

  public Long paid() {
    return (Long) storedValueForKey(_CourtPayment.PAID_KEY);
  }

  public void setPaid(Long value) {
    log.debug( "updating paid from {} to {}", paid(), value);
    takeStoredValueForKey(value, _CourtPayment.PAID_KEY);
  }

  public org.opencalaccess.invites.eo.User user() {
    return (org.opencalaccess.invites.eo.User)storedValueForKey(_CourtPayment.USER_KEY);
  }

  public void setUser(org.opencalaccess.invites.eo.User value) {
    takeStoredValueForKey(value, _CourtPayment.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.invites.eo.User value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.invites.eo.User oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtPayment.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtPayment.USER_KEY);
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> workloadEntries() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)storedValueForKey(_CourtPayment.WORKLOAD_ENTRIES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> workloadEntries(EOQualifier qualifier) {
    return workloadEntries(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> workloadEntries(EOQualifier qualifier, boolean fetch) {
    return workloadEntries(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> workloadEntries(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtWorkloadEntry.PAYMENT_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtWorkloadEntry.fetchCourtWorkloadEntries(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = workloadEntries();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToWorkloadEntries(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    includeObjectIntoPropertyWithKey(object, _CourtPayment.WORKLOAD_ENTRIES_KEY);
  }

  public void removeFromWorkloadEntries(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    excludeObjectFromPropertyWithKey(object, _CourtPayment.WORKLOAD_ENTRIES_KEY);
  }

  public void addToWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    log.debug("adding {} to workloadEntries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToWorkloadEntries(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CourtPayment.WORKLOAD_ENTRIES_KEY);
    }
  }

  public void removeFromWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    log.debug("removing {} from workloadEntries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromWorkloadEntries(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtPayment.WORKLOAD_ENTRIES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtWorkloadEntry createWorkloadEntriesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtWorkloadEntry.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CourtPayment.WORKLOAD_ENTRIES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtWorkloadEntry) eo;
  }

  public void deleteWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CourtPayment.WORKLOAD_ENTRIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllWorkloadEntriesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> objects = workloadEntries().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteWorkloadEntriesRelationship(objects.nextElement());
    }
  }


  public static CourtPayment createCourtPayment(EOEditingContext editingContext, Long created
, String digest
, org.opencalaccess.invites.eo.User user) {
    CourtPayment eo = (CourtPayment) EOUtilities.createAndInsertInstance(editingContext, _CourtPayment.ENTITY_NAME);
    eo.setCreated(created);
    eo.setDigest(digest);
    eo.setUserRelationship(user);
    return eo;
  }

  public static ERXFetchSpecification<CourtPayment> fetchSpec() {
    return new ERXFetchSpecification<CourtPayment>(_CourtPayment.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtPayment> fetchAllCourtPayments(EOEditingContext editingContext) {
    return _CourtPayment.fetchAllCourtPayments(editingContext, null);
  }

  public static NSArray<CourtPayment> fetchAllCourtPayments(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtPayment.fetchCourtPayments(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtPayment> fetchCourtPayments(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtPayment> fetchSpec = new ERXFetchSpecification<CourtPayment>(_CourtPayment.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtPayment> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtPayment fetchCourtPayment(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtPayment.fetchCourtPayment(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtPayment fetchCourtPayment(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtPayment> eoObjects = _CourtPayment.fetchCourtPayments(editingContext, qualifier, null);
    CourtPayment eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtPayment that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtPayment fetchRequiredCourtPayment(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtPayment.fetchRequiredCourtPayment(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtPayment fetchRequiredCourtPayment(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtPayment eoObject = _CourtPayment.fetchCourtPayment(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtPayment that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtPayment localInstanceIn(EOEditingContext editingContext, CourtPayment eo) {
    CourtPayment localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
