// DO NOT EDIT.  Make changes to CourtWorkerMessage.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtWorkerMessage extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtWorkerMessage";

  // Attribute Keys
  public static final ERXKey<String> CONTENT = new ERXKey<String>("content", Type.Attribute);
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.invites.eo.User> USER = new ERXKey<org.opencalaccess.invites.eo.User>("user", Type.ToOneRelationship);

  // Attributes
  public static final String CONTENT_KEY = CONTENT.key();
  public static final String CREATED_KEY = CREATED.key();

  // Relationships
  public static final String USER_KEY = USER.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtWorkerMessage.class);

  public CourtWorkerMessage localInstanceIn(EOEditingContext editingContext) {
    CourtWorkerMessage localInstance = (CourtWorkerMessage)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String content() {
    return (String) storedValueForKey(_CourtWorkerMessage.CONTENT_KEY);
  }

  public void setContent(String value) {
    log.debug( "updating content from {} to {}", content(), value);
    takeStoredValueForKey(value, _CourtWorkerMessage.CONTENT_KEY);
  }

  public Long created() {
    return (Long) storedValueForKey(_CourtWorkerMessage.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _CourtWorkerMessage.CREATED_KEY);
  }

  public org.opencalaccess.invites.eo.User user() {
    return (org.opencalaccess.invites.eo.User)storedValueForKey(_CourtWorkerMessage.USER_KEY);
  }

  public void setUser(org.opencalaccess.invites.eo.User value) {
    takeStoredValueForKey(value, _CourtWorkerMessage.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.invites.eo.User value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.invites.eo.User oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtWorkerMessage.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtWorkerMessage.USER_KEY);
    }
  }


  public static CourtWorkerMessage createCourtWorkerMessage(EOEditingContext editingContext, String content
, Long created
, org.opencalaccess.invites.eo.User user) {
    CourtWorkerMessage eo = (CourtWorkerMessage) EOUtilities.createAndInsertInstance(editingContext, _CourtWorkerMessage.ENTITY_NAME);
    eo.setContent(content);
    eo.setCreated(created);
    eo.setUserRelationship(user);
    return eo;
  }

  public static ERXFetchSpecification<CourtWorkerMessage> fetchSpec() {
    return new ERXFetchSpecification<CourtWorkerMessage>(_CourtWorkerMessage.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtWorkerMessage> fetchAllCourtWorkerMessages(EOEditingContext editingContext) {
    return _CourtWorkerMessage.fetchAllCourtWorkerMessages(editingContext, null);
  }

  public static NSArray<CourtWorkerMessage> fetchAllCourtWorkerMessages(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtWorkerMessage.fetchCourtWorkerMessages(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtWorkerMessage> fetchCourtWorkerMessages(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtWorkerMessage> fetchSpec = new ERXFetchSpecification<CourtWorkerMessage>(_CourtWorkerMessage.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtWorkerMessage> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtWorkerMessage fetchCourtWorkerMessage(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtWorkerMessage.fetchCourtWorkerMessage(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtWorkerMessage fetchCourtWorkerMessage(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtWorkerMessage> eoObjects = _CourtWorkerMessage.fetchCourtWorkerMessages(editingContext, qualifier, null);
    CourtWorkerMessage eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtWorkerMessage that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtWorkerMessage fetchRequiredCourtWorkerMessage(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtWorkerMessage.fetchRequiredCourtWorkerMessage(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtWorkerMessage fetchRequiredCourtWorkerMessage(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtWorkerMessage eoObject = _CourtWorkerMessage.fetchCourtWorkerMessage(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtWorkerMessage that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtWorkerMessage localInstanceIn(EOEditingContext editingContext, CourtWorkerMessage eo) {
    CourtWorkerMessage localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
