// DO NOT EDIT.  Make changes to CourtWorkloadEntry.java instead.
package org.opencalaccess.courtcases.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CourtWorkloadEntry extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CourtWorkloadEntry";

  // Attribute Keys
  public static final ERXKey<String> CASES_DIGEST = new ERXKey<String>("casesDigest", Type.Attribute);
  public static final ERXKey<String> CHECKS_PASSED = new ERXKey<String>("checksPassed", Type.Attribute);
  public static final ERXKey<Long> COMPLETED = new ERXKey<Long>("completed", Type.Attribute);
  public static final ERXKey<String> COMPLETE_DIGEST = new ERXKey<String>("completeDigest", Type.Attribute);
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> PAGE_DIGEST = new ERXKey<String>("pageDigest", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtPage> COURT_PAGE = new ERXKey<org.opencalaccess.courtcases.eo.CourtPage>("courtPage", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtPayment> PAYMENT = new ERXKey<org.opencalaccess.courtcases.eo.CourtPayment>("payment", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.invites.eo.User> USER = new ERXKey<org.opencalaccess.invites.eo.User>("user", Type.ToOneRelationship);

  // Attributes
  public static final String CASES_DIGEST_KEY = CASES_DIGEST.key();
  public static final String CHECKS_PASSED_KEY = CHECKS_PASSED.key();
  public static final String COMPLETED_KEY = COMPLETED.key();
  public static final String COMPLETE_DIGEST_KEY = COMPLETE_DIGEST.key();
  public static final String CREATED_KEY = CREATED.key();
  public static final String PAGE_DIGEST_KEY = PAGE_DIGEST.key();

  // Relationships
  public static final String COURT_PAGE_KEY = COURT_PAGE.key();
  public static final String PAYMENT_KEY = PAYMENT.key();
  public static final String USER_KEY = USER.key();

  private static final Logger log = LoggerFactory.getLogger(_CourtWorkloadEntry.class);

  public CourtWorkloadEntry localInstanceIn(EOEditingContext editingContext) {
    CourtWorkloadEntry localInstance = (CourtWorkloadEntry)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String casesDigest() {
    return (String) storedValueForKey(_CourtWorkloadEntry.CASES_DIGEST_KEY);
  }

  public void setCasesDigest(String value) {
    log.debug( "updating casesDigest from {} to {}", casesDigest(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.CASES_DIGEST_KEY);
  }

  public String checksPassed() {
    return (String) storedValueForKey(_CourtWorkloadEntry.CHECKS_PASSED_KEY);
  }

  public void setChecksPassed(String value) {
    log.debug( "updating checksPassed from {} to {}", checksPassed(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.CHECKS_PASSED_KEY);
  }

  public Long completed() {
    return (Long) storedValueForKey(_CourtWorkloadEntry.COMPLETED_KEY);
  }

  public void setCompleted(Long value) {
    log.debug( "updating completed from {} to {}", completed(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.COMPLETED_KEY);
  }

  public String completeDigest() {
    return (String) storedValueForKey(_CourtWorkloadEntry.COMPLETE_DIGEST_KEY);
  }

  public void setCompleteDigest(String value) {
    log.debug( "updating completeDigest from {} to {}", completeDigest(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.COMPLETE_DIGEST_KEY);
  }

  public Long created() {
    return (Long) storedValueForKey(_CourtWorkloadEntry.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.CREATED_KEY);
  }

  public String pageDigest() {
    return (String) storedValueForKey(_CourtWorkloadEntry.PAGE_DIGEST_KEY);
  }

  public void setPageDigest(String value) {
    log.debug( "updating pageDigest from {} to {}", pageDigest(), value);
    takeStoredValueForKey(value, _CourtWorkloadEntry.PAGE_DIGEST_KEY);
  }

  public org.opencalaccess.courtcases.eo.CourtPage courtPage() {
    return (org.opencalaccess.courtcases.eo.CourtPage)storedValueForKey(_CourtWorkloadEntry.COURT_PAGE_KEY);
  }

  public void setCourtPage(org.opencalaccess.courtcases.eo.CourtPage value) {
    takeStoredValueForKey(value, _CourtWorkloadEntry.COURT_PAGE_KEY);
  }

  public void setCourtPageRelationship(org.opencalaccess.courtcases.eo.CourtPage value) {
    log.debug("updating courtPage from {} to {}", courtPage(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setCourtPage(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtPage oldValue = courtPage();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtWorkloadEntry.COURT_PAGE_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtWorkloadEntry.COURT_PAGE_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtPayment payment() {
    return (org.opencalaccess.courtcases.eo.CourtPayment)storedValueForKey(_CourtWorkloadEntry.PAYMENT_KEY);
  }

  public void setPayment(org.opencalaccess.courtcases.eo.CourtPayment value) {
    takeStoredValueForKey(value, _CourtWorkloadEntry.PAYMENT_KEY);
  }

  public void setPaymentRelationship(org.opencalaccess.courtcases.eo.CourtPayment value) {
    log.debug("updating payment from {} to {}", payment(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setPayment(value);
    }
    else if (value == null) {
      org.opencalaccess.courtcases.eo.CourtPayment oldValue = payment();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtWorkloadEntry.PAYMENT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtWorkloadEntry.PAYMENT_KEY);
    }
  }

  public org.opencalaccess.invites.eo.User user() {
    return (org.opencalaccess.invites.eo.User)storedValueForKey(_CourtWorkloadEntry.USER_KEY);
  }

  public void setUser(org.opencalaccess.invites.eo.User value) {
    takeStoredValueForKey(value, _CourtWorkloadEntry.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.invites.eo.User value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.invites.eo.User oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _CourtWorkloadEntry.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _CourtWorkloadEntry.USER_KEY);
    }
  }


  public static CourtWorkloadEntry createCourtWorkloadEntry(EOEditingContext editingContext, Long created
, org.opencalaccess.courtcases.eo.CourtPage courtPage, org.opencalaccess.invites.eo.User user) {
    CourtWorkloadEntry eo = (CourtWorkloadEntry) EOUtilities.createAndInsertInstance(editingContext, _CourtWorkloadEntry.ENTITY_NAME);
    eo.setCreated(created);
    eo.setCourtPageRelationship(courtPage);
    eo.setUserRelationship(user);
    return eo;
  }

  public static ERXFetchSpecification<CourtWorkloadEntry> fetchSpec() {
    return new ERXFetchSpecification<CourtWorkloadEntry>(_CourtWorkloadEntry.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CourtWorkloadEntry> fetchAllCourtWorkloadEntries(EOEditingContext editingContext) {
    return _CourtWorkloadEntry.fetchAllCourtWorkloadEntries(editingContext, null);
  }

  public static NSArray<CourtWorkloadEntry> fetchAllCourtWorkloadEntries(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CourtWorkloadEntry.fetchCourtWorkloadEntries(editingContext, null, sortOrderings);
  }

  public static NSArray<CourtWorkloadEntry> fetchCourtWorkloadEntries(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CourtWorkloadEntry> fetchSpec = new ERXFetchSpecification<CourtWorkloadEntry>(_CourtWorkloadEntry.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CourtWorkloadEntry> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CourtWorkloadEntry fetchCourtWorkloadEntry(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtWorkloadEntry.fetchCourtWorkloadEntry(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtWorkloadEntry fetchCourtWorkloadEntry(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CourtWorkloadEntry> eoObjects = _CourtWorkloadEntry.fetchCourtWorkloadEntries(editingContext, qualifier, null);
    CourtWorkloadEntry eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CourtWorkloadEntry that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtWorkloadEntry fetchRequiredCourtWorkloadEntry(EOEditingContext editingContext, String keyName, Object value) {
    return _CourtWorkloadEntry.fetchRequiredCourtWorkloadEntry(editingContext, ERXQ.equals(keyName, value));
  }

  public static CourtWorkloadEntry fetchRequiredCourtWorkloadEntry(EOEditingContext editingContext, EOQualifier qualifier) {
    CourtWorkloadEntry eoObject = _CourtWorkloadEntry.fetchCourtWorkloadEntry(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CourtWorkloadEntry that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CourtWorkloadEntry localInstanceIn(EOEditingContext editingContext, CourtWorkloadEntry eo) {
    CourtWorkloadEntry localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
