package org.opencalaccess.dailyjail.eo;

import org.opencalaccess.U;
import org.opencalaccess.entities.eo.CaCounty;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSData;

public class DailyJailPop extends _DailyJailPop {

	private static final long serialVersionUID = 3697997846943459165L;

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(DailyJailPop.class);

	public static DailyJailPop createDailyJailPop(
			EOEditingContext ec,
			Long created,
			String dateStr,
			int pop,
			NSData pageSource,
			String pageSourceMimeType,
			CaCounty county) {

		DailyJailPop eo = DailyJailPop.createDailyJailPop(
				ec,
				created,
				dateStr,
				0,
				pop,
				county);

		if (pageSource != null) {

			DailyJailPopSource source = DailyJailPopSource.createDailyJailPopSource(ec, eo);

			source.setMimeType(pageSourceMimeType);

			if (source.mimeType().equals("application/pdf")) {

				source.setSourceBin(pageSource);

			} else {

				source.setSourceText(pageSource);
			}
		}

		return eo;
	}

	public DailyJailPopSource source() {

		NSArray<DailyJailPopSource> sources = this.sources();

		if (sources == null || sources.isEmpty()) {
			return null;
		}
		if (sources.size() > 1) {
			U.err("source for pop has more than one source. pop: ", this.county().name(), " ", this.dateStr(), " ", this.pop());
		}
		return sources.get(0);
	}

	public boolean invalid() {
		return this.isInvalid() != null && this.isInvalid() == 1;
	}

	public void setInvalid(boolean invalid) {
		this.setIsInvalid((invalid) ? 1 : 0);
	}
}
