// DO NOT EDIT.  Make changes to CcaBooking.java instead.
package org.opencalaccess.dailyjail.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CcaBooking extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CcaBooking";

  // Attribute Keys
  public static final ERXKey<String> BOOKING_DATE_TIME = new ERXKey<String>("bookingDateTime", Type.Attribute);
  public static final ERXKey<String> BOOKING_NUM = new ERXKey<String>("bookingNum", Type.Attribute);
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> DATE_OF_BIRTH = new ERXKey<String>("dateOfBirth", Type.Attribute);
  public static final ERXKey<String> INMATE_NAME = new ERXKey<String>("inmateName", Type.Attribute);
  public static final ERXKey<Long> LAST_SEEN = new ERXKey<Long>("lastSeen", Type.Attribute);
  public static final ERXKey<String> RELEASE_DATE = new ERXKey<String>("releaseDate", Type.Attribute);
  public static final ERXKey<Long> UPDATED = new ERXKey<Long>("updated", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String BOOKING_DATE_TIME_KEY = BOOKING_DATE_TIME.key();
  public static final String BOOKING_NUM_KEY = BOOKING_NUM.key();
  public static final String CREATED_KEY = CREATED.key();
  public static final String DATE_OF_BIRTH_KEY = DATE_OF_BIRTH.key();
  public static final String INMATE_NAME_KEY = INMATE_NAME.key();
  public static final String LAST_SEEN_KEY = LAST_SEEN.key();
  public static final String RELEASE_DATE_KEY = RELEASE_DATE.key();
  public static final String UPDATED_KEY = UPDATED.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_CcaBooking.class);

  public CcaBooking localInstanceIn(EOEditingContext editingContext) {
    CcaBooking localInstance = (CcaBooking)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String bookingDateTime() {
    return (String) storedValueForKey(_CcaBooking.BOOKING_DATE_TIME_KEY);
  }

  public void setBookingDateTime(String value) {
    log.debug( "updating bookingDateTime from {} to {}", bookingDateTime(), value);
    takeStoredValueForKey(value, _CcaBooking.BOOKING_DATE_TIME_KEY);
  }

  public String bookingNum() {
    return (String) storedValueForKey(_CcaBooking.BOOKING_NUM_KEY);
  }

  public void setBookingNum(String value) {
    log.debug( "updating bookingNum from {} to {}", bookingNum(), value);
    takeStoredValueForKey(value, _CcaBooking.BOOKING_NUM_KEY);
  }

  public Long created() {
    return (Long) storedValueForKey(_CcaBooking.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _CcaBooking.CREATED_KEY);
  }

  public String dateOfBirth() {
    return (String) storedValueForKey(_CcaBooking.DATE_OF_BIRTH_KEY);
  }

  public void setDateOfBirth(String value) {
    log.debug( "updating dateOfBirth from {} to {}", dateOfBirth(), value);
    takeStoredValueForKey(value, _CcaBooking.DATE_OF_BIRTH_KEY);
  }

  public String inmateName() {
    return (String) storedValueForKey(_CcaBooking.INMATE_NAME_KEY);
  }

  public void setInmateName(String value) {
    log.debug( "updating inmateName from {} to {}", inmateName(), value);
    takeStoredValueForKey(value, _CcaBooking.INMATE_NAME_KEY);
  }

  public Long lastSeen() {
    return (Long) storedValueForKey(_CcaBooking.LAST_SEEN_KEY);
  }

  public void setLastSeen(Long value) {
    log.debug( "updating lastSeen from {} to {}", lastSeen(), value);
    takeStoredValueForKey(value, _CcaBooking.LAST_SEEN_KEY);
  }

  public String releaseDate() {
    return (String) storedValueForKey(_CcaBooking.RELEASE_DATE_KEY);
  }

  public void setReleaseDate(String value) {
    log.debug( "updating releaseDate from {} to {}", releaseDate(), value);
    takeStoredValueForKey(value, _CcaBooking.RELEASE_DATE_KEY);
  }

  public Long updated() {
    return (Long) storedValueForKey(_CcaBooking.UPDATED_KEY);
  }

  public void setUpdated(Long value) {
    log.debug( "updating updated from {} to {}", updated(), value);
    takeStoredValueForKey(value, _CcaBooking.UPDATED_KEY);
  }


  public static CcaBooking createCcaBooking(EOEditingContext editingContext, String bookingDateTime
, String bookingNum
, Long created
, String dateOfBirth
, String inmateName
, Long lastSeen
, Long updated
) {
    CcaBooking eo = (CcaBooking) EOUtilities.createAndInsertInstance(editingContext, _CcaBooking.ENTITY_NAME);
    eo.setBookingDateTime(bookingDateTime);
    eo.setBookingNum(bookingNum);
    eo.setCreated(created);
    eo.setDateOfBirth(dateOfBirth);
    eo.setInmateName(inmateName);
    eo.setLastSeen(lastSeen);
    eo.setUpdated(updated);
    return eo;
  }

  public static ERXFetchSpecification<CcaBooking> fetchSpec() {
    return new ERXFetchSpecification<CcaBooking>(_CcaBooking.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CcaBooking> fetchAllCcaBookings(EOEditingContext editingContext) {
    return _CcaBooking.fetchAllCcaBookings(editingContext, null);
  }

  public static NSArray<CcaBooking> fetchAllCcaBookings(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CcaBooking.fetchCcaBookings(editingContext, null, sortOrderings);
  }

  public static NSArray<CcaBooking> fetchCcaBookings(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CcaBooking> fetchSpec = new ERXFetchSpecification<CcaBooking>(_CcaBooking.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CcaBooking> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CcaBooking fetchCcaBooking(EOEditingContext editingContext, String keyName, Object value) {
    return _CcaBooking.fetchCcaBooking(editingContext, ERXQ.equals(keyName, value));
  }

  public static CcaBooking fetchCcaBooking(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CcaBooking> eoObjects = _CcaBooking.fetchCcaBookings(editingContext, qualifier, null);
    CcaBooking eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CcaBooking that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CcaBooking fetchRequiredCcaBooking(EOEditingContext editingContext, String keyName, Object value) {
    return _CcaBooking.fetchRequiredCcaBooking(editingContext, ERXQ.equals(keyName, value));
  }

  public static CcaBooking fetchRequiredCcaBooking(EOEditingContext editingContext, EOQualifier qualifier) {
    CcaBooking eoObject = _CcaBooking.fetchCcaBooking(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CcaBooking that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CcaBooking localInstanceIn(EOEditingContext editingContext, CcaBooking eo) {
    CcaBooking localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
