// DO NOT EDIT.  Make changes to CcaRelease.java instead.
package org.opencalaccess.dailyjail.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CcaRelease extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CcaRelease";

  // Attribute Keys
  public static final ERXKey<Long> FIRST_APPEARED = new ERXKey<Long>("firstAppeared", Type.Attribute);
  public static final ERXKey<String> INMATE_NAME = new ERXKey<String>("inmateName", Type.Attribute);
  public static final ERXKey<Long> LAST_SEEN = new ERXKey<Long>("lastSeen", Type.Attribute);
  public static final ERXKey<String> RELEASE_DATE = new ERXKey<String>("releaseDate", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String FIRST_APPEARED_KEY = FIRST_APPEARED.key();
  public static final String INMATE_NAME_KEY = INMATE_NAME.key();
  public static final String LAST_SEEN_KEY = LAST_SEEN.key();
  public static final String RELEASE_DATE_KEY = RELEASE_DATE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_CcaRelease.class);

  public CcaRelease localInstanceIn(EOEditingContext editingContext) {
    CcaRelease localInstance = (CcaRelease)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long firstAppeared() {
    return (Long) storedValueForKey(_CcaRelease.FIRST_APPEARED_KEY);
  }

  public void setFirstAppeared(Long value) {
    log.debug( "updating firstAppeared from {} to {}", firstAppeared(), value);
    takeStoredValueForKey(value, _CcaRelease.FIRST_APPEARED_KEY);
  }

  public String inmateName() {
    return (String) storedValueForKey(_CcaRelease.INMATE_NAME_KEY);
  }

  public void setInmateName(String value) {
    log.debug( "updating inmateName from {} to {}", inmateName(), value);
    takeStoredValueForKey(value, _CcaRelease.INMATE_NAME_KEY);
  }

  public Long lastSeen() {
    return (Long) storedValueForKey(_CcaRelease.LAST_SEEN_KEY);
  }

  public void setLastSeen(Long value) {
    log.debug( "updating lastSeen from {} to {}", lastSeen(), value);
    takeStoredValueForKey(value, _CcaRelease.LAST_SEEN_KEY);
  }

  public String releaseDate() {
    return (String) storedValueForKey(_CcaRelease.RELEASE_DATE_KEY);
  }

  public void setReleaseDate(String value) {
    log.debug( "updating releaseDate from {} to {}", releaseDate(), value);
    takeStoredValueForKey(value, _CcaRelease.RELEASE_DATE_KEY);
  }


  public static CcaRelease createCcaRelease(EOEditingContext editingContext, Long firstAppeared
, String inmateName
, Long lastSeen
, String releaseDate
) {
    CcaRelease eo = (CcaRelease) EOUtilities.createAndInsertInstance(editingContext, _CcaRelease.ENTITY_NAME);
    eo.setFirstAppeared(firstAppeared);
    eo.setInmateName(inmateName);
    eo.setLastSeen(lastSeen);
    eo.setReleaseDate(releaseDate);
    return eo;
  }

  public static ERXFetchSpecification<CcaRelease> fetchSpec() {
    return new ERXFetchSpecification<CcaRelease>(_CcaRelease.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CcaRelease> fetchAllCcaReleases(EOEditingContext editingContext) {
    return _CcaRelease.fetchAllCcaReleases(editingContext, null);
  }

  public static NSArray<CcaRelease> fetchAllCcaReleases(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CcaRelease.fetchCcaReleases(editingContext, null, sortOrderings);
  }

  public static NSArray<CcaRelease> fetchCcaReleases(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CcaRelease> fetchSpec = new ERXFetchSpecification<CcaRelease>(_CcaRelease.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CcaRelease> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CcaRelease fetchCcaRelease(EOEditingContext editingContext, String keyName, Object value) {
    return _CcaRelease.fetchCcaRelease(editingContext, ERXQ.equals(keyName, value));
  }

  public static CcaRelease fetchCcaRelease(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CcaRelease> eoObjects = _CcaRelease.fetchCcaReleases(editingContext, qualifier, null);
    CcaRelease eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CcaRelease that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CcaRelease fetchRequiredCcaRelease(EOEditingContext editingContext, String keyName, Object value) {
    return _CcaRelease.fetchRequiredCcaRelease(editingContext, ERXQ.equals(keyName, value));
  }

  public static CcaRelease fetchRequiredCcaRelease(EOEditingContext editingContext, EOQualifier qualifier) {
    CcaRelease eoObject = _CcaRelease.fetchCcaRelease(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CcaRelease that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CcaRelease localInstanceIn(EOEditingContext editingContext, CcaRelease eo) {
    CcaRelease localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
