// DO NOT EDIT.  Make changes to DailyJailPopSource.java instead.
package org.opencalaccess.dailyjail.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _DailyJailPopSource extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "DailyJailPopSource";

  // Attribute Keys
  public static final ERXKey<String> MIME_TYPE = new ERXKey<String>("mimeType", Type.Attribute);
  public static final ERXKey<NSData> SOURCE_BIN = new ERXKey<NSData>("sourceBin", Type.Attribute);
  public static final ERXKey<NSData> SOURCE_TEXT = new ERXKey<NSData>("sourceText", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> INFOS = new ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo>("infos", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPop> POP = new ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPop>("pop", Type.ToOneRelationship);

  // Attributes
  public static final String MIME_TYPE_KEY = MIME_TYPE.key();
  public static final String SOURCE_BIN_KEY = SOURCE_BIN.key();
  public static final String SOURCE_TEXT_KEY = SOURCE_TEXT.key();

  // Relationships
  public static final String INFOS_KEY = INFOS.key();
  public static final String POP_KEY = POP.key();

  private static final Logger log = LoggerFactory.getLogger(_DailyJailPopSource.class);

  public DailyJailPopSource localInstanceIn(EOEditingContext editingContext) {
    DailyJailPopSource localInstance = (DailyJailPopSource)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String mimeType() {
    return (String) storedValueForKey(_DailyJailPopSource.MIME_TYPE_KEY);
  }

  public void setMimeType(String value) {
    log.debug( "updating mimeType from {} to {}", mimeType(), value);
    takeStoredValueForKey(value, _DailyJailPopSource.MIME_TYPE_KEY);
  }

  public NSData sourceBin() {
    return (NSData) storedValueForKey(_DailyJailPopSource.SOURCE_BIN_KEY);
  }

  public void setSourceBin(NSData value) {
    log.debug( "updating sourceBin from {} to {}", sourceBin(), value);
    takeStoredValueForKey(value, _DailyJailPopSource.SOURCE_BIN_KEY);
  }

  public NSData sourceText() {
    return (NSData) storedValueForKey(_DailyJailPopSource.SOURCE_TEXT_KEY);
  }

  public void setSourceText(NSData value) {
    log.debug( "updating sourceText from {} to {}", sourceText(), value);
    takeStoredValueForKey(value, _DailyJailPopSource.SOURCE_TEXT_KEY);
  }

  public org.opencalaccess.dailyjail.eo.DailyJailPop pop() {
    return (org.opencalaccess.dailyjail.eo.DailyJailPop)storedValueForKey(_DailyJailPopSource.POP_KEY);
  }

  public void setPop(org.opencalaccess.dailyjail.eo.DailyJailPop value) {
    takeStoredValueForKey(value, _DailyJailPopSource.POP_KEY);
  }

  public void setPopRelationship(org.opencalaccess.dailyjail.eo.DailyJailPop value) {
    log.debug("updating pop from {} to {}", pop(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setPop(value);
    }
    else if (value == null) {
      org.opencalaccess.dailyjail.eo.DailyJailPop oldValue = pop();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _DailyJailPopSource.POP_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _DailyJailPopSource.POP_KEY);
    }
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> infos() {
    return (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo>)storedValueForKey(_DailyJailPopSource.INFOS_KEY);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> infos(EOQualifier qualifier) {
    return infos(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> infos(EOQualifier qualifier, boolean fetch) {
    return infos(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> infos(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo.SOURCE_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo.fetchDailyJailPopSourceInfos(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = infos();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToInfos(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo object) {
    includeObjectIntoPropertyWithKey(object, _DailyJailPopSource.INFOS_KEY);
  }

  public void removeFromInfos(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo object) {
    excludeObjectFromPropertyWithKey(object, _DailyJailPopSource.INFOS_KEY);
  }

  public void addToInfosRelationship(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo object) {
    log.debug("adding {} to infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToInfos(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _DailyJailPopSource.INFOS_KEY);
    }
  }

  public void removeFromInfosRelationship(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo object) {
    log.debug("removing {} from infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromInfos(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _DailyJailPopSource.INFOS_KEY);
    }
  }

  public org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo createInfosRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _DailyJailPopSource.INFOS_KEY);
    return (org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo) eo;
  }

  public void deleteInfosRelationship(org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _DailyJailPopSource.INFOS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllInfosRelationships() {
    Enumeration<org.opencalaccess.dailyjail.eo.DailyJailPopSourceInfo> objects = infos().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteInfosRelationship(objects.nextElement());
    }
  }


  public static DailyJailPopSource createDailyJailPopSource(EOEditingContext editingContext, org.opencalaccess.dailyjail.eo.DailyJailPop pop) {
    DailyJailPopSource eo = (DailyJailPopSource) EOUtilities.createAndInsertInstance(editingContext, _DailyJailPopSource.ENTITY_NAME);
    eo.setPopRelationship(pop);
    return eo;
  }

  public static ERXFetchSpecification<DailyJailPopSource> fetchSpec() {
    return new ERXFetchSpecification<DailyJailPopSource>(_DailyJailPopSource.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<DailyJailPopSource> fetchAllDailyJailPopSources(EOEditingContext editingContext) {
    return _DailyJailPopSource.fetchAllDailyJailPopSources(editingContext, null);
  }

  public static NSArray<DailyJailPopSource> fetchAllDailyJailPopSources(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _DailyJailPopSource.fetchDailyJailPopSources(editingContext, null, sortOrderings);
  }

  public static NSArray<DailyJailPopSource> fetchDailyJailPopSources(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<DailyJailPopSource> fetchSpec = new ERXFetchSpecification<DailyJailPopSource>(_DailyJailPopSource.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<DailyJailPopSource> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static DailyJailPopSource fetchDailyJailPopSource(EOEditingContext editingContext, String keyName, Object value) {
    return _DailyJailPopSource.fetchDailyJailPopSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static DailyJailPopSource fetchDailyJailPopSource(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<DailyJailPopSource> eoObjects = _DailyJailPopSource.fetchDailyJailPopSources(editingContext, qualifier, null);
    DailyJailPopSource eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one DailyJailPopSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DailyJailPopSource fetchRequiredDailyJailPopSource(EOEditingContext editingContext, String keyName, Object value) {
    return _DailyJailPopSource.fetchRequiredDailyJailPopSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static DailyJailPopSource fetchRequiredDailyJailPopSource(EOEditingContext editingContext, EOQualifier qualifier) {
    DailyJailPopSource eoObject = _DailyJailPopSource.fetchDailyJailPopSource(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no DailyJailPopSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DailyJailPopSource localInstanceIn(EOEditingContext editingContext, DailyJailPopSource eo) {
    DailyJailPopSource localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
