// DO NOT EDIT.  Make changes to OffenseCodeListing.java instead.
package org.opencalaccess.dailyjail.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _OffenseCodeListing extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "OffenseCodeListing";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);
  public static final ERXKey<Integer> PAGE_SIZE = new ERXKey<Integer>("pageSize", Type.Attribute);
  public static final ERXKey<String> URL = new ERXKey<String>("url", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<com.webobjects.eocontrol.EOGenericRecord> OFFENSE_CODES_BY_CODE_SECTS = new ERXKey<com.webobjects.eocontrol.EOGenericRecord>("offenseCodesByCodeSects", Type.ToManyRelationship);
  public static final ERXKey<com.webobjects.eocontrol.EOGenericRecord> OFFENSE_CODES_WITH_LEI_CODES = new ERXKey<com.webobjects.eocontrol.EOGenericRecord>("offenseCodesWithLeiCodes", Type.ToManyRelationship);
  public static final ERXKey<com.webobjects.eocontrol.EOGenericRecord> OFFENSE_CODES_WITH_LIVESCANS = new ERXKey<com.webobjects.eocontrol.EOGenericRecord>("offenseCodesWithLivescans", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();
  public static final String PAGE_SIZE_KEY = PAGE_SIZE.key();
  public static final String URL_KEY = URL.key();

  // Relationships
  public static final String OFFENSE_CODES_BY_CODE_SECTS_KEY = OFFENSE_CODES_BY_CODE_SECTS.key();
  public static final String OFFENSE_CODES_WITH_LEI_CODES_KEY = OFFENSE_CODES_WITH_LEI_CODES.key();
  public static final String OFFENSE_CODES_WITH_LIVESCANS_KEY = OFFENSE_CODES_WITH_LIVESCANS.key();

  private static final Logger log = LoggerFactory.getLogger(_OffenseCodeListing.class);

  public OffenseCodeListing localInstanceIn(EOEditingContext editingContext) {
    OffenseCodeListing localInstance = (OffenseCodeListing)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_OffenseCodeListing.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _OffenseCodeListing.NAME_KEY);
  }

  public Integer pageSize() {
    return (Integer) storedValueForKey(_OffenseCodeListing.PAGE_SIZE_KEY);
  }

  public void setPageSize(Integer value) {
    log.debug( "updating pageSize from {} to {}", pageSize(), value);
    takeStoredValueForKey(value, _OffenseCodeListing.PAGE_SIZE_KEY);
  }

  public String url() {
    return (String) storedValueForKey(_OffenseCodeListing.URL_KEY);
  }

  public void setUrl(String value) {
    log.debug( "updating url from {} to {}", url(), value);
    takeStoredValueForKey(value, _OffenseCodeListing.URL_KEY);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesByCodeSects() {
    return (NSArray<com.webobjects.eocontrol.EOGenericRecord>)storedValueForKey(_OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesByCodeSects(EOQualifier qualifier) {
    return offenseCodesByCodeSects(qualifier, null, false);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesByCodeSects(EOQualifier qualifier, boolean fetch) {
    return offenseCodesByCodeSects(qualifier, null, fetch);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesByCodeSects(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<com.webobjects.eocontrol.EOGenericRecord> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals("listing", this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      ERXFetchSpecification<OffenseCodeListing> fetchSpec = new ERXFetchSpecification<OffenseCodeListing>("OffenseCodesByCodeSect", qualifier, sortOrderings);
      results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)editingContext().objectsWithFetchSpecification(fetchSpec);
    }
    else {
      results = offenseCodesByCodeSects();
      if (qualifier != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToOffenseCodesByCodeSects(com.webobjects.eocontrol.EOGenericRecord object) {
    includeObjectIntoPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
  }

  public void removeFromOffenseCodesByCodeSects(com.webobjects.eocontrol.EOGenericRecord object) {
    excludeObjectFromPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
  }

  public void addToOffenseCodesByCodeSectsRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("adding {} to offenseCodesByCodeSects relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToOffenseCodesByCodeSects(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
    }
  }

  public void removeFromOffenseCodesByCodeSectsRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("removing {} from offenseCodesByCodeSects relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromOffenseCodesByCodeSects(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
    }
  }

  public com.webobjects.eocontrol.EOGenericRecord createOffenseCodesByCodeSectsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(), "OffenseCodesByCodeSect");
    addObjectToBothSidesOfRelationshipWithKey(eo, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
    return (com.webobjects.eocontrol.EOGenericRecord) eo;
  }

  public void deleteOffenseCodesByCodeSectsRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_BY_CODE_SECTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllOffenseCodesByCodeSectsRelationships() {
    Enumeration<com.webobjects.eocontrol.EOGenericRecord> objects = offenseCodesByCodeSects().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteOffenseCodesByCodeSectsRelationship(objects.nextElement());
    }
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLeiCodes() {
    return (NSArray<com.webobjects.eocontrol.EOGenericRecord>)storedValueForKey(_OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLeiCodes(EOQualifier qualifier) {
    return offenseCodesWithLeiCodes(qualifier, null, false);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLeiCodes(EOQualifier qualifier, boolean fetch) {
    return offenseCodesWithLeiCodes(qualifier, null, fetch);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLeiCodes(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<com.webobjects.eocontrol.EOGenericRecord> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals("listing", this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      ERXFetchSpecification<OffenseCodeListing> fetchSpec = new ERXFetchSpecification<OffenseCodeListing>("OffenseCodesWithLeiCode", qualifier, sortOrderings);
      results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)editingContext().objectsWithFetchSpecification(fetchSpec);
    }
    else {
      results = offenseCodesWithLeiCodes();
      if (qualifier != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToOffenseCodesWithLeiCodes(com.webobjects.eocontrol.EOGenericRecord object) {
    includeObjectIntoPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
  }

  public void removeFromOffenseCodesWithLeiCodes(com.webobjects.eocontrol.EOGenericRecord object) {
    excludeObjectFromPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
  }

  public void addToOffenseCodesWithLeiCodesRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("adding {} to offenseCodesWithLeiCodes relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToOffenseCodesWithLeiCodes(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
    }
  }

  public void removeFromOffenseCodesWithLeiCodesRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("removing {} from offenseCodesWithLeiCodes relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromOffenseCodesWithLeiCodes(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
    }
  }

  public com.webobjects.eocontrol.EOGenericRecord createOffenseCodesWithLeiCodesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(), "OffenseCodesWithLeiCode");
    addObjectToBothSidesOfRelationshipWithKey(eo, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
    return (com.webobjects.eocontrol.EOGenericRecord) eo;
  }

  public void deleteOffenseCodesWithLeiCodesRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LEI_CODES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllOffenseCodesWithLeiCodesRelationships() {
    Enumeration<com.webobjects.eocontrol.EOGenericRecord> objects = offenseCodesWithLeiCodes().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteOffenseCodesWithLeiCodesRelationship(objects.nextElement());
    }
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLivescans() {
    return (NSArray<com.webobjects.eocontrol.EOGenericRecord>)storedValueForKey(_OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLivescans(EOQualifier qualifier) {
    return offenseCodesWithLivescans(qualifier, null, false);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLivescans(EOQualifier qualifier, boolean fetch) {
    return offenseCodesWithLivescans(qualifier, null, fetch);
  }

  public NSArray<com.webobjects.eocontrol.EOGenericRecord> offenseCodesWithLivescans(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<com.webobjects.eocontrol.EOGenericRecord> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals("listing", this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      ERXFetchSpecification<OffenseCodeListing> fetchSpec = new ERXFetchSpecification<OffenseCodeListing>("OffenseCodesWithLivescan", qualifier, sortOrderings);
      results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)editingContext().objectsWithFetchSpecification(fetchSpec);
    }
    else {
      results = offenseCodesWithLivescans();
      if (qualifier != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<com.webobjects.eocontrol.EOGenericRecord>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToOffenseCodesWithLivescans(com.webobjects.eocontrol.EOGenericRecord object) {
    includeObjectIntoPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
  }

  public void removeFromOffenseCodesWithLivescans(com.webobjects.eocontrol.EOGenericRecord object) {
    excludeObjectFromPropertyWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
  }

  public void addToOffenseCodesWithLivescansRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("adding {} to offenseCodesWithLivescans relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToOffenseCodesWithLivescans(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
    }
  }

  public void removeFromOffenseCodesWithLivescansRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    log.debug("removing {} from offenseCodesWithLivescans relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromOffenseCodesWithLivescans(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
    }
  }

  public com.webobjects.eocontrol.EOGenericRecord createOffenseCodesWithLivescansRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(), "OffenseCodesWithLivescan");
    addObjectToBothSidesOfRelationshipWithKey(eo, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
    return (com.webobjects.eocontrol.EOGenericRecord) eo;
  }

  public void deleteOffenseCodesWithLivescansRelationship(com.webobjects.eocontrol.EOGenericRecord object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _OffenseCodeListing.OFFENSE_CODES_WITH_LIVESCANS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllOffenseCodesWithLivescansRelationships() {
    Enumeration<com.webobjects.eocontrol.EOGenericRecord> objects = offenseCodesWithLivescans().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteOffenseCodesWithLivescansRelationship(objects.nextElement());
    }
  }


  public static OffenseCodeListing createOffenseCodeListing(EOEditingContext editingContext, String name
, String url
) {
    OffenseCodeListing eo = (OffenseCodeListing) EOUtilities.createAndInsertInstance(editingContext, _OffenseCodeListing.ENTITY_NAME);
    eo.setName(name);
    eo.setUrl(url);
    return eo;
  }

  public static ERXFetchSpecification<OffenseCodeListing> fetchSpec() {
    return new ERXFetchSpecification<OffenseCodeListing>(_OffenseCodeListing.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<OffenseCodeListing> fetchAllOffenseCodeListings(EOEditingContext editingContext) {
    return _OffenseCodeListing.fetchAllOffenseCodeListings(editingContext, null);
  }

  public static NSArray<OffenseCodeListing> fetchAllOffenseCodeListings(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _OffenseCodeListing.fetchOffenseCodeListings(editingContext, null, sortOrderings);
  }

  public static NSArray<OffenseCodeListing> fetchOffenseCodeListings(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<OffenseCodeListing> fetchSpec = new ERXFetchSpecification<OffenseCodeListing>(_OffenseCodeListing.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<OffenseCodeListing> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static OffenseCodeListing fetchOffenseCodeListing(EOEditingContext editingContext, String keyName, Object value) {
    return _OffenseCodeListing.fetchOffenseCodeListing(editingContext, ERXQ.equals(keyName, value));
  }

  public static OffenseCodeListing fetchOffenseCodeListing(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<OffenseCodeListing> eoObjects = _OffenseCodeListing.fetchOffenseCodeListings(editingContext, qualifier, null);
    OffenseCodeListing eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one OffenseCodeListing that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OffenseCodeListing fetchRequiredOffenseCodeListing(EOEditingContext editingContext, String keyName, Object value) {
    return _OffenseCodeListing.fetchRequiredOffenseCodeListing(editingContext, ERXQ.equals(keyName, value));
  }

  public static OffenseCodeListing fetchRequiredOffenseCodeListing(EOEditingContext editingContext, EOQualifier qualifier) {
    OffenseCodeListing eoObject = _OffenseCodeListing.fetchOffenseCodeListing(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no OffenseCodeListing that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OffenseCodeListing localInstanceIn(EOEditingContext editingContext, OffenseCodeListing eo) {
    OffenseCodeListing localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
