// DO NOT EDIT.  Make changes to SccDailyJailFile.java instead.
package org.opencalaccess.dailyjail.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _SccDailyJailFile extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "SccDailyJailFile";

  // Attribute Keys
  public static final ERXKey<String> PDF_NAME = new ERXKey<String>("pdfName", Type.Attribute);
  public static final ERXKey<Long> PDF_SIZE = new ERXKey<Long>("pdfSize", Type.Attribute);
  public static final ERXKey<String> TSV_NAME = new ERXKey<String>("tsvName", Type.Attribute);
  public static final ERXKey<Long> TSV_SIZE = new ERXKey<Long>("tsvSize", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String PDF_NAME_KEY = PDF_NAME.key();
  public static final String PDF_SIZE_KEY = PDF_SIZE.key();
  public static final String TSV_NAME_KEY = TSV_NAME.key();
  public static final String TSV_SIZE_KEY = TSV_SIZE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_SccDailyJailFile.class);

  public SccDailyJailFile localInstanceIn(EOEditingContext editingContext) {
    SccDailyJailFile localInstance = (SccDailyJailFile)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String pdfName() {
    return (String) storedValueForKey(_SccDailyJailFile.PDF_NAME_KEY);
  }

  public void setPdfName(String value) {
    log.debug( "updating pdfName from {} to {}", pdfName(), value);
    takeStoredValueForKey(value, _SccDailyJailFile.PDF_NAME_KEY);
  }

  public Long pdfSize() {
    return (Long) storedValueForKey(_SccDailyJailFile.PDF_SIZE_KEY);
  }

  public void setPdfSize(Long value) {
    log.debug( "updating pdfSize from {} to {}", pdfSize(), value);
    takeStoredValueForKey(value, _SccDailyJailFile.PDF_SIZE_KEY);
  }

  public String tsvName() {
    return (String) storedValueForKey(_SccDailyJailFile.TSV_NAME_KEY);
  }

  public void setTsvName(String value) {
    log.debug( "updating tsvName from {} to {}", tsvName(), value);
    takeStoredValueForKey(value, _SccDailyJailFile.TSV_NAME_KEY);
  }

  public Long tsvSize() {
    return (Long) storedValueForKey(_SccDailyJailFile.TSV_SIZE_KEY);
  }

  public void setTsvSize(Long value) {
    log.debug( "updating tsvSize from {} to {}", tsvSize(), value);
    takeStoredValueForKey(value, _SccDailyJailFile.TSV_SIZE_KEY);
  }


  public static SccDailyJailFile createSccDailyJailFile(EOEditingContext editingContext) {
    SccDailyJailFile eo = (SccDailyJailFile) EOUtilities.createAndInsertInstance(editingContext, _SccDailyJailFile.ENTITY_NAME);
    return eo;
  }

  public static ERXFetchSpecification<SccDailyJailFile> fetchSpec() {
    return new ERXFetchSpecification<SccDailyJailFile>(_SccDailyJailFile.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<SccDailyJailFile> fetchAllSccDailyJailFiles(EOEditingContext editingContext) {
    return _SccDailyJailFile.fetchAllSccDailyJailFiles(editingContext, null);
  }

  public static NSArray<SccDailyJailFile> fetchAllSccDailyJailFiles(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _SccDailyJailFile.fetchSccDailyJailFiles(editingContext, null, sortOrderings);
  }

  public static NSArray<SccDailyJailFile> fetchSccDailyJailFiles(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<SccDailyJailFile> fetchSpec = new ERXFetchSpecification<SccDailyJailFile>(_SccDailyJailFile.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<SccDailyJailFile> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static SccDailyJailFile fetchSccDailyJailFile(EOEditingContext editingContext, String keyName, Object value) {
    return _SccDailyJailFile.fetchSccDailyJailFile(editingContext, ERXQ.equals(keyName, value));
  }

  public static SccDailyJailFile fetchSccDailyJailFile(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<SccDailyJailFile> eoObjects = _SccDailyJailFile.fetchSccDailyJailFiles(editingContext, qualifier, null);
    SccDailyJailFile eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one SccDailyJailFile that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static SccDailyJailFile fetchRequiredSccDailyJailFile(EOEditingContext editingContext, String keyName, Object value) {
    return _SccDailyJailFile.fetchRequiredSccDailyJailFile(editingContext, ERXQ.equals(keyName, value));
  }

  public static SccDailyJailFile fetchRequiredSccDailyJailFile(EOEditingContext editingContext, EOQualifier qualifier) {
    SccDailyJailFile eoObject = _SccDailyJailFile.fetchSccDailyJailFile(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no SccDailyJailFile that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static SccDailyJailFile localInstanceIn(EOEditingContext editingContext, SccDailyJailFile eo) {
    SccDailyJailFile localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
