// DO NOT EDIT.  Make changes to PressRelease.java instead.
package org.opencalaccess.dailypress.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _PressRelease extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "PressRelease";

  // Attribute Keys
  public static final ERXKey<String> RELEASE_DATE = new ERXKey<String>("releaseDate", Type.Attribute);
  public static final ERXKey<String> TITLE = new ERXKey<String>("title", Type.Attribute);
  public static final ERXKey<String> URL = new ERXKey<String>("url", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String RELEASE_DATE_KEY = RELEASE_DATE.key();
  public static final String TITLE_KEY = TITLE.key();
  public static final String URL_KEY = URL.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_PressRelease.class);

  public PressRelease localInstanceIn(EOEditingContext editingContext) {
    PressRelease localInstance = (PressRelease)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String releaseDate() {
    return (String) storedValueForKey(_PressRelease.RELEASE_DATE_KEY);
  }

  public void setReleaseDate(String value) {
    log.debug( "updating releaseDate from {} to {}", releaseDate(), value);
    takeStoredValueForKey(value, _PressRelease.RELEASE_DATE_KEY);
  }

  public String title() {
    return (String) storedValueForKey(_PressRelease.TITLE_KEY);
  }

  public void setTitle(String value) {
    log.debug( "updating title from {} to {}", title(), value);
    takeStoredValueForKey(value, _PressRelease.TITLE_KEY);
  }

  public String url() {
    return (String) storedValueForKey(_PressRelease.URL_KEY);
  }

  public void setUrl(String value) {
    log.debug( "updating url from {} to {}", url(), value);
    takeStoredValueForKey(value, _PressRelease.URL_KEY);
  }


  public static PressRelease createPressRelease(EOEditingContext editingContext, String releaseDate
, String title
, String url
) {
    PressRelease eo = (PressRelease) EOUtilities.createAndInsertInstance(editingContext, _PressRelease.ENTITY_NAME);
    eo.setReleaseDate(releaseDate);
    eo.setTitle(title);
    eo.setUrl(url);
    return eo;
  }

  public static ERXFetchSpecification<PressRelease> fetchSpec() {
    return new ERXFetchSpecification<PressRelease>(_PressRelease.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<PressRelease> fetchAllPressReleases(EOEditingContext editingContext) {
    return _PressRelease.fetchAllPressReleases(editingContext, null);
  }

  public static NSArray<PressRelease> fetchAllPressReleases(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _PressRelease.fetchPressReleases(editingContext, null, sortOrderings);
  }

  public static NSArray<PressRelease> fetchPressReleases(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<PressRelease> fetchSpec = new ERXFetchSpecification<PressRelease>(_PressRelease.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<PressRelease> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static PressRelease fetchPressRelease(EOEditingContext editingContext, String keyName, Object value) {
    return _PressRelease.fetchPressRelease(editingContext, ERXQ.equals(keyName, value));
  }

  public static PressRelease fetchPressRelease(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<PressRelease> eoObjects = _PressRelease.fetchPressReleases(editingContext, qualifier, null);
    PressRelease eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one PressRelease that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static PressRelease fetchRequiredPressRelease(EOEditingContext editingContext, String keyName, Object value) {
    return _PressRelease.fetchRequiredPressRelease(editingContext, ERXQ.equals(keyName, value));
  }

  public static PressRelease fetchRequiredPressRelease(EOEditingContext editingContext, EOQualifier qualifier) {
    PressRelease eoObject = _PressRelease.fetchPressRelease(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no PressRelease that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static PressRelease localInstanceIn(EOEditingContext editingContext, PressRelease eo) {
    PressRelease localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
