// DO NOT EDIT.  Make changes to CaCounty.java instead.
package org.opencalaccess.entities.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _CaCounty extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "CaCounty";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);
  public static final ERXKey<Long> POP2020 = new ERXKey<Long>("pop2020", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPop> DAILY_JAIL_POPS = new ERXKey<org.opencalaccess.dailyjail.eo.DailyJailPop>("dailyJailPops", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.entities.eo.CaDailyJail> DAILY_JAILS = new ERXKey<org.opencalaccess.entities.eo.CaDailyJail>("dailyJails", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();
  public static final String POP2020_KEY = POP2020.key();

  // Relationships
  public static final String DAILY_JAIL_POPS_KEY = DAILY_JAIL_POPS.key();
  public static final String DAILY_JAILS_KEY = DAILY_JAILS.key();

  private static final Logger log = LoggerFactory.getLogger(_CaCounty.class);

  public CaCounty localInstanceIn(EOEditingContext editingContext) {
    CaCounty localInstance = (CaCounty)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_CaCounty.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _CaCounty.NAME_KEY);
  }

  public Long pop2020() {
    return (Long) storedValueForKey(_CaCounty.POP2020_KEY);
  }

  public void setPop2020(Long value) {
    log.debug( "updating pop2020 from {} to {}", pop2020(), value);
    takeStoredValueForKey(value, _CaCounty.POP2020_KEY);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop> dailyJailPops() {
    return (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop>)storedValueForKey(_CaCounty.DAILY_JAIL_POPS_KEY);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop> dailyJailPops(EOQualifier qualifier) {
    return dailyJailPops(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop> dailyJailPops(EOQualifier qualifier, boolean fetch) {
    return dailyJailPops(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop> dailyJailPops(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.dailyjail.eo.DailyJailPop.COUNTY_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.dailyjail.eo.DailyJailPop.fetchDailyJailPops(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = dailyJailPops();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.dailyjail.eo.DailyJailPop>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToDailyJailPops(org.opencalaccess.dailyjail.eo.DailyJailPop object) {
    includeObjectIntoPropertyWithKey(object, _CaCounty.DAILY_JAIL_POPS_KEY);
  }

  public void removeFromDailyJailPops(org.opencalaccess.dailyjail.eo.DailyJailPop object) {
    excludeObjectFromPropertyWithKey(object, _CaCounty.DAILY_JAIL_POPS_KEY);
  }

  public void addToDailyJailPopsRelationship(org.opencalaccess.dailyjail.eo.DailyJailPop object) {
    log.debug("adding {} to dailyJailPops relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToDailyJailPops(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAIL_POPS_KEY);
    }
  }

  public void removeFromDailyJailPopsRelationship(org.opencalaccess.dailyjail.eo.DailyJailPop object) {
    log.debug("removing {} from dailyJailPops relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromDailyJailPops(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAIL_POPS_KEY);
    }
  }

  public org.opencalaccess.dailyjail.eo.DailyJailPop createDailyJailPopsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.dailyjail.eo.DailyJailPop.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CaCounty.DAILY_JAIL_POPS_KEY);
    return (org.opencalaccess.dailyjail.eo.DailyJailPop) eo;
  }

  public void deleteDailyJailPopsRelationship(org.opencalaccess.dailyjail.eo.DailyJailPop object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAIL_POPS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllDailyJailPopsRelationships() {
    Enumeration<org.opencalaccess.dailyjail.eo.DailyJailPop> objects = dailyJailPops().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteDailyJailPopsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.entities.eo.CaDailyJail> dailyJails() {
    return (NSArray<org.opencalaccess.entities.eo.CaDailyJail>)storedValueForKey(_CaCounty.DAILY_JAILS_KEY);
  }

  public NSArray<org.opencalaccess.entities.eo.CaDailyJail> dailyJails(EOQualifier qualifier) {
    return dailyJails(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.entities.eo.CaDailyJail> dailyJails(EOQualifier qualifier, boolean fetch) {
    return dailyJails(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.entities.eo.CaDailyJail> dailyJails(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.entities.eo.CaDailyJail> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.entities.eo.CaDailyJail.COUNTY_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.entities.eo.CaDailyJail.fetchCaDailyJails(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = dailyJails();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.entities.eo.CaDailyJail>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.entities.eo.CaDailyJail>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToDailyJails(org.opencalaccess.entities.eo.CaDailyJail object) {
    includeObjectIntoPropertyWithKey(object, _CaCounty.DAILY_JAILS_KEY);
  }

  public void removeFromDailyJails(org.opencalaccess.entities.eo.CaDailyJail object) {
    excludeObjectFromPropertyWithKey(object, _CaCounty.DAILY_JAILS_KEY);
  }

  public void addToDailyJailsRelationship(org.opencalaccess.entities.eo.CaDailyJail object) {
    log.debug("adding {} to dailyJails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToDailyJails(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAILS_KEY);
    }
  }

  public void removeFromDailyJailsRelationship(org.opencalaccess.entities.eo.CaDailyJail object) {
    log.debug("removing {} from dailyJails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromDailyJails(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAILS_KEY);
    }
  }

  public org.opencalaccess.entities.eo.CaDailyJail createDailyJailsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.entities.eo.CaDailyJail.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _CaCounty.DAILY_JAILS_KEY);
    return (org.opencalaccess.entities.eo.CaDailyJail) eo;
  }

  public void deleteDailyJailsRelationship(org.opencalaccess.entities.eo.CaDailyJail object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _CaCounty.DAILY_JAILS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllDailyJailsRelationships() {
    Enumeration<org.opencalaccess.entities.eo.CaDailyJail> objects = dailyJails().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteDailyJailsRelationship(objects.nextElement());
    }
  }


  public static CaCounty createCaCounty(EOEditingContext editingContext, String name
, Long pop2020
) {
    CaCounty eo = (CaCounty) EOUtilities.createAndInsertInstance(editingContext, _CaCounty.ENTITY_NAME);
    eo.setName(name);
    eo.setPop2020(pop2020);
    return eo;
  }

  public static ERXFetchSpecification<CaCounty> fetchSpec() {
    return new ERXFetchSpecification<CaCounty>(_CaCounty.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<CaCounty> fetchAllCaCounties(EOEditingContext editingContext) {
    return _CaCounty.fetchAllCaCounties(editingContext, null);
  }

  public static NSArray<CaCounty> fetchAllCaCounties(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _CaCounty.fetchCaCounties(editingContext, null, sortOrderings);
  }

  public static NSArray<CaCounty> fetchCaCounties(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<CaCounty> fetchSpec = new ERXFetchSpecification<CaCounty>(_CaCounty.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<CaCounty> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static CaCounty fetchCaCounty(EOEditingContext editingContext, String keyName, Object value) {
    return _CaCounty.fetchCaCounty(editingContext, ERXQ.equals(keyName, value));
  }

  public static CaCounty fetchCaCounty(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<CaCounty> eoObjects = _CaCounty.fetchCaCounties(editingContext, qualifier, null);
    CaCounty eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one CaCounty that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CaCounty fetchRequiredCaCounty(EOEditingContext editingContext, String keyName, Object value) {
    return _CaCounty.fetchRequiredCaCounty(editingContext, ERXQ.equals(keyName, value));
  }

  public static CaCounty fetchRequiredCaCounty(EOEditingContext editingContext, EOQualifier qualifier) {
    CaCounty eoObject = _CaCounty.fetchCaCounty(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no CaCounty that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static CaCounty localInstanceIn(EOEditingContext editingContext, CaCounty eo) {
    CaCounty localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
