// DO NOT EDIT.  Make changes to User.java instead.
package org.opencalaccess.invites.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _User extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "User";

  // Attribute Keys
  public static final ERXKey<String> EMAIL_ADDRESS = new ERXKey<String>("emailAddress", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtPayment> COURT_PAYMENTS = new ERXKey<org.opencalaccess.courtcases.eo.CourtPayment>("courtPayments", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtWorkerMessage> COURT_WORKER_MESSAGES = new ERXKey<org.opencalaccess.courtcases.eo.CourtWorkerMessage>("courtWorkerMessages", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> COURT_WORKLOAD_ENTRIES = new ERXKey<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>("courtWorkloadEntries", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.invites.eo.UserInvite> USER_INVITES = new ERXKey<org.opencalaccess.invites.eo.UserInvite>("userInvites", Type.ToManyRelationship);

  // Attributes
  public static final String EMAIL_ADDRESS_KEY = EMAIL_ADDRESS.key();

  // Relationships
  public static final String COURT_PAYMENTS_KEY = COURT_PAYMENTS.key();
  public static final String COURT_WORKER_MESSAGES_KEY = COURT_WORKER_MESSAGES.key();
  public static final String COURT_WORKLOAD_ENTRIES_KEY = COURT_WORKLOAD_ENTRIES.key();
  public static final String USER_INVITES_KEY = USER_INVITES.key();

  private static final Logger log = LoggerFactory.getLogger(_User.class);

  public User localInstanceIn(EOEditingContext editingContext) {
    User localInstance = (User)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String emailAddress() {
    return (String) storedValueForKey(_User.EMAIL_ADDRESS_KEY);
  }

  public void setEmailAddress(String value) {
    log.debug( "updating emailAddress from {} to {}", emailAddress(), value);
    takeStoredValueForKey(value, _User.EMAIL_ADDRESS_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPayment> courtPayments() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtPayment>)storedValueForKey(_User.COURT_PAYMENTS_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPayment> courtPayments(EOQualifier qualifier) {
    return courtPayments(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPayment> courtPayments(EOQualifier qualifier, boolean fetch) {
    return courtPayments(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtPayment> courtPayments(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtPayment> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtPayment.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtPayment.fetchCourtPayments(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = courtPayments();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtPayment>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtPayment>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCourtPayments(org.opencalaccess.courtcases.eo.CourtPayment object) {
    includeObjectIntoPropertyWithKey(object, _User.COURT_PAYMENTS_KEY);
  }

  public void removeFromCourtPayments(org.opencalaccess.courtcases.eo.CourtPayment object) {
    excludeObjectFromPropertyWithKey(object, _User.COURT_PAYMENTS_KEY);
  }

  public void addToCourtPaymentsRelationship(org.opencalaccess.courtcases.eo.CourtPayment object) {
    log.debug("adding {} to courtPayments relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCourtPayments(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _User.COURT_PAYMENTS_KEY);
    }
  }

  public void removeFromCourtPaymentsRelationship(org.opencalaccess.courtcases.eo.CourtPayment object) {
    log.debug("removing {} from courtPayments relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCourtPayments(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_PAYMENTS_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtPayment createCourtPaymentsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtPayment.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _User.COURT_PAYMENTS_KEY);
    return (org.opencalaccess.courtcases.eo.CourtPayment) eo;
  }

  public void deleteCourtPaymentsRelationship(org.opencalaccess.courtcases.eo.CourtPayment object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_PAYMENTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCourtPaymentsRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtPayment> objects = courtPayments().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCourtPaymentsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage> courtWorkerMessages() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage>)storedValueForKey(_User.COURT_WORKER_MESSAGES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage> courtWorkerMessages(EOQualifier qualifier) {
    return courtWorkerMessages(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage> courtWorkerMessages(EOQualifier qualifier, boolean fetch) {
    return courtWorkerMessages(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage> courtWorkerMessages(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtWorkerMessage.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtWorkerMessage.fetchCourtWorkerMessages(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = courtWorkerMessages();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkerMessage>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCourtWorkerMessages(org.opencalaccess.courtcases.eo.CourtWorkerMessage object) {
    includeObjectIntoPropertyWithKey(object, _User.COURT_WORKER_MESSAGES_KEY);
  }

  public void removeFromCourtWorkerMessages(org.opencalaccess.courtcases.eo.CourtWorkerMessage object) {
    excludeObjectFromPropertyWithKey(object, _User.COURT_WORKER_MESSAGES_KEY);
  }

  public void addToCourtWorkerMessagesRelationship(org.opencalaccess.courtcases.eo.CourtWorkerMessage object) {
    log.debug("adding {} to courtWorkerMessages relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCourtWorkerMessages(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _User.COURT_WORKER_MESSAGES_KEY);
    }
  }

  public void removeFromCourtWorkerMessagesRelationship(org.opencalaccess.courtcases.eo.CourtWorkerMessage object) {
    log.debug("removing {} from courtWorkerMessages relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCourtWorkerMessages(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_WORKER_MESSAGES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtWorkerMessage createCourtWorkerMessagesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtWorkerMessage.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _User.COURT_WORKER_MESSAGES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtWorkerMessage) eo;
  }

  public void deleteCourtWorkerMessagesRelationship(org.opencalaccess.courtcases.eo.CourtWorkerMessage object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_WORKER_MESSAGES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCourtWorkerMessagesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtWorkerMessage> objects = courtWorkerMessages().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCourtWorkerMessagesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> courtWorkloadEntries() {
    return (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)storedValueForKey(_User.COURT_WORKLOAD_ENTRIES_KEY);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> courtWorkloadEntries(EOQualifier qualifier) {
    return courtWorkloadEntries(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> courtWorkloadEntries(EOQualifier qualifier, boolean fetch) {
    return courtWorkloadEntries(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> courtWorkloadEntries(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.courtcases.eo.CourtWorkloadEntry.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.courtcases.eo.CourtWorkloadEntry.fetchCourtWorkloadEntries(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = courtWorkloadEntries();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.courtcases.eo.CourtWorkloadEntry>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToCourtWorkloadEntries(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    includeObjectIntoPropertyWithKey(object, _User.COURT_WORKLOAD_ENTRIES_KEY);
  }

  public void removeFromCourtWorkloadEntries(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    excludeObjectFromPropertyWithKey(object, _User.COURT_WORKLOAD_ENTRIES_KEY);
  }

  public void addToCourtWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    log.debug("adding {} to courtWorkloadEntries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToCourtWorkloadEntries(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _User.COURT_WORKLOAD_ENTRIES_KEY);
    }
  }

  public void removeFromCourtWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    log.debug("removing {} from courtWorkloadEntries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromCourtWorkloadEntries(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_WORKLOAD_ENTRIES_KEY);
    }
  }

  public org.opencalaccess.courtcases.eo.CourtWorkloadEntry createCourtWorkloadEntriesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.courtcases.eo.CourtWorkloadEntry.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _User.COURT_WORKLOAD_ENTRIES_KEY);
    return (org.opencalaccess.courtcases.eo.CourtWorkloadEntry) eo;
  }

  public void deleteCourtWorkloadEntriesRelationship(org.opencalaccess.courtcases.eo.CourtWorkloadEntry object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _User.COURT_WORKLOAD_ENTRIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllCourtWorkloadEntriesRelationships() {
    Enumeration<org.opencalaccess.courtcases.eo.CourtWorkloadEntry> objects = courtWorkloadEntries().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteCourtWorkloadEntriesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites() {
    return (NSArray<org.opencalaccess.invites.eo.UserInvite>)storedValueForKey(_User.USER_INVITES_KEY);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier) {
    return userInvites(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier, boolean fetch) {
    return userInvites(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.invites.eo.UserInvite> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.invites.eo.UserInvite.USER_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.invites.eo.UserInvite.fetchUserInvites(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = userInvites();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.invites.eo.UserInvite>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.invites.eo.UserInvite>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToUserInvites(org.opencalaccess.invites.eo.UserInvite object) {
    includeObjectIntoPropertyWithKey(object, _User.USER_INVITES_KEY);
  }

  public void removeFromUserInvites(org.opencalaccess.invites.eo.UserInvite object) {
    excludeObjectFromPropertyWithKey(object, _User.USER_INVITES_KEY);
  }

  public void addToUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    log.debug("adding {} to userInvites relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToUserInvites(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _User.USER_INVITES_KEY);
    }
  }

  public void removeFromUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    log.debug("removing {} from userInvites relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromUserInvites(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _User.USER_INVITES_KEY);
    }
  }

  public org.opencalaccess.invites.eo.UserInvite createUserInvitesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.invites.eo.UserInvite.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _User.USER_INVITES_KEY);
    return (org.opencalaccess.invites.eo.UserInvite) eo;
  }

  public void deleteUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _User.USER_INVITES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllUserInvitesRelationships() {
    Enumeration<org.opencalaccess.invites.eo.UserInvite> objects = userInvites().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteUserInvitesRelationship(objects.nextElement());
    }
  }


  public static User createUser(EOEditingContext editingContext, String emailAddress
) {
    User eo = (User) EOUtilities.createAndInsertInstance(editingContext, _User.ENTITY_NAME);
    eo.setEmailAddress(emailAddress);
    return eo;
  }

  public static ERXFetchSpecification<User> fetchSpec() {
    return new ERXFetchSpecification<User>(_User.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<User> fetchAllUsers(EOEditingContext editingContext) {
    return _User.fetchAllUsers(editingContext, null);
  }

  public static NSArray<User> fetchAllUsers(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _User.fetchUsers(editingContext, null, sortOrderings);
  }

  public static NSArray<User> fetchUsers(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<User> fetchSpec = new ERXFetchSpecification<User>(_User.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<User> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static User fetchUser(EOEditingContext editingContext, String keyName, Object value) {
    return _User.fetchUser(editingContext, ERXQ.equals(keyName, value));
  }

  public static User fetchUser(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<User> eoObjects = _User.fetchUsers(editingContext, qualifier, null);
    User eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one User that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static User fetchRequiredUser(EOEditingContext editingContext, String keyName, Object value) {
    return _User.fetchRequiredUser(editingContext, ERXQ.equals(keyName, value));
  }

  public static User fetchRequiredUser(EOEditingContext editingContext, EOQualifier qualifier) {
    User eoObject = _User.fetchUser(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no User that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static User localInstanceIn(EOEditingContext editingContext, User eo) {
    User localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
