// DO NOT EDIT.  Make changes to UserInvite.java instead.
package org.opencalaccess.invites.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _UserInvite extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "UserInvite";

  // Attribute Keys
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> DIGEST = new ERXKey<String>("digest", Type.Attribute);
  public static final ERXKey<Long> EXPIRES = new ERXKey<Long>("expires", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.invites.eo.User> USER = new ERXKey<org.opencalaccess.invites.eo.User>("user", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.invites.eo.UserRight> USER_RIGHT = new ERXKey<org.opencalaccess.invites.eo.UserRight>("userRight", Type.ToOneRelationship);

  // Attributes
  public static final String CREATED_KEY = CREATED.key();
  public static final String DIGEST_KEY = DIGEST.key();
  public static final String EXPIRES_KEY = EXPIRES.key();

  // Relationships
  public static final String USER_KEY = USER.key();
  public static final String USER_RIGHT_KEY = USER_RIGHT.key();

  private static final Logger log = LoggerFactory.getLogger(_UserInvite.class);

  public UserInvite localInstanceIn(EOEditingContext editingContext) {
    UserInvite localInstance = (UserInvite)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long created() {
    return (Long) storedValueForKey(_UserInvite.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _UserInvite.CREATED_KEY);
  }

  public String digest() {
    return (String) storedValueForKey(_UserInvite.DIGEST_KEY);
  }

  public void setDigest(String value) {
    log.debug( "updating digest from {} to {}", digest(), value);
    takeStoredValueForKey(value, _UserInvite.DIGEST_KEY);
  }

  public Long expires() {
    return (Long) storedValueForKey(_UserInvite.EXPIRES_KEY);
  }

  public void setExpires(Long value) {
    log.debug( "updating expires from {} to {}", expires(), value);
    takeStoredValueForKey(value, _UserInvite.EXPIRES_KEY);
  }

  public org.opencalaccess.invites.eo.User user() {
    return (org.opencalaccess.invites.eo.User)storedValueForKey(_UserInvite.USER_KEY);
  }

  public void setUser(org.opencalaccess.invites.eo.User value) {
    takeStoredValueForKey(value, _UserInvite.USER_KEY);
  }

  public void setUserRelationship(org.opencalaccess.invites.eo.User value) {
    log.debug("updating user from {} to {}", user(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUser(value);
    }
    else if (value == null) {
      org.opencalaccess.invites.eo.User oldValue = user();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _UserInvite.USER_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _UserInvite.USER_KEY);
    }
  }

  public org.opencalaccess.invites.eo.UserRight userRight() {
    return (org.opencalaccess.invites.eo.UserRight)storedValueForKey(_UserInvite.USER_RIGHT_KEY);
  }

  public void setUserRight(org.opencalaccess.invites.eo.UserRight value) {
    takeStoredValueForKey(value, _UserInvite.USER_RIGHT_KEY);
  }

  public void setUserRightRelationship(org.opencalaccess.invites.eo.UserRight value) {
    log.debug("updating userRight from {} to {}", userRight(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setUserRight(value);
    }
    else if (value == null) {
      org.opencalaccess.invites.eo.UserRight oldValue = userRight();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _UserInvite.USER_RIGHT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _UserInvite.USER_RIGHT_KEY);
    }
  }


  public static UserInvite createUserInvite(EOEditingContext editingContext, Long created
, org.opencalaccess.invites.eo.User user, org.opencalaccess.invites.eo.UserRight userRight) {
    UserInvite eo = (UserInvite) EOUtilities.createAndInsertInstance(editingContext, _UserInvite.ENTITY_NAME);
    eo.setCreated(created);
    eo.setUserRelationship(user);
    eo.setUserRightRelationship(userRight);
    return eo;
  }

  public static ERXFetchSpecification<UserInvite> fetchSpec() {
    return new ERXFetchSpecification<UserInvite>(_UserInvite.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<UserInvite> fetchAllUserInvites(EOEditingContext editingContext) {
    return _UserInvite.fetchAllUserInvites(editingContext, null);
  }

  public static NSArray<UserInvite> fetchAllUserInvites(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _UserInvite.fetchUserInvites(editingContext, null, sortOrderings);
  }

  public static NSArray<UserInvite> fetchUserInvites(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<UserInvite> fetchSpec = new ERXFetchSpecification<UserInvite>(_UserInvite.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<UserInvite> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static UserInvite fetchUserInvite(EOEditingContext editingContext, String keyName, Object value) {
    return _UserInvite.fetchUserInvite(editingContext, ERXQ.equals(keyName, value));
  }

  public static UserInvite fetchUserInvite(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<UserInvite> eoObjects = _UserInvite.fetchUserInvites(editingContext, qualifier, null);
    UserInvite eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one UserInvite that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UserInvite fetchRequiredUserInvite(EOEditingContext editingContext, String keyName, Object value) {
    return _UserInvite.fetchRequiredUserInvite(editingContext, ERXQ.equals(keyName, value));
  }

  public static UserInvite fetchRequiredUserInvite(EOEditingContext editingContext, EOQualifier qualifier) {
    UserInvite eoObject = _UserInvite.fetchUserInvite(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no UserInvite that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UserInvite localInstanceIn(EOEditingContext editingContext, UserInvite eo) {
    UserInvite localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
