// DO NOT EDIT.  Make changes to UserRight.java instead.
package org.opencalaccess.invites.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _UserRight extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "UserRight";

  // Attribute Keys
  public static final ERXKey<String> APP_NAME = new ERXKey<String>("appName", Type.Attribute);
  public static final ERXKey<String> APP_RIGHT = new ERXKey<String>("appRight", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.invites.eo.UserInvite> USER_INVITES = new ERXKey<org.opencalaccess.invites.eo.UserInvite>("userInvites", Type.ToManyRelationship);

  // Attributes
  public static final String APP_NAME_KEY = APP_NAME.key();
  public static final String APP_RIGHT_KEY = APP_RIGHT.key();

  // Relationships
  public static final String USER_INVITES_KEY = USER_INVITES.key();

  private static final Logger log = LoggerFactory.getLogger(_UserRight.class);

  public UserRight localInstanceIn(EOEditingContext editingContext) {
    UserRight localInstance = (UserRight)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String appName() {
    return (String) storedValueForKey(_UserRight.APP_NAME_KEY);
  }

  public void setAppName(String value) {
    log.debug( "updating appName from {} to {}", appName(), value);
    takeStoredValueForKey(value, _UserRight.APP_NAME_KEY);
  }

  public String appRight() {
    return (String) storedValueForKey(_UserRight.APP_RIGHT_KEY);
  }

  public void setAppRight(String value) {
    log.debug( "updating appRight from {} to {}", appRight(), value);
    takeStoredValueForKey(value, _UserRight.APP_RIGHT_KEY);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites() {
    return (NSArray<org.opencalaccess.invites.eo.UserInvite>)storedValueForKey(_UserRight.USER_INVITES_KEY);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier) {
    return userInvites(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier, boolean fetch) {
    return userInvites(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.invites.eo.UserInvite> userInvites(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.invites.eo.UserInvite> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.invites.eo.UserInvite.USER_RIGHT_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.invites.eo.UserInvite.fetchUserInvites(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = userInvites();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.invites.eo.UserInvite>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.invites.eo.UserInvite>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToUserInvites(org.opencalaccess.invites.eo.UserInvite object) {
    includeObjectIntoPropertyWithKey(object, _UserRight.USER_INVITES_KEY);
  }

  public void removeFromUserInvites(org.opencalaccess.invites.eo.UserInvite object) {
    excludeObjectFromPropertyWithKey(object, _UserRight.USER_INVITES_KEY);
  }

  public void addToUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    log.debug("adding {} to userInvites relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToUserInvites(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _UserRight.USER_INVITES_KEY);
    }
  }

  public void removeFromUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    log.debug("removing {} from userInvites relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromUserInvites(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _UserRight.USER_INVITES_KEY);
    }
  }

  public org.opencalaccess.invites.eo.UserInvite createUserInvitesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.invites.eo.UserInvite.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _UserRight.USER_INVITES_KEY);
    return (org.opencalaccess.invites.eo.UserInvite) eo;
  }

  public void deleteUserInvitesRelationship(org.opencalaccess.invites.eo.UserInvite object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _UserRight.USER_INVITES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllUserInvitesRelationships() {
    Enumeration<org.opencalaccess.invites.eo.UserInvite> objects = userInvites().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteUserInvitesRelationship(objects.nextElement());
    }
  }


  public static UserRight createUserRight(EOEditingContext editingContext, String appName
, String appRight
) {
    UserRight eo = (UserRight) EOUtilities.createAndInsertInstance(editingContext, _UserRight.ENTITY_NAME);
    eo.setAppName(appName);
    eo.setAppRight(appRight);
    return eo;
  }

  public static ERXFetchSpecification<UserRight> fetchSpec() {
    return new ERXFetchSpecification<UserRight>(_UserRight.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<UserRight> fetchAllUserRights(EOEditingContext editingContext) {
    return _UserRight.fetchAllUserRights(editingContext, null);
  }

  public static NSArray<UserRight> fetchAllUserRights(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _UserRight.fetchUserRights(editingContext, null, sortOrderings);
  }

  public static NSArray<UserRight> fetchUserRights(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<UserRight> fetchSpec = new ERXFetchSpecification<UserRight>(_UserRight.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<UserRight> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static UserRight fetchUserRight(EOEditingContext editingContext, String keyName, Object value) {
    return _UserRight.fetchUserRight(editingContext, ERXQ.equals(keyName, value));
  }

  public static UserRight fetchUserRight(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<UserRight> eoObjects = _UserRight.fetchUserRights(editingContext, qualifier, null);
    UserRight eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one UserRight that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UserRight fetchRequiredUserRight(EOEditingContext editingContext, String keyName, Object value) {
    return _UserRight.fetchRequiredUserRight(editingContext, ERXQ.equals(keyName, value));
  }

  public static UserRight fetchRequiredUserRight(EOEditingContext editingContext, EOQualifier qualifier) {
    UserRight eoObject = _UserRight.fetchUserRight(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no UserRight that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UserRight localInstanceIn(EOEditingContext editingContext, UserRight eo) {
    UserRight localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
