package org.opencalaccess.leginfo.eo;

import org.apache.log4j.Logger;

import com.webobjects.eocontrol.EOEditingContext;

public class Legislator extends _Legislator {

	private static final long serialVersionUID = -7522480046666296642L;

	@SuppressWarnings("unused")
	private static Logger log = Logger.getLogger(Legislator.class);

	public static Legislator legislatorForAuthorName(EOEditingContext ec, String authorName) {
		return Legislator.fetchLegislator(ec, Legislator.AUTHOR_NAME_KEY, authorName);
	}


	public String shortTitle() {
		if ("A".equals(this.houseType())) {
			return "Asm";
		}
		if ("S".equals(this.houseType())) {
			return "Sen";
		}
		throw new IllegalArgumentException("houseType of legislator should be either \"A\" or \"S\"");
	}

	public String longTitle() {
		if ("A".equals(this.houseType())) {
			return "Assemblymember";
		}
		if ("S".equals(this.houseType())) {
			return "Senator";
		}
		throw new IllegalArgumentException("houseType of legislator should be either \"A\" or \"S\"");
	}
}
