// DO NOT EDIT.  Make changes to Author.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Author extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Author";

  // Attribute Keys
  public static final ERXKey<String> CONTACT_INFO = new ERXKey<String>("contactInfo", Type.Attribute);
  public static final ERXKey<String> DISTRICT = new ERXKey<String>("district", Type.Attribute);
  public static final ERXKey<String> HOUSE = new ERXKey<String>("house", Type.Attribute);
  public static final ERXKey<String> IN_OFFICE = new ERXKey<String>("inOffice", Type.Attribute);
  public static final ERXKey<Integer> LEGISLATOR_PK = new ERXKey<Integer>("legislatorPk", Type.Attribute);
  public static final ERXKey<String> LONG_NAME = new ERXKey<String>("longName", Type.Attribute);
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);
  public static final ERXKey<String> PARTY = new ERXKey<String>("party", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Authoring> AUTHORINGS = new ERXKey<org.opencalaccess.leginfo.eo.Authoring>("authorings", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.Legislator> LEGISLATOR = new ERXKey<org.opencalaccess.leginfo.eo.Legislator>("legislator", Type.ToOneRelationship);

  // Attributes
  public static final String CONTACT_INFO_KEY = CONTACT_INFO.key();
  public static final String DISTRICT_KEY = DISTRICT.key();
  public static final String HOUSE_KEY = HOUSE.key();
  public static final String IN_OFFICE_KEY = IN_OFFICE.key();
  public static final String LEGISLATOR_PK_KEY = LEGISLATOR_PK.key();
  public static final String LONG_NAME_KEY = LONG_NAME.key();
  public static final String NAME_KEY = NAME.key();
  public static final String PARTY_KEY = PARTY.key();

  // Relationships
  public static final String AUTHORINGS_KEY = AUTHORINGS.key();
  public static final String LEGISLATOR_KEY = LEGISLATOR.key();

  private static final Logger log = LoggerFactory.getLogger(_Author.class);

  public Author localInstanceIn(EOEditingContext editingContext) {
    Author localInstance = (Author)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String contactInfo() {
    return (String) storedValueForKey(_Author.CONTACT_INFO_KEY);
  }

  public void setContactInfo(String value) {
    log.debug( "updating contactInfo from {} to {}", contactInfo(), value);
    takeStoredValueForKey(value, _Author.CONTACT_INFO_KEY);
  }

  public String district() {
    return (String) storedValueForKey(_Author.DISTRICT_KEY);
  }

  public void setDistrict(String value) {
    log.debug( "updating district from {} to {}", district(), value);
    takeStoredValueForKey(value, _Author.DISTRICT_KEY);
  }

  public String house() {
    return (String) storedValueForKey(_Author.HOUSE_KEY);
  }

  public void setHouse(String value) {
    log.debug( "updating house from {} to {}", house(), value);
    takeStoredValueForKey(value, _Author.HOUSE_KEY);
  }

  public String inOffice() {
    return (String) storedValueForKey(_Author.IN_OFFICE_KEY);
  }

  public void setInOffice(String value) {
    log.debug( "updating inOffice from {} to {}", inOffice(), value);
    takeStoredValueForKey(value, _Author.IN_OFFICE_KEY);
  }

  public Integer legislatorPk() {
    return (Integer) storedValueForKey(_Author.LEGISLATOR_PK_KEY);
  }

  public void setLegislatorPk(Integer value) {
    log.debug( "updating legislatorPk from {} to {}", legislatorPk(), value);
    takeStoredValueForKey(value, _Author.LEGISLATOR_PK_KEY);
  }

  public String longName() {
    return (String) storedValueForKey(_Author.LONG_NAME_KEY);
  }

  public void setLongName(String value) {
    log.debug( "updating longName from {} to {}", longName(), value);
    takeStoredValueForKey(value, _Author.LONG_NAME_KEY);
  }

  public String name() {
    return (String) storedValueForKey(_Author.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _Author.NAME_KEY);
  }

  public String party() {
    return (String) storedValueForKey(_Author.PARTY_KEY);
  }

  public void setParty(String value) {
    log.debug( "updating party from {} to {}", party(), value);
    takeStoredValueForKey(value, _Author.PARTY_KEY);
  }

  public org.opencalaccess.leginfo.eo.Legislator legislator() {
    return (org.opencalaccess.leginfo.eo.Legislator)storedValueForKey(_Author.LEGISLATOR_KEY);
  }

  public void setLegislator(org.opencalaccess.leginfo.eo.Legislator value) {
    takeStoredValueForKey(value, _Author.LEGISLATOR_KEY);
  }

  public void setLegislatorRelationship(org.opencalaccess.leginfo.eo.Legislator value) {
    log.debug("updating legislator from {} to {}", legislator(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setLegislator(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Legislator oldValue = legislator();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Author.LEGISLATOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Author.LEGISLATOR_KEY);
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings() {
    return (NSArray<org.opencalaccess.leginfo.eo.Authoring>)storedValueForKey(_Author.AUTHORINGS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier) {
    return authorings(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier, boolean fetch) {
    return authorings(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.Authoring> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.Authoring.AUTHOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.Authoring.fetchAuthorings(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = authorings();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Authoring>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Authoring>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToAuthorings(org.opencalaccess.leginfo.eo.Authoring object) {
    includeObjectIntoPropertyWithKey(object, _Author.AUTHORINGS_KEY);
  }

  public void removeFromAuthorings(org.opencalaccess.leginfo.eo.Authoring object) {
    excludeObjectFromPropertyWithKey(object, _Author.AUTHORINGS_KEY);
  }

  public void addToAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    log.debug("adding {} to authorings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAuthorings(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Author.AUTHORINGS_KEY);
    }
  }

  public void removeFromAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    log.debug("removing {} from authorings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAuthorings(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Author.AUTHORINGS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.Authoring createAuthoringsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.Authoring.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Author.AUTHORINGS_KEY);
    return (org.opencalaccess.leginfo.eo.Authoring) eo;
  }

  public void deleteAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Author.AUTHORINGS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAuthoringsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.Authoring> objects = authorings().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAuthoringsRelationship(objects.nextElement());
    }
  }


  public static Author createAuthor(EOEditingContext editingContext, String house
, String inOffice
, String name
) {
    Author eo = (Author) EOUtilities.createAndInsertInstance(editingContext, _Author.ENTITY_NAME);
    eo.setHouse(house);
    eo.setInOffice(inOffice);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<Author> fetchSpec() {
    return new ERXFetchSpecification<Author>(_Author.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Author> fetchAllAuthors(EOEditingContext editingContext) {
    return _Author.fetchAllAuthors(editingContext, null);
  }

  public static NSArray<Author> fetchAllAuthors(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Author.fetchAuthors(editingContext, null, sortOrderings);
  }

  public static NSArray<Author> fetchAuthors(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Author> fetchSpec = new ERXFetchSpecification<Author>(_Author.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Author> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Author fetchAuthor(EOEditingContext editingContext, String keyName, Object value) {
    return _Author.fetchAuthor(editingContext, ERXQ.equals(keyName, value));
  }

  public static Author fetchAuthor(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Author> eoObjects = _Author.fetchAuthors(editingContext, qualifier, null);
    Author eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Author that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Author fetchRequiredAuthor(EOEditingContext editingContext, String keyName, Object value) {
    return _Author.fetchRequiredAuthor(editingContext, ERXQ.equals(keyName, value));
  }

  public static Author fetchRequiredAuthor(EOEditingContext editingContext, EOQualifier qualifier) {
    Author eoObject = _Author.fetchAuthor(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Author that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Author localInstanceIn(EOEditingContext editingContext, Author eo) {
    Author localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
