// DO NOT EDIT.  Make changes to Authoring.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Authoring extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Authoring";

  // Attribute Keys
  public static final ERXKey<String> CONTRIBUTION = new ERXKey<String>("contribution", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Author> AUTHOR = new ERXKey<org.opencalaccess.leginfo.eo.Author>("author", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVersionAuthor> BILL_VERSION_AUTHOR = new ERXKey<org.opencalaccess.leginfo.eo.BillVersionAuthor>("billVersionAuthor", Type.ToOneRelationship);

  // Attributes
  public static final String CONTRIBUTION_KEY = CONTRIBUTION.key();

  // Relationships
  public static final String AUTHOR_KEY = AUTHOR.key();
  public static final String BILL_VERSION_AUTHOR_KEY = BILL_VERSION_AUTHOR.key();

  private static final Logger log = LoggerFactory.getLogger(_Authoring.class);

  public Authoring localInstanceIn(EOEditingContext editingContext) {
    Authoring localInstance = (Authoring)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String contribution() {
    return (String) storedValueForKey(_Authoring.CONTRIBUTION_KEY);
  }

  public void setContribution(String value) {
    log.debug( "updating contribution from {} to {}", contribution(), value);
    takeStoredValueForKey(value, _Authoring.CONTRIBUTION_KEY);
  }

  public org.opencalaccess.leginfo.eo.Author author() {
    return (org.opencalaccess.leginfo.eo.Author)storedValueForKey(_Authoring.AUTHOR_KEY);
  }

  public void setAuthor(org.opencalaccess.leginfo.eo.Author value) {
    takeStoredValueForKey(value, _Authoring.AUTHOR_KEY);
  }

  public void setAuthorRelationship(org.opencalaccess.leginfo.eo.Author value) {
    log.debug("updating author from {} to {}", author(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setAuthor(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Author oldValue = author();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Authoring.AUTHOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Authoring.AUTHOR_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVersionAuthor billVersionAuthor() {
    return (org.opencalaccess.leginfo.eo.BillVersionAuthor)storedValueForKey(_Authoring.BILL_VERSION_AUTHOR_KEY);
  }

  public void setBillVersionAuthor(org.opencalaccess.leginfo.eo.BillVersionAuthor value) {
    takeStoredValueForKey(value, _Authoring.BILL_VERSION_AUTHOR_KEY);
  }

  public void setBillVersionAuthorRelationship(org.opencalaccess.leginfo.eo.BillVersionAuthor value) {
    log.debug("updating billVersionAuthor from {} to {}", billVersionAuthor(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBillVersionAuthor(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.BillVersionAuthor oldValue = billVersionAuthor();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Authoring.BILL_VERSION_AUTHOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Authoring.BILL_VERSION_AUTHOR_KEY);
    }
  }


  public static Authoring createAuthoring(EOEditingContext editingContext, String contribution
, org.opencalaccess.leginfo.eo.Author author, org.opencalaccess.leginfo.eo.BillVersionAuthor billVersionAuthor) {
    Authoring eo = (Authoring) EOUtilities.createAndInsertInstance(editingContext, _Authoring.ENTITY_NAME);
    eo.setContribution(contribution);
    eo.setAuthorRelationship(author);
    eo.setBillVersionAuthorRelationship(billVersionAuthor);
    return eo;
  }

  public static ERXFetchSpecification<Authoring> fetchSpec() {
    return new ERXFetchSpecification<Authoring>(_Authoring.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Authoring> fetchAllAuthorings(EOEditingContext editingContext) {
    return _Authoring.fetchAllAuthorings(editingContext, null);
  }

  public static NSArray<Authoring> fetchAllAuthorings(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Authoring.fetchAuthorings(editingContext, null, sortOrderings);
  }

  public static NSArray<Authoring> fetchAuthorings(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Authoring> fetchSpec = new ERXFetchSpecification<Authoring>(_Authoring.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Authoring> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Authoring fetchAuthoring(EOEditingContext editingContext, String keyName, Object value) {
    return _Authoring.fetchAuthoring(editingContext, ERXQ.equals(keyName, value));
  }

  public static Authoring fetchAuthoring(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Authoring> eoObjects = _Authoring.fetchAuthorings(editingContext, qualifier, null);
    Authoring eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Authoring that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Authoring fetchRequiredAuthoring(EOEditingContext editingContext, String keyName, Object value) {
    return _Authoring.fetchRequiredAuthoring(editingContext, ERXQ.equals(keyName, value));
  }

  public static Authoring fetchRequiredAuthoring(EOEditingContext editingContext, EOQualifier qualifier) {
    Authoring eoObject = _Authoring.fetchAuthoring(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Authoring that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Authoring localInstanceIn(EOEditingContext editingContext, Authoring eo) {
    Authoring localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
