// DO NOT EDIT.  Make changes to Bill.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Bill extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Bill";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> CHAPTER_NUM = new ERXKey<String>("chapterNum", Type.Attribute);
  public static final ERXKey<String> CHAPTER_SESSION_NUM = new ERXKey<String>("chapterSessionNum", Type.Attribute);
  public static final ERXKey<String> CHAPTER_TYPE = new ERXKey<String>("chapterType", Type.Attribute);
  public static final ERXKey<String> CHAPTER_YEAR = new ERXKey<String>("chapterYear", Type.Attribute);
  public static final ERXKey<String> CURRENT_HOUSE = new ERXKey<String>("currentHouse", Type.Attribute);
  public static final ERXKey<String> CURRENT_LOCATION = new ERXKey<String>("currentLocation", Type.Attribute);
  public static final ERXKey<String> CURRENT_SECONDARY_LOC = new ERXKey<String>("currentSecondaryLoc", Type.Attribute);
  public static final ERXKey<String> CURRENT_STATUS = new ERXKey<String>("currentStatus", Type.Attribute);
  public static final ERXKey<NSTimestamp> DAYS31_IN_PRINT = new ERXKey<NSTimestamp>("days31InPrint", Type.Attribute);
  public static final ERXKey<String> LATEST_BILL_VERSION_ID = new ERXKey<String>("latestBillVersionId", Type.Attribute);
  public static final ERXKey<Long> MEASURE_NUM = new ERXKey<Long>("measureNum", Type.Attribute);
  public static final ERXKey<String> MEASURE_STATE = new ERXKey<String>("measureState", Type.Attribute);
  public static final ERXKey<String> MEASURE_TYPE = new ERXKey<String>("measureType", Type.Attribute);
  public static final ERXKey<String> SESSION_NUM = new ERXKey<String>("sessionNum", Type.Attribute);
  public static final ERXKey<String> SESSION_YEAR = new ERXKey<String>("sessionYear", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillAnalysis> ANALYSES = new ERXKey<org.opencalaccess.leginfo.eo.BillAnalysis>("analyses", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail> BILL_VOTE_DETAILS = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail>("billVoteDetails", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillHistory> HISTORIES = new ERXKey<org.opencalaccess.leginfo.eo.BillHistory>("histories", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVersion> LATEST_VERSION = new ERXKey<org.opencalaccess.leginfo.eo.BillVersion>("latestVersion", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVersion> VERSIONS = new ERXKey<org.opencalaccess.leginfo.eo.BillVersion>("versions", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteSummary> VOTE_SUMMARIES = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteSummary>("voteSummaries", Type.ToManyRelationship);

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String CHAPTER_NUM_KEY = CHAPTER_NUM.key();
  public static final String CHAPTER_SESSION_NUM_KEY = CHAPTER_SESSION_NUM.key();
  public static final String CHAPTER_TYPE_KEY = CHAPTER_TYPE.key();
  public static final String CHAPTER_YEAR_KEY = CHAPTER_YEAR.key();
  public static final String CURRENT_HOUSE_KEY = CURRENT_HOUSE.key();
  public static final String CURRENT_LOCATION_KEY = CURRENT_LOCATION.key();
  public static final String CURRENT_SECONDARY_LOC_KEY = CURRENT_SECONDARY_LOC.key();
  public static final String CURRENT_STATUS_KEY = CURRENT_STATUS.key();
  public static final String DAYS31_IN_PRINT_KEY = DAYS31_IN_PRINT.key();
  public static final String LATEST_BILL_VERSION_ID_KEY = LATEST_BILL_VERSION_ID.key();
  public static final String MEASURE_NUM_KEY = MEASURE_NUM.key();
  public static final String MEASURE_STATE_KEY = MEASURE_STATE.key();
  public static final String MEASURE_TYPE_KEY = MEASURE_TYPE.key();
  public static final String SESSION_NUM_KEY = SESSION_NUM.key();
  public static final String SESSION_YEAR_KEY = SESSION_YEAR.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();

  // Relationships
  public static final String ANALYSES_KEY = ANALYSES.key();
  public static final String BILL_VOTE_DETAILS_KEY = BILL_VOTE_DETAILS.key();
  public static final String HISTORIES_KEY = HISTORIES.key();
  public static final String LATEST_VERSION_KEY = LATEST_VERSION.key();
  public static final String VERSIONS_KEY = VERSIONS.key();
  public static final String VOTE_SUMMARIES_KEY = VOTE_SUMMARIES.key();

  private static final Logger log = LoggerFactory.getLogger(_Bill.class);

  public Bill localInstanceIn(EOEditingContext editingContext) {
    Bill localInstance = (Bill)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_Bill.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _Bill.ACTIVE_FLG_KEY);
  }

  public String billId() {
    return (String) storedValueForKey(_Bill.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _Bill.BILL_ID_KEY);
  }

  public String chapterNum() {
    return (String) storedValueForKey(_Bill.CHAPTER_NUM_KEY);
  }

  public void setChapterNum(String value) {
    log.debug( "updating chapterNum from {} to {}", chapterNum(), value);
    takeStoredValueForKey(value, _Bill.CHAPTER_NUM_KEY);
  }

  public String chapterSessionNum() {
    return (String) storedValueForKey(_Bill.CHAPTER_SESSION_NUM_KEY);
  }

  public void setChapterSessionNum(String value) {
    log.debug( "updating chapterSessionNum from {} to {}", chapterSessionNum(), value);
    takeStoredValueForKey(value, _Bill.CHAPTER_SESSION_NUM_KEY);
  }

  public String chapterType() {
    return (String) storedValueForKey(_Bill.CHAPTER_TYPE_KEY);
  }

  public void setChapterType(String value) {
    log.debug( "updating chapterType from {} to {}", chapterType(), value);
    takeStoredValueForKey(value, _Bill.CHAPTER_TYPE_KEY);
  }

  public String chapterYear() {
    return (String) storedValueForKey(_Bill.CHAPTER_YEAR_KEY);
  }

  public void setChapterYear(String value) {
    log.debug( "updating chapterYear from {} to {}", chapterYear(), value);
    takeStoredValueForKey(value, _Bill.CHAPTER_YEAR_KEY);
  }

  public String currentHouse() {
    return (String) storedValueForKey(_Bill.CURRENT_HOUSE_KEY);
  }

  public void setCurrentHouse(String value) {
    log.debug( "updating currentHouse from {} to {}", currentHouse(), value);
    takeStoredValueForKey(value, _Bill.CURRENT_HOUSE_KEY);
  }

  public String currentLocation() {
    return (String) storedValueForKey(_Bill.CURRENT_LOCATION_KEY);
  }

  public void setCurrentLocation(String value) {
    log.debug( "updating currentLocation from {} to {}", currentLocation(), value);
    takeStoredValueForKey(value, _Bill.CURRENT_LOCATION_KEY);
  }

  public String currentSecondaryLoc() {
    return (String) storedValueForKey(_Bill.CURRENT_SECONDARY_LOC_KEY);
  }

  public void setCurrentSecondaryLoc(String value) {
    log.debug( "updating currentSecondaryLoc from {} to {}", currentSecondaryLoc(), value);
    takeStoredValueForKey(value, _Bill.CURRENT_SECONDARY_LOC_KEY);
  }

  public String currentStatus() {
    return (String) storedValueForKey(_Bill.CURRENT_STATUS_KEY);
  }

  public void setCurrentStatus(String value) {
    log.debug( "updating currentStatus from {} to {}", currentStatus(), value);
    takeStoredValueForKey(value, _Bill.CURRENT_STATUS_KEY);
  }

  public NSTimestamp days31InPrint() {
    return (NSTimestamp) storedValueForKey(_Bill.DAYS31_IN_PRINT_KEY);
  }

  public void setDays31InPrint(NSTimestamp value) {
    log.debug( "updating days31InPrint from {} to {}", days31InPrint(), value);
    takeStoredValueForKey(value, _Bill.DAYS31_IN_PRINT_KEY);
  }

  public String latestBillVersionId() {
    return (String) storedValueForKey(_Bill.LATEST_BILL_VERSION_ID_KEY);
  }

  public void setLatestBillVersionId(String value) {
    log.debug( "updating latestBillVersionId from {} to {}", latestBillVersionId(), value);
    takeStoredValueForKey(value, _Bill.LATEST_BILL_VERSION_ID_KEY);
  }

  public Long measureNum() {
    return (Long) storedValueForKey(_Bill.MEASURE_NUM_KEY);
  }

  public void setMeasureNum(Long value) {
    log.debug( "updating measureNum from {} to {}", measureNum(), value);
    takeStoredValueForKey(value, _Bill.MEASURE_NUM_KEY);
  }

  public String measureState() {
    return (String) storedValueForKey(_Bill.MEASURE_STATE_KEY);
  }

  public void setMeasureState(String value) {
    log.debug( "updating measureState from {} to {}", measureState(), value);
    takeStoredValueForKey(value, _Bill.MEASURE_STATE_KEY);
  }

  public String measureType() {
    return (String) storedValueForKey(_Bill.MEASURE_TYPE_KEY);
  }

  public void setMeasureType(String value) {
    log.debug( "updating measureType from {} to {}", measureType(), value);
    takeStoredValueForKey(value, _Bill.MEASURE_TYPE_KEY);
  }

  public String sessionNum() {
    return (String) storedValueForKey(_Bill.SESSION_NUM_KEY);
  }

  public void setSessionNum(String value) {
    log.debug( "updating sessionNum from {} to {}", sessionNum(), value);
    takeStoredValueForKey(value, _Bill.SESSION_NUM_KEY);
  }

  public String sessionYear() {
    return (String) storedValueForKey(_Bill.SESSION_YEAR_KEY);
  }

  public void setSessionYear(String value) {
    log.debug( "updating sessionYear from {} to {}", sessionYear(), value);
    takeStoredValueForKey(value, _Bill.SESSION_YEAR_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_Bill.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _Bill.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_Bill.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _Bill.TRANS_UPDATE_KEY);
  }

  public org.opencalaccess.leginfo.eo.BillVersion latestVersion() {
    return (org.opencalaccess.leginfo.eo.BillVersion)storedValueForKey(_Bill.LATEST_VERSION_KEY);
  }

  public void setLatestVersion(org.opencalaccess.leginfo.eo.BillVersion value) {
    takeStoredValueForKey(value, _Bill.LATEST_VERSION_KEY);
  }

  public void setLatestVersionRelationship(org.opencalaccess.leginfo.eo.BillVersion value) {
    log.debug("updating latestVersion from {} to {}", latestVersion(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setLatestVersion(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.BillVersion oldValue = latestVersion();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Bill.LATEST_VERSION_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Bill.LATEST_VERSION_KEY);
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAnalysis> analyses() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillAnalysis>)storedValueForKey(_Bill.ANALYSES_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAnalysis> analyses(EOQualifier qualifier) {
    return analyses(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAnalysis> analyses(EOQualifier qualifier, boolean fetch) {
    return analyses(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAnalysis> analyses(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillAnalysis> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillAnalysis.BILL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillAnalysis.fetchBillAnalysises(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = analyses();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillAnalysis>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillAnalysis>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToAnalyses(org.opencalaccess.leginfo.eo.BillAnalysis object) {
    includeObjectIntoPropertyWithKey(object, _Bill.ANALYSES_KEY);
  }

  public void removeFromAnalyses(org.opencalaccess.leginfo.eo.BillAnalysis object) {
    excludeObjectFromPropertyWithKey(object, _Bill.ANALYSES_KEY);
  }

  public void addToAnalysesRelationship(org.opencalaccess.leginfo.eo.BillAnalysis object) {
    log.debug("adding {} to analyses relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAnalyses(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Bill.ANALYSES_KEY);
    }
  }

  public void removeFromAnalysesRelationship(org.opencalaccess.leginfo.eo.BillAnalysis object) {
    log.debug("removing {} from analyses relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAnalyses(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.ANALYSES_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillAnalysis createAnalysesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillAnalysis.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Bill.ANALYSES_KEY);
    return (org.opencalaccess.leginfo.eo.BillAnalysis) eo;
  }

  public void deleteAnalysesRelationship(org.opencalaccess.leginfo.eo.BillAnalysis object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.ANALYSES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAnalysesRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillAnalysis> objects = analyses().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAnalysesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> billVoteDetails() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)storedValueForKey(_Bill.BILL_VOTE_DETAILS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> billVoteDetails(EOQualifier qualifier) {
    return billVoteDetails(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> billVoteDetails(EOQualifier qualifier, boolean fetch) {
    return billVoteDetails(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> billVoteDetails(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVoteDetail.BILL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVoteDetail.fetchBillVoteDetails(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = billVoteDetails();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToBillVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    includeObjectIntoPropertyWithKey(object, _Bill.BILL_VOTE_DETAILS_KEY);
  }

  public void removeFromBillVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    excludeObjectFromPropertyWithKey(object, _Bill.BILL_VOTE_DETAILS_KEY);
  }

  public void addToBillVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("adding {} to billVoteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToBillVoteDetails(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Bill.BILL_VOTE_DETAILS_KEY);
    }
  }

  public void removeFromBillVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("removing {} from billVoteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromBillVoteDetails(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.BILL_VOTE_DETAILS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteDetail createBillVoteDetailsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteDetail.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Bill.BILL_VOTE_DETAILS_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteDetail) eo;
  }

  public void deleteBillVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.BILL_VOTE_DETAILS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllBillVoteDetailsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteDetail> objects = billVoteDetails().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteBillVoteDetailsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillHistory> histories() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillHistory>)storedValueForKey(_Bill.HISTORIES_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillHistory> histories(EOQualifier qualifier) {
    return histories(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillHistory> histories(EOQualifier qualifier, boolean fetch) {
    return histories(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillHistory> histories(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillHistory> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillHistory.BILL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillHistory.fetchBillHistories(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = histories();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillHistory>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillHistory>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToHistories(org.opencalaccess.leginfo.eo.BillHistory object) {
    includeObjectIntoPropertyWithKey(object, _Bill.HISTORIES_KEY);
  }

  public void removeFromHistories(org.opencalaccess.leginfo.eo.BillHistory object) {
    excludeObjectFromPropertyWithKey(object, _Bill.HISTORIES_KEY);
  }

  public void addToHistoriesRelationship(org.opencalaccess.leginfo.eo.BillHistory object) {
    log.debug("adding {} to histories relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToHistories(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Bill.HISTORIES_KEY);
    }
  }

  public void removeFromHistoriesRelationship(org.opencalaccess.leginfo.eo.BillHistory object) {
    log.debug("removing {} from histories relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromHistories(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.HISTORIES_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillHistory createHistoriesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillHistory.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Bill.HISTORIES_KEY);
    return (org.opencalaccess.leginfo.eo.BillHistory) eo;
  }

  public void deleteHistoriesRelationship(org.opencalaccess.leginfo.eo.BillHistory object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.HISTORIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllHistoriesRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillHistory> objects = histories().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteHistoriesRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersion> versions() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVersion>)storedValueForKey(_Bill.VERSIONS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersion> versions(EOQualifier qualifier) {
    return versions(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersion> versions(EOQualifier qualifier, boolean fetch) {
    return versions(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersion> versions(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVersion> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVersion.BILL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVersion.fetchBillVersions(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = versions();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVersion>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVersion>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToVersions(org.opencalaccess.leginfo.eo.BillVersion object) {
    includeObjectIntoPropertyWithKey(object, _Bill.VERSIONS_KEY);
  }

  public void removeFromVersions(org.opencalaccess.leginfo.eo.BillVersion object) {
    excludeObjectFromPropertyWithKey(object, _Bill.VERSIONS_KEY);
  }

  public void addToVersionsRelationship(org.opencalaccess.leginfo.eo.BillVersion object) {
    log.debug("adding {} to versions relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVersions(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Bill.VERSIONS_KEY);
    }
  }

  public void removeFromVersionsRelationship(org.opencalaccess.leginfo.eo.BillVersion object) {
    log.debug("removing {} from versions relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVersions(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.VERSIONS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVersion createVersionsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVersion.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Bill.VERSIONS_KEY);
    return (org.opencalaccess.leginfo.eo.BillVersion) eo;
  }

  public void deleteVersionsRelationship(org.opencalaccess.leginfo.eo.BillVersion object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.VERSIONS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVersionsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVersion> objects = versions().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVersionsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummaries() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)storedValueForKey(_Bill.VOTE_SUMMARIES_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummaries(EOQualifier qualifier) {
    return voteSummaries(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummaries(EOQualifier qualifier, boolean fetch) {
    return voteSummaries(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummaries(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVoteSummary.BILL_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVoteSummary.fetchBillVoteSummaries(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = voteSummaries();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToVoteSummaries(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    includeObjectIntoPropertyWithKey(object, _Bill.VOTE_SUMMARIES_KEY);
  }

  public void removeFromVoteSummaries(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    excludeObjectFromPropertyWithKey(object, _Bill.VOTE_SUMMARIES_KEY);
  }

  public void addToVoteSummariesRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    log.debug("adding {} to voteSummaries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVoteSummaries(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Bill.VOTE_SUMMARIES_KEY);
    }
  }

  public void removeFromVoteSummariesRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    log.debug("removing {} from voteSummaries relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVoteSummaries(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.VOTE_SUMMARIES_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteSummary createVoteSummariesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteSummary.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Bill.VOTE_SUMMARIES_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteSummary) eo;
  }

  public void deleteVoteSummariesRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Bill.VOTE_SUMMARIES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVoteSummariesRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteSummary> objects = voteSummaries().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVoteSummariesRelationship(objects.nextElement());
    }
  }


  public static Bill createBill(EOEditingContext editingContext, String billId
, String latestBillVersionId
, Long measureNum
, String measureState
, String measureType
, String sessionNum
, String sessionYear
, org.opencalaccess.leginfo.eo.BillVersion latestVersion) {
    Bill eo = (Bill) EOUtilities.createAndInsertInstance(editingContext, _Bill.ENTITY_NAME);
    eo.setBillId(billId);
    eo.setLatestBillVersionId(latestBillVersionId);
    eo.setMeasureNum(measureNum);
    eo.setMeasureState(measureState);
    eo.setMeasureType(measureType);
    eo.setSessionNum(sessionNum);
    eo.setSessionYear(sessionYear);
    eo.setLatestVersionRelationship(latestVersion);
    return eo;
  }

  public static ERXFetchSpecification<Bill> fetchSpec() {
    return new ERXFetchSpecification<Bill>(_Bill.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Bill> fetchAllBills(EOEditingContext editingContext) {
    return _Bill.fetchAllBills(editingContext, null);
  }

  public static NSArray<Bill> fetchAllBills(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Bill.fetchBills(editingContext, null, sortOrderings);
  }

  public static NSArray<Bill> fetchBills(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Bill> fetchSpec = new ERXFetchSpecification<Bill>(_Bill.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Bill> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Bill fetchBill(EOEditingContext editingContext, String keyName, Object value) {
    return _Bill.fetchBill(editingContext, ERXQ.equals(keyName, value));
  }

  public static Bill fetchBill(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Bill> eoObjects = _Bill.fetchBills(editingContext, qualifier, null);
    Bill eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Bill that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Bill fetchRequiredBill(EOEditingContext editingContext, String keyName, Object value) {
    return _Bill.fetchRequiredBill(editingContext, ERXQ.equals(keyName, value));
  }

  public static Bill fetchRequiredBill(EOEditingContext editingContext, EOQualifier qualifier) {
    Bill eoObject = _Bill.fetchBill(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Bill that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Bill localInstanceIn(EOEditingContext editingContext, Bill eo) {
    Bill localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
