// DO NOT EDIT.  Make changes to BillAmending.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillAmending extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillAmending";

  // Attribute Keys
  public static final ERXKey<String> ACTION = new ERXKey<String>("action", Type.Attribute);
  public static final ERXKey<String> AMENDING = new ERXKey<String>("amending", Type.Attribute);
  public static final ERXKey<String> BILL_VERSION_ID = new ERXKey<String>("billVersionId", Type.Attribute);
  public static final ERXKey<String> FIXED_AMENDING = new ERXKey<String>("fixedAmending", Type.Attribute);
  public static final ERXKey<String> FIXED_CODENAME = new ERXKey<String>("fixedCodename", Type.Attribute);
  public static final ERXKey<String> FIXED_CODENUM = new ERXKey<String>("fixedCodenum", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVersion> VERSION = new ERXKey<org.opencalaccess.leginfo.eo.BillVersion>("version", Type.ToOneRelationship);

  // Attributes
  public static final String ACTION_KEY = ACTION.key();
  public static final String AMENDING_KEY = AMENDING.key();
  public static final String BILL_VERSION_ID_KEY = BILL_VERSION_ID.key();
  public static final String FIXED_AMENDING_KEY = FIXED_AMENDING.key();
  public static final String FIXED_CODENAME_KEY = FIXED_CODENAME.key();
  public static final String FIXED_CODENUM_KEY = FIXED_CODENUM.key();

  // Relationships
  public static final String VERSION_KEY = VERSION.key();

  private static final Logger log = LoggerFactory.getLogger(_BillAmending.class);

  public BillAmending localInstanceIn(EOEditingContext editingContext) {
    BillAmending localInstance = (BillAmending)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String action() {
    return (String) storedValueForKey(_BillAmending.ACTION_KEY);
  }

  public void setAction(String value) {
    log.debug( "updating action from {} to {}", action(), value);
    takeStoredValueForKey(value, _BillAmending.ACTION_KEY);
  }

  public String amending() {
    return (String) storedValueForKey(_BillAmending.AMENDING_KEY);
  }

  public void setAmending(String value) {
    log.debug( "updating amending from {} to {}", amending(), value);
    takeStoredValueForKey(value, _BillAmending.AMENDING_KEY);
  }

  public String billVersionId() {
    return (String) storedValueForKey(_BillAmending.BILL_VERSION_ID_KEY);
  }

  public void setBillVersionId(String value) {
    log.debug( "updating billVersionId from {} to {}", billVersionId(), value);
    takeStoredValueForKey(value, _BillAmending.BILL_VERSION_ID_KEY);
  }

  public String fixedAmending() {
    return (String) storedValueForKey(_BillAmending.FIXED_AMENDING_KEY);
  }

  public void setFixedAmending(String value) {
    log.debug( "updating fixedAmending from {} to {}", fixedAmending(), value);
    takeStoredValueForKey(value, _BillAmending.FIXED_AMENDING_KEY);
  }

  public String fixedCodename() {
    return (String) storedValueForKey(_BillAmending.FIXED_CODENAME_KEY);
  }

  public void setFixedCodename(String value) {
    log.debug( "updating fixedCodename from {} to {}", fixedCodename(), value);
    takeStoredValueForKey(value, _BillAmending.FIXED_CODENAME_KEY);
  }

  public String fixedCodenum() {
    return (String) storedValueForKey(_BillAmending.FIXED_CODENUM_KEY);
  }

  public void setFixedCodenum(String value) {
    log.debug( "updating fixedCodenum from {} to {}", fixedCodenum(), value);
    takeStoredValueForKey(value, _BillAmending.FIXED_CODENUM_KEY);
  }

  public org.opencalaccess.leginfo.eo.BillVersion version() {
    return (org.opencalaccess.leginfo.eo.BillVersion)storedValueForKey(_BillAmending.VERSION_KEY);
  }

  public void setVersion(org.opencalaccess.leginfo.eo.BillVersion value) {
    takeStoredValueForKey(value, _BillAmending.VERSION_KEY);
  }

  public void setVersionRelationship(org.opencalaccess.leginfo.eo.BillVersion value) {
    log.debug("updating version from {} to {}", version(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setVersion(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.BillVersion oldValue = version();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillAmending.VERSION_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillAmending.VERSION_KEY);
    }
  }


  public static BillAmending createBillAmending(EOEditingContext editingContext, String action
, String amending
, String billVersionId
, org.opencalaccess.leginfo.eo.BillVersion version) {
    BillAmending eo = (BillAmending) EOUtilities.createAndInsertInstance(editingContext, _BillAmending.ENTITY_NAME);
    eo.setAction(action);
    eo.setAmending(amending);
    eo.setBillVersionId(billVersionId);
    eo.setVersionRelationship(version);
    return eo;
  }

  public static ERXFetchSpecification<BillAmending> fetchSpec() {
    return new ERXFetchSpecification<BillAmending>(_BillAmending.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillAmending> fetchAllBillAmendings(EOEditingContext editingContext) {
    return _BillAmending.fetchAllBillAmendings(editingContext, null);
  }

  public static NSArray<BillAmending> fetchAllBillAmendings(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillAmending.fetchBillAmendings(editingContext, null, sortOrderings);
  }

  public static NSArray<BillAmending> fetchBillAmendings(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillAmending> fetchSpec = new ERXFetchSpecification<BillAmending>(_BillAmending.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillAmending> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillAmending fetchBillAmending(EOEditingContext editingContext, String keyName, Object value) {
    return _BillAmending.fetchBillAmending(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillAmending fetchBillAmending(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillAmending> eoObjects = _BillAmending.fetchBillAmendings(editingContext, qualifier, null);
    BillAmending eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillAmending that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillAmending fetchRequiredBillAmending(EOEditingContext editingContext, String keyName, Object value) {
    return _BillAmending.fetchRequiredBillAmending(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillAmending fetchRequiredBillAmending(EOEditingContext editingContext, EOQualifier qualifier) {
    BillAmending eoObject = _BillAmending.fetchBillAmending(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillAmending that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillAmending localInstanceIn(EOEditingContext editingContext, BillAmending eo) {
    BillAmending localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
