// DO NOT EDIT.  Make changes to BillAnalysis.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillAnalysis extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillAnalysis";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> AMENDMENT_AUTHOR = new ERXKey<String>("amendmentAuthor", Type.Attribute);
  public static final ERXKey<NSTimestamp> AMENDMENT_DATE = new ERXKey<NSTimestamp>("amendmentDate", Type.Attribute);
  public static final ERXKey<NSTimestamp> ANALYSIS_DATE = new ERXKey<NSTimestamp>("analysisDate", Type.Attribute);
  public static final ERXKey<java.math.BigDecimal> ANALYSIS_ID = new ERXKey<java.math.BigDecimal>("analysisId", Type.Attribute);
  public static final ERXKey<String> ANALYSIS_TYPE = new ERXKey<String>("analysisType", Type.Attribute);
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> COMMITTEE_CODE = new ERXKey<String>("committeeCode", Type.Attribute);
  public static final ERXKey<String> COMMITTEE_NAME = new ERXKey<String>("committeeName", Type.Attribute);
  public static final ERXKey<String> HOUSE = new ERXKey<String>("house", Type.Attribute);
  public static final ERXKey<java.math.BigDecimal> PAGE_NUM = new ERXKey<java.math.BigDecimal>("pageNum", Type.Attribute);
  public static final ERXKey<String> RELEASED_FLOOR = new ERXKey<String>("releasedFloor", Type.Attribute);
  public static final ERXKey<NSData> SOURCE_DOC = new ERXKey<NSData>("sourceDoc", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<Integer> XML_FIXED = new ERXKey<Integer>("xmlFixed", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Bill> BILL = new ERXKey<org.opencalaccess.leginfo.eo.Bill>("bill", Type.ToOneRelationship);

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String AMENDMENT_AUTHOR_KEY = AMENDMENT_AUTHOR.key();
  public static final String AMENDMENT_DATE_KEY = AMENDMENT_DATE.key();
  public static final String ANALYSIS_DATE_KEY = ANALYSIS_DATE.key();
  public static final String ANALYSIS_ID_KEY = ANALYSIS_ID.key();
  public static final String ANALYSIS_TYPE_KEY = ANALYSIS_TYPE.key();
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String COMMITTEE_CODE_KEY = COMMITTEE_CODE.key();
  public static final String COMMITTEE_NAME_KEY = COMMITTEE_NAME.key();
  public static final String HOUSE_KEY = HOUSE.key();
  public static final String PAGE_NUM_KEY = PAGE_NUM.key();
  public static final String RELEASED_FLOOR_KEY = RELEASED_FLOOR.key();
  public static final String SOURCE_DOC_KEY = SOURCE_DOC.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String XML_FIXED_KEY = XML_FIXED.key();

  // Relationships
  public static final String BILL_KEY = BILL.key();

  private static final Logger log = LoggerFactory.getLogger(_BillAnalysis.class);

  public BillAnalysis localInstanceIn(EOEditingContext editingContext) {
    BillAnalysis localInstance = (BillAnalysis)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_BillAnalysis.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _BillAnalysis.ACTIVE_FLG_KEY);
  }

  public String amendmentAuthor() {
    return (String) storedValueForKey(_BillAnalysis.AMENDMENT_AUTHOR_KEY);
  }

  public void setAmendmentAuthor(String value) {
    log.debug( "updating amendmentAuthor from {} to {}", amendmentAuthor(), value);
    takeStoredValueForKey(value, _BillAnalysis.AMENDMENT_AUTHOR_KEY);
  }

  public NSTimestamp amendmentDate() {
    return (NSTimestamp) storedValueForKey(_BillAnalysis.AMENDMENT_DATE_KEY);
  }

  public void setAmendmentDate(NSTimestamp value) {
    log.debug( "updating amendmentDate from {} to {}", amendmentDate(), value);
    takeStoredValueForKey(value, _BillAnalysis.AMENDMENT_DATE_KEY);
  }

  public NSTimestamp analysisDate() {
    return (NSTimestamp) storedValueForKey(_BillAnalysis.ANALYSIS_DATE_KEY);
  }

  public void setAnalysisDate(NSTimestamp value) {
    log.debug( "updating analysisDate from {} to {}", analysisDate(), value);
    takeStoredValueForKey(value, _BillAnalysis.ANALYSIS_DATE_KEY);
  }

  public java.math.BigDecimal analysisId() {
    return (java.math.BigDecimal) storedValueForKey(_BillAnalysis.ANALYSIS_ID_KEY);
  }

  public void setAnalysisId(java.math.BigDecimal value) {
    log.debug( "updating analysisId from {} to {}", analysisId(), value);
    takeStoredValueForKey(value, _BillAnalysis.ANALYSIS_ID_KEY);
  }

  public String analysisType() {
    return (String) storedValueForKey(_BillAnalysis.ANALYSIS_TYPE_KEY);
  }

  public void setAnalysisType(String value) {
    log.debug( "updating analysisType from {} to {}", analysisType(), value);
    takeStoredValueForKey(value, _BillAnalysis.ANALYSIS_TYPE_KEY);
  }

  public String billId() {
    return (String) storedValueForKey(_BillAnalysis.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _BillAnalysis.BILL_ID_KEY);
  }

  public String committeeCode() {
    return (String) storedValueForKey(_BillAnalysis.COMMITTEE_CODE_KEY);
  }

  public void setCommitteeCode(String value) {
    log.debug( "updating committeeCode from {} to {}", committeeCode(), value);
    takeStoredValueForKey(value, _BillAnalysis.COMMITTEE_CODE_KEY);
  }

  public String committeeName() {
    return (String) storedValueForKey(_BillAnalysis.COMMITTEE_NAME_KEY);
  }

  public void setCommitteeName(String value) {
    log.debug( "updating committeeName from {} to {}", committeeName(), value);
    takeStoredValueForKey(value, _BillAnalysis.COMMITTEE_NAME_KEY);
  }

  public String house() {
    return (String) storedValueForKey(_BillAnalysis.HOUSE_KEY);
  }

  public void setHouse(String value) {
    log.debug( "updating house from {} to {}", house(), value);
    takeStoredValueForKey(value, _BillAnalysis.HOUSE_KEY);
  }

  public java.math.BigDecimal pageNum() {
    return (java.math.BigDecimal) storedValueForKey(_BillAnalysis.PAGE_NUM_KEY);
  }

  public void setPageNum(java.math.BigDecimal value) {
    log.debug( "updating pageNum from {} to {}", pageNum(), value);
    takeStoredValueForKey(value, _BillAnalysis.PAGE_NUM_KEY);
  }

  public String releasedFloor() {
    return (String) storedValueForKey(_BillAnalysis.RELEASED_FLOOR_KEY);
  }

  public void setReleasedFloor(String value) {
    log.debug( "updating releasedFloor from {} to {}", releasedFloor(), value);
    takeStoredValueForKey(value, _BillAnalysis.RELEASED_FLOOR_KEY);
  }

  public NSData sourceDoc() {
    return (NSData) storedValueForKey(_BillAnalysis.SOURCE_DOC_KEY);
  }

  public void setSourceDoc(NSData value) {
    log.debug( "updating sourceDoc from {} to {}", sourceDoc(), value);
    takeStoredValueForKey(value, _BillAnalysis.SOURCE_DOC_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillAnalysis.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillAnalysis.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillAnalysis.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillAnalysis.TRANS_UPDATE_KEY);
  }

  public Integer xmlFixed() {
    return (Integer) storedValueForKey(_BillAnalysis.XML_FIXED_KEY);
  }

  public void setXmlFixed(Integer value) {
    log.debug( "updating xmlFixed from {} to {}", xmlFixed(), value);
    takeStoredValueForKey(value, _BillAnalysis.XML_FIXED_KEY);
  }

  public org.opencalaccess.leginfo.eo.Bill bill() {
    return (org.opencalaccess.leginfo.eo.Bill)storedValueForKey(_BillAnalysis.BILL_KEY);
  }

  public void setBill(org.opencalaccess.leginfo.eo.Bill value) {
    takeStoredValueForKey(value, _BillAnalysis.BILL_KEY);
  }

  public void setBillRelationship(org.opencalaccess.leginfo.eo.Bill value) {
    log.debug("updating bill from {} to {}", bill(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBill(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Bill oldValue = bill();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillAnalysis.BILL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillAnalysis.BILL_KEY);
    }
  }


  public static BillAnalysis createBillAnalysis(EOEditingContext editingContext, java.math.BigDecimal analysisId
, String billId
, org.opencalaccess.leginfo.eo.Bill bill) {
    BillAnalysis eo = (BillAnalysis) EOUtilities.createAndInsertInstance(editingContext, _BillAnalysis.ENTITY_NAME);
    eo.setAnalysisId(analysisId);
    eo.setBillId(billId);
    eo.setBillRelationship(bill);
    return eo;
  }

  public static ERXFetchSpecification<BillAnalysis> fetchSpec() {
    return new ERXFetchSpecification<BillAnalysis>(_BillAnalysis.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillAnalysis> fetchAllBillAnalysises(EOEditingContext editingContext) {
    return _BillAnalysis.fetchAllBillAnalysises(editingContext, null);
  }

  public static NSArray<BillAnalysis> fetchAllBillAnalysises(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillAnalysis.fetchBillAnalysises(editingContext, null, sortOrderings);
  }

  public static NSArray<BillAnalysis> fetchBillAnalysises(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillAnalysis> fetchSpec = new ERXFetchSpecification<BillAnalysis>(_BillAnalysis.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillAnalysis> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillAnalysis fetchBillAnalysis(EOEditingContext editingContext, String keyName, Object value) {
    return _BillAnalysis.fetchBillAnalysis(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillAnalysis fetchBillAnalysis(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillAnalysis> eoObjects = _BillAnalysis.fetchBillAnalysises(editingContext, qualifier, null);
    BillAnalysis eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillAnalysis that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillAnalysis fetchRequiredBillAnalysis(EOEditingContext editingContext, String keyName, Object value) {
    return _BillAnalysis.fetchRequiredBillAnalysis(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillAnalysis fetchRequiredBillAnalysis(EOEditingContext editingContext, EOQualifier qualifier) {
    BillAnalysis eoObject = _BillAnalysis.fetchBillAnalysis(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillAnalysis that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillAnalysis localInstanceIn(EOEditingContext editingContext, BillAnalysis eo) {
    BillAnalysis localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
