// DO NOT EDIT.  Make changes to BillHistory.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillHistory extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillHistory";

  // Attribute Keys
  public static final ERXKey<String> ACTION = new ERXKey<String>("action", Type.Attribute);
  public static final ERXKey<String> ACTION_CODE = new ERXKey<String>("actionCode", Type.Attribute);
  public static final ERXKey<String> ACTION_DATE = new ERXKey<String>("actionDate", Type.Attribute);
  public static final ERXKey<Long> ACTION_SEQUENCE = new ERXKey<Long>("actionSequence", Type.Attribute);
  public static final ERXKey<String> ACTION_STATUS = new ERXKey<String>("actionStatus", Type.Attribute);
  public static final ERXKey<java.math.BigDecimal> BILL_HISTORY_ID = new ERXKey<java.math.BigDecimal>("billHistoryId", Type.Attribute);
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> END_STATUS = new ERXKey<String>("endStatus", Type.Attribute);
  public static final ERXKey<String> PRIMARY_LOCATION = new ERXKey<String>("primaryLocation", Type.Attribute);
  public static final ERXKey<String> SECONDARY_LOCATION = new ERXKey<String>("secondaryLocation", Type.Attribute);
  public static final ERXKey<String> TERNARY_LOCATION = new ERXKey<String>("ternaryLocation", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<String> TRANS_UPDATE_DT = new ERXKey<String>("transUpdateDt", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Bill> BILL = new ERXKey<org.opencalaccess.leginfo.eo.Bill>("bill", Type.ToOneRelationship);

  // Attributes
  public static final String ACTION_KEY = ACTION.key();
  public static final String ACTION_CODE_KEY = ACTION_CODE.key();
  public static final String ACTION_DATE_KEY = ACTION_DATE.key();
  public static final String ACTION_SEQUENCE_KEY = ACTION_SEQUENCE.key();
  public static final String ACTION_STATUS_KEY = ACTION_STATUS.key();
  public static final String BILL_HISTORY_ID_KEY = BILL_HISTORY_ID.key();
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String END_STATUS_KEY = END_STATUS.key();
  public static final String PRIMARY_LOCATION_KEY = PRIMARY_LOCATION.key();
  public static final String SECONDARY_LOCATION_KEY = SECONDARY_LOCATION.key();
  public static final String TERNARY_LOCATION_KEY = TERNARY_LOCATION.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_DT_KEY = TRANS_UPDATE_DT.key();

  // Relationships
  public static final String BILL_KEY = BILL.key();

  private static final Logger log = LoggerFactory.getLogger(_BillHistory.class);

  public BillHistory localInstanceIn(EOEditingContext editingContext) {
    BillHistory localInstance = (BillHistory)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String action() {
    return (String) storedValueForKey(_BillHistory.ACTION_KEY);
  }

  public void setAction(String value) {
    log.debug( "updating action from {} to {}", action(), value);
    takeStoredValueForKey(value, _BillHistory.ACTION_KEY);
  }

  public String actionCode() {
    return (String) storedValueForKey(_BillHistory.ACTION_CODE_KEY);
  }

  public void setActionCode(String value) {
    log.debug( "updating actionCode from {} to {}", actionCode(), value);
    takeStoredValueForKey(value, _BillHistory.ACTION_CODE_KEY);
  }

  public String actionDate() {
    return (String) storedValueForKey(_BillHistory.ACTION_DATE_KEY);
  }

  public void setActionDate(String value) {
    log.debug( "updating actionDate from {} to {}", actionDate(), value);
    takeStoredValueForKey(value, _BillHistory.ACTION_DATE_KEY);
  }

  public Long actionSequence() {
    return (Long) storedValueForKey(_BillHistory.ACTION_SEQUENCE_KEY);
  }

  public void setActionSequence(Long value) {
    log.debug( "updating actionSequence from {} to {}", actionSequence(), value);
    takeStoredValueForKey(value, _BillHistory.ACTION_SEQUENCE_KEY);
  }

  public String actionStatus() {
    return (String) storedValueForKey(_BillHistory.ACTION_STATUS_KEY);
  }

  public void setActionStatus(String value) {
    log.debug( "updating actionStatus from {} to {}", actionStatus(), value);
    takeStoredValueForKey(value, _BillHistory.ACTION_STATUS_KEY);
  }

  public java.math.BigDecimal billHistoryId() {
    return (java.math.BigDecimal) storedValueForKey(_BillHistory.BILL_HISTORY_ID_KEY);
  }

  public void setBillHistoryId(java.math.BigDecimal value) {
    log.debug( "updating billHistoryId from {} to {}", billHistoryId(), value);
    takeStoredValueForKey(value, _BillHistory.BILL_HISTORY_ID_KEY);
  }

  public String billId() {
    return (String) storedValueForKey(_BillHistory.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _BillHistory.BILL_ID_KEY);
  }

  public String endStatus() {
    return (String) storedValueForKey(_BillHistory.END_STATUS_KEY);
  }

  public void setEndStatus(String value) {
    log.debug( "updating endStatus from {} to {}", endStatus(), value);
    takeStoredValueForKey(value, _BillHistory.END_STATUS_KEY);
  }

  public String primaryLocation() {
    return (String) storedValueForKey(_BillHistory.PRIMARY_LOCATION_KEY);
  }

  public void setPrimaryLocation(String value) {
    log.debug( "updating primaryLocation from {} to {}", primaryLocation(), value);
    takeStoredValueForKey(value, _BillHistory.PRIMARY_LOCATION_KEY);
  }

  public String secondaryLocation() {
    return (String) storedValueForKey(_BillHistory.SECONDARY_LOCATION_KEY);
  }

  public void setSecondaryLocation(String value) {
    log.debug( "updating secondaryLocation from {} to {}", secondaryLocation(), value);
    takeStoredValueForKey(value, _BillHistory.SECONDARY_LOCATION_KEY);
  }

  public String ternaryLocation() {
    return (String) storedValueForKey(_BillHistory.TERNARY_LOCATION_KEY);
  }

  public void setTernaryLocation(String value) {
    log.debug( "updating ternaryLocation from {} to {}", ternaryLocation(), value);
    takeStoredValueForKey(value, _BillHistory.TERNARY_LOCATION_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillHistory.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillHistory.TRANS_UID_KEY);
  }

  public String transUpdateDt() {
    return (String) storedValueForKey(_BillHistory.TRANS_UPDATE_DT_KEY);
  }

  public void setTransUpdateDt(String value) {
    log.debug( "updating transUpdateDt from {} to {}", transUpdateDt(), value);
    takeStoredValueForKey(value, _BillHistory.TRANS_UPDATE_DT_KEY);
  }

  public org.opencalaccess.leginfo.eo.Bill bill() {
    return (org.opencalaccess.leginfo.eo.Bill)storedValueForKey(_BillHistory.BILL_KEY);
  }

  public void setBill(org.opencalaccess.leginfo.eo.Bill value) {
    takeStoredValueForKey(value, _BillHistory.BILL_KEY);
  }

  public void setBillRelationship(org.opencalaccess.leginfo.eo.Bill value) {
    log.debug("updating bill from {} to {}", bill(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBill(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Bill oldValue = bill();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillHistory.BILL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillHistory.BILL_KEY);
    }
  }


  public static BillHistory createBillHistory(EOEditingContext editingContext, String actionDate
, java.math.BigDecimal billHistoryId
, String billId
, String transUpdateDt
, org.opencalaccess.leginfo.eo.Bill bill) {
    BillHistory eo = (BillHistory) EOUtilities.createAndInsertInstance(editingContext, _BillHistory.ENTITY_NAME);
    eo.setActionDate(actionDate);
    eo.setBillHistoryId(billHistoryId);
    eo.setBillId(billId);
    eo.setTransUpdateDt(transUpdateDt);
    eo.setBillRelationship(bill);
    return eo;
  }

  public static ERXFetchSpecification<BillHistory> fetchSpec() {
    return new ERXFetchSpecification<BillHistory>(_BillHistory.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillHistory> fetchAllBillHistories(EOEditingContext editingContext) {
    return _BillHistory.fetchAllBillHistories(editingContext, null);
  }

  public static NSArray<BillHistory> fetchAllBillHistories(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillHistory.fetchBillHistories(editingContext, null, sortOrderings);
  }

  public static NSArray<BillHistory> fetchBillHistories(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillHistory> fetchSpec = new ERXFetchSpecification<BillHistory>(_BillHistory.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillHistory> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillHistory fetchBillHistory(EOEditingContext editingContext, String keyName, Object value) {
    return _BillHistory.fetchBillHistory(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillHistory fetchBillHistory(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillHistory> eoObjects = _BillHistory.fetchBillHistories(editingContext, qualifier, null);
    BillHistory eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillHistory that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillHistory fetchRequiredBillHistory(EOEditingContext editingContext, String keyName, Object value) {
    return _BillHistory.fetchRequiredBillHistory(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillHistory fetchRequiredBillHistory(EOEditingContext editingContext, EOQualifier qualifier) {
    BillHistory eoObject = _BillHistory.fetchBillHistory(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillHistory that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillHistory localInstanceIn(EOEditingContext editingContext, BillHistory eo) {
    BillHistory localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
