// DO NOT EDIT.  Make changes to BillMotion.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillMotion extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillMotion";

  // Attribute Keys
  public static final ERXKey<Long> MOTION_ID = new ERXKey<Long>("motionId", Type.Attribute);
  public static final ERXKey<String> MOTION_TEXT = new ERXKey<String>("motionText", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail> VOTE_DETAILS = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail>("voteDetails", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteSummary> VOTE_SUMMARY = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteSummary>("voteSummary", Type.ToManyRelationship);

  // Attributes
  public static final String MOTION_ID_KEY = MOTION_ID.key();
  public static final String MOTION_TEXT_KEY = MOTION_TEXT.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();

  // Relationships
  public static final String VOTE_DETAILS_KEY = VOTE_DETAILS.key();
  public static final String VOTE_SUMMARY_KEY = VOTE_SUMMARY.key();

  private static final Logger log = LoggerFactory.getLogger(_BillMotion.class);

  public BillMotion localInstanceIn(EOEditingContext editingContext) {
    BillMotion localInstance = (BillMotion)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long motionId() {
    return (Long) storedValueForKey(_BillMotion.MOTION_ID_KEY);
  }

  public void setMotionId(Long value) {
    log.debug( "updating motionId from {} to {}", motionId(), value);
    takeStoredValueForKey(value, _BillMotion.MOTION_ID_KEY);
  }

  public String motionText() {
    return (String) storedValueForKey(_BillMotion.MOTION_TEXT_KEY);
  }

  public void setMotionText(String value) {
    log.debug( "updating motionText from {} to {}", motionText(), value);
    takeStoredValueForKey(value, _BillMotion.MOTION_TEXT_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillMotion.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillMotion.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillMotion.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillMotion.TRANS_UPDATE_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)storedValueForKey(_BillMotion.VOTE_DETAILS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails(EOQualifier qualifier) {
    return voteDetails(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails(EOQualifier qualifier, boolean fetch) {
    return voteDetails(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVoteDetail.MOTION_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVoteDetail.fetchBillVoteDetails(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = voteDetails();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    includeObjectIntoPropertyWithKey(object, _BillMotion.VOTE_DETAILS_KEY);
  }

  public void removeFromVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    excludeObjectFromPropertyWithKey(object, _BillMotion.VOTE_DETAILS_KEY);
  }

  public void addToVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("adding {} to voteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVoteDetails(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_DETAILS_KEY);
    }
  }

  public void removeFromVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("removing {} from voteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVoteDetails(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_DETAILS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteDetail createVoteDetailsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteDetail.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillMotion.VOTE_DETAILS_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteDetail) eo;
  }

  public void deleteVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_DETAILS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVoteDetailsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteDetail> objects = voteDetails().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVoteDetailsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummary() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)storedValueForKey(_BillMotion.VOTE_SUMMARY_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummary(EOQualifier qualifier) {
    return voteSummary(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummary(EOQualifier qualifier, boolean fetch) {
    return voteSummary(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> voteSummary(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVoteSummary.MOTIONS_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVoteSummary.fetchBillVoteSummaries(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = voteSummary();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteSummary>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToVoteSummary(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    includeObjectIntoPropertyWithKey(object, _BillMotion.VOTE_SUMMARY_KEY);
  }

  public void removeFromVoteSummary(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    excludeObjectFromPropertyWithKey(object, _BillMotion.VOTE_SUMMARY_KEY);
  }

  public void addToVoteSummaryRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    log.debug("adding {} to voteSummary relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVoteSummary(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_SUMMARY_KEY);
    }
  }

  public void removeFromVoteSummaryRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    log.debug("removing {} from voteSummary relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVoteSummary(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_SUMMARY_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteSummary createVoteSummaryRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteSummary.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillMotion.VOTE_SUMMARY_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteSummary) eo;
  }

  public void deleteVoteSummaryRelationship(org.opencalaccess.leginfo.eo.BillVoteSummary object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillMotion.VOTE_SUMMARY_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVoteSummaryRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteSummary> objects = voteSummary().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVoteSummaryRelationship(objects.nextElement());
    }
  }


  public static BillMotion createBillMotion(EOEditingContext editingContext, Long motionId
, String transUid
, NSTimestamp transUpdate
) {
    BillMotion eo = (BillMotion) EOUtilities.createAndInsertInstance(editingContext, _BillMotion.ENTITY_NAME);
    eo.setMotionId(motionId);
    eo.setTransUid(transUid);
    eo.setTransUpdate(transUpdate);
    return eo;
  }

  public static ERXFetchSpecification<BillMotion> fetchSpec() {
    return new ERXFetchSpecification<BillMotion>(_BillMotion.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillMotion> fetchAllBillMotions(EOEditingContext editingContext) {
    return _BillMotion.fetchAllBillMotions(editingContext, null);
  }

  public static NSArray<BillMotion> fetchAllBillMotions(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillMotion.fetchBillMotions(editingContext, null, sortOrderings);
  }

  public static NSArray<BillMotion> fetchBillMotions(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillMotion> fetchSpec = new ERXFetchSpecification<BillMotion>(_BillMotion.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillMotion> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillMotion fetchBillMotion(EOEditingContext editingContext, String keyName, Object value) {
    return _BillMotion.fetchBillMotion(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillMotion fetchBillMotion(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillMotion> eoObjects = _BillMotion.fetchBillMotions(editingContext, qualifier, null);
    BillMotion eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillMotion that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillMotion fetchRequiredBillMotion(EOEditingContext editingContext, String keyName, Object value) {
    return _BillMotion.fetchRequiredBillMotion(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillMotion fetchRequiredBillMotion(EOEditingContext editingContext, EOQualifier qualifier) {
    BillMotion eoObject = _BillMotion.fetchBillMotion(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillMotion that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillMotion localInstanceIn(EOEditingContext editingContext, BillMotion eo) {
    BillMotion localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
