// DO NOT EDIT.  Make changes to BillVersion.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillVersion extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillVersion";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> APPROPRIATION = new ERXKey<String>("appropriation", Type.Attribute);
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> BILL_VERSION_ACTION = new ERXKey<String>("billVersionAction", Type.Attribute);
  public static final ERXKey<String> BILL_VERSION_ACTION_DATE = new ERXKey<String>("billVersionActionDate", Type.Attribute);
  public static final ERXKey<String> BILL_VERSION_ID = new ERXKey<String>("billVersionId", Type.Attribute);
  public static final ERXKey<String> BILL_XML = new ERXKey<String>("billXml", Type.Attribute);
  public static final ERXKey<String> FISCAL_COMMITTEE = new ERXKey<String>("fiscalCommittee", Type.Attribute);
  public static final ERXKey<Integer> IS_LATEST = new ERXKey<Integer>("isLatest", Type.Attribute);
  public static final ERXKey<String> LOCAL_PROGRAM = new ERXKey<String>("localProgram", Type.Attribute);
  public static final ERXKey<String> REQUEST_NUM = new ERXKey<String>("requestNum", Type.Attribute);
  public static final ERXKey<String> SUBJECT = new ERXKey<String>("subject", Type.Attribute);
  public static final ERXKey<String> SUBSTANTIVE_CHANGES = new ERXKey<String>("substantiveChanges", Type.Attribute);
  public static final ERXKey<String> TAXLEVY = new ERXKey<String>("taxlevy", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<String> URGENCY = new ERXKey<String>("urgency", Type.Attribute);
  public static final ERXKey<Integer> VERSION_NUM = new ERXKey<Integer>("versionNum", Type.Attribute);
  public static final ERXKey<String> VOTE_REQUIRED = new ERXKey<String>("voteRequired", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillAmending> AMENDINGS = new ERXKey<org.opencalaccess.leginfo.eo.BillAmending>("amendings", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVersionAuthor> AUTHORS = new ERXKey<org.opencalaccess.leginfo.eo.BillVersionAuthor>("authors", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.Bill> BILL = new ERXKey<org.opencalaccess.leginfo.eo.Bill>("bill", Type.ToOneRelationship);

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String APPROPRIATION_KEY = APPROPRIATION.key();
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String BILL_VERSION_ACTION_KEY = BILL_VERSION_ACTION.key();
  public static final String BILL_VERSION_ACTION_DATE_KEY = BILL_VERSION_ACTION_DATE.key();
  public static final String BILL_VERSION_ID_KEY = BILL_VERSION_ID.key();
  public static final String BILL_XML_KEY = BILL_XML.key();
  public static final String FISCAL_COMMITTEE_KEY = FISCAL_COMMITTEE.key();
  public static final String IS_LATEST_KEY = IS_LATEST.key();
  public static final String LOCAL_PROGRAM_KEY = LOCAL_PROGRAM.key();
  public static final String REQUEST_NUM_KEY = REQUEST_NUM.key();
  public static final String SUBJECT_KEY = SUBJECT.key();
  public static final String SUBSTANTIVE_CHANGES_KEY = SUBSTANTIVE_CHANGES.key();
  public static final String TAXLEVY_KEY = TAXLEVY.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String URGENCY_KEY = URGENCY.key();
  public static final String VERSION_NUM_KEY = VERSION_NUM.key();
  public static final String VOTE_REQUIRED_KEY = VOTE_REQUIRED.key();

  // Relationships
  public static final String AMENDINGS_KEY = AMENDINGS.key();
  public static final String AUTHORS_KEY = AUTHORS.key();
  public static final String BILL_KEY = BILL.key();

  private static final Logger log = LoggerFactory.getLogger(_BillVersion.class);

  public BillVersion localInstanceIn(EOEditingContext editingContext) {
    BillVersion localInstance = (BillVersion)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_BillVersion.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _BillVersion.ACTIVE_FLG_KEY);
  }

  public String appropriation() {
    return (String) storedValueForKey(_BillVersion.APPROPRIATION_KEY);
  }

  public void setAppropriation(String value) {
    log.debug( "updating appropriation from {} to {}", appropriation(), value);
    takeStoredValueForKey(value, _BillVersion.APPROPRIATION_KEY);
  }

  public String billId() {
    return (String) storedValueForKey(_BillVersion.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _BillVersion.BILL_ID_KEY);
  }

  public String billVersionAction() {
    return (String) storedValueForKey(_BillVersion.BILL_VERSION_ACTION_KEY);
  }

  public void setBillVersionAction(String value) {
    log.debug( "updating billVersionAction from {} to {}", billVersionAction(), value);
    takeStoredValueForKey(value, _BillVersion.BILL_VERSION_ACTION_KEY);
  }

  public String billVersionActionDate() {
    return (String) storedValueForKey(_BillVersion.BILL_VERSION_ACTION_DATE_KEY);
  }

  public void setBillVersionActionDate(String value) {
    log.debug( "updating billVersionActionDate from {} to {}", billVersionActionDate(), value);
    takeStoredValueForKey(value, _BillVersion.BILL_VERSION_ACTION_DATE_KEY);
  }

  public String billVersionId() {
    return (String) storedValueForKey(_BillVersion.BILL_VERSION_ID_KEY);
  }

  public void setBillVersionId(String value) {
    log.debug( "updating billVersionId from {} to {}", billVersionId(), value);
    takeStoredValueForKey(value, _BillVersion.BILL_VERSION_ID_KEY);
  }

  public String billXml() {
    return (String) storedValueForKey(_BillVersion.BILL_XML_KEY);
  }

  public void setBillXml(String value) {
    log.debug( "updating billXml from {} to {}", billXml(), value);
    takeStoredValueForKey(value, _BillVersion.BILL_XML_KEY);
  }

  public String fiscalCommittee() {
    return (String) storedValueForKey(_BillVersion.FISCAL_COMMITTEE_KEY);
  }

  public void setFiscalCommittee(String value) {
    log.debug( "updating fiscalCommittee from {} to {}", fiscalCommittee(), value);
    takeStoredValueForKey(value, _BillVersion.FISCAL_COMMITTEE_KEY);
  }

  public Integer isLatest() {
    return (Integer) storedValueForKey(_BillVersion.IS_LATEST_KEY);
  }

  public void setIsLatest(Integer value) {
    log.debug( "updating isLatest from {} to {}", isLatest(), value);
    takeStoredValueForKey(value, _BillVersion.IS_LATEST_KEY);
  }

  public String localProgram() {
    return (String) storedValueForKey(_BillVersion.LOCAL_PROGRAM_KEY);
  }

  public void setLocalProgram(String value) {
    log.debug( "updating localProgram from {} to {}", localProgram(), value);
    takeStoredValueForKey(value, _BillVersion.LOCAL_PROGRAM_KEY);
  }

  public String requestNum() {
    return (String) storedValueForKey(_BillVersion.REQUEST_NUM_KEY);
  }

  public void setRequestNum(String value) {
    log.debug( "updating requestNum from {} to {}", requestNum(), value);
    takeStoredValueForKey(value, _BillVersion.REQUEST_NUM_KEY);
  }

  public String subject() {
    return (String) storedValueForKey(_BillVersion.SUBJECT_KEY);
  }

  public void setSubject(String value) {
    log.debug( "updating subject from {} to {}", subject(), value);
    takeStoredValueForKey(value, _BillVersion.SUBJECT_KEY);
  }

  public String substantiveChanges() {
    return (String) storedValueForKey(_BillVersion.SUBSTANTIVE_CHANGES_KEY);
  }

  public void setSubstantiveChanges(String value) {
    log.debug( "updating substantiveChanges from {} to {}", substantiveChanges(), value);
    takeStoredValueForKey(value, _BillVersion.SUBSTANTIVE_CHANGES_KEY);
  }

  public String taxlevy() {
    return (String) storedValueForKey(_BillVersion.TAXLEVY_KEY);
  }

  public void setTaxlevy(String value) {
    log.debug( "updating taxlevy from {} to {}", taxlevy(), value);
    takeStoredValueForKey(value, _BillVersion.TAXLEVY_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillVersion.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillVersion.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillVersion.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillVersion.TRANS_UPDATE_KEY);
  }

  public String urgency() {
    return (String) storedValueForKey(_BillVersion.URGENCY_KEY);
  }

  public void setUrgency(String value) {
    log.debug( "updating urgency from {} to {}", urgency(), value);
    takeStoredValueForKey(value, _BillVersion.URGENCY_KEY);
  }

  public Integer versionNum() {
    return (Integer) storedValueForKey(_BillVersion.VERSION_NUM_KEY);
  }

  public void setVersionNum(Integer value) {
    log.debug( "updating versionNum from {} to {}", versionNum(), value);
    takeStoredValueForKey(value, _BillVersion.VERSION_NUM_KEY);
  }

  public String voteRequired() {
    return (String) storedValueForKey(_BillVersion.VOTE_REQUIRED_KEY);
  }

  public void setVoteRequired(String value) {
    log.debug( "updating voteRequired from {} to {}", voteRequired(), value);
    takeStoredValueForKey(value, _BillVersion.VOTE_REQUIRED_KEY);
  }

  public org.opencalaccess.leginfo.eo.Bill bill() {
    return (org.opencalaccess.leginfo.eo.Bill)storedValueForKey(_BillVersion.BILL_KEY);
  }

  public void setBill(org.opencalaccess.leginfo.eo.Bill value) {
    takeStoredValueForKey(value, _BillVersion.BILL_KEY);
  }

  public void setBillRelationship(org.opencalaccess.leginfo.eo.Bill value) {
    log.debug("updating bill from {} to {}", bill(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBill(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Bill oldValue = bill();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillVersion.BILL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillVersion.BILL_KEY);
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAmending> amendings() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillAmending>)storedValueForKey(_BillVersion.AMENDINGS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAmending> amendings(EOQualifier qualifier) {
    return amendings(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAmending> amendings(EOQualifier qualifier, boolean fetch) {
    return amendings(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillAmending> amendings(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillAmending> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillAmending.VERSION_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillAmending.fetchBillAmendings(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = amendings();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillAmending>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillAmending>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToAmendings(org.opencalaccess.leginfo.eo.BillAmending object) {
    includeObjectIntoPropertyWithKey(object, _BillVersion.AMENDINGS_KEY);
  }

  public void removeFromAmendings(org.opencalaccess.leginfo.eo.BillAmending object) {
    excludeObjectFromPropertyWithKey(object, _BillVersion.AMENDINGS_KEY);
  }

  public void addToAmendingsRelationship(org.opencalaccess.leginfo.eo.BillAmending object) {
    log.debug("adding {} to amendings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAmendings(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillVersion.AMENDINGS_KEY);
    }
  }

  public void removeFromAmendingsRelationship(org.opencalaccess.leginfo.eo.BillAmending object) {
    log.debug("removing {} from amendings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAmendings(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersion.AMENDINGS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillAmending createAmendingsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillAmending.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillVersion.AMENDINGS_KEY);
    return (org.opencalaccess.leginfo.eo.BillAmending) eo;
  }

  public void deleteAmendingsRelationship(org.opencalaccess.leginfo.eo.BillAmending object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersion.AMENDINGS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAmendingsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillAmending> objects = amendings().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAmendingsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor> authors() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor>)storedValueForKey(_BillVersion.AUTHORS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor> authors(EOQualifier qualifier) {
    return authors(qualifier, null);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor> authors(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor> results;
      results = authors();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVersionAuthor>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToAuthors(org.opencalaccess.leginfo.eo.BillVersionAuthor object) {
    includeObjectIntoPropertyWithKey(object, _BillVersion.AUTHORS_KEY);
  }

  public void removeFromAuthors(org.opencalaccess.leginfo.eo.BillVersionAuthor object) {
    excludeObjectFromPropertyWithKey(object, _BillVersion.AUTHORS_KEY);
  }

  public void addToAuthorsRelationship(org.opencalaccess.leginfo.eo.BillVersionAuthor object) {
    log.debug("adding {} to authors relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAuthors(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillVersion.AUTHORS_KEY);
    }
  }

  public void removeFromAuthorsRelationship(org.opencalaccess.leginfo.eo.BillVersionAuthor object) {
    log.debug("removing {} from authors relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAuthors(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersion.AUTHORS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVersionAuthor createAuthorsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVersionAuthor.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillVersion.AUTHORS_KEY);
    return (org.opencalaccess.leginfo.eo.BillVersionAuthor) eo;
  }

  public void deleteAuthorsRelationship(org.opencalaccess.leginfo.eo.BillVersionAuthor object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersion.AUTHORS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAuthorsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVersionAuthor> objects = authors().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAuthorsRelationship(objects.nextElement());
    }
  }


  public static BillVersion createBillVersion(EOEditingContext editingContext, String billId
, String billVersionActionDate
, String billVersionId
, Integer versionNum
, org.opencalaccess.leginfo.eo.Bill bill) {
    BillVersion eo = (BillVersion) EOUtilities.createAndInsertInstance(editingContext, _BillVersion.ENTITY_NAME);
    eo.setBillId(billId);
    eo.setBillVersionActionDate(billVersionActionDate);
    eo.setBillVersionId(billVersionId);
    eo.setVersionNum(versionNum);
    eo.setBillRelationship(bill);
    return eo;
  }

  public static ERXFetchSpecification<BillVersion> fetchSpec() {
    return new ERXFetchSpecification<BillVersion>(_BillVersion.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillVersion> fetchAllBillVersions(EOEditingContext editingContext) {
    return _BillVersion.fetchAllBillVersions(editingContext, null);
  }

  public static NSArray<BillVersion> fetchAllBillVersions(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillVersion.fetchBillVersions(editingContext, null, sortOrderings);
  }

  public static NSArray<BillVersion> fetchBillVersions(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillVersion> fetchSpec = new ERXFetchSpecification<BillVersion>(_BillVersion.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillVersion> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillVersion fetchBillVersion(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVersion.fetchBillVersion(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVersion fetchBillVersion(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillVersion> eoObjects = _BillVersion.fetchBillVersions(editingContext, qualifier, null);
    BillVersion eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillVersion that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVersion fetchRequiredBillVersion(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVersion.fetchRequiredBillVersion(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVersion fetchRequiredBillVersion(EOEditingContext editingContext, EOQualifier qualifier) {
    BillVersion eoObject = _BillVersion.fetchBillVersion(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillVersion that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVersion localInstanceIn(EOEditingContext editingContext, BillVersion eo) {
    BillVersion localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
