// DO NOT EDIT.  Make changes to BillVersionAuthor.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillVersionAuthor extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillVersionAuthor";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> BILL_VERSION_ID = new ERXKey<String>("billVersionId", Type.Attribute);
  public static final ERXKey<String> COMMITTEE_MEMBERS = new ERXKey<String>("committeeMembers", Type.Attribute);
  public static final ERXKey<String> CONTRIBUTION = new ERXKey<String>("contribution", Type.Attribute);
  public static final ERXKey<String> HOUSE = new ERXKey<String>("house", Type.Attribute);
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);
  public static final ERXKey<String> PRIMARY_AUTHOR_FLG = new ERXKey<String>("primaryAuthorFlg", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<String> TYPE = new ERXKey<String>("type", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Authoring> AUTHORINGS = new ERXKey<org.opencalaccess.leginfo.eo.Authoring>("authorings", Type.ToManyRelationship);

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String BILL_VERSION_ID_KEY = BILL_VERSION_ID.key();
  public static final String COMMITTEE_MEMBERS_KEY = COMMITTEE_MEMBERS.key();
  public static final String CONTRIBUTION_KEY = CONTRIBUTION.key();
  public static final String HOUSE_KEY = HOUSE.key();
  public static final String NAME_KEY = NAME.key();
  public static final String PRIMARY_AUTHOR_FLG_KEY = PRIMARY_AUTHOR_FLG.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String TYPE_KEY = TYPE.key();

  // Relationships
  public static final String AUTHORINGS_KEY = AUTHORINGS.key();

  private static final Logger log = LoggerFactory.getLogger(_BillVersionAuthor.class);

  public BillVersionAuthor localInstanceIn(EOEditingContext editingContext) {
    BillVersionAuthor localInstance = (BillVersionAuthor)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_BillVersionAuthor.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.ACTIVE_FLG_KEY);
  }

  public String billVersionId() {
    return (String) storedValueForKey(_BillVersionAuthor.BILL_VERSION_ID_KEY);
  }

  public void setBillVersionId(String value) {
    log.debug( "updating billVersionId from {} to {}", billVersionId(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.BILL_VERSION_ID_KEY);
  }

  public String committeeMembers() {
    return (String) storedValueForKey(_BillVersionAuthor.COMMITTEE_MEMBERS_KEY);
  }

  public void setCommitteeMembers(String value) {
    log.debug( "updating committeeMembers from {} to {}", committeeMembers(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.COMMITTEE_MEMBERS_KEY);
  }

  public String contribution() {
    return (String) storedValueForKey(_BillVersionAuthor.CONTRIBUTION_KEY);
  }

  public void setContribution(String value) {
    log.debug( "updating contribution from {} to {}", contribution(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.CONTRIBUTION_KEY);
  }

  public String house() {
    return (String) storedValueForKey(_BillVersionAuthor.HOUSE_KEY);
  }

  public void setHouse(String value) {
    log.debug( "updating house from {} to {}", house(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.HOUSE_KEY);
  }

  public String name() {
    return (String) storedValueForKey(_BillVersionAuthor.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.NAME_KEY);
  }

  public String primaryAuthorFlg() {
    return (String) storedValueForKey(_BillVersionAuthor.PRIMARY_AUTHOR_FLG_KEY);
  }

  public void setPrimaryAuthorFlg(String value) {
    log.debug( "updating primaryAuthorFlg from {} to {}", primaryAuthorFlg(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.PRIMARY_AUTHOR_FLG_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillVersionAuthor.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillVersionAuthor.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.TRANS_UPDATE_KEY);
  }

  public String type() {
    return (String) storedValueForKey(_BillVersionAuthor.TYPE_KEY);
  }

  public void setType(String value) {
    log.debug( "updating type from {} to {}", type(), value);
    takeStoredValueForKey(value, _BillVersionAuthor.TYPE_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings() {
    return (NSArray<org.opencalaccess.leginfo.eo.Authoring>)storedValueForKey(_BillVersionAuthor.AUTHORINGS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier) {
    return authorings(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier, boolean fetch) {
    return authorings(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Authoring> authorings(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.Authoring> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.Authoring.BILL_VERSION_AUTHOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.Authoring.fetchAuthorings(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = authorings();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Authoring>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Authoring>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToAuthorings(org.opencalaccess.leginfo.eo.Authoring object) {
    includeObjectIntoPropertyWithKey(object, _BillVersionAuthor.AUTHORINGS_KEY);
  }

  public void removeFromAuthorings(org.opencalaccess.leginfo.eo.Authoring object) {
    excludeObjectFromPropertyWithKey(object, _BillVersionAuthor.AUTHORINGS_KEY);
  }

  public void addToAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    log.debug("adding {} to authorings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAuthorings(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillVersionAuthor.AUTHORINGS_KEY);
    }
  }

  public void removeFromAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    log.debug("removing {} from authorings relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAuthorings(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersionAuthor.AUTHORINGS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.Authoring createAuthoringsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.Authoring.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillVersionAuthor.AUTHORINGS_KEY);
    return (org.opencalaccess.leginfo.eo.Authoring) eo;
  }

  public void deleteAuthoringsRelationship(org.opencalaccess.leginfo.eo.Authoring object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVersionAuthor.AUTHORINGS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAuthoringsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.Authoring> objects = authorings().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAuthoringsRelationship(objects.nextElement());
    }
  }


  public static BillVersionAuthor createBillVersionAuthor(EOEditingContext editingContext, String activeFlg
, String billVersionId
, String contribution
, String house
, String name
, String primaryAuthorFlg
, String transUid
, NSTimestamp transUpdate
, String type
) {
    BillVersionAuthor eo = (BillVersionAuthor) EOUtilities.createAndInsertInstance(editingContext, _BillVersionAuthor.ENTITY_NAME);
    eo.setActiveFlg(activeFlg);
    eo.setBillVersionId(billVersionId);
    eo.setContribution(contribution);
    eo.setHouse(house);
    eo.setName(name);
    eo.setPrimaryAuthorFlg(primaryAuthorFlg);
    eo.setTransUid(transUid);
    eo.setTransUpdate(transUpdate);
    eo.setType(type);
    return eo;
  }

  public static ERXFetchSpecification<BillVersionAuthor> fetchSpec() {
    return new ERXFetchSpecification<BillVersionAuthor>(_BillVersionAuthor.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillVersionAuthor> fetchAllBillVersionAuthors(EOEditingContext editingContext) {
    return _BillVersionAuthor.fetchAllBillVersionAuthors(editingContext, null);
  }

  public static NSArray<BillVersionAuthor> fetchAllBillVersionAuthors(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillVersionAuthor.fetchBillVersionAuthors(editingContext, null, sortOrderings);
  }

  public static NSArray<BillVersionAuthor> fetchBillVersionAuthors(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillVersionAuthor> fetchSpec = new ERXFetchSpecification<BillVersionAuthor>(_BillVersionAuthor.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillVersionAuthor> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillVersionAuthor fetchBillVersionAuthor(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVersionAuthor.fetchBillVersionAuthor(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVersionAuthor fetchBillVersionAuthor(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillVersionAuthor> eoObjects = _BillVersionAuthor.fetchBillVersionAuthors(editingContext, qualifier, null);
    BillVersionAuthor eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillVersionAuthor that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVersionAuthor fetchRequiredBillVersionAuthor(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVersionAuthor.fetchRequiredBillVersionAuthor(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVersionAuthor fetchRequiredBillVersionAuthor(EOEditingContext editingContext, EOQualifier qualifier) {
    BillVersionAuthor eoObject = _BillVersionAuthor.fetchBillVersionAuthor(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillVersionAuthor that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVersionAuthor localInstanceIn(EOEditingContext editingContext, BillVersionAuthor eo) {
    BillVersionAuthor localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
