// DO NOT EDIT.  Make changes to BillVoteDetail.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillVoteDetail extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillVoteDetail";

  // Attribute Keys
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> LEGISLATOR_NAME = new ERXKey<String>("legislatorName", Type.Attribute);
  public static final ERXKey<String> LOCATION_CODE = new ERXKey<String>("locationCode", Type.Attribute);
  public static final ERXKey<Long> MEMBER_ORDER = new ERXKey<Long>("memberOrder", Type.Attribute);
  public static final ERXKey<Long> MOTION_ID = new ERXKey<Long>("motionId", Type.Attribute);
  public static final ERXKey<NSTimestamp> SESSION_DATE = new ERXKey<NSTimestamp>("sessionDate", Type.Attribute);
  public static final ERXKey<String> SPEAKER = new ERXKey<String>("speaker", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<String> VOTE_CODE = new ERXKey<String>("voteCode", Type.Attribute);
  public static final ERXKey<Long> VOTE_DATE_SEQ = new ERXKey<Long>("voteDateSeq", Type.Attribute);
  public static final ERXKey<NSTimestamp> VOTE_DATE_TIME = new ERXKey<NSTimestamp>("voteDateTime", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Bill> BILL = new ERXKey<org.opencalaccess.leginfo.eo.Bill>("bill", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.Legislator> LEGISLATOR = new ERXKey<org.opencalaccess.leginfo.eo.Legislator>("legislator", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillMotion> MOTION = new ERXKey<org.opencalaccess.leginfo.eo.BillMotion>("motion", Type.ToOneRelationship);

  // Attributes
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String LEGISLATOR_NAME_KEY = LEGISLATOR_NAME.key();
  public static final String LOCATION_CODE_KEY = LOCATION_CODE.key();
  public static final String MEMBER_ORDER_KEY = MEMBER_ORDER.key();
  public static final String MOTION_ID_KEY = MOTION_ID.key();
  public static final String SESSION_DATE_KEY = SESSION_DATE.key();
  public static final String SPEAKER_KEY = SPEAKER.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String VOTE_CODE_KEY = VOTE_CODE.key();
  public static final String VOTE_DATE_SEQ_KEY = VOTE_DATE_SEQ.key();
  public static final String VOTE_DATE_TIME_KEY = VOTE_DATE_TIME.key();

  // Relationships
  public static final String BILL_KEY = BILL.key();
  public static final String LEGISLATOR_KEY = LEGISLATOR.key();
  public static final String MOTION_KEY = MOTION.key();

  private static final Logger log = LoggerFactory.getLogger(_BillVoteDetail.class);

  public BillVoteDetail localInstanceIn(EOEditingContext editingContext) {
    BillVoteDetail localInstance = (BillVoteDetail)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String billId() {
    return (String) storedValueForKey(_BillVoteDetail.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _BillVoteDetail.BILL_ID_KEY);
  }

  public String legislatorName() {
    return (String) storedValueForKey(_BillVoteDetail.LEGISLATOR_NAME_KEY);
  }

  public void setLegislatorName(String value) {
    log.debug( "updating legislatorName from {} to {}", legislatorName(), value);
    takeStoredValueForKey(value, _BillVoteDetail.LEGISLATOR_NAME_KEY);
  }

  public String locationCode() {
    return (String) storedValueForKey(_BillVoteDetail.LOCATION_CODE_KEY);
  }

  public void setLocationCode(String value) {
    log.debug( "updating locationCode from {} to {}", locationCode(), value);
    takeStoredValueForKey(value, _BillVoteDetail.LOCATION_CODE_KEY);
  }

  public Long memberOrder() {
    return (Long) storedValueForKey(_BillVoteDetail.MEMBER_ORDER_KEY);
  }

  public void setMemberOrder(Long value) {
    log.debug( "updating memberOrder from {} to {}", memberOrder(), value);
    takeStoredValueForKey(value, _BillVoteDetail.MEMBER_ORDER_KEY);
  }

  public Long motionId() {
    return (Long) storedValueForKey(_BillVoteDetail.MOTION_ID_KEY);
  }

  public void setMotionId(Long value) {
    log.debug( "updating motionId from {} to {}", motionId(), value);
    takeStoredValueForKey(value, _BillVoteDetail.MOTION_ID_KEY);
  }

  public NSTimestamp sessionDate() {
    return (NSTimestamp) storedValueForKey(_BillVoteDetail.SESSION_DATE_KEY);
  }

  public void setSessionDate(NSTimestamp value) {
    log.debug( "updating sessionDate from {} to {}", sessionDate(), value);
    takeStoredValueForKey(value, _BillVoteDetail.SESSION_DATE_KEY);
  }

  public String speaker() {
    return (String) storedValueForKey(_BillVoteDetail.SPEAKER_KEY);
  }

  public void setSpeaker(String value) {
    log.debug( "updating speaker from {} to {}", speaker(), value);
    takeStoredValueForKey(value, _BillVoteDetail.SPEAKER_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillVoteDetail.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillVoteDetail.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillVoteDetail.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillVoteDetail.TRANS_UPDATE_KEY);
  }

  public String voteCode() {
    return (String) storedValueForKey(_BillVoteDetail.VOTE_CODE_KEY);
  }

  public void setVoteCode(String value) {
    log.debug( "updating voteCode from {} to {}", voteCode(), value);
    takeStoredValueForKey(value, _BillVoteDetail.VOTE_CODE_KEY);
  }

  public Long voteDateSeq() {
    return (Long) storedValueForKey(_BillVoteDetail.VOTE_DATE_SEQ_KEY);
  }

  public void setVoteDateSeq(Long value) {
    log.debug( "updating voteDateSeq from {} to {}", voteDateSeq(), value);
    takeStoredValueForKey(value, _BillVoteDetail.VOTE_DATE_SEQ_KEY);
  }

  public NSTimestamp voteDateTime() {
    return (NSTimestamp) storedValueForKey(_BillVoteDetail.VOTE_DATE_TIME_KEY);
  }

  public void setVoteDateTime(NSTimestamp value) {
    log.debug( "updating voteDateTime from {} to {}", voteDateTime(), value);
    takeStoredValueForKey(value, _BillVoteDetail.VOTE_DATE_TIME_KEY);
  }

  public org.opencalaccess.leginfo.eo.Bill bill() {
    return (org.opencalaccess.leginfo.eo.Bill)storedValueForKey(_BillVoteDetail.BILL_KEY);
  }

  public void setBill(org.opencalaccess.leginfo.eo.Bill value) {
    takeStoredValueForKey(value, _BillVoteDetail.BILL_KEY);
  }

  public void setBillRelationship(org.opencalaccess.leginfo.eo.Bill value) {
    log.debug("updating bill from {} to {}", bill(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBill(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Bill oldValue = bill();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillVoteDetail.BILL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillVoteDetail.BILL_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.Legislator legislator() {
    return (org.opencalaccess.leginfo.eo.Legislator)storedValueForKey(_BillVoteDetail.LEGISLATOR_KEY);
  }

  public void setLegislator(org.opencalaccess.leginfo.eo.Legislator value) {
    takeStoredValueForKey(value, _BillVoteDetail.LEGISLATOR_KEY);
  }

  public void setLegislatorRelationship(org.opencalaccess.leginfo.eo.Legislator value) {
    log.debug("updating legislator from {} to {}", legislator(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setLegislator(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Legislator oldValue = legislator();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillVoteDetail.LEGISLATOR_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillVoteDetail.LEGISLATOR_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillMotion motion() {
    return (org.opencalaccess.leginfo.eo.BillMotion)storedValueForKey(_BillVoteDetail.MOTION_KEY);
  }

  public void setMotion(org.opencalaccess.leginfo.eo.BillMotion value) {
    takeStoredValueForKey(value, _BillVoteDetail.MOTION_KEY);
  }

  public void setMotionRelationship(org.opencalaccess.leginfo.eo.BillMotion value) {
    log.debug("updating motion from {} to {}", motion(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setMotion(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.BillMotion oldValue = motion();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillVoteDetail.MOTION_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillVoteDetail.MOTION_KEY);
    }
  }


  public static BillVoteDetail createBillVoteDetail(EOEditingContext editingContext, String billId
, String legislatorName
, String locationCode
, Long memberOrder
, Long motionId
, NSTimestamp sessionDate
, String transUid
, NSTimestamp transUpdate
, String voteCode
, Long voteDateSeq
, NSTimestamp voteDateTime
, org.opencalaccess.leginfo.eo.Bill bill, org.opencalaccess.leginfo.eo.Legislator legislator, org.opencalaccess.leginfo.eo.BillMotion motion) {
    BillVoteDetail eo = (BillVoteDetail) EOUtilities.createAndInsertInstance(editingContext, _BillVoteDetail.ENTITY_NAME);
    eo.setBillId(billId);
    eo.setLegislatorName(legislatorName);
    eo.setLocationCode(locationCode);
    eo.setMemberOrder(memberOrder);
    eo.setMotionId(motionId);
    eo.setSessionDate(sessionDate);
    eo.setTransUid(transUid);
    eo.setTransUpdate(transUpdate);
    eo.setVoteCode(voteCode);
    eo.setVoteDateSeq(voteDateSeq);
    eo.setVoteDateTime(voteDateTime);
    eo.setBillRelationship(bill);
    eo.setLegislatorRelationship(legislator);
    eo.setMotionRelationship(motion);
    return eo;
  }

  public static ERXFetchSpecification<BillVoteDetail> fetchSpec() {
    return new ERXFetchSpecification<BillVoteDetail>(_BillVoteDetail.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillVoteDetail> fetchAllBillVoteDetails(EOEditingContext editingContext) {
    return _BillVoteDetail.fetchAllBillVoteDetails(editingContext, null);
  }

  public static NSArray<BillVoteDetail> fetchAllBillVoteDetails(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillVoteDetail.fetchBillVoteDetails(editingContext, null, sortOrderings);
  }

  public static NSArray<BillVoteDetail> fetchBillVoteDetails(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillVoteDetail> fetchSpec = new ERXFetchSpecification<BillVoteDetail>(_BillVoteDetail.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillVoteDetail> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillVoteDetail fetchBillVoteDetail(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVoteDetail.fetchBillVoteDetail(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVoteDetail fetchBillVoteDetail(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillVoteDetail> eoObjects = _BillVoteDetail.fetchBillVoteDetails(editingContext, qualifier, null);
    BillVoteDetail eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillVoteDetail that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVoteDetail fetchRequiredBillVoteDetail(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVoteDetail.fetchRequiredBillVoteDetail(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVoteDetail fetchRequiredBillVoteDetail(EOEditingContext editingContext, EOQualifier qualifier) {
    BillVoteDetail eoObject = _BillVoteDetail.fetchBillVoteDetail(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillVoteDetail that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVoteDetail localInstanceIn(EOEditingContext editingContext, BillVoteDetail eo) {
    BillVoteDetail localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
