// DO NOT EDIT.  Make changes to BillVoteSummary.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BillVoteSummary extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BillVoteSummary";

  // Attribute Keys
  public static final ERXKey<Long> ABSTAIN = new ERXKey<Long>("abstain", Type.Attribute);
  public static final ERXKey<Long> AYES = new ERXKey<Long>("ayes", Type.Attribute);
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<String> DISPLAY_LINES = new ERXKey<String>("displayLines", Type.Attribute);
  public static final ERXKey<String> FILE_ITEM_NUM = new ERXKey<String>("fileItemNum", Type.Attribute);
  public static final ERXKey<String> FILE_LOCATION = new ERXKey<String>("fileLocation", Type.Attribute);
  public static final ERXKey<String> LOCATION_CODE = new ERXKey<String>("locationCode", Type.Attribute);
  public static final ERXKey<Long> MOTION_ID = new ERXKey<Long>("motionId", Type.Attribute);
  public static final ERXKey<Long> NOES = new ERXKey<Long>("noes", Type.Attribute);
  public static final ERXKey<NSTimestamp> SESSION_DATE = new ERXKey<NSTimestamp>("sessionDate", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<Long> VOTE_DATE_SEQ = new ERXKey<Long>("voteDateSeq", Type.Attribute);
  public static final ERXKey<NSTimestamp> VOTE_DATE_TIME = new ERXKey<NSTimestamp>("voteDateTime", Type.Attribute);
  public static final ERXKey<String> VOTE_RESULT = new ERXKey<String>("voteResult", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Bill> BILL = new ERXKey<org.opencalaccess.leginfo.eo.Bill>("bill", Type.ToOneRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillMotion> MOTIONS = new ERXKey<org.opencalaccess.leginfo.eo.BillMotion>("motions", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail> VOTE_DETAILS = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail>("voteDetails", Type.ToManyRelationship);

  // Attributes
  public static final String ABSTAIN_KEY = ABSTAIN.key();
  public static final String AYES_KEY = AYES.key();
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String DISPLAY_LINES_KEY = DISPLAY_LINES.key();
  public static final String FILE_ITEM_NUM_KEY = FILE_ITEM_NUM.key();
  public static final String FILE_LOCATION_KEY = FILE_LOCATION.key();
  public static final String LOCATION_CODE_KEY = LOCATION_CODE.key();
  public static final String MOTION_ID_KEY = MOTION_ID.key();
  public static final String NOES_KEY = NOES.key();
  public static final String SESSION_DATE_KEY = SESSION_DATE.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String VOTE_DATE_SEQ_KEY = VOTE_DATE_SEQ.key();
  public static final String VOTE_DATE_TIME_KEY = VOTE_DATE_TIME.key();
  public static final String VOTE_RESULT_KEY = VOTE_RESULT.key();

  // Relationships
  public static final String BILL_KEY = BILL.key();
  public static final String MOTIONS_KEY = MOTIONS.key();
  public static final String VOTE_DETAILS_KEY = VOTE_DETAILS.key();

  private static final Logger log = LoggerFactory.getLogger(_BillVoteSummary.class);

  public BillVoteSummary localInstanceIn(EOEditingContext editingContext) {
    BillVoteSummary localInstance = (BillVoteSummary)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long abstain() {
    return (Long) storedValueForKey(_BillVoteSummary.ABSTAIN_KEY);
  }

  public void setAbstain(Long value) {
    log.debug( "updating abstain from {} to {}", abstain(), value);
    takeStoredValueForKey(value, _BillVoteSummary.ABSTAIN_KEY);
  }

  public Long ayes() {
    return (Long) storedValueForKey(_BillVoteSummary.AYES_KEY);
  }

  public void setAyes(Long value) {
    log.debug( "updating ayes from {} to {}", ayes(), value);
    takeStoredValueForKey(value, _BillVoteSummary.AYES_KEY);
  }

  public String billId() {
    return (String) storedValueForKey(_BillVoteSummary.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _BillVoteSummary.BILL_ID_KEY);
  }

  public String displayLines() {
    return (String) storedValueForKey(_BillVoteSummary.DISPLAY_LINES_KEY);
  }

  public void setDisplayLines(String value) {
    log.debug( "updating displayLines from {} to {}", displayLines(), value);
    takeStoredValueForKey(value, _BillVoteSummary.DISPLAY_LINES_KEY);
  }

  public String fileItemNum() {
    return (String) storedValueForKey(_BillVoteSummary.FILE_ITEM_NUM_KEY);
  }

  public void setFileItemNum(String value) {
    log.debug( "updating fileItemNum from {} to {}", fileItemNum(), value);
    takeStoredValueForKey(value, _BillVoteSummary.FILE_ITEM_NUM_KEY);
  }

  public String fileLocation() {
    return (String) storedValueForKey(_BillVoteSummary.FILE_LOCATION_KEY);
  }

  public void setFileLocation(String value) {
    log.debug( "updating fileLocation from {} to {}", fileLocation(), value);
    takeStoredValueForKey(value, _BillVoteSummary.FILE_LOCATION_KEY);
  }

  public String locationCode() {
    return (String) storedValueForKey(_BillVoteSummary.LOCATION_CODE_KEY);
  }

  public void setLocationCode(String value) {
    log.debug( "updating locationCode from {} to {}", locationCode(), value);
    takeStoredValueForKey(value, _BillVoteSummary.LOCATION_CODE_KEY);
  }

  public Long motionId() {
    return (Long) storedValueForKey(_BillVoteSummary.MOTION_ID_KEY);
  }

  public void setMotionId(Long value) {
    log.debug( "updating motionId from {} to {}", motionId(), value);
    takeStoredValueForKey(value, _BillVoteSummary.MOTION_ID_KEY);
  }

  public Long noes() {
    return (Long) storedValueForKey(_BillVoteSummary.NOES_KEY);
  }

  public void setNoes(Long value) {
    log.debug( "updating noes from {} to {}", noes(), value);
    takeStoredValueForKey(value, _BillVoteSummary.NOES_KEY);
  }

  public NSTimestamp sessionDate() {
    return (NSTimestamp) storedValueForKey(_BillVoteSummary.SESSION_DATE_KEY);
  }

  public void setSessionDate(NSTimestamp value) {
    log.debug( "updating sessionDate from {} to {}", sessionDate(), value);
    takeStoredValueForKey(value, _BillVoteSummary.SESSION_DATE_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_BillVoteSummary.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _BillVoteSummary.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_BillVoteSummary.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _BillVoteSummary.TRANS_UPDATE_KEY);
  }

  public Long voteDateSeq() {
    return (Long) storedValueForKey(_BillVoteSummary.VOTE_DATE_SEQ_KEY);
  }

  public void setVoteDateSeq(Long value) {
    log.debug( "updating voteDateSeq from {} to {}", voteDateSeq(), value);
    takeStoredValueForKey(value, _BillVoteSummary.VOTE_DATE_SEQ_KEY);
  }

  public NSTimestamp voteDateTime() {
    return (NSTimestamp) storedValueForKey(_BillVoteSummary.VOTE_DATE_TIME_KEY);
  }

  public void setVoteDateTime(NSTimestamp value) {
    log.debug( "updating voteDateTime from {} to {}", voteDateTime(), value);
    takeStoredValueForKey(value, _BillVoteSummary.VOTE_DATE_TIME_KEY);
  }

  public String voteResult() {
    return (String) storedValueForKey(_BillVoteSummary.VOTE_RESULT_KEY);
  }

  public void setVoteResult(String value) {
    log.debug( "updating voteResult from {} to {}", voteResult(), value);
    takeStoredValueForKey(value, _BillVoteSummary.VOTE_RESULT_KEY);
  }

  public org.opencalaccess.leginfo.eo.Bill bill() {
    return (org.opencalaccess.leginfo.eo.Bill)storedValueForKey(_BillVoteSummary.BILL_KEY);
  }

  public void setBill(org.opencalaccess.leginfo.eo.Bill value) {
    takeStoredValueForKey(value, _BillVoteSummary.BILL_KEY);
  }

  public void setBillRelationship(org.opencalaccess.leginfo.eo.Bill value) {
    log.debug("updating bill from {} to {}", bill(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setBill(value);
    }
    else if (value == null) {
      org.opencalaccess.leginfo.eo.Bill oldValue = bill();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _BillVoteSummary.BILL_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _BillVoteSummary.BILL_KEY);
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillMotion> motions() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillMotion>)storedValueForKey(_BillVoteSummary.MOTIONS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillMotion> motions(EOQualifier qualifier) {
    return motions(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillMotion> motions(EOQualifier qualifier, boolean fetch) {
    return motions(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillMotion> motions(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillMotion> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillMotion.VOTE_SUMMARY_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillMotion.fetchBillMotions(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = motions();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillMotion>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillMotion>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToMotions(org.opencalaccess.leginfo.eo.BillMotion object) {
    includeObjectIntoPropertyWithKey(object, _BillVoteSummary.MOTIONS_KEY);
  }

  public void removeFromMotions(org.opencalaccess.leginfo.eo.BillMotion object) {
    excludeObjectFromPropertyWithKey(object, _BillVoteSummary.MOTIONS_KEY);
  }

  public void addToMotionsRelationship(org.opencalaccess.leginfo.eo.BillMotion object) {
    log.debug("adding {} to motions relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToMotions(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillVoteSummary.MOTIONS_KEY);
    }
  }

  public void removeFromMotionsRelationship(org.opencalaccess.leginfo.eo.BillMotion object) {
    log.debug("removing {} from motions relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromMotions(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVoteSummary.MOTIONS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillMotion createMotionsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillMotion.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillVoteSummary.MOTIONS_KEY);
    return (org.opencalaccess.leginfo.eo.BillMotion) eo;
  }

  public void deleteMotionsRelationship(org.opencalaccess.leginfo.eo.BillMotion object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVoteSummary.MOTIONS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllMotionsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillMotion> objects = motions().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteMotionsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)storedValueForKey(_BillVoteSummary.VOTE_DETAILS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails(EOQualifier qualifier) {
    return voteDetails(qualifier, null);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> voteDetails(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> results;
      results = voteDetails();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    includeObjectIntoPropertyWithKey(object, _BillVoteSummary.VOTE_DETAILS_KEY);
  }

  public void removeFromVoteDetails(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    excludeObjectFromPropertyWithKey(object, _BillVoteSummary.VOTE_DETAILS_KEY);
  }

  public void addToVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("adding {} to voteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVoteDetails(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BillVoteSummary.VOTE_DETAILS_KEY);
    }
  }

  public void removeFromVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("removing {} from voteDetails relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVoteDetails(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVoteSummary.VOTE_DETAILS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteDetail createVoteDetailsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteDetail.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BillVoteSummary.VOTE_DETAILS_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteDetail) eo;
  }

  public void deleteVoteDetailsRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BillVoteSummary.VOTE_DETAILS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVoteDetailsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteDetail> objects = voteDetails().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVoteDetailsRelationship(objects.nextElement());
    }
  }


  public static BillVoteSummary createBillVoteSummary(EOEditingContext editingContext, Long abstain
, Long ayes
, String billId
, String locationCode
, Long motionId
, Long noes
, NSTimestamp sessionDate
, String transUid
, NSTimestamp transUpdate
, Long voteDateSeq
, NSTimestamp voteDateTime
, String voteResult
, org.opencalaccess.leginfo.eo.Bill bill) {
    BillVoteSummary eo = (BillVoteSummary) EOUtilities.createAndInsertInstance(editingContext, _BillVoteSummary.ENTITY_NAME);
    eo.setAbstain(abstain);
    eo.setAyes(ayes);
    eo.setBillId(billId);
    eo.setLocationCode(locationCode);
    eo.setMotionId(motionId);
    eo.setNoes(noes);
    eo.setSessionDate(sessionDate);
    eo.setTransUid(transUid);
    eo.setTransUpdate(transUpdate);
    eo.setVoteDateSeq(voteDateSeq);
    eo.setVoteDateTime(voteDateTime);
    eo.setVoteResult(voteResult);
    eo.setBillRelationship(bill);
    return eo;
  }

  public static ERXFetchSpecification<BillVoteSummary> fetchSpec() {
    return new ERXFetchSpecification<BillVoteSummary>(_BillVoteSummary.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BillVoteSummary> fetchAllBillVoteSummaries(EOEditingContext editingContext) {
    return _BillVoteSummary.fetchAllBillVoteSummaries(editingContext, null);
  }

  public static NSArray<BillVoteSummary> fetchAllBillVoteSummaries(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BillVoteSummary.fetchBillVoteSummaries(editingContext, null, sortOrderings);
  }

  public static NSArray<BillVoteSummary> fetchBillVoteSummaries(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BillVoteSummary> fetchSpec = new ERXFetchSpecification<BillVoteSummary>(_BillVoteSummary.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BillVoteSummary> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BillVoteSummary fetchBillVoteSummary(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVoteSummary.fetchBillVoteSummary(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVoteSummary fetchBillVoteSummary(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BillVoteSummary> eoObjects = _BillVoteSummary.fetchBillVoteSummaries(editingContext, qualifier, null);
    BillVoteSummary eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BillVoteSummary that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVoteSummary fetchRequiredBillVoteSummary(EOEditingContext editingContext, String keyName, Object value) {
    return _BillVoteSummary.fetchRequiredBillVoteSummary(editingContext, ERXQ.equals(keyName, value));
  }

  public static BillVoteSummary fetchRequiredBillVoteSummary(EOEditingContext editingContext, EOQualifier qualifier) {
    BillVoteSummary eoObject = _BillVoteSummary.fetchBillVoteSummary(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BillVoteSummary that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BillVoteSummary localInstanceIn(EOEditingContext editingContext, BillVoteSummary eo) {
    BillVoteSummary localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
