// DO NOT EDIT.  Make changes to DailyFileItem.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _DailyFileItem extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "DailyFileItem";

  // Attribute Keys
  public static final ERXKey<String> BILL_ID = new ERXKey<String>("billId", Type.Attribute);
  public static final ERXKey<Integer> CONSENT_CALENDAR_CODE = new ERXKey<Integer>("consentCalendarCode", Type.Attribute);
  public static final ERXKey<String> FILE_LOCATION = new ERXKey<String>("fileLocation", Type.Attribute);
  public static final ERXKey<String> FLOOR_MANAGER = new ERXKey<String>("floorManager", Type.Attribute);
  public static final ERXKey<String> LOCATION_CODE = new ERXKey<String>("locationCode", Type.Attribute);
  public static final ERXKey<String> PUBLICATION_DATE = new ERXKey<String>("publicationDate", Type.Attribute);
  public static final ERXKey<String> SESSION_NUM = new ERXKey<String>("sessionNum", Type.Attribute);
  public static final ERXKey<String> STATUS = new ERXKey<String>("status", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE_DATE = new ERXKey<NSTimestamp>("transUpdateDate", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String BILL_ID_KEY = BILL_ID.key();
  public static final String CONSENT_CALENDAR_CODE_KEY = CONSENT_CALENDAR_CODE.key();
  public static final String FILE_LOCATION_KEY = FILE_LOCATION.key();
  public static final String FLOOR_MANAGER_KEY = FLOOR_MANAGER.key();
  public static final String LOCATION_CODE_KEY = LOCATION_CODE.key();
  public static final String PUBLICATION_DATE_KEY = PUBLICATION_DATE.key();
  public static final String SESSION_NUM_KEY = SESSION_NUM.key();
  public static final String STATUS_KEY = STATUS.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_DATE_KEY = TRANS_UPDATE_DATE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_DailyFileItem.class);

  public DailyFileItem localInstanceIn(EOEditingContext editingContext) {
    DailyFileItem localInstance = (DailyFileItem)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String billId() {
    return (String) storedValueForKey(_DailyFileItem.BILL_ID_KEY);
  }

  public void setBillId(String value) {
    log.debug( "updating billId from {} to {}", billId(), value);
    takeStoredValueForKey(value, _DailyFileItem.BILL_ID_KEY);
  }

  public Integer consentCalendarCode() {
    return (Integer) storedValueForKey(_DailyFileItem.CONSENT_CALENDAR_CODE_KEY);
  }

  public void setConsentCalendarCode(Integer value) {
    log.debug( "updating consentCalendarCode from {} to {}", consentCalendarCode(), value);
    takeStoredValueForKey(value, _DailyFileItem.CONSENT_CALENDAR_CODE_KEY);
  }

  public String fileLocation() {
    return (String) storedValueForKey(_DailyFileItem.FILE_LOCATION_KEY);
  }

  public void setFileLocation(String value) {
    log.debug( "updating fileLocation from {} to {}", fileLocation(), value);
    takeStoredValueForKey(value, _DailyFileItem.FILE_LOCATION_KEY);
  }

  public String floorManager() {
    return (String) storedValueForKey(_DailyFileItem.FLOOR_MANAGER_KEY);
  }

  public void setFloorManager(String value) {
    log.debug( "updating floorManager from {} to {}", floorManager(), value);
    takeStoredValueForKey(value, _DailyFileItem.FLOOR_MANAGER_KEY);
  }

  public String locationCode() {
    return (String) storedValueForKey(_DailyFileItem.LOCATION_CODE_KEY);
  }

  public void setLocationCode(String value) {
    log.debug( "updating locationCode from {} to {}", locationCode(), value);
    takeStoredValueForKey(value, _DailyFileItem.LOCATION_CODE_KEY);
  }

  public String publicationDate() {
    return (String) storedValueForKey(_DailyFileItem.PUBLICATION_DATE_KEY);
  }

  public void setPublicationDate(String value) {
    log.debug( "updating publicationDate from {} to {}", publicationDate(), value);
    takeStoredValueForKey(value, _DailyFileItem.PUBLICATION_DATE_KEY);
  }

  public String sessionNum() {
    return (String) storedValueForKey(_DailyFileItem.SESSION_NUM_KEY);
  }

  public void setSessionNum(String value) {
    log.debug( "updating sessionNum from {} to {}", sessionNum(), value);
    takeStoredValueForKey(value, _DailyFileItem.SESSION_NUM_KEY);
  }

  public String status() {
    return (String) storedValueForKey(_DailyFileItem.STATUS_KEY);
  }

  public void setStatus(String value) {
    log.debug( "updating status from {} to {}", status(), value);
    takeStoredValueForKey(value, _DailyFileItem.STATUS_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_DailyFileItem.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _DailyFileItem.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdateDate() {
    return (NSTimestamp) storedValueForKey(_DailyFileItem.TRANS_UPDATE_DATE_KEY);
  }

  public void setTransUpdateDate(NSTimestamp value) {
    log.debug( "updating transUpdateDate from {} to {}", transUpdateDate(), value);
    takeStoredValueForKey(value, _DailyFileItem.TRANS_UPDATE_DATE_KEY);
  }


  public static DailyFileItem createDailyFileItem(EOEditingContext editingContext, String billId
, Integer consentCalendarCode
, String fileLocation
, String floorManager
, String locationCode
, String publicationDate
, String sessionNum
, String status
, String transUid
, NSTimestamp transUpdateDate
) {
    DailyFileItem eo = (DailyFileItem) EOUtilities.createAndInsertInstance(editingContext, _DailyFileItem.ENTITY_NAME);
    eo.setBillId(billId);
    eo.setConsentCalendarCode(consentCalendarCode);
    eo.setFileLocation(fileLocation);
    eo.setFloorManager(floorManager);
    eo.setLocationCode(locationCode);
    eo.setPublicationDate(publicationDate);
    eo.setSessionNum(sessionNum);
    eo.setStatus(status);
    eo.setTransUid(transUid);
    eo.setTransUpdateDate(transUpdateDate);
    return eo;
  }

  public static ERXFetchSpecification<DailyFileItem> fetchSpec() {
    return new ERXFetchSpecification<DailyFileItem>(_DailyFileItem.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<DailyFileItem> fetchAllDailyFileItems(EOEditingContext editingContext) {
    return _DailyFileItem.fetchAllDailyFileItems(editingContext, null);
  }

  public static NSArray<DailyFileItem> fetchAllDailyFileItems(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _DailyFileItem.fetchDailyFileItems(editingContext, null, sortOrderings);
  }

  public static NSArray<DailyFileItem> fetchDailyFileItems(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<DailyFileItem> fetchSpec = new ERXFetchSpecification<DailyFileItem>(_DailyFileItem.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<DailyFileItem> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static DailyFileItem fetchDailyFileItem(EOEditingContext editingContext, String keyName, Object value) {
    return _DailyFileItem.fetchDailyFileItem(editingContext, ERXQ.equals(keyName, value));
  }

  public static DailyFileItem fetchDailyFileItem(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<DailyFileItem> eoObjects = _DailyFileItem.fetchDailyFileItems(editingContext, qualifier, null);
    DailyFileItem eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one DailyFileItem that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DailyFileItem fetchRequiredDailyFileItem(EOEditingContext editingContext, String keyName, Object value) {
    return _DailyFileItem.fetchRequiredDailyFileItem(editingContext, ERXQ.equals(keyName, value));
  }

  public static DailyFileItem fetchRequiredDailyFileItem(EOEditingContext editingContext, EOQualifier qualifier) {
    DailyFileItem eoObject = _DailyFileItem.fetchDailyFileItem(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no DailyFileItem that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DailyFileItem localInstanceIn(EOEditingContext editingContext, DailyFileItem eo) {
    DailyFileItem localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
