// DO NOT EDIT.  Make changes to DataSource.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _DataSource extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "DataSource";

  // Attribute Keys
  public static final ERXKey<String> SOURCE_NAME = new ERXKey<String>("sourceName", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String SOURCE_NAME_KEY = SOURCE_NAME.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_DataSource.class);

  public DataSource localInstanceIn(EOEditingContext editingContext) {
    DataSource localInstance = (DataSource)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String sourceName() {
    return (String) storedValueForKey(_DataSource.SOURCE_NAME_KEY);
  }

  public void setSourceName(String value) {
    log.debug( "updating sourceName from {} to {}", sourceName(), value);
    takeStoredValueForKey(value, _DataSource.SOURCE_NAME_KEY);
  }


  public static DataSource createDataSource(EOEditingContext editingContext, String sourceName
) {
    DataSource eo = (DataSource) EOUtilities.createAndInsertInstance(editingContext, _DataSource.ENTITY_NAME);
    eo.setSourceName(sourceName);
    return eo;
  }

  public static ERXFetchSpecification<DataSource> fetchSpec() {
    return new ERXFetchSpecification<DataSource>(_DataSource.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<DataSource> fetchAllDataSources(EOEditingContext editingContext) {
    return _DataSource.fetchAllDataSources(editingContext, null);
  }

  public static NSArray<DataSource> fetchAllDataSources(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _DataSource.fetchDataSources(editingContext, null, sortOrderings);
  }

  public static NSArray<DataSource> fetchDataSources(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<DataSource> fetchSpec = new ERXFetchSpecification<DataSource>(_DataSource.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<DataSource> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static DataSource fetchDataSource(EOEditingContext editingContext, String keyName, Object value) {
    return _DataSource.fetchDataSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static DataSource fetchDataSource(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<DataSource> eoObjects = _DataSource.fetchDataSources(editingContext, qualifier, null);
    DataSource eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one DataSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DataSource fetchRequiredDataSource(EOEditingContext editingContext, String keyName, Object value) {
    return _DataSource.fetchRequiredDataSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static DataSource fetchRequiredDataSource(EOEditingContext editingContext, EOQualifier qualifier) {
    DataSource eoObject = _DataSource.fetchDataSource(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no DataSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static DataSource localInstanceIn(EOEditingContext editingContext, DataSource eo) {
    DataSource localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
