// DO NOT EDIT.  Make changes to Legislator.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Legislator extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Legislator";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> ACTIVE_LEGISLATOR = new ERXKey<String>("activeLegislator", Type.Attribute);
  public static final ERXKey<String> AUTHOR_NAME = new ERXKey<String>("authorName", Type.Attribute);
  public static final ERXKey<String> DISTRICT = new ERXKey<String>("district", Type.Attribute);
  public static final ERXKey<String> FIRST_NAME = new ERXKey<String>("firstName", Type.Attribute);
  public static final ERXKey<String> HOUSE_TYPE = new ERXKey<String>("houseType", Type.Attribute);
  public static final ERXKey<String> LAST_NAME = new ERXKey<String>("lastName", Type.Attribute);
  public static final ERXKey<String> LEGISLATOR_NAME = new ERXKey<String>("legislatorName", Type.Attribute);
  public static final ERXKey<String> MIDDLE_INITIAL = new ERXKey<String>("middleInitial", Type.Attribute);
  public static final ERXKey<String> NAME_SUFFIX = new ERXKey<String>("nameSuffix", Type.Attribute);
  public static final ERXKey<String> NAME_TITLE = new ERXKey<String>("nameTitle", Type.Attribute);
  public static final ERXKey<String> PARTY = new ERXKey<String>("party", Type.Attribute);
  public static final ERXKey<String> SESSION_YEAR = new ERXKey<String>("sessionYear", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);
  public static final ERXKey<String> WEB_NAME_TITLE = new ERXKey<String>("webNameTitle", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.leginfo.eo.Author> AUTHORS = new ERXKey<org.opencalaccess.leginfo.eo.Author>("authors", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail> VOTES = new ERXKey<org.opencalaccess.leginfo.eo.BillVoteDetail>("votes", Type.ToManyRelationship);

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String ACTIVE_LEGISLATOR_KEY = ACTIVE_LEGISLATOR.key();
  public static final String AUTHOR_NAME_KEY = AUTHOR_NAME.key();
  public static final String DISTRICT_KEY = DISTRICT.key();
  public static final String FIRST_NAME_KEY = FIRST_NAME.key();
  public static final String HOUSE_TYPE_KEY = HOUSE_TYPE.key();
  public static final String LAST_NAME_KEY = LAST_NAME.key();
  public static final String LEGISLATOR_NAME_KEY = LEGISLATOR_NAME.key();
  public static final String MIDDLE_INITIAL_KEY = MIDDLE_INITIAL.key();
  public static final String NAME_SUFFIX_KEY = NAME_SUFFIX.key();
  public static final String NAME_TITLE_KEY = NAME_TITLE.key();
  public static final String PARTY_KEY = PARTY.key();
  public static final String SESSION_YEAR_KEY = SESSION_YEAR.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();
  public static final String WEB_NAME_TITLE_KEY = WEB_NAME_TITLE.key();

  // Relationships
  public static final String AUTHORS_KEY = AUTHORS.key();
  public static final String VOTES_KEY = VOTES.key();

  private static final Logger log = LoggerFactory.getLogger(_Legislator.class);

  public Legislator localInstanceIn(EOEditingContext editingContext) {
    Legislator localInstance = (Legislator)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_Legislator.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _Legislator.ACTIVE_FLG_KEY);
  }

  public String activeLegislator() {
    return (String) storedValueForKey(_Legislator.ACTIVE_LEGISLATOR_KEY);
  }

  public void setActiveLegislator(String value) {
    log.debug( "updating activeLegislator from {} to {}", activeLegislator(), value);
    takeStoredValueForKey(value, _Legislator.ACTIVE_LEGISLATOR_KEY);
  }

  public String authorName() {
    return (String) storedValueForKey(_Legislator.AUTHOR_NAME_KEY);
  }

  public void setAuthorName(String value) {
    log.debug( "updating authorName from {} to {}", authorName(), value);
    takeStoredValueForKey(value, _Legislator.AUTHOR_NAME_KEY);
  }

  public String district() {
    return (String) storedValueForKey(_Legislator.DISTRICT_KEY);
  }

  public void setDistrict(String value) {
    log.debug( "updating district from {} to {}", district(), value);
    takeStoredValueForKey(value, _Legislator.DISTRICT_KEY);
  }

  public String firstName() {
    return (String) storedValueForKey(_Legislator.FIRST_NAME_KEY);
  }

  public void setFirstName(String value) {
    log.debug( "updating firstName from {} to {}", firstName(), value);
    takeStoredValueForKey(value, _Legislator.FIRST_NAME_KEY);
  }

  public String houseType() {
    return (String) storedValueForKey(_Legislator.HOUSE_TYPE_KEY);
  }

  public void setHouseType(String value) {
    log.debug( "updating houseType from {} to {}", houseType(), value);
    takeStoredValueForKey(value, _Legislator.HOUSE_TYPE_KEY);
  }

  public String lastName() {
    return (String) storedValueForKey(_Legislator.LAST_NAME_KEY);
  }

  public void setLastName(String value) {
    log.debug( "updating lastName from {} to {}", lastName(), value);
    takeStoredValueForKey(value, _Legislator.LAST_NAME_KEY);
  }

  public String legislatorName() {
    return (String) storedValueForKey(_Legislator.LEGISLATOR_NAME_KEY);
  }

  public void setLegislatorName(String value) {
    log.debug( "updating legislatorName from {} to {}", legislatorName(), value);
    takeStoredValueForKey(value, _Legislator.LEGISLATOR_NAME_KEY);
  }

  public String middleInitial() {
    return (String) storedValueForKey(_Legislator.MIDDLE_INITIAL_KEY);
  }

  public void setMiddleInitial(String value) {
    log.debug( "updating middleInitial from {} to {}", middleInitial(), value);
    takeStoredValueForKey(value, _Legislator.MIDDLE_INITIAL_KEY);
  }

  public String nameSuffix() {
    return (String) storedValueForKey(_Legislator.NAME_SUFFIX_KEY);
  }

  public void setNameSuffix(String value) {
    log.debug( "updating nameSuffix from {} to {}", nameSuffix(), value);
    takeStoredValueForKey(value, _Legislator.NAME_SUFFIX_KEY);
  }

  public String nameTitle() {
    return (String) storedValueForKey(_Legislator.NAME_TITLE_KEY);
  }

  public void setNameTitle(String value) {
    log.debug( "updating nameTitle from {} to {}", nameTitle(), value);
    takeStoredValueForKey(value, _Legislator.NAME_TITLE_KEY);
  }

  public String party() {
    return (String) storedValueForKey(_Legislator.PARTY_KEY);
  }

  public void setParty(String value) {
    log.debug( "updating party from {} to {}", party(), value);
    takeStoredValueForKey(value, _Legislator.PARTY_KEY);
  }

  public String sessionYear() {
    return (String) storedValueForKey(_Legislator.SESSION_YEAR_KEY);
  }

  public void setSessionYear(String value) {
    log.debug( "updating sessionYear from {} to {}", sessionYear(), value);
    takeStoredValueForKey(value, _Legislator.SESSION_YEAR_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_Legislator.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _Legislator.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_Legislator.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _Legislator.TRANS_UPDATE_KEY);
  }

  public String webNameTitle() {
    return (String) storedValueForKey(_Legislator.WEB_NAME_TITLE_KEY);
  }

  public void setWebNameTitle(String value) {
    log.debug( "updating webNameTitle from {} to {}", webNameTitle(), value);
    takeStoredValueForKey(value, _Legislator.WEB_NAME_TITLE_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Author> authors() {
    return (NSArray<org.opencalaccess.leginfo.eo.Author>)storedValueForKey(_Legislator.AUTHORS_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Author> authors(EOQualifier qualifier) {
    return authors(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Author> authors(EOQualifier qualifier, boolean fetch) {
    return authors(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.Author> authors(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.Author> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.Author.LEGISLATOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.Author.fetchAuthors(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = authors();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Author>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.Author>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToAuthors(org.opencalaccess.leginfo.eo.Author object) {
    includeObjectIntoPropertyWithKey(object, _Legislator.AUTHORS_KEY);
  }

  public void removeFromAuthors(org.opencalaccess.leginfo.eo.Author object) {
    excludeObjectFromPropertyWithKey(object, _Legislator.AUTHORS_KEY);
  }

  public void addToAuthorsRelationship(org.opencalaccess.leginfo.eo.Author object) {
    log.debug("adding {} to authors relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToAuthors(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Legislator.AUTHORS_KEY);
    }
  }

  public void removeFromAuthorsRelationship(org.opencalaccess.leginfo.eo.Author object) {
    log.debug("removing {} from authors relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromAuthors(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Legislator.AUTHORS_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.Author createAuthorsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.Author.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Legislator.AUTHORS_KEY);
    return (org.opencalaccess.leginfo.eo.Author) eo;
  }

  public void deleteAuthorsRelationship(org.opencalaccess.leginfo.eo.Author object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Legislator.AUTHORS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllAuthorsRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.Author> objects = authors().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteAuthorsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> votes() {
    return (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)storedValueForKey(_Legislator.VOTES_KEY);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> votes(EOQualifier qualifier) {
    return votes(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> votes(EOQualifier qualifier, boolean fetch) {
    return votes(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> votes(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.leginfo.eo.BillVoteDetail.LEGISLATOR_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.leginfo.eo.BillVoteDetail.fetchBillVoteDetails(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = votes();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.leginfo.eo.BillVoteDetail>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToVotes(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    includeObjectIntoPropertyWithKey(object, _Legislator.VOTES_KEY);
  }

  public void removeFromVotes(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    excludeObjectFromPropertyWithKey(object, _Legislator.VOTES_KEY);
  }

  public void addToVotesRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("adding {} to votes relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToVotes(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Legislator.VOTES_KEY);
    }
  }

  public void removeFromVotesRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    log.debug("removing {} from votes relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromVotes(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Legislator.VOTES_KEY);
    }
  }

  public org.opencalaccess.leginfo.eo.BillVoteDetail createVotesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.leginfo.eo.BillVoteDetail.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Legislator.VOTES_KEY);
    return (org.opencalaccess.leginfo.eo.BillVoteDetail) eo;
  }

  public void deleteVotesRelationship(org.opencalaccess.leginfo.eo.BillVoteDetail object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Legislator.VOTES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllVotesRelationships() {
    Enumeration<org.opencalaccess.leginfo.eo.BillVoteDetail> objects = votes().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteVotesRelationship(objects.nextElement());
    }
  }


  public static Legislator createLegislator(EOEditingContext editingContext, String activeFlg
, String district
) {
    Legislator eo = (Legislator) EOUtilities.createAndInsertInstance(editingContext, _Legislator.ENTITY_NAME);
    eo.setActiveFlg(activeFlg);
    eo.setDistrict(district);
    return eo;
  }

  public static ERXFetchSpecification<Legislator> fetchSpec() {
    return new ERXFetchSpecification<Legislator>(_Legislator.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Legislator> fetchAllLegislators(EOEditingContext editingContext) {
    return _Legislator.fetchAllLegislators(editingContext, null);
  }

  public static NSArray<Legislator> fetchAllLegislators(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Legislator.fetchLegislators(editingContext, null, sortOrderings);
  }

  public static NSArray<Legislator> fetchLegislators(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Legislator> fetchSpec = new ERXFetchSpecification<Legislator>(_Legislator.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Legislator> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Legislator fetchLegislator(EOEditingContext editingContext, String keyName, Object value) {
    return _Legislator.fetchLegislator(editingContext, ERXQ.equals(keyName, value));
  }

  public static Legislator fetchLegislator(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Legislator> eoObjects = _Legislator.fetchLegislators(editingContext, qualifier, null);
    Legislator eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Legislator that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Legislator fetchRequiredLegislator(EOEditingContext editingContext, String keyName, Object value) {
    return _Legislator.fetchRequiredLegislator(editingContext, ERXQ.equals(keyName, value));
  }

  public static Legislator fetchRequiredLegislator(EOEditingContext editingContext, EOQualifier qualifier) {
    Legislator eoObject = _Legislator.fetchLegislator(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Legislator that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Legislator localInstanceIn(EOEditingContext editingContext, Legislator eo) {
    Legislator localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
