// DO NOT EDIT.  Make changes to LocationCode.java instead.
package org.opencalaccess.leginfo.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _LocationCode extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "LocationCode";

  // Attribute Keys
  public static final ERXKey<String> ACTIVE_FLG = new ERXKey<String>("activeFlg", Type.Attribute);
  public static final ERXKey<String> CONSENT_CALENDAR_CODE = new ERXKey<String>("consentCalendarCode", Type.Attribute);
  public static final ERXKey<String> DESCRIPTION = new ERXKey<String>("description", Type.Attribute);
  public static final ERXKey<String> INACTIVE_FILE_FLG = new ERXKey<String>("inactiveFileFlg", Type.Attribute);
  public static final ERXKey<String> LOCATION_CODE = new ERXKey<String>("locationCode", Type.Attribute);
  public static final ERXKey<String> LOCATION_TYPE = new ERXKey<String>("locationType", Type.Attribute);
  public static final ERXKey<String> LONG_DESCRIPTION = new ERXKey<String>("longDescription", Type.Attribute);
  public static final ERXKey<String> SESSION_YEAR = new ERXKey<String>("sessionYear", Type.Attribute);
  public static final ERXKey<String> TRANS_UID = new ERXKey<String>("transUid", Type.Attribute);
  public static final ERXKey<NSTimestamp> TRANS_UPDATE = new ERXKey<NSTimestamp>("transUpdate", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String ACTIVE_FLG_KEY = ACTIVE_FLG.key();
  public static final String CONSENT_CALENDAR_CODE_KEY = CONSENT_CALENDAR_CODE.key();
  public static final String DESCRIPTION_KEY = DESCRIPTION.key();
  public static final String INACTIVE_FILE_FLG_KEY = INACTIVE_FILE_FLG.key();
  public static final String LOCATION_CODE_KEY = LOCATION_CODE.key();
  public static final String LOCATION_TYPE_KEY = LOCATION_TYPE.key();
  public static final String LONG_DESCRIPTION_KEY = LONG_DESCRIPTION.key();
  public static final String SESSION_YEAR_KEY = SESSION_YEAR.key();
  public static final String TRANS_UID_KEY = TRANS_UID.key();
  public static final String TRANS_UPDATE_KEY = TRANS_UPDATE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_LocationCode.class);

  public LocationCode localInstanceIn(EOEditingContext editingContext) {
    LocationCode localInstance = (LocationCode)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String activeFlg() {
    return (String) storedValueForKey(_LocationCode.ACTIVE_FLG_KEY);
  }

  public void setActiveFlg(String value) {
    log.debug( "updating activeFlg from {} to {}", activeFlg(), value);
    takeStoredValueForKey(value, _LocationCode.ACTIVE_FLG_KEY);
  }

  public String consentCalendarCode() {
    return (String) storedValueForKey(_LocationCode.CONSENT_CALENDAR_CODE_KEY);
  }

  public void setConsentCalendarCode(String value) {
    log.debug( "updating consentCalendarCode from {} to {}", consentCalendarCode(), value);
    takeStoredValueForKey(value, _LocationCode.CONSENT_CALENDAR_CODE_KEY);
  }

  public String description() {
    return (String) storedValueForKey(_LocationCode.DESCRIPTION_KEY);
  }

  public void setDescription(String value) {
    log.debug( "updating description from {} to {}", description(), value);
    takeStoredValueForKey(value, _LocationCode.DESCRIPTION_KEY);
  }

  public String inactiveFileFlg() {
    return (String) storedValueForKey(_LocationCode.INACTIVE_FILE_FLG_KEY);
  }

  public void setInactiveFileFlg(String value) {
    log.debug( "updating inactiveFileFlg from {} to {}", inactiveFileFlg(), value);
    takeStoredValueForKey(value, _LocationCode.INACTIVE_FILE_FLG_KEY);
  }

  public String locationCode() {
    return (String) storedValueForKey(_LocationCode.LOCATION_CODE_KEY);
  }

  public void setLocationCode(String value) {
    log.debug( "updating locationCode from {} to {}", locationCode(), value);
    takeStoredValueForKey(value, _LocationCode.LOCATION_CODE_KEY);
  }

  public String locationType() {
    return (String) storedValueForKey(_LocationCode.LOCATION_TYPE_KEY);
  }

  public void setLocationType(String value) {
    log.debug( "updating locationType from {} to {}", locationType(), value);
    takeStoredValueForKey(value, _LocationCode.LOCATION_TYPE_KEY);
  }

  public String longDescription() {
    return (String) storedValueForKey(_LocationCode.LONG_DESCRIPTION_KEY);
  }

  public void setLongDescription(String value) {
    log.debug( "updating longDescription from {} to {}", longDescription(), value);
    takeStoredValueForKey(value, _LocationCode.LONG_DESCRIPTION_KEY);
  }

  public String sessionYear() {
    return (String) storedValueForKey(_LocationCode.SESSION_YEAR_KEY);
  }

  public void setSessionYear(String value) {
    log.debug( "updating sessionYear from {} to {}", sessionYear(), value);
    takeStoredValueForKey(value, _LocationCode.SESSION_YEAR_KEY);
  }

  public String transUid() {
    return (String) storedValueForKey(_LocationCode.TRANS_UID_KEY);
  }

  public void setTransUid(String value) {
    log.debug( "updating transUid from {} to {}", transUid(), value);
    takeStoredValueForKey(value, _LocationCode.TRANS_UID_KEY);
  }

  public NSTimestamp transUpdate() {
    return (NSTimestamp) storedValueForKey(_LocationCode.TRANS_UPDATE_KEY);
  }

  public void setTransUpdate(NSTimestamp value) {
    log.debug( "updating transUpdate from {} to {}", transUpdate(), value);
    takeStoredValueForKey(value, _LocationCode.TRANS_UPDATE_KEY);
  }


  public static LocationCode createLocationCode(EOEditingContext editingContext, String consentCalendarCode
, String description
, String inactiveFileFlg
, String locationCode
, String locationType
, String longDescription
, String sessionYear
) {
    LocationCode eo = (LocationCode) EOUtilities.createAndInsertInstance(editingContext, _LocationCode.ENTITY_NAME);
    eo.setConsentCalendarCode(consentCalendarCode);
    eo.setDescription(description);
    eo.setInactiveFileFlg(inactiveFileFlg);
    eo.setLocationCode(locationCode);
    eo.setLocationType(locationType);
    eo.setLongDescription(longDescription);
    eo.setSessionYear(sessionYear);
    return eo;
  }

  public static ERXFetchSpecification<LocationCode> fetchSpec() {
    return new ERXFetchSpecification<LocationCode>(_LocationCode.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<LocationCode> fetchAllLocationCodes(EOEditingContext editingContext) {
    return _LocationCode.fetchAllLocationCodes(editingContext, null);
  }

  public static NSArray<LocationCode> fetchAllLocationCodes(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _LocationCode.fetchLocationCodes(editingContext, null, sortOrderings);
  }

  public static NSArray<LocationCode> fetchLocationCodes(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<LocationCode> fetchSpec = new ERXFetchSpecification<LocationCode>(_LocationCode.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<LocationCode> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static LocationCode fetchLocationCode(EOEditingContext editingContext, String keyName, Object value) {
    return _LocationCode.fetchLocationCode(editingContext, ERXQ.equals(keyName, value));
  }

  public static LocationCode fetchLocationCode(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<LocationCode> eoObjects = _LocationCode.fetchLocationCodes(editingContext, qualifier, null);
    LocationCode eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one LocationCode that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static LocationCode fetchRequiredLocationCode(EOEditingContext editingContext, String keyName, Object value) {
    return _LocationCode.fetchRequiredLocationCode(editingContext, ERXQ.equals(keyName, value));
  }

  public static LocationCode fetchRequiredLocationCode(EOEditingContext editingContext, EOQualifier qualifier) {
    LocationCode eoObject = _LocationCode.fetchLocationCode(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no LocationCode that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static LocationCode localInstanceIn(EOEditingContext editingContext, LocationCode eo) {
    LocationCode localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
