// DO NOT EDIT.  Make changes to Nonogram.java instead.
package org.opencalaccess.nonograms.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Nonogram extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Nonogram";

  // Attribute Keys
  public static final ERXKey<String> NAME = new ERXKey<String>("name", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.nonograms.eo.Nonorow> NONOROWS = new ERXKey<org.opencalaccess.nonograms.eo.Nonorow>("nonorows", Type.ToManyRelationship);

  // Attributes
  public static final String NAME_KEY = NAME.key();

  // Relationships
  public static final String NONOROWS_KEY = NONOROWS.key();

  private static final Logger log = LoggerFactory.getLogger(_Nonogram.class);

  public Nonogram localInstanceIn(EOEditingContext editingContext) {
    Nonogram localInstance = (Nonogram)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String name() {
    return (String) storedValueForKey(_Nonogram.NAME_KEY);
  }

  public void setName(String value) {
    log.debug( "updating name from {} to {}", name(), value);
    takeStoredValueForKey(value, _Nonogram.NAME_KEY);
  }

  public NSArray<org.opencalaccess.nonograms.eo.Nonorow> nonorows() {
    return (NSArray<org.opencalaccess.nonograms.eo.Nonorow>)storedValueForKey(_Nonogram.NONOROWS_KEY);
  }

  public NSArray<org.opencalaccess.nonograms.eo.Nonorow> nonorows(EOQualifier qualifier) {
    return nonorows(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.nonograms.eo.Nonorow> nonorows(EOQualifier qualifier, boolean fetch) {
    return nonorows(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.nonograms.eo.Nonorow> nonorows(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.nonograms.eo.Nonorow> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.nonograms.eo.Nonorow.NONOGRAM_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.nonograms.eo.Nonorow.fetchNonorows(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = nonorows();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.nonograms.eo.Nonorow>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.nonograms.eo.Nonorow>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToNonorows(org.opencalaccess.nonograms.eo.Nonorow object) {
    includeObjectIntoPropertyWithKey(object, _Nonogram.NONOROWS_KEY);
  }

  public void removeFromNonorows(org.opencalaccess.nonograms.eo.Nonorow object) {
    excludeObjectFromPropertyWithKey(object, _Nonogram.NONOROWS_KEY);
  }

  public void addToNonorowsRelationship(org.opencalaccess.nonograms.eo.Nonorow object) {
    log.debug("adding {} to nonorows relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToNonorows(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _Nonogram.NONOROWS_KEY);
    }
  }

  public void removeFromNonorowsRelationship(org.opencalaccess.nonograms.eo.Nonorow object) {
    log.debug("removing {} from nonorows relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromNonorows(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _Nonogram.NONOROWS_KEY);
    }
  }

  public org.opencalaccess.nonograms.eo.Nonorow createNonorowsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.nonograms.eo.Nonorow.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _Nonogram.NONOROWS_KEY);
    return (org.opencalaccess.nonograms.eo.Nonorow) eo;
  }

  public void deleteNonorowsRelationship(org.opencalaccess.nonograms.eo.Nonorow object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _Nonogram.NONOROWS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllNonorowsRelationships() {
    Enumeration<org.opencalaccess.nonograms.eo.Nonorow> objects = nonorows().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteNonorowsRelationship(objects.nextElement());
    }
  }


  public static Nonogram createNonogram(EOEditingContext editingContext, String name
) {
    Nonogram eo = (Nonogram) EOUtilities.createAndInsertInstance(editingContext, _Nonogram.ENTITY_NAME);
    eo.setName(name);
    return eo;
  }

  public static ERXFetchSpecification<Nonogram> fetchSpec() {
    return new ERXFetchSpecification<Nonogram>(_Nonogram.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Nonogram> fetchAllNonograms(EOEditingContext editingContext) {
    return _Nonogram.fetchAllNonograms(editingContext, null);
  }

  public static NSArray<Nonogram> fetchAllNonograms(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Nonogram.fetchNonograms(editingContext, null, sortOrderings);
  }

  public static NSArray<Nonogram> fetchNonograms(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Nonogram> fetchSpec = new ERXFetchSpecification<Nonogram>(_Nonogram.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Nonogram> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Nonogram fetchNonogram(EOEditingContext editingContext, String keyName, Object value) {
    return _Nonogram.fetchNonogram(editingContext, ERXQ.equals(keyName, value));
  }

  public static Nonogram fetchNonogram(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Nonogram> eoObjects = _Nonogram.fetchNonograms(editingContext, qualifier, null);
    Nonogram eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Nonogram that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Nonogram fetchRequiredNonogram(EOEditingContext editingContext, String keyName, Object value) {
    return _Nonogram.fetchRequiredNonogram(editingContext, ERXQ.equals(keyName, value));
  }

  public static Nonogram fetchRequiredNonogram(EOEditingContext editingContext, EOQualifier qualifier) {
    Nonogram eoObject = _Nonogram.fetchNonogram(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Nonogram that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Nonogram localInstanceIn(EOEditingContext editingContext, Nonogram eo) {
    Nonogram localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
