// DO NOT EDIT.  Make changes to Nonorow.java instead.
package org.opencalaccess.nonograms.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _Nonorow extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Nonorow";

  // Attribute Keys
  public static final ERXKey<String> ROW_DATA = new ERXKey<String>("rowData", Type.Attribute);
  public static final ERXKey<Integer> ROW_NUM = new ERXKey<Integer>("rowNum", Type.Attribute);
  public static final ERXKey<String> ROW_TYPE = new ERXKey<String>("rowType", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.nonograms.eo.Nonogram> NONOGRAM = new ERXKey<org.opencalaccess.nonograms.eo.Nonogram>("nonogram", Type.ToOneRelationship);

  // Attributes
  public static final String ROW_DATA_KEY = ROW_DATA.key();
  public static final String ROW_NUM_KEY = ROW_NUM.key();
  public static final String ROW_TYPE_KEY = ROW_TYPE.key();

  // Relationships
  public static final String NONOGRAM_KEY = NONOGRAM.key();

  private static final Logger log = LoggerFactory.getLogger(_Nonorow.class);

  public Nonorow localInstanceIn(EOEditingContext editingContext) {
    Nonorow localInstance = (Nonorow)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String rowData() {
    return (String) storedValueForKey(_Nonorow.ROW_DATA_KEY);
  }

  public void setRowData(String value) {
    log.debug( "updating rowData from {} to {}", rowData(), value);
    takeStoredValueForKey(value, _Nonorow.ROW_DATA_KEY);
  }

  public Integer rowNum() {
    return (Integer) storedValueForKey(_Nonorow.ROW_NUM_KEY);
  }

  public void setRowNum(Integer value) {
    log.debug( "updating rowNum from {} to {}", rowNum(), value);
    takeStoredValueForKey(value, _Nonorow.ROW_NUM_KEY);
  }

  public String rowType() {
    return (String) storedValueForKey(_Nonorow.ROW_TYPE_KEY);
  }

  public void setRowType(String value) {
    log.debug( "updating rowType from {} to {}", rowType(), value);
    takeStoredValueForKey(value, _Nonorow.ROW_TYPE_KEY);
  }

  public org.opencalaccess.nonograms.eo.Nonogram nonogram() {
    return (org.opencalaccess.nonograms.eo.Nonogram)storedValueForKey(_Nonorow.NONOGRAM_KEY);
  }

  public void setNonogram(org.opencalaccess.nonograms.eo.Nonogram value) {
    takeStoredValueForKey(value, _Nonorow.NONOGRAM_KEY);
  }

  public void setNonogramRelationship(org.opencalaccess.nonograms.eo.Nonogram value) {
    log.debug("updating nonogram from {} to {}", nonogram(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setNonogram(value);
    }
    else if (value == null) {
      org.opencalaccess.nonograms.eo.Nonogram oldValue = nonogram();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _Nonorow.NONOGRAM_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _Nonorow.NONOGRAM_KEY);
    }
  }


  public static Nonorow createNonorow(EOEditingContext editingContext, String rowData
, Integer rowNum
, String rowType
, org.opencalaccess.nonograms.eo.Nonogram nonogram) {
    Nonorow eo = (Nonorow) EOUtilities.createAndInsertInstance(editingContext, _Nonorow.ENTITY_NAME);
    eo.setRowData(rowData);
    eo.setRowNum(rowNum);
    eo.setRowType(rowType);
    eo.setNonogramRelationship(nonogram);
    return eo;
  }

  public static ERXFetchSpecification<Nonorow> fetchSpec() {
    return new ERXFetchSpecification<Nonorow>(_Nonorow.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<Nonorow> fetchAllNonorows(EOEditingContext editingContext) {
    return _Nonorow.fetchAllNonorows(editingContext, null);
  }

  public static NSArray<Nonorow> fetchAllNonorows(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _Nonorow.fetchNonorows(editingContext, null, sortOrderings);
  }

  public static NSArray<Nonorow> fetchNonorows(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<Nonorow> fetchSpec = new ERXFetchSpecification<Nonorow>(_Nonorow.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<Nonorow> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static Nonorow fetchNonorow(EOEditingContext editingContext, String keyName, Object value) {
    return _Nonorow.fetchNonorow(editingContext, ERXQ.equals(keyName, value));
  }

  public static Nonorow fetchNonorow(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<Nonorow> eoObjects = _Nonorow.fetchNonorows(editingContext, qualifier, null);
    Nonorow eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Nonorow that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Nonorow fetchRequiredNonorow(EOEditingContext editingContext, String keyName, Object value) {
    return _Nonorow.fetchRequiredNonorow(editingContext, ERXQ.equals(keyName, value));
  }

  public static Nonorow fetchRequiredNonorow(EOEditingContext editingContext, EOQualifier qualifier) {
    Nonorow eoObject = _Nonorow.fetchNonorow(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Nonorow that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static Nonorow localInstanceIn(EOEditingContext editingContext, Nonorow eo) {
    Nonorow localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
