// DO NOT EDIT.  Make changes to OilWell.java instead.
package org.opencalaccess.oilwells.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _OilWell extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "OilWell";

  // Attribute Keys
  public static final ERXKey<String> API_NUM = new ERXKey<String>("apiNum", Type.Attribute);
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> DESIGNATION = new ERXKey<String>("designation", Type.Attribute);
  public static final ERXKey<String> FIELDS_LIST = new ERXKey<String>("fieldsList", Type.Attribute);
  public static final ERXKey<String> LAT_LONG = new ERXKey<String>("latLong", Type.Attribute);
  public static final ERXKey<String> OPERATOR = new ERXKey<String>("operator", Type.Attribute);
  public static final ERXKey<String> STATUS_NAME = new ERXKey<String>("statusName", Type.Attribute);
  public static final ERXKey<String> WELL_TYPE = new ERXKey<String>("wellType", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String API_NUM_KEY = API_NUM.key();
  public static final String CREATED_KEY = CREATED.key();
  public static final String DESIGNATION_KEY = DESIGNATION.key();
  public static final String FIELDS_LIST_KEY = FIELDS_LIST.key();
  public static final String LAT_LONG_KEY = LAT_LONG.key();
  public static final String OPERATOR_KEY = OPERATOR.key();
  public static final String STATUS_NAME_KEY = STATUS_NAME.key();
  public static final String WELL_TYPE_KEY = WELL_TYPE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_OilWell.class);

  public OilWell localInstanceIn(EOEditingContext editingContext) {
    OilWell localInstance = (OilWell)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String apiNum() {
    return (String) storedValueForKey(_OilWell.API_NUM_KEY);
  }

  public void setApiNum(String value) {
    log.debug( "updating apiNum from {} to {}", apiNum(), value);
    takeStoredValueForKey(value, _OilWell.API_NUM_KEY);
  }

  public Long created() {
    return (Long) storedValueForKey(_OilWell.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _OilWell.CREATED_KEY);
  }

  public String designation() {
    return (String) storedValueForKey(_OilWell.DESIGNATION_KEY);
  }

  public void setDesignation(String value) {
    log.debug( "updating designation from {} to {}", designation(), value);
    takeStoredValueForKey(value, _OilWell.DESIGNATION_KEY);
  }

  public String fieldsList() {
    return (String) storedValueForKey(_OilWell.FIELDS_LIST_KEY);
  }

  public void setFieldsList(String value) {
    log.debug( "updating fieldsList from {} to {}", fieldsList(), value);
    takeStoredValueForKey(value, _OilWell.FIELDS_LIST_KEY);
  }

  public String latLong() {
    return (String) storedValueForKey(_OilWell.LAT_LONG_KEY);
  }

  public void setLatLong(String value) {
    log.debug( "updating latLong from {} to {}", latLong(), value);
    takeStoredValueForKey(value, _OilWell.LAT_LONG_KEY);
  }

  public String operator() {
    return (String) storedValueForKey(_OilWell.OPERATOR_KEY);
  }

  public void setOperator(String value) {
    log.debug( "updating operator from {} to {}", operator(), value);
    takeStoredValueForKey(value, _OilWell.OPERATOR_KEY);
  }

  public String statusName() {
    return (String) storedValueForKey(_OilWell.STATUS_NAME_KEY);
  }

  public void setStatusName(String value) {
    log.debug( "updating statusName from {} to {}", statusName(), value);
    takeStoredValueForKey(value, _OilWell.STATUS_NAME_KEY);
  }

  public String wellType() {
    return (String) storedValueForKey(_OilWell.WELL_TYPE_KEY);
  }

  public void setWellType(String value) {
    log.debug( "updating wellType from {} to {}", wellType(), value);
    takeStoredValueForKey(value, _OilWell.WELL_TYPE_KEY);
  }


  public static OilWell createOilWell(EOEditingContext editingContext, Long created
) {
    OilWell eo = (OilWell) EOUtilities.createAndInsertInstance(editingContext, _OilWell.ENTITY_NAME);
    eo.setCreated(created);
    return eo;
  }

  public static ERXFetchSpecification<OilWell> fetchSpec() {
    return new ERXFetchSpecification<OilWell>(_OilWell.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<OilWell> fetchAllOilWells(EOEditingContext editingContext) {
    return _OilWell.fetchAllOilWells(editingContext, null);
  }

  public static NSArray<OilWell> fetchAllOilWells(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _OilWell.fetchOilWells(editingContext, null, sortOrderings);
  }

  public static NSArray<OilWell> fetchOilWells(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<OilWell> fetchSpec = new ERXFetchSpecification<OilWell>(_OilWell.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<OilWell> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static OilWell fetchOilWell(EOEditingContext editingContext, String keyName, Object value) {
    return _OilWell.fetchOilWell(editingContext, ERXQ.equals(keyName, value));
  }

  public static OilWell fetchOilWell(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<OilWell> eoObjects = _OilWell.fetchOilWells(editingContext, qualifier, null);
    OilWell eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one OilWell that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OilWell fetchRequiredOilWell(EOEditingContext editingContext, String keyName, Object value) {
    return _OilWell.fetchRequiredOilWell(editingContext, ERXQ.equals(keyName, value));
  }

  public static OilWell fetchRequiredOilWell(EOEditingContext editingContext, EOQualifier qualifier) {
    OilWell eoObject = _OilWell.fetchOilWell(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no OilWell that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OilWell localInstanceIn(EOEditingContext editingContext, OilWell eo) {
    OilWell localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
