// DO NOT EDIT.  Make changes to OneTimeFact.java instead.
package org.opencalaccess.reference.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _OneTimeFact extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "OneTimeFact";

  // Attribute Keys
  public static final ERXKey<String> DIGEST = new ERXKey<String>("digest", Type.Attribute);
  public static final ERXKey<String> FACT = new ERXKey<String>("fact", Type.Attribute);
  public static final ERXKey<String> SOURCE_IPV4_ADDRESS = new ERXKey<String>("sourceIpv4Address", Type.Attribute);
  public static final ERXKey<Long> SOURCE_TIMESTAMP = new ERXKey<Long>("sourceTimestamp", Type.Attribute);
  public static final ERXKey<String> TARGET_IPV4_ADDRESS = new ERXKey<String>("targetIpv4Address", Type.Attribute);
  public static final ERXKey<java.math.BigDecimal> TARGET_TIMESTAMP = new ERXKey<java.math.BigDecimal>("targetTimestamp", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String DIGEST_KEY = DIGEST.key();
  public static final String FACT_KEY = FACT.key();
  public static final String SOURCE_IPV4_ADDRESS_KEY = SOURCE_IPV4_ADDRESS.key();
  public static final String SOURCE_TIMESTAMP_KEY = SOURCE_TIMESTAMP.key();
  public static final String TARGET_IPV4_ADDRESS_KEY = TARGET_IPV4_ADDRESS.key();
  public static final String TARGET_TIMESTAMP_KEY = TARGET_TIMESTAMP.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_OneTimeFact.class);

  public OneTimeFact localInstanceIn(EOEditingContext editingContext) {
    OneTimeFact localInstance = (OneTimeFact)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String digest() {
    return (String) storedValueForKey(_OneTimeFact.DIGEST_KEY);
  }

  public void setDigest(String value) {
    log.debug( "updating digest from {} to {}", digest(), value);
    takeStoredValueForKey(value, _OneTimeFact.DIGEST_KEY);
  }

  public String fact() {
    return (String) storedValueForKey(_OneTimeFact.FACT_KEY);
  }

  public void setFact(String value) {
    log.debug( "updating fact from {} to {}", fact(), value);
    takeStoredValueForKey(value, _OneTimeFact.FACT_KEY);
  }

  public String sourceIpv4Address() {
    return (String) storedValueForKey(_OneTimeFact.SOURCE_IPV4_ADDRESS_KEY);
  }

  public void setSourceIpv4Address(String value) {
    log.debug( "updating sourceIpv4Address from {} to {}", sourceIpv4Address(), value);
    takeStoredValueForKey(value, _OneTimeFact.SOURCE_IPV4_ADDRESS_KEY);
  }

  public Long sourceTimestamp() {
    return (Long) storedValueForKey(_OneTimeFact.SOURCE_TIMESTAMP_KEY);
  }

  public void setSourceTimestamp(Long value) {
    log.debug( "updating sourceTimestamp from {} to {}", sourceTimestamp(), value);
    takeStoredValueForKey(value, _OneTimeFact.SOURCE_TIMESTAMP_KEY);
  }

  public String targetIpv4Address() {
    return (String) storedValueForKey(_OneTimeFact.TARGET_IPV4_ADDRESS_KEY);
  }

  public void setTargetIpv4Address(String value) {
    log.debug( "updating targetIpv4Address from {} to {}", targetIpv4Address(), value);
    takeStoredValueForKey(value, _OneTimeFact.TARGET_IPV4_ADDRESS_KEY);
  }

  public java.math.BigDecimal targetTimestamp() {
    return (java.math.BigDecimal) storedValueForKey(_OneTimeFact.TARGET_TIMESTAMP_KEY);
  }

  public void setTargetTimestamp(java.math.BigDecimal value) {
    log.debug( "updating targetTimestamp from {} to {}", targetTimestamp(), value);
    takeStoredValueForKey(value, _OneTimeFact.TARGET_TIMESTAMP_KEY);
  }


  public static OneTimeFact createOneTimeFact(EOEditingContext editingContext, String digest
, String sourceIpv4Address
, Long sourceTimestamp
) {
    OneTimeFact eo = (OneTimeFact) EOUtilities.createAndInsertInstance(editingContext, _OneTimeFact.ENTITY_NAME);
    eo.setDigest(digest);
    eo.setSourceIpv4Address(sourceIpv4Address);
    eo.setSourceTimestamp(sourceTimestamp);
    return eo;
  }

  public static ERXFetchSpecification<OneTimeFact> fetchSpec() {
    return new ERXFetchSpecification<OneTimeFact>(_OneTimeFact.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<OneTimeFact> fetchAllOneTimeFacts(EOEditingContext editingContext) {
    return _OneTimeFact.fetchAllOneTimeFacts(editingContext, null);
  }

  public static NSArray<OneTimeFact> fetchAllOneTimeFacts(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _OneTimeFact.fetchOneTimeFacts(editingContext, null, sortOrderings);
  }

  public static NSArray<OneTimeFact> fetchOneTimeFacts(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<OneTimeFact> fetchSpec = new ERXFetchSpecification<OneTimeFact>(_OneTimeFact.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<OneTimeFact> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static OneTimeFact fetchOneTimeFact(EOEditingContext editingContext, String keyName, Object value) {
    return _OneTimeFact.fetchOneTimeFact(editingContext, ERXQ.equals(keyName, value));
  }

  public static OneTimeFact fetchOneTimeFact(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<OneTimeFact> eoObjects = _OneTimeFact.fetchOneTimeFacts(editingContext, qualifier, null);
    OneTimeFact eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one OneTimeFact that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OneTimeFact fetchRequiredOneTimeFact(EOEditingContext editingContext, String keyName, Object value) {
    return _OneTimeFact.fetchRequiredOneTimeFact(editingContext, ERXQ.equals(keyName, value));
  }

  public static OneTimeFact fetchRequiredOneTimeFact(EOEditingContext editingContext, EOQualifier qualifier) {
    OneTimeFact eoObject = _OneTimeFact.fetchOneTimeFact(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no OneTimeFact that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static OneTimeFact localInstanceIn(EOEditingContext editingContext, OneTimeFact eo) {
    OneTimeFact localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
