// DO NOT EDIT.  Make changes to BudgetUnit.java instead.
package org.opencalaccess.scccontracts.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _BudgetUnit extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "BudgetUnit";

  // Attribute Keys
  public static final ERXKey<String> UNIT_NAME = new ERXKey<String>("unitName", Type.Attribute);
  public static final ERXKey<Integer> UNIT_NUM = new ERXKey<Integer>("unitNum", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract> CONTRACTS = new ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract>("contracts", Type.ToManyRelationship);

  // Attributes
  public static final String UNIT_NAME_KEY = UNIT_NAME.key();
  public static final String UNIT_NUM_KEY = UNIT_NUM.key();

  // Relationships
  public static final String CONTRACTS_KEY = CONTRACTS.key();

  private static final Logger log = LoggerFactory.getLogger(_BudgetUnit.class);

  public BudgetUnit localInstanceIn(EOEditingContext editingContext) {
    BudgetUnit localInstance = (BudgetUnit)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String unitName() {
    return (String) storedValueForKey(_BudgetUnit.UNIT_NAME_KEY);
  }

  public void setUnitName(String value) {
    log.debug( "updating unitName from {} to {}", unitName(), value);
    takeStoredValueForKey(value, _BudgetUnit.UNIT_NAME_KEY);
  }

  public Integer unitNum() {
    return (Integer) storedValueForKey(_BudgetUnit.UNIT_NUM_KEY);
  }

  public void setUnitNum(Integer value) {
    log.debug( "updating unitNum from {} to {}", unitNum(), value);
    takeStoredValueForKey(value, _BudgetUnit.UNIT_NUM_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts() {
    return (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)storedValueForKey(_BudgetUnit.CONTRACTS_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts(EOQualifier qualifier) {
    return contracts(qualifier, null);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> results;
      results = contracts();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToContracts(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    includeObjectIntoPropertyWithKey(object, _BudgetUnit.CONTRACTS_KEY);
  }

  public void removeFromContracts(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    excludeObjectFromPropertyWithKey(object, _BudgetUnit.CONTRACTS_KEY);
  }

  public void addToContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    log.debug("adding {} to contracts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToContracts(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _BudgetUnit.CONTRACTS_KEY);
    }
  }

  public void removeFromContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    log.debug("removing {} from contracts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromContracts(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _BudgetUnit.CONTRACTS_KEY);
    }
  }

  public org.opencalaccess.scccontracts.eo.MonthlyContract createContractsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.scccontracts.eo.MonthlyContract.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _BudgetUnit.CONTRACTS_KEY);
    return (org.opencalaccess.scccontracts.eo.MonthlyContract) eo;
  }

  public void deleteContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _BudgetUnit.CONTRACTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllContractsRelationships() {
    Enumeration<org.opencalaccess.scccontracts.eo.MonthlyContract> objects = contracts().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteContractsRelationship(objects.nextElement());
    }
  }


  public static BudgetUnit createBudgetUnit(EOEditingContext editingContext, String unitName
) {
    BudgetUnit eo = (BudgetUnit) EOUtilities.createAndInsertInstance(editingContext, _BudgetUnit.ENTITY_NAME);
    eo.setUnitName(unitName);
    return eo;
  }

  public static ERXFetchSpecification<BudgetUnit> fetchSpec() {
    return new ERXFetchSpecification<BudgetUnit>(_BudgetUnit.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<BudgetUnit> fetchAllBudgetUnits(EOEditingContext editingContext) {
    return _BudgetUnit.fetchAllBudgetUnits(editingContext, null);
  }

  public static NSArray<BudgetUnit> fetchAllBudgetUnits(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _BudgetUnit.fetchBudgetUnits(editingContext, null, sortOrderings);
  }

  public static NSArray<BudgetUnit> fetchBudgetUnits(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<BudgetUnit> fetchSpec = new ERXFetchSpecification<BudgetUnit>(_BudgetUnit.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<BudgetUnit> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static BudgetUnit fetchBudgetUnit(EOEditingContext editingContext, String keyName, Object value) {
    return _BudgetUnit.fetchBudgetUnit(editingContext, ERXQ.equals(keyName, value));
  }

  public static BudgetUnit fetchBudgetUnit(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<BudgetUnit> eoObjects = _BudgetUnit.fetchBudgetUnits(editingContext, qualifier, null);
    BudgetUnit eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one BudgetUnit that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BudgetUnit fetchRequiredBudgetUnit(EOEditingContext editingContext, String keyName, Object value) {
    return _BudgetUnit.fetchRequiredBudgetUnit(editingContext, ERXQ.equals(keyName, value));
  }

  public static BudgetUnit fetchRequiredBudgetUnit(EOEditingContext editingContext, EOQualifier qualifier) {
    BudgetUnit eoObject = _BudgetUnit.fetchBudgetUnit(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no BudgetUnit that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static BudgetUnit localInstanceIn(EOEditingContext editingContext, BudgetUnit eo) {
    BudgetUnit localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
