// DO NOT EDIT.  Make changes to MonthlyContract.java instead.
package org.opencalaccess.scccontracts.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _MonthlyContract extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "MonthlyContract";

  // Attribute Keys
  public static final ERXKey<String> ARIBA_ID = new ERXKey<String>("aribaId", Type.Attribute);
  public static final ERXKey<String> COMMODITY_DESC = new ERXKey<String>("commodityDesc", Type.Attribute);
  public static final ERXKey<String> CONTRACT_ID = new ERXKey<String>("contractId", Type.Attribute);
  public static final ERXKey<String> CONTRACT_TYPE = new ERXKey<String>("contractType", Type.Attribute);
  public static final ERXKey<Long> CONTRACT_VALUE = new ERXKey<Long>("contractValue", Type.Attribute);
  public static final ERXKey<String> EFFECTIVE_DATE = new ERXKey<String>("effectiveDate", Type.Attribute);
  public static final ERXKey<String> EXPIR_DATE = new ERXKey<String>("expirDate", Type.Attribute);
  public static final ERXKey<String> OWNER_NAME = new ERXKey<String>("ownerName", Type.Attribute);
  public static final ERXKey<String> SAP_ID = new ERXKey<String>("sapId", Type.Attribute);
  public static final ERXKey<String> VENDOR_NAME = new ERXKey<String>("vendorName", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.scccontracts.eo.BudgetUnit> BUDGET_UNITS = new ERXKey<org.opencalaccess.scccontracts.eo.BudgetUnit>("budgetUnits", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.scccontracts.eo.ReportMonth> MONTH = new ERXKey<org.opencalaccess.scccontracts.eo.ReportMonth>("month", Type.ToOneRelationship);

  // Attributes
  public static final String ARIBA_ID_KEY = ARIBA_ID.key();
  public static final String COMMODITY_DESC_KEY = COMMODITY_DESC.key();
  public static final String CONTRACT_ID_KEY = CONTRACT_ID.key();
  public static final String CONTRACT_TYPE_KEY = CONTRACT_TYPE.key();
  public static final String CONTRACT_VALUE_KEY = CONTRACT_VALUE.key();
  public static final String EFFECTIVE_DATE_KEY = EFFECTIVE_DATE.key();
  public static final String EXPIR_DATE_KEY = EXPIR_DATE.key();
  public static final String OWNER_NAME_KEY = OWNER_NAME.key();
  public static final String SAP_ID_KEY = SAP_ID.key();
  public static final String VENDOR_NAME_KEY = VENDOR_NAME.key();

  // Relationships
  public static final String BUDGET_UNITS_KEY = BUDGET_UNITS.key();
  public static final String MONTH_KEY = MONTH.key();

  private static final Logger log = LoggerFactory.getLogger(_MonthlyContract.class);

  public MonthlyContract localInstanceIn(EOEditingContext editingContext) {
    MonthlyContract localInstance = (MonthlyContract)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String aribaId() {
    return (String) storedValueForKey(_MonthlyContract.ARIBA_ID_KEY);
  }

  public void setAribaId(String value) {
    log.debug( "updating aribaId from {} to {}", aribaId(), value);
    takeStoredValueForKey(value, _MonthlyContract.ARIBA_ID_KEY);
  }

  public String commodityDesc() {
    return (String) storedValueForKey(_MonthlyContract.COMMODITY_DESC_KEY);
  }

  public void setCommodityDesc(String value) {
    log.debug( "updating commodityDesc from {} to {}", commodityDesc(), value);
    takeStoredValueForKey(value, _MonthlyContract.COMMODITY_DESC_KEY);
  }

  public String contractId() {
    return (String) storedValueForKey(_MonthlyContract.CONTRACT_ID_KEY);
  }

  public void setContractId(String value) {
    log.debug( "updating contractId from {} to {}", contractId(), value);
    takeStoredValueForKey(value, _MonthlyContract.CONTRACT_ID_KEY);
  }

  public String contractType() {
    return (String) storedValueForKey(_MonthlyContract.CONTRACT_TYPE_KEY);
  }

  public void setContractType(String value) {
    log.debug( "updating contractType from {} to {}", contractType(), value);
    takeStoredValueForKey(value, _MonthlyContract.CONTRACT_TYPE_KEY);
  }

  public Long contractValue() {
    return (Long) storedValueForKey(_MonthlyContract.CONTRACT_VALUE_KEY);
  }

  public void setContractValue(Long value) {
    log.debug( "updating contractValue from {} to {}", contractValue(), value);
    takeStoredValueForKey(value, _MonthlyContract.CONTRACT_VALUE_KEY);
  }

  public String effectiveDate() {
    return (String) storedValueForKey(_MonthlyContract.EFFECTIVE_DATE_KEY);
  }

  public void setEffectiveDate(String value) {
    log.debug( "updating effectiveDate from {} to {}", effectiveDate(), value);
    takeStoredValueForKey(value, _MonthlyContract.EFFECTIVE_DATE_KEY);
  }

  public String expirDate() {
    return (String) storedValueForKey(_MonthlyContract.EXPIR_DATE_KEY);
  }

  public void setExpirDate(String value) {
    log.debug( "updating expirDate from {} to {}", expirDate(), value);
    takeStoredValueForKey(value, _MonthlyContract.EXPIR_DATE_KEY);
  }

  public String ownerName() {
    return (String) storedValueForKey(_MonthlyContract.OWNER_NAME_KEY);
  }

  public void setOwnerName(String value) {
    log.debug( "updating ownerName from {} to {}", ownerName(), value);
    takeStoredValueForKey(value, _MonthlyContract.OWNER_NAME_KEY);
  }

  public String sapId() {
    return (String) storedValueForKey(_MonthlyContract.SAP_ID_KEY);
  }

  public void setSapId(String value) {
    log.debug( "updating sapId from {} to {}", sapId(), value);
    takeStoredValueForKey(value, _MonthlyContract.SAP_ID_KEY);
  }

  public String vendorName() {
    return (String) storedValueForKey(_MonthlyContract.VENDOR_NAME_KEY);
  }

  public void setVendorName(String value) {
    log.debug( "updating vendorName from {} to {}", vendorName(), value);
    takeStoredValueForKey(value, _MonthlyContract.VENDOR_NAME_KEY);
  }

  public org.opencalaccess.scccontracts.eo.ReportMonth month() {
    return (org.opencalaccess.scccontracts.eo.ReportMonth)storedValueForKey(_MonthlyContract.MONTH_KEY);
  }

  public void setMonth(org.opencalaccess.scccontracts.eo.ReportMonth value) {
    takeStoredValueForKey(value, _MonthlyContract.MONTH_KEY);
  }

  public void setMonthRelationship(org.opencalaccess.scccontracts.eo.ReportMonth value) {
    log.debug("updating month from {} to {}", month(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setMonth(value);
    }
    else if (value == null) {
      org.opencalaccess.scccontracts.eo.ReportMonth oldValue = month();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _MonthlyContract.MONTH_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _MonthlyContract.MONTH_KEY);
    }
  }

  public NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit> budgetUnits() {
    return (NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit>)storedValueForKey(_MonthlyContract.BUDGET_UNITS_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit> budgetUnits(EOQualifier qualifier) {
    return budgetUnits(qualifier, null);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit> budgetUnits(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit> results;
      results = budgetUnits();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.BudgetUnit>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    return results;
  }

  public void addToBudgetUnits(org.opencalaccess.scccontracts.eo.BudgetUnit object) {
    includeObjectIntoPropertyWithKey(object, _MonthlyContract.BUDGET_UNITS_KEY);
  }

  public void removeFromBudgetUnits(org.opencalaccess.scccontracts.eo.BudgetUnit object) {
    excludeObjectFromPropertyWithKey(object, _MonthlyContract.BUDGET_UNITS_KEY);
  }

  public void addToBudgetUnitsRelationship(org.opencalaccess.scccontracts.eo.BudgetUnit object) {
    log.debug("adding {} to budgetUnits relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToBudgetUnits(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _MonthlyContract.BUDGET_UNITS_KEY);
    }
  }

  public void removeFromBudgetUnitsRelationship(org.opencalaccess.scccontracts.eo.BudgetUnit object) {
    log.debug("removing {} from budgetUnits relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromBudgetUnits(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _MonthlyContract.BUDGET_UNITS_KEY);
    }
  }

  public org.opencalaccess.scccontracts.eo.BudgetUnit createBudgetUnitsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.scccontracts.eo.BudgetUnit.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _MonthlyContract.BUDGET_UNITS_KEY);
    return (org.opencalaccess.scccontracts.eo.BudgetUnit) eo;
  }

  public void deleteBudgetUnitsRelationship(org.opencalaccess.scccontracts.eo.BudgetUnit object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _MonthlyContract.BUDGET_UNITS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllBudgetUnitsRelationships() {
    Enumeration<org.opencalaccess.scccontracts.eo.BudgetUnit> objects = budgetUnits().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteBudgetUnitsRelationship(objects.nextElement());
    }
  }


  public static MonthlyContract createMonthlyContract(EOEditingContext editingContext, String commodityDesc
, Long contractValue
, String effectiveDate
, String expirDate
, String vendorName
, org.opencalaccess.scccontracts.eo.ReportMonth month) {
    MonthlyContract eo = (MonthlyContract) EOUtilities.createAndInsertInstance(editingContext, _MonthlyContract.ENTITY_NAME);
    eo.setCommodityDesc(commodityDesc);
    eo.setContractValue(contractValue);
    eo.setEffectiveDate(effectiveDate);
    eo.setExpirDate(expirDate);
    eo.setVendorName(vendorName);
    eo.setMonthRelationship(month);
    return eo;
  }

  public static ERXFetchSpecification<MonthlyContract> fetchSpec() {
    return new ERXFetchSpecification<MonthlyContract>(_MonthlyContract.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<MonthlyContract> fetchAllMonthlyContracts(EOEditingContext editingContext) {
    return _MonthlyContract.fetchAllMonthlyContracts(editingContext, null);
  }

  public static NSArray<MonthlyContract> fetchAllMonthlyContracts(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _MonthlyContract.fetchMonthlyContracts(editingContext, null, sortOrderings);
  }

  public static NSArray<MonthlyContract> fetchMonthlyContracts(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<MonthlyContract> fetchSpec = new ERXFetchSpecification<MonthlyContract>(_MonthlyContract.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<MonthlyContract> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static MonthlyContract fetchMonthlyContract(EOEditingContext editingContext, String keyName, Object value) {
    return _MonthlyContract.fetchMonthlyContract(editingContext, ERXQ.equals(keyName, value));
  }

  public static MonthlyContract fetchMonthlyContract(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<MonthlyContract> eoObjects = _MonthlyContract.fetchMonthlyContracts(editingContext, qualifier, null);
    MonthlyContract eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one MonthlyContract that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static MonthlyContract fetchRequiredMonthlyContract(EOEditingContext editingContext, String keyName, Object value) {
    return _MonthlyContract.fetchRequiredMonthlyContract(editingContext, ERXQ.equals(keyName, value));
  }

  public static MonthlyContract fetchRequiredMonthlyContract(EOEditingContext editingContext, EOQualifier qualifier) {
    MonthlyContract eoObject = _MonthlyContract.fetchMonthlyContract(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no MonthlyContract that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static MonthlyContract localInstanceIn(EOEditingContext editingContext, MonthlyContract eo) {
    MonthlyContract localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
