// DO NOT EDIT.  Make changes to MonthlyContractValue.java instead.
package org.opencalaccess.scccontracts.eo;

import java.util.NoSuchElementException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.eoaccess.EOUtilities;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.eocontrol.EOSortOrdering;
import com.webobjects.foundation.NSArray;

import er.extensions.eof.ERXEOControlUtilities;
import er.extensions.eof.ERXFetchSpecification;
import er.extensions.eof.ERXGenericRecord;
import er.extensions.eof.ERXKey;
import er.extensions.eof.ERXKey.Type;
import er.extensions.eof.ERXQ;

@SuppressWarnings("all")
public abstract class _MonthlyContractValue extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "MonthlyContractValue";

  // Attribute Keys
  public static final ERXKey<Long> CONTRACT_VALUE = new ERXKey<Long>("contractValue", Type.Attribute);
  public static final ERXKey<String> EFFECTIVE_DATE = new ERXKey<String>("effectiveDate", Type.Attribute);
  public static final ERXKey<String> EXPIR_DATE = new ERXKey<String>("expirDate", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract> CONTRACT = new ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract>("contract", Type.ToOneRelationship);

  // Attributes
  public static final String CONTRACT_VALUE_KEY = CONTRACT_VALUE.key();
  public static final String EFFECTIVE_DATE_KEY = EFFECTIVE_DATE.key();
  public static final String EXPIR_DATE_KEY = EXPIR_DATE.key();

  // Relationships
  public static final String CONTRACT_KEY = CONTRACT.key();

  private static final Logger log = LoggerFactory.getLogger(_MonthlyContractValue.class);

  public MonthlyContractValue localInstanceIn(EOEditingContext editingContext) {
    MonthlyContractValue localInstance = (MonthlyContractValue)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long contractValue() {
    return (Long) storedValueForKey(_MonthlyContractValue.CONTRACT_VALUE_KEY);
  }

  public void setContractValue(Long value) {
    log.debug( "updating contractValue from {} to {}", contractValue(), value);
    takeStoredValueForKey(value, _MonthlyContractValue.CONTRACT_VALUE_KEY);
  }

  public String effectiveDate() {
    return (String) storedValueForKey(_MonthlyContractValue.EFFECTIVE_DATE_KEY);
  }

  public void setEffectiveDate(String value) {
    log.debug( "updating effectiveDate from {} to {}", effectiveDate(), value);
    takeStoredValueForKey(value, _MonthlyContractValue.EFFECTIVE_DATE_KEY);
  }

  public String expirDate() {
    return (String) storedValueForKey(_MonthlyContractValue.EXPIR_DATE_KEY);
  }

  public void setExpirDate(String value) {
    log.debug( "updating expirDate from {} to {}", expirDate(), value);
    takeStoredValueForKey(value, _MonthlyContractValue.EXPIR_DATE_KEY);
  }

  public org.opencalaccess.scccontracts.eo.MonthlyContract contract() {
    return (org.opencalaccess.scccontracts.eo.MonthlyContract)storedValueForKey(_MonthlyContractValue.CONTRACT_KEY);
  }

  public void setContract(org.opencalaccess.scccontracts.eo.MonthlyContract value) {
    takeStoredValueForKey(value, _MonthlyContractValue.CONTRACT_KEY);
  }

  public void setContractRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract value) {
    log.debug("updating contract from {} to {}", contract(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setContract(value);
    }
    else if (value == null) {
      org.opencalaccess.scccontracts.eo.MonthlyContract oldValue = contract();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _MonthlyContractValue.CONTRACT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _MonthlyContractValue.CONTRACT_KEY);
    }
  }


  public static MonthlyContractValue createMonthlyContractValue(EOEditingContext editingContext, Long contractValue
, String effectiveDate
, String expirDate
, org.opencalaccess.scccontracts.eo.MonthlyContract contract) {
    MonthlyContractValue eo = (MonthlyContractValue) EOUtilities.createAndInsertInstance(editingContext, _MonthlyContractValue.ENTITY_NAME);
    eo.setContractValue(contractValue);
    eo.setEffectiveDate(effectiveDate);
    eo.setExpirDate(expirDate);
    eo.setContractRelationship(contract);
    return eo;
  }

  public static ERXFetchSpecification<MonthlyContractValue> fetchSpec() {
    return new ERXFetchSpecification<MonthlyContractValue>(_MonthlyContractValue.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<MonthlyContractValue> fetchAllMonthlyContractValues(EOEditingContext editingContext) {
    return _MonthlyContractValue.fetchAllMonthlyContractValues(editingContext, null);
  }

  public static NSArray<MonthlyContractValue> fetchAllMonthlyContractValues(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _MonthlyContractValue.fetchMonthlyContractValues(editingContext, null, sortOrderings);
  }

  public static NSArray<MonthlyContractValue> fetchMonthlyContractValues(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<MonthlyContractValue> fetchSpec = new ERXFetchSpecification<MonthlyContractValue>(_MonthlyContractValue.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<MonthlyContractValue> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static MonthlyContractValue fetchMonthlyContractValue(EOEditingContext editingContext, String keyName, Object value) {
    return _MonthlyContractValue.fetchMonthlyContractValue(editingContext, ERXQ.equals(keyName, value));
  }

  public static MonthlyContractValue fetchMonthlyContractValue(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<MonthlyContractValue> eoObjects = _MonthlyContractValue.fetchMonthlyContractValues(editingContext, qualifier, null);
    MonthlyContractValue eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one MonthlyContractValue that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static MonthlyContractValue fetchRequiredMonthlyContractValue(EOEditingContext editingContext, String keyName, Object value) {
    return _MonthlyContractValue.fetchRequiredMonthlyContractValue(editingContext, ERXQ.equals(keyName, value));
  }

  public static MonthlyContractValue fetchRequiredMonthlyContractValue(EOEditingContext editingContext, EOQualifier qualifier) {
    MonthlyContractValue eoObject = _MonthlyContractValue.fetchMonthlyContractValue(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no MonthlyContractValue that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static MonthlyContractValue localInstanceIn(EOEditingContext editingContext, MonthlyContractValue eo) {
    MonthlyContractValue localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
