// DO NOT EDIT.  Make changes to ReportMonth.java instead.
package org.opencalaccess.scccontracts.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ReportMonth extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "ReportMonth";

  // Attribute Keys
  public static final ERXKey<String> MONTH = new ERXKey<String>("month", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract> CONTRACTS = new ERXKey<org.opencalaccess.scccontracts.eo.MonthlyContract>("contracts", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.scccontracts.eo.ReportMonthSource> SOURCES = new ERXKey<org.opencalaccess.scccontracts.eo.ReportMonthSource>("sources", Type.ToManyRelationship);

  // Attributes
  public static final String MONTH_KEY = MONTH.key();

  // Relationships
  public static final String CONTRACTS_KEY = CONTRACTS.key();
  public static final String SOURCES_KEY = SOURCES.key();

  private static final Logger log = LoggerFactory.getLogger(_ReportMonth.class);

  public ReportMonth localInstanceIn(EOEditingContext editingContext) {
    ReportMonth localInstance = (ReportMonth)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String month() {
    return (String) storedValueForKey(_ReportMonth.MONTH_KEY);
  }

  public void setMonth(String value) {
    log.debug( "updating month from {} to {}", month(), value);
    takeStoredValueForKey(value, _ReportMonth.MONTH_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts() {
    return (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)storedValueForKey(_ReportMonth.CONTRACTS_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts(EOQualifier qualifier) {
    return contracts(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts(EOQualifier qualifier, boolean fetch) {
    return contracts(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> contracts(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.scccontracts.eo.MonthlyContract.MONTH_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.scccontracts.eo.MonthlyContract.fetchMonthlyContracts(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = contracts();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.MonthlyContract>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToContracts(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    includeObjectIntoPropertyWithKey(object, _ReportMonth.CONTRACTS_KEY);
  }

  public void removeFromContracts(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    excludeObjectFromPropertyWithKey(object, _ReportMonth.CONTRACTS_KEY);
  }

  public void addToContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    log.debug("adding {} to contracts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToContracts(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ReportMonth.CONTRACTS_KEY);
    }
  }

  public void removeFromContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    log.debug("removing {} from contracts relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromContracts(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ReportMonth.CONTRACTS_KEY);
    }
  }

  public org.opencalaccess.scccontracts.eo.MonthlyContract createContractsRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.scccontracts.eo.MonthlyContract.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ReportMonth.CONTRACTS_KEY);
    return (org.opencalaccess.scccontracts.eo.MonthlyContract) eo;
  }

  public void deleteContractsRelationship(org.opencalaccess.scccontracts.eo.MonthlyContract object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ReportMonth.CONTRACTS_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllContractsRelationships() {
    Enumeration<org.opencalaccess.scccontracts.eo.MonthlyContract> objects = contracts().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteContractsRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource> sources() {
    return (NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource>)storedValueForKey(_ReportMonth.SOURCES_KEY);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource> sources(EOQualifier qualifier) {
    return sources(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource> sources(EOQualifier qualifier, boolean fetch) {
    return sources(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource> sources(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.scccontracts.eo.ReportMonthSource.MONTH_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.scccontracts.eo.ReportMonthSource.fetchReportMonthSources(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = sources();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.scccontracts.eo.ReportMonthSource>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToSources(org.opencalaccess.scccontracts.eo.ReportMonthSource object) {
    includeObjectIntoPropertyWithKey(object, _ReportMonth.SOURCES_KEY);
  }

  public void removeFromSources(org.opencalaccess.scccontracts.eo.ReportMonthSource object) {
    excludeObjectFromPropertyWithKey(object, _ReportMonth.SOURCES_KEY);
  }

  public void addToSourcesRelationship(org.opencalaccess.scccontracts.eo.ReportMonthSource object) {
    log.debug("adding {} to sources relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToSources(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ReportMonth.SOURCES_KEY);
    }
  }

  public void removeFromSourcesRelationship(org.opencalaccess.scccontracts.eo.ReportMonthSource object) {
    log.debug("removing {} from sources relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromSources(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ReportMonth.SOURCES_KEY);
    }
  }

  public org.opencalaccess.scccontracts.eo.ReportMonthSource createSourcesRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.scccontracts.eo.ReportMonthSource.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ReportMonth.SOURCES_KEY);
    return (org.opencalaccess.scccontracts.eo.ReportMonthSource) eo;
  }

  public void deleteSourcesRelationship(org.opencalaccess.scccontracts.eo.ReportMonthSource object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ReportMonth.SOURCES_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllSourcesRelationships() {
    Enumeration<org.opencalaccess.scccontracts.eo.ReportMonthSource> objects = sources().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteSourcesRelationship(objects.nextElement());
    }
  }


  public static ReportMonth createReportMonth(EOEditingContext editingContext, String month
) {
    ReportMonth eo = (ReportMonth) EOUtilities.createAndInsertInstance(editingContext, _ReportMonth.ENTITY_NAME);
    eo.setMonth(month);
    return eo;
  }

  public static ERXFetchSpecification<ReportMonth> fetchSpec() {
    return new ERXFetchSpecification<ReportMonth>(_ReportMonth.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ReportMonth> fetchAllReportMonths(EOEditingContext editingContext) {
    return _ReportMonth.fetchAllReportMonths(editingContext, null);
  }

  public static NSArray<ReportMonth> fetchAllReportMonths(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ReportMonth.fetchReportMonths(editingContext, null, sortOrderings);
  }

  public static NSArray<ReportMonth> fetchReportMonths(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ReportMonth> fetchSpec = new ERXFetchSpecification<ReportMonth>(_ReportMonth.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ReportMonth> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ReportMonth fetchReportMonth(EOEditingContext editingContext, String keyName, Object value) {
    return _ReportMonth.fetchReportMonth(editingContext, ERXQ.equals(keyName, value));
  }

  public static ReportMonth fetchReportMonth(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ReportMonth> eoObjects = _ReportMonth.fetchReportMonths(editingContext, qualifier, null);
    ReportMonth eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one ReportMonth that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ReportMonth fetchRequiredReportMonth(EOEditingContext editingContext, String keyName, Object value) {
    return _ReportMonth.fetchRequiredReportMonth(editingContext, ERXQ.equals(keyName, value));
  }

  public static ReportMonth fetchRequiredReportMonth(EOEditingContext editingContext, EOQualifier qualifier) {
    ReportMonth eoObject = _ReportMonth.fetchReportMonth(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no ReportMonth that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ReportMonth localInstanceIn(EOEditingContext editingContext, ReportMonth eo) {
    ReportMonth localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
