// DO NOT EDIT.  Make changes to ReportMonthSource.java instead.
package org.opencalaccess.scccontracts.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ReportMonthSource extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "ReportMonthSource";

  // Attribute Keys
  public static final ERXKey<NSData> CONTENT = new ERXKey<NSData>("content", Type.Attribute);
  public static final ERXKey<String> SOURCE_URL = new ERXKey<String>("sourceUrl", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.scccontracts.eo.ReportMonth> MONTH = new ERXKey<org.opencalaccess.scccontracts.eo.ReportMonth>("month", Type.ToOneRelationship);

  // Attributes
  public static final String CONTENT_KEY = CONTENT.key();
  public static final String SOURCE_URL_KEY = SOURCE_URL.key();

  // Relationships
  public static final String MONTH_KEY = MONTH.key();

  private static final Logger log = LoggerFactory.getLogger(_ReportMonthSource.class);

  public ReportMonthSource localInstanceIn(EOEditingContext editingContext) {
    ReportMonthSource localInstance = (ReportMonthSource)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public NSData content() {
    return (NSData) storedValueForKey(_ReportMonthSource.CONTENT_KEY);
  }

  public void setContent(NSData value) {
    log.debug( "updating content from {} to {}", content(), value);
    takeStoredValueForKey(value, _ReportMonthSource.CONTENT_KEY);
  }

  public String sourceUrl() {
    return (String) storedValueForKey(_ReportMonthSource.SOURCE_URL_KEY);
  }

  public void setSourceUrl(String value) {
    log.debug( "updating sourceUrl from {} to {}", sourceUrl(), value);
    takeStoredValueForKey(value, _ReportMonthSource.SOURCE_URL_KEY);
  }

  public org.opencalaccess.scccontracts.eo.ReportMonth month() {
    return (org.opencalaccess.scccontracts.eo.ReportMonth)storedValueForKey(_ReportMonthSource.MONTH_KEY);
  }

  public void setMonth(org.opencalaccess.scccontracts.eo.ReportMonth value) {
    takeStoredValueForKey(value, _ReportMonthSource.MONTH_KEY);
  }

  public void setMonthRelationship(org.opencalaccess.scccontracts.eo.ReportMonth value) {
    log.debug("updating month from {} to {}", month(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setMonth(value);
    }
    else if (value == null) {
      org.opencalaccess.scccontracts.eo.ReportMonth oldValue = month();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _ReportMonthSource.MONTH_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _ReportMonthSource.MONTH_KEY);
    }
  }


  public static ReportMonthSource createReportMonthSource(EOEditingContext editingContext, NSData content
, String sourceUrl
, org.opencalaccess.scccontracts.eo.ReportMonth month) {
    ReportMonthSource eo = (ReportMonthSource) EOUtilities.createAndInsertInstance(editingContext, _ReportMonthSource.ENTITY_NAME);
    eo.setContent(content);
    eo.setSourceUrl(sourceUrl);
    eo.setMonthRelationship(month);
    return eo;
  }

  public static ERXFetchSpecification<ReportMonthSource> fetchSpec() {
    return new ERXFetchSpecification<ReportMonthSource>(_ReportMonthSource.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ReportMonthSource> fetchAllReportMonthSources(EOEditingContext editingContext) {
    return _ReportMonthSource.fetchAllReportMonthSources(editingContext, null);
  }

  public static NSArray<ReportMonthSource> fetchAllReportMonthSources(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ReportMonthSource.fetchReportMonthSources(editingContext, null, sortOrderings);
  }

  public static NSArray<ReportMonthSource> fetchReportMonthSources(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ReportMonthSource> fetchSpec = new ERXFetchSpecification<ReportMonthSource>(_ReportMonthSource.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ReportMonthSource> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ReportMonthSource fetchReportMonthSource(EOEditingContext editingContext, String keyName, Object value) {
    return _ReportMonthSource.fetchReportMonthSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static ReportMonthSource fetchReportMonthSource(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ReportMonthSource> eoObjects = _ReportMonthSource.fetchReportMonthSources(editingContext, qualifier, null);
    ReportMonthSource eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one ReportMonthSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ReportMonthSource fetchRequiredReportMonthSource(EOEditingContext editingContext, String keyName, Object value) {
    return _ReportMonthSource.fetchRequiredReportMonthSource(editingContext, ERXQ.equals(keyName, value));
  }

  public static ReportMonthSource fetchRequiredReportMonthSource(EOEditingContext editingContext, EOQualifier qualifier) {
    ReportMonthSource eoObject = _ReportMonthSource.fetchReportMonthSource(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no ReportMonthSource that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ReportMonthSource localInstanceIn(EOEditingContext editingContext, ReportMonthSource eo) {
    ReportMonthSource localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
