package org.opencalaccess.tvnt.eo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;

import er.extensions.eof.ERXQ;

public class ToDo extends _ToDo {

	private static final long serialVersionUID = -2849717472304434294L;

	private static final String TIME_ESTIMAGE_ATTR = "timeEstimate";

	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(ToDo.class);

	public String timeEstimate() {

		NSArray<ToDoInfo> found = ToDoInfo.fetchToDoInfos(
				this.editingContext(),
				ERXQ.and(
						ToDoInfo.TODO.is(this),
						ToDoInfo.KEY_STR.is(TIME_ESTIMAGE_ATTR)),
				null);

		if (found == null || found.isEmpty()) {
			return null; 
		} else {
			return found.get(0).valueStr();
		}
	}

	public void setTimeEstimate(String value) {

		EOEditingContext ec = this.editingContext();

		NSArray<ToDoInfo> found = ToDoInfo.fetchToDoInfos(
				ec,
				ERXQ.and(
						ToDoInfo.TODO.is(this),
						ToDoInfo.KEY_STR.is(TIME_ESTIMAGE_ATTR)),
				null);

		if (found == null || found.isEmpty()) {

			if (value == null || value.isEmpty()) {
				// do nothing
				//
			} else {
				// we found none and supplied a value, so create.
				//
				ToDoInfo.createToDoInfo(ec, TIME_ESTIMAGE_ATTR, value, this);
				ec.saveChanges();
			}
		} else {

			if (value == null || value.isEmpty()) {
				// we found one, but supplied nothing, so delete.
				ec.deleteObject(found.get(0));
				ec.saveChanges();
			} else {
				// we found one, and were give a value, so update;
				found.get(0).setValueStr(value);
				ec.saveChanges();
			}
		}
	}
}
