// DO NOT EDIT.  Make changes to ToDo.java instead.
package org.opencalaccess.tvnt.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ToDo extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "Todo";

  // Attribute Keys
  public static final ERXKey<Long> CREATED = new ERXKey<Long>("created", Type.Attribute);
  public static final ERXKey<String> INFO = new ERXKey<String>("info", Type.Attribute);
  public static final ERXKey<String> NOTE = new ERXKey<String>("note", Type.Attribute);
  public static final ERXKey<Long> RESOLVED = new ERXKey<Long>("resolved", Type.Attribute);
  public static final ERXKey<String> RESOLVE_TYPE = new ERXKey<String>("resolveType", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.tvnt.eo.ToDo> CHILDREN = new ERXKey<org.opencalaccess.tvnt.eo.ToDo>("children", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.tvnt.eo.ToDoInfo> INFOS = new ERXKey<org.opencalaccess.tvnt.eo.ToDoInfo>("infos", Type.ToManyRelationship);
  public static final ERXKey<org.opencalaccess.tvnt.eo.ToDo> PARENT = new ERXKey<org.opencalaccess.tvnt.eo.ToDo>("parent", Type.ToOneRelationship);

  // Attributes
  public static final String CREATED_KEY = CREATED.key();
  public static final String INFO_KEY = INFO.key();
  public static final String NOTE_KEY = NOTE.key();
  public static final String RESOLVED_KEY = RESOLVED.key();
  public static final String RESOLVE_TYPE_KEY = RESOLVE_TYPE.key();

  // Relationships
  public static final String CHILDREN_KEY = CHILDREN.key();
  public static final String INFOS_KEY = INFOS.key();
  public static final String PARENT_KEY = PARENT.key();

  private static final Logger log = LoggerFactory.getLogger(_ToDo.class);

  public ToDo localInstanceIn(EOEditingContext editingContext) {
    ToDo localInstance = (ToDo)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public Long created() {
    return (Long) storedValueForKey(_ToDo.CREATED_KEY);
  }

  public void setCreated(Long value) {
    log.debug( "updating created from {} to {}", created(), value);
    takeStoredValueForKey(value, _ToDo.CREATED_KEY);
  }

  public String info() {
    return (String) storedValueForKey(_ToDo.INFO_KEY);
  }

  public void setInfo(String value) {
    log.debug( "updating info from {} to {}", info(), value);
    takeStoredValueForKey(value, _ToDo.INFO_KEY);
  }

  public String note() {
    return (String) storedValueForKey(_ToDo.NOTE_KEY);
  }

  public void setNote(String value) {
    log.debug( "updating note from {} to {}", note(), value);
    takeStoredValueForKey(value, _ToDo.NOTE_KEY);
  }

  public Long resolved() {
    return (Long) storedValueForKey(_ToDo.RESOLVED_KEY);
  }

  public void setResolved(Long value) {
    log.debug( "updating resolved from {} to {}", resolved(), value);
    takeStoredValueForKey(value, _ToDo.RESOLVED_KEY);
  }

  public String resolveType() {
    return (String) storedValueForKey(_ToDo.RESOLVE_TYPE_KEY);
  }

  public void setResolveType(String value) {
    log.debug( "updating resolveType from {} to {}", resolveType(), value);
    takeStoredValueForKey(value, _ToDo.RESOLVE_TYPE_KEY);
  }

  public org.opencalaccess.tvnt.eo.ToDo parent() {
    return (org.opencalaccess.tvnt.eo.ToDo)storedValueForKey(_ToDo.PARENT_KEY);
  }

  public void setParent(org.opencalaccess.tvnt.eo.ToDo value) {
    takeStoredValueForKey(value, _ToDo.PARENT_KEY);
  }

  public void setParentRelationship(org.opencalaccess.tvnt.eo.ToDo value) {
    log.debug("updating parent from {} to {}", parent(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setParent(value);
    }
    else if (value == null) {
      org.opencalaccess.tvnt.eo.ToDo oldValue = parent();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _ToDo.PARENT_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _ToDo.PARENT_KEY);
    }
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDo> children() {
    return (NSArray<org.opencalaccess.tvnt.eo.ToDo>)storedValueForKey(_ToDo.CHILDREN_KEY);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDo> children(EOQualifier qualifier) {
    return children(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDo> children(EOQualifier qualifier, boolean fetch) {
    return children(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDo> children(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.tvnt.eo.ToDo> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.tvnt.eo.ToDo.PARENT_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.tvnt.eo.ToDo.fetchTodos(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = children();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.tvnt.eo.ToDo>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.tvnt.eo.ToDo>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToChildren(org.opencalaccess.tvnt.eo.ToDo object) {
    includeObjectIntoPropertyWithKey(object, _ToDo.CHILDREN_KEY);
  }

  public void removeFromChildren(org.opencalaccess.tvnt.eo.ToDo object) {
    excludeObjectFromPropertyWithKey(object, _ToDo.CHILDREN_KEY);
  }

  public void addToChildrenRelationship(org.opencalaccess.tvnt.eo.ToDo object) {
    log.debug("adding {} to children relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToChildren(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ToDo.CHILDREN_KEY);
    }
  }

  public void removeFromChildrenRelationship(org.opencalaccess.tvnt.eo.ToDo object) {
    log.debug("removing {} from children relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromChildren(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ToDo.CHILDREN_KEY);
    }
  }

  public org.opencalaccess.tvnt.eo.ToDo createChildrenRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.tvnt.eo.ToDo.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ToDo.CHILDREN_KEY);
    return (org.opencalaccess.tvnt.eo.ToDo) eo;
  }

  public void deleteChildrenRelationship(org.opencalaccess.tvnt.eo.ToDo object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ToDo.CHILDREN_KEY);
    editingContext().deleteObject(object);
  }

  public void deleteAllChildrenRelationships() {
    Enumeration<org.opencalaccess.tvnt.eo.ToDo> objects = children().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteChildrenRelationship(objects.nextElement());
    }
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDoInfo> infos() {
    return (NSArray<org.opencalaccess.tvnt.eo.ToDoInfo>)storedValueForKey(_ToDo.INFOS_KEY);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDoInfo> infos(EOQualifier qualifier) {
    return infos(qualifier, null, false);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDoInfo> infos(EOQualifier qualifier, boolean fetch) {
    return infos(qualifier, null, fetch);
  }

  public NSArray<org.opencalaccess.tvnt.eo.ToDoInfo> infos(EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings, boolean fetch) {
    NSArray<org.opencalaccess.tvnt.eo.ToDoInfo> results;
    if (fetch) {
      EOQualifier fullQualifier;
      EOQualifier inverseQualifier = ERXQ.equals(org.opencalaccess.tvnt.eo.ToDoInfo.TODO_KEY, this);

      if (qualifier == null) {
        fullQualifier = inverseQualifier;
      }
      else {
        fullQualifier = ERXQ.and(qualifier, inverseQualifier);
      }

      results = org.opencalaccess.tvnt.eo.ToDoInfo.fetchToDoInfos(editingContext(), fullQualifier, sortOrderings);
    }
    else {
      results = infos();
      if (qualifier != null) {
        results = (NSArray<org.opencalaccess.tvnt.eo.ToDoInfo>)EOQualifier.filteredArrayWithQualifier(results, qualifier);
      }
      if (sortOrderings != null) {
        results = (NSArray<org.opencalaccess.tvnt.eo.ToDoInfo>)EOSortOrdering.sortedArrayUsingKeyOrderArray(results, sortOrderings);
      }
    }
    return results;
  }

  public void addToInfos(org.opencalaccess.tvnt.eo.ToDoInfo object) {
    includeObjectIntoPropertyWithKey(object, _ToDo.INFOS_KEY);
  }

  public void removeFromInfos(org.opencalaccess.tvnt.eo.ToDoInfo object) {
    excludeObjectFromPropertyWithKey(object, _ToDo.INFOS_KEY);
  }

  public void addToInfosRelationship(org.opencalaccess.tvnt.eo.ToDoInfo object) {
    log.debug("adding {} to infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      addToInfos(object);
    }
    else {
      addObjectToBothSidesOfRelationshipWithKey(object, _ToDo.INFOS_KEY);
    }
  }

  public void removeFromInfosRelationship(org.opencalaccess.tvnt.eo.ToDoInfo object) {
    log.debug("removing {} from infos relationship", object);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      removeFromInfos(object);
    }
    else {
      removeObjectFromBothSidesOfRelationshipWithKey(object, _ToDo.INFOS_KEY);
    }
  }

  public org.opencalaccess.tvnt.eo.ToDoInfo createInfosRelationship() {
    EOEnterpriseObject eo = EOUtilities.createAndInsertInstance(editingContext(),  org.opencalaccess.tvnt.eo.ToDoInfo.ENTITY_NAME );
    addObjectToBothSidesOfRelationshipWithKey(eo, _ToDo.INFOS_KEY);
    return (org.opencalaccess.tvnt.eo.ToDoInfo) eo;
  }

  public void deleteInfosRelationship(org.opencalaccess.tvnt.eo.ToDoInfo object) {
    removeObjectFromBothSidesOfRelationshipWithKey(object, _ToDo.INFOS_KEY);
  }

  public void deleteAllInfosRelationships() {
    Enumeration<org.opencalaccess.tvnt.eo.ToDoInfo> objects = infos().immutableClone().objectEnumerator();
    while (objects.hasMoreElements()) {
      deleteInfosRelationship(objects.nextElement());
    }
  }


  public static ToDo createTodo(EOEditingContext editingContext, Long created
, String info
) {
    ToDo eo = (ToDo) EOUtilities.createAndInsertInstance(editingContext, _ToDo.ENTITY_NAME);
    eo.setCreated(created);
    eo.setInfo(info);
    return eo;
  }

  public static ERXFetchSpecification<ToDo> fetchSpec() {
    return new ERXFetchSpecification<ToDo>(_ToDo.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ToDo> fetchAllTodos(EOEditingContext editingContext) {
    return _ToDo.fetchAllTodos(editingContext, null);
  }

  public static NSArray<ToDo> fetchAllTodos(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ToDo.fetchTodos(editingContext, null, sortOrderings);
  }

  public static NSArray<ToDo> fetchTodos(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ToDo> fetchSpec = new ERXFetchSpecification<ToDo>(_ToDo.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ToDo> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ToDo fetchTodo(EOEditingContext editingContext, String keyName, Object value) {
    return _ToDo.fetchTodo(editingContext, ERXQ.equals(keyName, value));
  }

  public static ToDo fetchTodo(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ToDo> eoObjects = _ToDo.fetchTodos(editingContext, qualifier, null);
    ToDo eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one Todo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ToDo fetchRequiredTodo(EOEditingContext editingContext, String keyName, Object value) {
    return _ToDo.fetchRequiredTodo(editingContext, ERXQ.equals(keyName, value));
  }

  public static ToDo fetchRequiredTodo(EOEditingContext editingContext, EOQualifier qualifier) {
    ToDo eoObject = _ToDo.fetchTodo(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no Todo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ToDo localInstanceIn(EOEditingContext editingContext, ToDo eo) {
    ToDo localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
