// DO NOT EDIT.  Make changes to ToDoInfo.java instead.
package org.opencalaccess.tvnt.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _ToDoInfo extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "ToDoInfo";

  // Attribute Keys
  public static final ERXKey<String> KEY_STR = new ERXKey<String>("keyStr", Type.Attribute);
  public static final ERXKey<String> VALUE_STR = new ERXKey<String>("valueStr", Type.Attribute);

  // Relationship Keys
  public static final ERXKey<org.opencalaccess.tvnt.eo.ToDo> TODO = new ERXKey<org.opencalaccess.tvnt.eo.ToDo>("todo", Type.ToOneRelationship);

  // Attributes
  public static final String KEY_STR_KEY = KEY_STR.key();
  public static final String VALUE_STR_KEY = VALUE_STR.key();

  // Relationships
  public static final String TODO_KEY = TODO.key();

  private static final Logger log = LoggerFactory.getLogger(_ToDoInfo.class);

  public ToDoInfo localInstanceIn(EOEditingContext editingContext) {
    ToDoInfo localInstance = (ToDoInfo)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String keyStr() {
    return (String) storedValueForKey(_ToDoInfo.KEY_STR_KEY);
  }

  public void setKeyStr(String value) {
    log.debug( "updating keyStr from {} to {}", keyStr(), value);
    takeStoredValueForKey(value, _ToDoInfo.KEY_STR_KEY);
  }

  public String valueStr() {
    return (String) storedValueForKey(_ToDoInfo.VALUE_STR_KEY);
  }

  public void setValueStr(String value) {
    log.debug( "updating valueStr from {} to {}", valueStr(), value);
    takeStoredValueForKey(value, _ToDoInfo.VALUE_STR_KEY);
  }

  public org.opencalaccess.tvnt.eo.ToDo todo() {
    return (org.opencalaccess.tvnt.eo.ToDo)storedValueForKey(_ToDoInfo.TODO_KEY);
  }

  public void setTodo(org.opencalaccess.tvnt.eo.ToDo value) {
    takeStoredValueForKey(value, _ToDoInfo.TODO_KEY);
  }

  public void setTodoRelationship(org.opencalaccess.tvnt.eo.ToDo value) {
    log.debug("updating todo from {} to {}", todo(), value);
    if (er.extensions.eof.ERXGenericRecord.InverseRelationshipUpdater.updateInverseRelationships()) {
      setTodo(value);
    }
    else if (value == null) {
      org.opencalaccess.tvnt.eo.ToDo oldValue = todo();
      if (oldValue != null) {
        removeObjectFromBothSidesOfRelationshipWithKey(oldValue, _ToDoInfo.TODO_KEY);
      }
    } else {
      addObjectToBothSidesOfRelationshipWithKey(value, _ToDoInfo.TODO_KEY);
    }
  }


  public static ToDoInfo createToDoInfo(EOEditingContext editingContext, String keyStr
, String valueStr
, org.opencalaccess.tvnt.eo.ToDo todo) {
    ToDoInfo eo = (ToDoInfo) EOUtilities.createAndInsertInstance(editingContext, _ToDoInfo.ENTITY_NAME);
    eo.setKeyStr(keyStr);
    eo.setValueStr(valueStr);
    eo.setTodoRelationship(todo);
    return eo;
  }

  public static ERXFetchSpecification<ToDoInfo> fetchSpec() {
    return new ERXFetchSpecification<ToDoInfo>(_ToDoInfo.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<ToDoInfo> fetchAllToDoInfos(EOEditingContext editingContext) {
    return _ToDoInfo.fetchAllToDoInfos(editingContext, null);
  }

  public static NSArray<ToDoInfo> fetchAllToDoInfos(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _ToDoInfo.fetchToDoInfos(editingContext, null, sortOrderings);
  }

  public static NSArray<ToDoInfo> fetchToDoInfos(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<ToDoInfo> fetchSpec = new ERXFetchSpecification<ToDoInfo>(_ToDoInfo.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<ToDoInfo> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static ToDoInfo fetchToDoInfo(EOEditingContext editingContext, String keyName, Object value) {
    return _ToDoInfo.fetchToDoInfo(editingContext, ERXQ.equals(keyName, value));
  }

  public static ToDoInfo fetchToDoInfo(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<ToDoInfo> eoObjects = _ToDoInfo.fetchToDoInfos(editingContext, qualifier, null);
    ToDoInfo eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one ToDoInfo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ToDoInfo fetchRequiredToDoInfo(EOEditingContext editingContext, String keyName, Object value) {
    return _ToDoInfo.fetchRequiredToDoInfo(editingContext, ERXQ.equals(keyName, value));
  }

  public static ToDoInfo fetchRequiredToDoInfo(EOEditingContext editingContext, EOQualifier qualifier) {
    ToDoInfo eoObject = _ToDoInfo.fetchToDoInfo(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no ToDoInfo that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static ToDoInfo localInstanceIn(EOEditingContext editingContext, ToDoInfo eo) {
    ToDoInfo localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
