// DO NOT EDIT.  Make changes to UUName.java instead.
package org.opencalaccess.uudirectory.eo;

import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import com.webobjects.foundation.*;
import java.math.*;
import java.util.*;

import er.extensions.eof.*;
import er.extensions.eof.ERXKey.Type;
import er.extensions.foundation.*;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("all")
public abstract class _UUName extends  ERXGenericRecord {
  public static final String ENTITY_NAME = "UUName";

  // Attribute Keys
  public static final ERXKey<String> CELL_PHONE = new ERXKey<String>("cellPhone", Type.Attribute);
  public static final ERXKey<String> DIR_NAME = new ERXKey<String>("dirName", Type.Attribute);
  public static final ERXKey<String> EMAIL = new ERXKey<String>("email", Type.Attribute);
  public static final ERXKey<String> FIRST_NAME = new ERXKey<String>("firstName", Type.Attribute);
  public static final ERXKey<String> LAST_NAME = new ERXKey<String>("lastName", Type.Attribute);
  public static final ERXKey<String> OTHER_PHONE = new ERXKey<String>("otherPhone", Type.Attribute);

  // Relationship Keys

  // Attributes
  public static final String CELL_PHONE_KEY = CELL_PHONE.key();
  public static final String DIR_NAME_KEY = DIR_NAME.key();
  public static final String EMAIL_KEY = EMAIL.key();
  public static final String FIRST_NAME_KEY = FIRST_NAME.key();
  public static final String LAST_NAME_KEY = LAST_NAME.key();
  public static final String OTHER_PHONE_KEY = OTHER_PHONE.key();

  // Relationships

  private static final Logger log = LoggerFactory.getLogger(_UUName.class);

  public UUName localInstanceIn(EOEditingContext editingContext) {
    UUName localInstance = (UUName)EOUtilities.localInstanceOfObject(editingContext, this);
    if (localInstance == null) {
      throw new IllegalStateException("You attempted to localInstance " + this + ", which has not yet committed.");
    }
    return localInstance;
  }

  public String cellPhone() {
    return (String) storedValueForKey(_UUName.CELL_PHONE_KEY);
  }

  public void setCellPhone(String value) {
    log.debug( "updating cellPhone from {} to {}", cellPhone(), value);
    takeStoredValueForKey(value, _UUName.CELL_PHONE_KEY);
  }

  public String dirName() {
    return (String) storedValueForKey(_UUName.DIR_NAME_KEY);
  }

  public void setDirName(String value) {
    log.debug( "updating dirName from {} to {}", dirName(), value);
    takeStoredValueForKey(value, _UUName.DIR_NAME_KEY);
  }

  public String email() {
    return (String) storedValueForKey(_UUName.EMAIL_KEY);
  }

  public void setEmail(String value) {
    log.debug( "updating email from {} to {}", email(), value);
    takeStoredValueForKey(value, _UUName.EMAIL_KEY);
  }

  public String firstName() {
    return (String) storedValueForKey(_UUName.FIRST_NAME_KEY);
  }

  public void setFirstName(String value) {
    log.debug( "updating firstName from {} to {}", firstName(), value);
    takeStoredValueForKey(value, _UUName.FIRST_NAME_KEY);
  }

  public String lastName() {
    return (String) storedValueForKey(_UUName.LAST_NAME_KEY);
  }

  public void setLastName(String value) {
    log.debug( "updating lastName from {} to {}", lastName(), value);
    takeStoredValueForKey(value, _UUName.LAST_NAME_KEY);
  }

  public String otherPhone() {
    return (String) storedValueForKey(_UUName.OTHER_PHONE_KEY);
  }

  public void setOtherPhone(String value) {
    log.debug( "updating otherPhone from {} to {}", otherPhone(), value);
    takeStoredValueForKey(value, _UUName.OTHER_PHONE_KEY);
  }


  public static UUName createUUName(EOEditingContext editingContext, String cellPhone
, String dirName
, String email
, String firstName
, String lastName
, String otherPhone
) {
    UUName eo = (UUName) EOUtilities.createAndInsertInstance(editingContext, _UUName.ENTITY_NAME);
    eo.setCellPhone(cellPhone);
    eo.setDirName(dirName);
    eo.setEmail(email);
    eo.setFirstName(firstName);
    eo.setLastName(lastName);
    eo.setOtherPhone(otherPhone);
    return eo;
  }

  public static ERXFetchSpecification<UUName> fetchSpec() {
    return new ERXFetchSpecification<UUName>(_UUName.ENTITY_NAME, null, null, false, true, null);
  }

  public static NSArray<UUName> fetchAllUUNames(EOEditingContext editingContext) {
    return _UUName.fetchAllUUNames(editingContext, null);
  }

  public static NSArray<UUName> fetchAllUUNames(EOEditingContext editingContext, NSArray<EOSortOrdering> sortOrderings) {
    return _UUName.fetchUUNames(editingContext, null, sortOrderings);
  }

  public static NSArray<UUName> fetchUUNames(EOEditingContext editingContext, EOQualifier qualifier, NSArray<EOSortOrdering> sortOrderings) {
    ERXFetchSpecification<UUName> fetchSpec = new ERXFetchSpecification<UUName>(_UUName.ENTITY_NAME, qualifier, sortOrderings);
    NSArray<UUName> eoObjects = fetchSpec.fetchObjects(editingContext);
    return eoObjects;
  }

  public static UUName fetchUUName(EOEditingContext editingContext, String keyName, Object value) {
    return _UUName.fetchUUName(editingContext, ERXQ.equals(keyName, value));
  }

  public static UUName fetchUUName(EOEditingContext editingContext, EOQualifier qualifier) {
    NSArray<UUName> eoObjects = _UUName.fetchUUNames(editingContext, qualifier, null);
    UUName eoObject;
    int count = eoObjects.count();
    if (count == 0) {
      eoObject = null;
    }
    else if (count == 1) {
      eoObject = eoObjects.objectAtIndex(0);
    }
    else {
      throw new IllegalStateException("There was more than one UUName that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UUName fetchRequiredUUName(EOEditingContext editingContext, String keyName, Object value) {
    return _UUName.fetchRequiredUUName(editingContext, ERXQ.equals(keyName, value));
  }

  public static UUName fetchRequiredUUName(EOEditingContext editingContext, EOQualifier qualifier) {
    UUName eoObject = _UUName.fetchUUName(editingContext, qualifier);
    if (eoObject == null) {
      throw new NoSuchElementException("There was no UUName that matched the qualifier '" + qualifier + "'.");
    }
    return eoObject;
  }

  public static UUName localInstanceIn(EOEditingContext editingContext, UUName eo) {
    UUName localInstance = (eo == null) ? null : ERXEOControlUtilities.localInstanceOfObject(editingContext, eo);
    if (localInstance == null && eo != null) {
      throw new IllegalStateException("You attempted to localInstance " + eo + ", which has not yet committed.");
    }
    return localInstance;
  }
}
